local name = {
    id = 1,                             -- 编号
    cd = 2,                             -- 冷却时间
    type1 = 3,                          -- 类型1
    value1 = 4,                         -- 值1
    times1 = 5,                         -- 数量1
    type2 = 6,                          -- 类型2
    value2 = 7,                         -- 值2
    times2 = 8,                         -- 数量2
    type3 = 9,                          -- 类型3
    value3 = 10,                        -- 值3
    times3 = 11,                        -- 数量3
    cdBegin = 12,                       -- 是否初始就冷却
}

local data = {
{ 1, 30, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, },
{ 2, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
{ 3, 120, 4, 50007, 1, 0, 0, 0, 0, 0, 0, 0, },
{ 4, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, },
{ 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
