local name = {
    code = 1,                           -- 编号
    name = 2,                           -- 对应功能
    isAD = 3,                           -- 对应广告
    cd = 4,                             -- 广告cd
}

local data = {
{ 1, "恢复生命（0）", 1, 20, },
{ 2, "恢复生命（1）", 1, 60, },
{ 3, "登陆奖励X2", 1, 60, },
{ 4, "额外挑战机会", 1, 240, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    idx = data[i][1]
    ret[idx] = tab
end
return ret
