local name = {
    id = 1,                             -- 编号
    name = 2,                           -- 组名
    type1 = 3,                          -- 类型1
    value1 = 4,                         -- 值1
    times1 = 5,                         -- 数量1
    type2 = 6,                          -- 类型2
    value2 = 7,                         -- 值2
    times2 = 8,                         -- 数量2
    type3 = 9,                          -- 类型3
    value3 = 10,                        -- 值3
    times3 = 11,                        -- 数量3
}

local data = {
{ 70001, "￥1", 1, 0, 30, 6, 50001, 1, 6, 50002, 1, },
{ 70002, "￥3", 1, 0, 50, 6, 50001, 1, 6, 50002, 1, },
{ 70003, "奖励3", 6, 12301, 1, 6, 21101, 1, 2, 0, 15, },
{ 70004, "奖励4", 1, 0, 100, 5, 0, 20, 2, 0, 20, },
{ 70005, "奖励5", 6, 50001, 1, 6, 50002, 1, 0, 0, 0, },
{ 70006, "奖励6", 1, 0, 100, 5, 0, 1, 2, 0, 1, },
{ 70007, "奖励7", 1, 0, 10, 5, 0, 1, 2, 0, 1, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
