local name = {
    code = 1,                           -- 编号
    type = 2,                           -- 类型
    imageId = 3,                        -- 图片ID
    cost = 4,                           -- 售卖价格
    getType = 5,                        -- 获得类型
    getNum = 6,                         -- 获得数量
    name = 7,                           -- 名字
    iapId = 8,                          -- 商品ID
    iapName = 9,                        -- 商品名称
    isHot = 10,                         -- 是否热销
}

local data = {
{ 40101, 1, "Image/diamond/diamond1.png", 6, 1, 60, "60钻石", "com.locojoytj.cnmsonline.buy1", "少量钻石", 0, },
{ 40102, 1, "Image/diamond/diamond1.png", 6, 2, 80001, "超值礼包", "com.locojoytj.cnmsonline.buy2", "超值礼包", 0, },
{ 40103, 1, "Image/diamond/diamond2.png", 30, 1, 310, "310钻石", "com.locojoytj.cnmsonline.buy3", "一些钻石", 0, },
{ 40104, 1, "Image/diamond/diamond3.png", 68, 1, 700, "700钻石", "com.locojoytj.cnmsonline.buy4", "一箱钻石", 0, },
{ 40105, 1, "Image/diamond/diamond4.png", 128, 1, 1320, "1320钻石", "com.locojoytj.cnmsonline.buy5", "大量钻石", 1, },
{ 40106, 1, "Image/diamond/diamond5.png", 328, 1, 3360, "3360钻石", "com.locojoytj.cnmsonline.buy6", "巨量钻石", 1, },
{ 40107, 1, "Image/diamond/diamond6.png", 648, 1, 6580, "6580钻石", "com.locojoytj.cnmsonline.buy7", "超量钻石", 1, },
{ 40201, 2, "Image/diamond/diamond1.png", 0.990, 1, 60, "60钻石", "com.locojoytj.msonline.buy1", "A few diamonds", 0, },
{ 40202, 2, "Image/diamond/diamond2.png", 4.990, 1, 310, "310钻石", "com.locojoytj.msonline.buy3", "A sack of diamonds", 0, },
{ 40203, 2, "Image/diamond/diamond3.png", 9.990, 1, 700, "700钻石", "com.locojoytj.msonline.buy4", "A box of diamonds", 0, },
{ 40204, 2, "Image/diamond/diamond4.png", 19.990, 1, 1320, "1320钻石", "com.locojoytj.msonline.buy5", "Plenty of diamonds", 1, },
{ 40205, 2, "Image/diamond/diamond5.png", 49.990, 1, 3360, "3360钻石", "com.locojoytj.msonline.buy6", "Huge amount diamonds", 1, },
{ 40206, 2, "Image/diamond/diamond6.png", 99.990, 1, 6580, "6580钻石", "com.locojoytj.msonline.buy7", "Super amount diamonds", 1, },
{ 40207, 2, "Image/diamond/diamond7.png", 0.990, 2, 80001, "Promotion", "com.locojoytj.msonline.buy2", "many diamonds and many items", 1, },
{ 40301, 3, "Image/diamond/diamond1.png", 0.990, 1, 60, "60钻石", "com.locojoytj.msonline.gpbuy1", "A few diamonds", 0, },
{ 40302, 3, "Image/diamond/diamond2.png", 4.990, 1, 310, "310钻石", "com.locojoytj.msonline.gpbuy3", "A sack of diamonds", 0, },
{ 40303, 3, "Image/diamond/diamond3.png", 9.990, 1, 700, "700钻石", "com.locojoytj.msonline.gpbuy4", "A box of diamonds", 0, },
{ 40304, 3, "Image/diamond/diamond4.png", 19.990, 1, 1320, "1320钻石", "com.locojoytj.msonline.gpbuy5", "Plenty of diamonds", 1, },
{ 40305, 3, "Image/diamond/diamond5.png", 49.990, 1, 3360, "3360钻石", "com.locojoytj.msonline.gpbuy6", "Huge amount diamonds", 1, },
{ 40306, 3, "Image/diamond/diamond6.png", 99.990, 1, 6580, "6580钻石", "com.locojoytj.msonline.gpbuy7", "Super amount diamonds", 1, },
{ 40307, 3, "Image/diamond/diamond7.png", 0.990, 2, 80001, "Promotion", "com.locojoytj.msonline.gpbuy2", "many diamonds and many items", 1, },
{ 40401, 4, "Image/diamond/diamond1.png", 6, 1, 60, "60钻石", "com.locojoytj.cnmsonline.wxbuy1", "少量钻石", 0, },
{ 40402, 4, "Image/diamond/diamond1.png", 6, 2, 80001, "超值礼包", "com.locojoytj.cnmsonline.wxbuy2", "超值礼包", 0, },
{ 40403, 4, "Image/diamond/diamond2.png", 30, 1, 310, "310钻石", "com.locojoytj.cnmsonline.wxbuy3", "一些钻石", 0, },
{ 40404, 4, "Image/diamond/diamond3.png", 68, 1, 700, "700钻石", "com.locojoytj.cnmsonline.wxbuy4", "一箱钻石", 0, },
{ 40405, 4, "Image/diamond/diamond4.png", 128, 1, 1320, "1320钻石", "com.locojoytj.cnmsonline.wxbuy5", "大量钻石", 1, },
{ 40406, 4, "Image/diamond/diamond5.png", 328, 1, 3360, "3360钻石", "com.locojoytj.cnmsonline.wxbuy6", "巨量钻石", 1, },
{ 40407, 4, "Image/diamond/diamond6.png", 648, 1, 6580, "6580钻石", "com.locojoytj.cnmsonline.wxbuy7", "超量钻石", 1, },
{ 40501, 5, "Image/diamond/diamond1.png", 6, 1, 60, "60钻石", "com.locojoytj.cnmsonline.zfbbuy1", "少量钻石", 0, },
{ 40502, 5, "Image/diamond/diamond1.png", 6, 2, 80001, "超值礼包", "com.locojoytj.cnmsonline.zfbbuy2", "超值礼包", 0, },
{ 40503, 5, "Image/diamond/diamond2.png", 30, 1, 310, "310钻石", "com.locojoytj.cnmsonline.zfbbuy3", "一些钻石", 0, },
{ 40504, 5, "Image/diamond/diamond3.png", 68, 1, 700, "700钻石", "com.locojoytj.cnmsonline.zfbbuy4", "一箱钻石", 0, },
{ 40505, 5, "Image/diamond/diamond4.png", 128, 1, 1320, "1320钻石", "com.locojoytj.cnmsonline.zfbbuy5", "大量钻石", 1, },
{ 40506, 5, "Image/diamond/diamond5.png", 328, 1, 3360, "3360钻石", "com.locojoytj.cnmsonline.zfbbuy6", "巨量钻石", 1, },
{ 40507, 5, "Image/diamond/diamond6.png", 648, 1, 6580, "6580钻石", "com.locojoytj.cnmsonline.zfbbuy7", "超量钻石", 1, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
