local name = {
    id = 1,                             -- 编号
    name = 2,                           -- 名称
    imageId = 3,                        -- 图片ID
    type = 4,                           -- 类型
    effect = 5,                         -- 效果ID
    cdTime1 = 6,                        -- cd时间
    boxNum = 7,                         -- 是否出现在箱子中
    beforeID = 8,                       -- 前置ID
    nextID = 9,                         -- 升级后ID
    canUse = 10,                        -- 是否使用
    canEquip = 11,                      -- 是否装备
    isOnly = 12,                        -- 是否只有一个
}

local data = {
{ 10101, "0", "Image/Theme1/flagset.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12201, "0", "Image/qi/34.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12202, "0", "Image/qi/35.png", 1, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 11401, "0", "Image/qi/26.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 11501, "0", "Image/qi/27.png", 1, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 11601, "0", "Image/qi/28.png", 1, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 11701, "0", "Image/qi/29.png", 1, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 11801, "0", "Image/qi/30.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 11901, "0", "Image/qi/31.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12001, "0", "Image/qi/32.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 10201, "0", "Image/qi/7.png", 1, 0, 0, 1, 0, 10202, 0, 1, 1, },
{ 10202, "0", "Image/qi/19.png", 1, 0, 0, 0, 10201, 0, 0, 1, 1, },
{ 10301, "0", "Image/qi/25.png", 1, 0, 0, 1, 0, 10302, 0, 1, 1, },
{ 10302, "0", "Image/qi/10.png", 1, 0, 0, 0, 10301, 0, 0, 1, 1, },
{ 10401, "0", "Image/qi/4.png", 1, 0, 0, 1, 0, 10402, 0, 1, 1, },
{ 10402, "0", "Image/qi/13.png", 1, 0, 0, 0, 10401, 0, 0, 1, 1, },
{ 10601, "0", "Image/qi/18.png", 1, 0, 0, 1, 0, 10602, 0, 1, 1, },
{ 10602, "0", "Image/qi/5.png", 1, 0, 0, 0, 10601, 0, 0, 1, 1, },
{ 10701, "0", "Image/qi/8.png", 1, 0, 0, 1, 0, 10702, 0, 1, 1, },
{ 10702, "0", "Image/qi/11.png", 1, 0, 0, 0, 10701, 0, 0, 1, 1, },
{ 12301, "0", "Image/qi/beer.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12401, "0", "Image/qi/box.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12501, "0", "Image/qi/cccc.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12601, "0", "Image/qi/cdr.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12701, "0", "Image/qi/cherry.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12801, "0", "Image/qi/dk.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 12901, "0", "Image/qi/dq.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13001, "0", "Image/qi/fs.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13101, "0", "Image/qi/js.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13201, "0", "Image/qi/pdx.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13301, "0", "Image/qi/slm.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13401, "0", "Image/qi/tv.png", 1, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 13501, "0", "Image/qi/ub.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 13601, "0", "Image/qi/xx.png", 1, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20101, "0", "Image/cursor/0.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20201, "0", "Image/cursor/1.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20301, "0", "Image/cursor/2.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20401, "0", "Image/cursor/3.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20501, "0", "Image/cursor/4.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20601, "0", "Image/cursor/5.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20701, "0", "Image/cursor/6.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20801, "0", "Image/cursor/7.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 20901, "0", "Image/cursor/8.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 21001, "0", "Image/cursor/9.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 21101, "0", "Image/cursor/10.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21201, "0", "Image/cursor/11.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21301, "0", "Image/cursor/12.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21401, "0", "Image/cursor/13.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21501, "0", "Image/cursor/14.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21601, "0", "Image/cursor/15.png", 2, 0, 0, 1, 0, 0, 0, 1, 1, },
{ 21701, "0", "Image/cursor/16.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 21801, "0", "Image/cursor/17.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 21901, "0", "Image/cursor/18.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 22001, "0", "Image/cursor/19.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 22101, "0", "Image/cursor/20.png", 2, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 30101, "0", "Image/Theme/normal.png", 3, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 30102, "0", "Image/Theme/cristal.png", 3, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 30103, "0", "Image/Theme/grass.png", 3, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 40000, "0", "0", 4, 0, 0, 0, 0, 0, 0, 1, 1, },
{ 50001, "bomb", "Image/darkUI/bomb.png", 5, 1, 10, 1, 0, 0, 1, 0, 0, },
{ 50002, "god", "Image/darkUI/wudi.png", 5, 2, 10, 1, 0, 0, 1, 0, 0, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
