local name = {
    code = 1,                           -- 编号
    getType = 2,                        -- 获得种类
    itemPro = 3,                        -- 获得几率
    itemCode = 4,                       -- 物品属性
}

local data = {
{ 1, 0, 10000, 0, },
{ 2, 1, 0, 0, },
{ 3, 2, 200, 50001, },
{ 4, 2, 10, 50002, },
{ 5, 2, 1, 50003, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
