local name = {
    code = 1,                           -- 编号
    imageId = 2,                        -- 图片ID
    cost = 3,                           -- 售卖价格
    getNum = 4,                         -- 获得数量
    name = 5,                           -- 名字
    isHot = 6,                          -- 是否热销
}

local data = {
{ 50001, "Image/diamond/coin1.png", 1, 5, "0", 0, },
{ 50002, "Image/diamond/coin2.png", 5, 27, "0", 0, },
{ 50003, "Image/diamond/coin3.png", 10, 55, "0", 0, },
{ 50004, "Image/diamond/coin4.png", 50, 280, "0", 1, },
{ 50005, "Image/diamond/coin5.png", 100, 660, "0", 1, },
{ 50006, "Image/diamond/coin6.png", 400, 2250, "0", 1, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
