local name = {
    code = 1,                           -- 序号
    type = 2,                           -- 种类
    num = 3,                            -- 数值
    text = 4,                           -- 文字
    zmdType = 5,                        -- 走马灯类型
}

local data = {
{ 1, 1, 100, "30133", 1, },
{ 2, 1, 200, "30134", 1, },
{ 3, 1, 500, "30135", 1, },
{ 4, 1, 1000, "30136", 1, },
{ 5, 1, 2000, "30137", 1, },
{ 6, 1, 5000, "30138", 1, },
{ 7, 1, 10000, "30139", 2, },
{ 8, 1, 20000, "30140", 2, },
{ 9, 1, 50000, "30141", 2, },
{ 10, 4, 1, "30142", 1, },
{ 11, 4, 10, "30142", 2, },
{ 12, 5, 1, "30144", 2, },
{ 13, 6, 1, "30143", 2, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
