cc.exports.ctr = ctr or {}
local notice = {}


function notice.start()
    async.create(function()

        while(true) do
            local ret = async.call(async.bind(net.notice, mdl.playerName, async.callback))
            local hasValue = false
            if ret then
                for i=1,#ret.body do
                    local d = ret.body[i]
                    event.dispatch('onPushMessage', d)
                    hasValue = true
                end
            end

            if hasValue then
                async.waitForEvent('onPushMessageOver')
            else
                async.delay(5)
            end
        end

    end)
end

function notice.push(key, list)
    local id = static.VALUE.NOTICE[key]
--    for i=1, #list do
--        msg = string.gsub(msg, '(%%s'..i..')', list[i])
--    end
    
    util.delay(0, function() net.addnotice(id, list) end )
end

function notice.pushMessage(txt)
    ctr.notice.msgList = ctr.notice.msgList or {}
    local function addMessage(txt2)
        local view = util.getApp():createView('Common.Message')
        view:setString(txt2)
        util.getScene():addChild(view)
    end
    
    if txt==ctr.notice.msgList[#ctr.notice.msgList] then
        return
    end
    table.insert(ctr.notice.msgList, txt)
    if ctr.notice.pushing then
        
    else
        ctr.notice.pushing = true
        async.create(function()
            while(table.nums(ctr.notice.msgList)>0) do
                local txt2 = ctr.notice.msgList[1]
                table.remove(ctr.notice.msgList, 1)
                addMessage(txt2)
                async.delay(0.5)
            end
            ctr.notice.pushing = false
        end)
    end
end

ctr.notice = notice
return ctr.notice