local SDKAdcolony = class("SDKAdcolony",sdkManager:getSDK("sdkBase"))

	SDKAdcolony["id"]="adcolony"
	SDKAdcolony["cmd"]={
		SHOW_ADS=1001, -- 播放广告
	    CHECK_ADS=1002, -- 检查广告是否获取成功

	    CB_SHOW_ADS=2010, --[回调]播放广告
	}

	--[[显示广告]]
	function SDKAdcolony:showAds(callback)
		if self:isAndroid() or self:isIOS() then
			self:setCallback(self.cmd.SHOW_ADS,callback)
		    sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SHOW_ADS))
		end
	end
	function SDKAdcolony:processShowAds(info)
		local callback = self:getCallback(self.cmd.SHOW_ADS)
		if type(callback) == "function" then
			callback(info)
		end
	end
	--[[获取当前广告播放状态]]
	function SDKAdcolony:isAdsReady()
		print("SDKAdcolony:isAdsReady")
	    local adsInfo = sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CHECK_ADS))
        return sdkManager:checkAdAvalible(adsInfo)
	end
	--[[广告回调处理]]
	function SDKAdcolony:handler(response)
		local cmd=response["cmd"]
		if type(cmd)=="number" then
		        if cmd == self.cmd.CB_SHOW_ADS then
                    sdkManager.talkingdata:setEvent("34",{AD3 = "AD3"})
                    sdkManager.appsflyer:setEvent("34",{AD3 = "AD3"})
		        	self:processShowAds(response.param)
		        end
		end
	end

return SDKAdcolony