local SDKAppsflyer = class("SDKAppsflyer",sdkManager:getSDK("sdkBase"))

	SDKAppsflyer["id"]="appsflyer"
	SDKAppsflyer["cmd"]={
		SET_EVENT=1001, --设置自定义事件
		SET_PAY_SUCCESS=1002, --设置玩家支付成功
	}

	--[[设置支付成功]]
	function SDKAppsflyer:setPaySuccess(receiptId,contentId,revenue,currency)
		if self:isIOS() then
			if type(receiptId)=="string" and type(contentId)=="string" and type(revenue)=="number" then
				local param={["receiptId"]=receiptId,["contentId"]=contentId,["revenue"]=revenue,["currency"]=currency}
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY_SUCCESS,param))
			end
		elseif self:isAndroid() then
				local param={["orderID"]=receiptId,["revenue"]=revenue,["contentId"]=contentId,["currency"]=currency}
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY_SUCCESS,param))
		end
	end
	--[[设置独立事件]]
	function SDKAppsflyer:setEvent(eventId,eventInfo)
        if nil ~= eventId then
			eventId = tostring(eventId)
			if self:isIOS() or self:isAndroid() then
				local param = {["eventId"] = eventId,["eventInfo"] = eventInfo}
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_EVENT,param))
			end
			printInfo("【设置埋点(appsflyer)】: %s",eventId)
		end
	end

return SDKAppsflyer       