local SDKUC = class("SDKUC",sdkManager:getSDK("sdkBase"))

	SDKUC["id"] = "uc"
	SDKUC["cmd"] = {
		SET_ACCOUNT_INFOS = 1001, --设置Account 参数:playerID,playerName
		SET_PAY = 1002, --设置玩家支付
		SET_PAY_SUCCESS = 1003, --设置玩家支付成功
		SET_EVENT = 1004, --设置自定义事件
		SET_LOGIN = 2001,
		SET_LOGIN_OUT = 2002,
		SET_ACCOUNT_INFOS = 3001,--UC需要传游戏人物信息
		CB_SET_LOGIN = 2010,
		CB_SET_LOGIN_OUT = 2011,
		CB_PAY_SUCCESS = 8888,
		SET_INIT = 9999,
	}
	--[[初始化SDK]]
	function SDKUC:initUCSdkToJava()
		if self:isIOS() or self:isAndroid() then
			sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_INIT,param))
			print("999999999999999999")
		end
	end

	--[[设置玩家信息]]
	function SDKUC:setAccountInfos(playerId)
		if self:isIOS() or self:isAndroid() then
			if type(playerId) == "string" then
				local param = {}
				param["playerId"] = playerId
		-- 		if type(playerName) == "string" then
		-- 			param["playerName"] = playerName 
		-- 		end
		-- 		if not (type(gender) == "number" and (gender==0 or gender == 1 or gender == 2)) then --0:unknow 1:male 2:female
		-- 			param["gender"] = 0
		-- 		end
		-- 		param["gender"] = gender
		-- 		if type(age) ~= "number" then
		-- 			param["age"] = 0
		-- 		end
		-- 		param["age"] = age
		-- 		param["server"] = server
		-- 		param["channel"] = channel
		-- 		dump(param)
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_ACCOUNT_INFOS,param))
			end
		end
	end
	--[[设置支付]]
	function SDKUC:setPay(amount,notifyUrl,cpOrderId,accountId,signType,sign,callBackInfo)
		--currencyType =  currencyType or "CNY"
		if self:isIOS() or self:isAndroid() then
			-- if type(notifyUrl) == "string" and type(cpOrderId) == "string" and type(price) == "number" then
			print("UCCCpay")
				local param = {["amount"] = tostring(amount),["notifyUrl"] = notifyUrl,["cpOrderId"] = cpOrderId,["accountId"] = accountId ,["signType"]=signType,["sign"] = sign,["callBackInfo"] =callBackInfo }
			print("UCCCpay222")
				--mdt.payOrderID = orderId
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY,param))
			-- end
		end
	end
	--[[设置支付成功]]
	function SDKUC:setPaySuccess(orderId)
		-- if self:isIOS() or self:isAndroid() then
		-- 	if type(orderId) == "string" then
		-- 		local param = {["orderId"] = orderId}
		-- 		sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY_SUCCESS,param))
		-- 	end
		-- end
	end
	--[[设置事件]]
	function SDKUC:setEvent(eventId,eventInfo)
		-- if nil ~= eventId then
		-- 	eventId = tostring(eventId)
		-- 	if self:isIOS() or self:isAndroid() then
		-- 		local param = {["eventId"] = eventId,["eventInfo"] = eventInfo}
		-- 		sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_EVENT,param))
		-- 	end
		-- 	printInfo("【设置埋点】: %s",eventId)
		-- end
	end
	--[[设置退出登录]]
	function SDKUC:exit(eventId,eventInfo)
		-- if nil ~= eventId then
		-- 	eventId = tostring(eventId)
		-- 	if self:isIOS() or self:isAndroid() then
		-- 		local param = {["eventId"] = eventId,["eventInfo"] = eventInfo}
		-- 		sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_EVENT,param))
		-- 	end
		-- 	printInfo("【设置埋点】: %s",eventId)
		-- end
		--currencyType =  currencyType or "CNY"
		if self:isIOS() or self:isAndroid() then
			-- if type(notifyUrl) == "string" and type(cpOrderId) == "string" and type(price) == "number" then
				--mdt.payOrderID = orderId
		sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_LOGIN_OUT,param))
			-- end
		end
	end

	--[[设置登录回调]]
	function SDKUC:handler(response)
		--print("【UC登录回调！！】")
		local cmd=response["cmd"]
		if type(cmd)=="number" then
	       		 if cmd==self.cmd.CB_SET_LOGIN then
	            			--self:processCompleted(response.param)
	            		mdt.player.loginType = 6
	            		local temp = response["accountId"]
	            		--mdt.player.accountId = response["accountId"]

	            		local ip = "http://13.229.196.58:8080/MineShareServer/UcVerifySession?"
             		   	local url = "sid="..temp
                		print("UCCCCCCCCCCCCCCLogin"..ip..url)
                  		util.HttpManagerPOST(ip, url, function (result)
                        		dump()          
		              local accountId = result["accountId"]  
		              mdt.player.accountId =  accountId
		              mdt.player.sdkId = "uc"         
                       		 print("收到服务器的了!Login!"..accountId)
                   		 end)
			end
			  if cmd==self.cmd.CB_PAY_SUCCESS then
			                            --self:processCompleted(response.param)
			                       --logoutCallback()
			                       print("登出回调处理！")
			                    if mdt.FristCharge ~= nil and mdt.FristCharge then
			                           mdt.nFirstChargeGiftIsBuy = 1
			                            event.dispatch('updateFristCharge')
			                            mdt.FristCharge = false
			                    end                  
               		 end
               		   if cmd==self.cmd.CB_SET_LOGIN_OUT then
		                            --self:processCompleted(response.param)
		                       --logoutCallback()
		                       print("登出回调处理！UC")
		                        mdt.session = nil
		                        mdr.token = nil
		                        mdr.save()
		                        mdlogin.setAccountAndPassward(mdlogin.getCurLoginServerID(), "", "")
		                        os.exit()
		                      --ctr.player.restart()
		                end
		end
	end

return SDKUC