--
-- Author: MrC
-- Date: 2016-05-11 11:23:48
--
--Vungle 视频广告
local SDKVungle = class("SDKVungle",sdkManager:getSDK("sdkBase"))

	SDKVungle["id"]="vungle"
	SDKVungle["isReady"]=false
	SDKVungle["cmd"]={
		SHOW_ADS=1001, -- 播放广告
	    CHECK_ADS=1002, -- 检查广告是否获取成功

		CB_SHOW_ADS=2010, -- [回调]播放广告
	}


	--[[显示广告]]
	function SDKVungle:showAds(callback)
		if self:isAndroid() or self:isIOS() then
		    self:setCallback(self.cmd.SHOW_ADS,callback)
		    sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SHOW_ADS))
		end
	end
	--[[获取当前广告播放状态]]
	function SDKVungle:isAdsReady()
	    local adsInfo = sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CHECK_ADS))
        return sdkManager:checkAdAvalible(adsInfo)
	end
	--[[看完广告处理]]
	function SDKVungle:processCompleted(cbInfo)
		local callback = self:getCallback(self.cmd.SHOW_ADS)
		if type(callback) == "function" then
			callback(cbInfo)
		end
	end
	--[[广告回调处理]]
	function SDKVungle:handler(response)
		local cmd=response["cmd"]

		if type(cmd)=="number" then

	        if cmd==self.cmd.CB_SHOW_ADS then

	        	print("【广告(Vungle)已经关闭！】")
                sdkManager.talkingdata:setEvent("32",{AD3 = "AD1"})
                sdkManager.appsflyer:setEvent("32",{AD3 = "AD1"})
	            self:processCompleted(response.param)
			end
		end
	end

return SDKVungle