local init = {}

local tab = {
	'app.util.util',
    'app.extensions.sdk.sdkManager',
    'app.extensions.sdk.AdManager',
	'app.util.event',
	'app.util.async',
    'app.util.audio',
    'app.util.lang',
    'app.util.smart',
    'app.util.profiler',
    'app.controllers.loginController',
	'app.controllers.playerController',
    'app.controllers.noticeController',
    'app.controllers.gameController',
    'app.models.staticData',
    'app.models.romData',
	'app.models.gameData',
    'app.models.tempData',
    'app.models.loginData',
    --'app.net.WSNet',
    'app.net.ndp.NDPNet',
    'app.net.ndp.NDPServer',
    'app.net.http.HTTPNet',
    'app.controllers.serverController',
}

function init.init()
	for i,v in ipairs(tab) do
		require(v)
	end
end

function init.reload()
    for i,v in ipairs(tab) do
		init.reloadModule(v)
	end	
end

function init.reloadModule( moduleName )

    package.loaded[moduleName] = nil

    return require(moduleName)
end

return init