local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM
-------------------------------------------------------------------------------
-- filename: BattleData.h
-- author: chdeng
-- actor:
-- data: 2015-09-02
-- last: 2015-09-02
-- brief:
-------------------------------------------------------------------------------



local MAX_RANK_NUM = (1000)

-------------------------------------------------------------------------------
-- а;
-------------------------------------------------------------------------------
CMD_ENUM("ERankingType", 
{
    ET_Rank_Null            =   0,
    ET_Grid_Rank            =   1,                      -- ȷ׵
    ET_Bomb_Rank            =   2,                      -- ȷ׵
    ET_TFlag_Rank           =   3,                      -- ׵
    ET_FFlag_Rank           =   4,                      -- ׵
    ET_ComboMax_Rank        =   5,                      -- ֵ
    ET_ClickScore_Rank      =   6,                      -- 
    ET_Dedication_Rank      =   7,                      -- ׶

    ET_Rank_Max             =   8,
})
-------------------------------------------------------------------------------
-- tagRankingData (͸ͻ˵)
-------------------------------------------------------------------------------
CMD_STRUCT("tagRankingData", {
    { "ulIndex", tag.int },                             -- ;
    { "nPlayerGuid", tag.int64 },                       -- nPlayerGuid;
    { "szName", tag.string, 32 },                       -- ;
    { "nPlayerHead", tag.int },                         -- ͷurlʾ
    { "nCountry", tag.int },                            -- 
    { "nParam1", tag.int },                             -- Ͳ1;
    { "nParam2", tag.int },                             -- Ͳ2;
})
-------------------------------------------------------------------------------
-- Ԥص
-------------------------------------------------------------------------------
CMD_STRUCT("tagPrestrainData", {
    { "m_playerGuid", tag.int64 },
    { "m_sPlayerName", tag.string, 32 },
    { "m_nPortraitId", tag.int },                       -- ͷID
    { "m_nLv", tag.int },
    { "m_nFriendNum", tag.short },                      -- ѵ
})


-------------------------------------------------------------------------------
-- tagRankingNode
-------------------------------------------------------------------------------
CMD_STRUCT("tagRankingNode", {
    { "nRankIndex", tag.int },                          -- ;
    { "nPlayerGuid", tag.int64 },                       -- ID;
    { "nRankValue", tag.int },                          -- а
    { "nTempRankValue", tag.int },                      -- аʱ
})


