local init = {}
local file_list = {
    base_define = {
        "AchievementData", 
        "AdvertisingData", 
        "BoxData", 
        "ChallengeData", 
        "CountryRank", 
        "ExchangeCodeData", 
        "InvitationCodeData", 
        "MineMapData", 
        "MineMapRankRecordData", 
        "MsgBoardData", 
        "PlayerItemData", 
        "PlayerShopData", 
        "RankData", 
        "RoleData", 
        "ServerData", 
        "ShareData", 
        "ShopListData", 
        "SysRewardData", 
        "TopUpData", 
    },
    msg_c_s = {
        "msg_c_gs_achievement", 
        "msg_c_gs_advertising", 
        "msg_c_gs_bigmap", 
        "msg_c_gs_box", 
        "msg_c_gs_challenge", 
        "msg_c_gs_cooldown", 
        "msg_c_gs_country_rank", 
        "msg_c_gs_drift_bottle", 
        "msg_c_gs_exchange_code", 
        "msg_c_gs_getreward", 
        "msg_c_gs_inside_prompt", 
        "msg_c_gs_integral_wall", 
        "msg_c_gs_invitation_code", 
        "msg_c_gs_item", 
        "msg_c_gs_login", 
        "msg_c_gs_mine_map_record", 
        "msg_c_gs_msgboard", 
        "msg_c_gs_playerfeedback", 
        "msg_c_gs_ranking", 
        "msg_c_gs_recharge", 
        "msg_c_gs_reward", 
        "msg_c_gs_role", 
        "msg_c_gs_share", 
        "msg_c_gs_shop", 
        "msg_c_gs_topup", 
        "msg_c_ls_login", 
        "msg_c_rs_move", 
    },
    msg_process = {
        "msg_c_gs_achievement", 
        "msg_c_gs_advertising", 
        "msg_c_gs_bigmap", 
        "msg_c_gs_box", 
        "msg_c_gs_challenge", 
        "msg_c_gs_cooldown", 
        "msg_c_gs_country_rank", 
        "msg_c_gs_drift_bottle", 
        "msg_c_gs_exchange_code", 
        "msg_c_gs_getreward", 
        "msg_c_gs_inside_prompt", 
        "msg_c_gs_integral_wall", 
        "msg_c_gs_invitation_code", 
        "msg_c_gs_item", 
        "msg_c_gs_login", 
        "msg_c_gs_mine_map_record", 
        "msg_c_gs_msgboard", 
        "msg_c_gs_playerfeedback", 
        "msg_c_gs_ranking", 
        "msg_c_gs_recharge", 
        "msg_c_gs_reward", 
        "msg_c_gs_role", 
        "msg_c_gs_share", 
        "msg_c_gs_shop", 
        "msg_c_gs_topup", 
        "msg_c_ls_login", 
        "msg_c_rs_move", 
    },
}
function init.init()
    local list = {}
    for _, dir in pairs({"base_define", "msg_c_s", "msg_process" }) do
        for _, file in pairs(file_list[dir]) do
            list[#list+1] = 'app.net.ndp.'..dir..'.'..file
        end
    end
    return list
end

return init