local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM



--״̬
CMD_ENUM("class EChallengeNSReturnStatus", 
{
    ECNSRS_Success          =   0,
    ECNSRS_Fail             =   1,
    ECNSRS_EnterNotEnoughNum=   2,                      --
    ECNSRS_EnterInterval    =   3,                      --
    ECNSRS_HaveGet          =   4,                      --ȡ
    ECNSRS_NotCoolDown      =   5,                      --]е_srg
    ECNSRS_CoolDownCanUseAndNotEnoughNum=   6,          --]е_srg
})

-------------------------------------------------------------------------------
--ս
-------------------------------------------------------------------------------	
CMD_START("NC_EnterChallenge", {
    { "nGUID", tag.int64 },
    { "nX", tag.int },
    { "nY", tag.int },
})

CMD_START("NS_EnterChallenge", {
    { "nErrorCode", tag.int },
    { "nWidth", tag.int },
    { "nHeight", tag.int },
    { "nParam1", tag.int },                             --ʧǣҪѵǮ
    { "nADId", tag.int },
})

-------------------------------------------------------------------------------
--˳ս
-------------------------------------------------------------------------------	
CMD_START("NC_ExitChallenge", {
    { "nGUID", tag.int64 },
})

CMD_START("NS_ExitChallenge", {
    { "nErrorCode", tag.int },                          --EChallengeNSReturnStatus
})

-------------------------------------------------------------------------------
--ս
-------------------------------------------------------------------------------	
CMD_START("NC_BuyNumEnterChallenge", {
    { "nGUID", tag.int64 },
    { "nX", tag.int },
    { "nY", tag.int },
    { "nIsAD", tag.int },
    { "nADId", tag.int },
})

CMD_START("NS_BuyNumEnterChallenge", {
    { "nErrorCode", tag.int },
    { "nCurGold", tag.int },                            --ǰ
})

------------------------------------------------------------------------------
-- ʾϢ
------------------------------------------------------------------------------
CMD_START("NC_ChallengeUiInfo", {
    { "nGUID", tag.int64 },
})  

CMD_START("NS_ChallengeUiInfo", {
    { "nLastBombNumber", tag.short },
    { "nLastTimeSecond", tag.short },
})

------------------------------------------------------------------------------
-- һ
------------------------------------------------------------------------------
CMD_START("NC_ChallengeClickGrid", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_START("NS_ChallengeClickGrid", {
    { "nErrorCode", tag.int },                          --λȷ
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})

------------------------------------------------------------------------------
-- ״̬
------------------------------------------------------------------------------
-- 1. 귢
CMD_STRUCT("tagChallengeGrid", {
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nState", tag.byte },
})

CMD_START("NS_ChallengeGridStateChange", {
    { "byData", tag.tagChallengeGrid, tag.array },
})  

------------------------------------------------------------------------------
-- Ǹ
------------------------------------------------------------------------------
CMD_START("NC_ChallengeFlagGrid", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_START("NS_ChallengeFlagGrid", {
    { "nErrorCode", tag.int },                          --λȷ
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

------------------------------------------------------------------------------
-- ս
------------------------------------------------------------------------------
-- 1. 귢
CMD_ENUM("class EChallengeCompleteType", 
{
    ECCT_Win                =   0,
    ECCT_Fail               =   1,
})
CMD_START("NS_ChallengeComplete", {
    { "nCompleteType", tag.int },                       --EChallengeCompleteType
    { "nUserTime", tag.short },                         --ʹʱ
    { "nOldUserTime", tag.short },                      --ϴʹʱ
    { "nOldUserOriginalTime", tag.short },              --ϴʹõԭʼʱ
    { "nAddChallengeScore", tag.short },                --ӻ
    { "nReliveDiamond", tag.int },                      --Ҫʯ
})  

------------------------------------------------------------------------------
-- սλб
------------------------------------------------------------------------------
CMD_STRUCT("tagMsgChallengePointPos", {
    { "nId", tag.int },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nPointType", tag.byte },                         --0:Сͣ 1:
    { "nIsOpen", tag.bool },                            --Ƿ
})

CMD_START("NC_AllChallengePointPosList", {
    { "nGUID", tag.int64 },
})  

CMD_START("NS_AllChallengePointPosList", {
    { "byData", tag.tagMsgChallengePointPos, tag.array },
})  

------------------------------------------------------------------------------
-- սϢ
------------------------------------------------------------------------------
CMD_START("NC_ChallengePointInfo", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_START("NS_ChallengePointInfo", {
    { "nErrorCode", tag.int },                          --EChallengeNSReturnStatus
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nPointType", tag.int },                          --0:Сͣ 1:
    { "nPlayerId", tag.int64 },                         --ID 0û
    { "nPlayerName", tag.string, 32 },                  --
    { "nPlayerHeadUrlIndex", tag.int },                 --ͷ
    { "nCountryIndex", tag.int },                       --ͷ
    { "nChallengeTime", tag.int },                      --սʱ
    { "nCurPlayerChallengeNum", tag.short },            --ǰս
    { "nOriginalChallengeTime", tag.int },              --ԭʼսʱ
})  

------------------------------------------------------------------------------
-- սϸбϢ
------------------------------------------------------------------------------
CMD_STRUCT("tagMsgChallengePointInfo", {
    { "nId", tag.int },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nIsOpen", tag.bool },                            --Ƿ
    { "nPointType", tag.int },                          --0:Сͣ 1:
    { "nPlayerId", tag.int64 },                         --ID 0û
    { "nPlayerName", tag.string, 32 },                  --
    { "nPlayerHeadUrlIndex", tag.int },                 --ͷ
    { "nPlayerCountryIndex", tag.int },                 --ҹ
    { "nChallengeTime", tag.int },                      --սʱ
    { "nOriginalChallengeTime", tag.int },              --ԭʼսʱ
})

CMD_START("NC_ChallengePointListInfo", {
    { "nGUID", tag.int64 },
    { "nId", tag.int, tag.array },
})  

CMD_START("NS_ChallengePointListInfo", {
    { "sInfo", tag.tagMsgChallengePointInfo, tag.array },
})  

------------------------------------------------------------------------------
-- ·սλϢ
------------------------------------------------------------------------------
CMD_START("NS_OpenNewChallengePoint", {
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

------------------------------------------------------------------------------
-- ҹս
------------------------------------------------------------------------------
CMD_START("NC_BuyChallengeLife", {
    { "nGUID", tag.int64 },
    { "nDiamond", tag.int },
    { "nIsAD", tag.int },
})  

CMD_START("NS_BuyChallengeLife", {
    { "nGUID", tag.int64 },
    { "nReturnStatus", tag.short },                     --EChallengeNSReturnStatus
    { "nDiamond", tag.int },
})  

------------------------------------------------------------------------------
-- ҵ½Լս
------------------------------------------------------------------------------
CMD_START("NS_LoginContinueChallenge", {
    { "nLastTime", tag.int },                           -- ʣʱ
    { "nLastBombNum", tag.int },                        -- ʣ
    { "nMapWidth", tag.int },                           -- ͼ
    { "nMapHeight", tag.int },                          -- ͼ
    { "statusList", tag.byte, tag.array },              --
})  

------------------------------------------------------------------------------
-- սʣʱ
------------------------------------------------------------------------------
CMD_START("NC_RequestChallengeLastTime", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_RequestChallengeLastTime", {
    { "nReturnStatus", tag.int },                       -- ״̬ EChallengeNSReturnStatus
    { "nLastTime", tag.int },                           -- ʣʱ
}) 

------------------------------------------------------------------------------
-- ÿս
------------------------------------------------------------------------------
CMD_STRUCT("tagMsgDayChallengeReward", {
    { "nTableId", tag.int64 },
    { "nAddScore", tag.int },
})

CMD_START("NC_RequestDayChallengeReward", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_RequestDayChallengeReward", {
    { "nGUID", tag.int64 },
    { "reward", tag.tagMsgDayChallengeReward, tag.array },
}) 

------------------------------------------------------------------------------
-- ȡÿս
------------------------------------------------------------------------------
CMD_START("NC_GetDayChallengeReward", {
    { "nGUID", tag.int64 },
    { "nTableId", tag.int64 },
}) 

CMD_START("NS_GetDayChallengeReward", {
    { "nGUID", tag.int64 },
    { "nReturnStatus", tag.int },                       -- ״̬ EChallengeNSReturnStatus
    { "nTableId", tag.int64 },
    { "nAddScore", tag.int },
}) 

--__NDPROTOCOL_MSG_CHALLENGE_H__