local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM



CMD_ENUM("ERechargeReturnStatus", 
{
    ERechargeReturnStatus_Succeess=   0,
    ERechargeReturnStatus_Fail=   1,
})

--ֵ
CMD_ENUM("EMsgRechargeType", 
{
    EMsgRechargeType_Null   =   0,                      --
    EMsgRechargeType_Google =   1,                      --googleplay
    EMsgRechargeType_Ios    =   2,                      --iOSapp
    EMsgRechargeType_Alipay =   3,                      --֧
})

------------------------------------------------------------------------------
-- iOSֵ(java -> WS)
------------------------------------------------------------------------------
CMD_START("NJ2W_IOSRechargeComplete", {
    { "szChannelOrderID", tag.string, 50 },             -- Ͷ
    { "szProductID", tag.string, 50 },                  -- ƷID
    { "nProductCount", tag.int },                       -- Ʒ
    { "nGUID", tag.int64 },                             -- GUID
    { "szMD5", tag.string, 50 },                        -- MD5SIGN
}) 

-- javaɹʶ
CMD_ENUM("", 
{
    E_RequestSuccess        =   1000,                   -- ɹ
    E_RequestFail           =   1001,                   -- ʧ
    E_RequestSvrList        =   9999,
})

-- javaĴԭ
CMD_ENUM("", 
{
    E_OrderSuccess          =   0,                      -- ɹ
    E_OrderIsExist          =   1,                      -- öѾʹù
    E_OrderDataIsNull       =   2,                      -- ݲ
    E_OrderNetWorkError     =   3,                      -- 
    E_OrderPlayerIsNull     =   4,                      -- Ҳ
    E_OrderMD5FAIL          =   5,                      -- MD5Уʧ
})

------------------------------------------------------------------------------
-- javaϢ(WS -> java)
------------------------------------------------------------------------------
CMD_STRUCT("tagNW2J_IOSRechargeComplete", {
    { "nIsSuccess", tag.int },                          -- Ƿɹ(1000:ɹ 0:ʧ)
    { "nErrorCode", tag.int },                          -- ʧԭ
})


CMD_STRUCT("tagNW2JGM", {
    { "nIsSuccess", tag.int },                          -- Ƿɹ(1000:ɹ 0:ʧ)
    { "nErrorCode", tag.int },                          -- ʧԭ
    { "nList", tag.string, tag.array },
})

------------------------------------------------------------------------------
-- iosֵ֪ͨGSʯ(WS -> GS)
------------------------------------------------------------------------------
CMD_START("NW2S_IOSRechargeComplete", {
    { "nGUID", tag.int64 },                             -- GUID
    { "nDiamondNum", tag.int },                         -- ʯ
    { "nRewardGiftId", tag.int },                       -- ID
})

------------------------------------------------------------------------------
-- iosֵ֪ͨGSʯ(GS -> GW)
------------------------------------------------------------------------------
CMD_START("NS_IOSRechargeComplete", {
    { "nGUID", tag.int64 },                             -- GUID
    { "nDiamondNum", tag.int },                         -- ʯ
})

--__NDPROTOCOL_MSG_RECHARGE_H__
