local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM
-------------------------------------------------------------------------------
-- filename: msg_c_gs_shop.h
-- author: liuchang
-- actor:
-- data: 2017-6-12
-- last: 2017-6-12
-- brief: Ʒ
-------------------------------------------------------------------------------



CMD_ENUM("EMsgShopItemReturn", 
{
    EMsgBuyShopItemReturn_Success=   0,                 --ɹ	
    EMsgBuyShopItemReturn_Fail=   1,                    --ʧ
    EMsgBuyShopItemReturn_NotEnough=   2,               --Ѳ
    EMsgBuyShopItemReturn_NotBuy=   3,                  --ܹ
    EMsgBuyShopItemReturn_NotLevelUp=   4,              --
    EMsgBuyShopItemReturn_Have=   5,                    --ӵƷ
    EMsgBuyShopItemReturn_NotHave=   6,                 --ûƷ
})


------------------------------------------------------------------------------
-- ̵Ʒ
------------------------------------------------------------------------------
CMD_START("NC_RequestAllShopItem", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_RequestAllShopItem", {
    { "itemData", tag.tagPlayerItem, tag.array },       --ƷϢ
}) 

------------------------------------------------------------------------------
-- Ʒ
------------------------------------------------------------------------------
CMD_START("NC_BuyShopItem", {
    { "nGUID", tag.int64 },
    { "nItemID", tag.int },
}) 

CMD_START("NS_BuyShopItem", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn
    { "nItemID", tag.int },                             --֮ǰƷID
    { "nCostType", tag.int },                           --
    { "nCostNum", tag.int },                            --ĸ
}) 

------------------------------------------------------------------------------
--̵Ʒ
------------------------------------------------------------------------------
CMD_START("NC_ShopItemLevelUp", {
    { "nGUID", tag.int64 },
    { "nItemID", tag.int },
}) 

CMD_START("NS_ShopItemLevelUp", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn
    { "nOldItemID", tag.int },                          --֮ǰƷID
    { "nNewItemId", tag.int },                          --ƷID
    { "nCostType", tag.int },                           --
    { "nCostNum", tag.int },                            --ĸ
}) 

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_BuyLife", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_BuyLife", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn
    { "nLifeNum", tag.int },                            --ǰ
    { "nNextCostNum", tag.int },                        --´λ
}) 

------------------------------------------------------------------------------
-- ʯһ
------------------------------------------------------------------------------
CMD_START("NC_DiamondExchangeMoney", {
    { "nGUID", tag.int64 },
    { "nShopId", tag.int },
}) 

CMD_START("NS_DiamondExchangeMoney", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn_
})

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_ExchangeTheme", {
    { "nGUID", tag.int64 },
    { "nThemeId", tag.int },
}) 

CMD_START("NS_ExchangeTheme", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn_
    { "nThemeId", tag.int },
})

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_ExchangeCursor", {
    { "nGUID", tag.int64 },
    { "nCursorId", tag.int },
}) 

CMD_START("NS_ExchangeCursor", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn_
    { "nCursorId", tag.int },
})

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_ExchangeFlag", {
    { "nGUID", tag.int64 },
    { "nFlagId", tag.int },
}) 

CMD_START("NS_ExchangeFlag", {
    { "nErrorCode", tag.int },                          --EMsgShopItemReturn_
    { "nFlagId", tag.int },
})


