local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM
-------------------------------------------------------------------------------
-- filename: msg_login.h
-- author: chdeng
-- actor:
-- data: 2015-09-02
-- last: 2015-09-02
-- brief: ҵ¼Ϣ
-------------------------------------------------------------------------------



-------------------------------------------------------------------------------
-- ֤
-------------------------------------------------------------------------------
CMD_ENUM(" ELoginType", 
{
    ELoginType_Tourist      =   0,                      --ο
    ELoginType_Normal       =   1,                      --ͨ½
    ELoginType_Facebook     =   2,                      --Facebook½
    ELoginType_Locojoy      =   3,                      --locojoy½
    ELoginType_Device       =   4,                      --豸½
    ELoginType_WeChat       =   5,                      --΢ŵ½

    ELoginType_Unknow       =   100,                    --δ֪
})

-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------
CMD_ENUM("", 
{
    E_Login_Success         =   0,                      -- ½ɹ
    E_Login_VerfiyAbnormal  =   1,                      -- ֤쳣
    E_Login_Verfiying       =   2,                      -- ֤ Ե
    E_Login_AccountDotExist =   3,                      -- ʺŲ
    E_Login_PasswordError   =   4,                      -- 
    E_Login_HaveOnLine      =   5,                      -- Ѿ
    E_Login_Reload          =   6,                      -- Ҷ
    E_Login_ServerFull      =   7,                      -- ع,ݲɽ
    E_Login_Name_Is_Null    =   8,                      -- ˺ǿ
    E_Login_Version         =   9,                      -- 汾
    E_Login_Replace         =   10,                     -- 
    E_Login_AccountNoSame   =   11,                     -- ƽ̨ʺGUIDNodeʺŲͬ
    E_Login_GsEmpty         =   12,                     -- ޻ԾGs
    E_Login_DsEmpty         =   13,                     -- ޻ԾDs
    E_Login_DsEmpty1        =   14,                     -- ޻ԾDs
    E_Login_GUIDRepeat      =   15,                     -- GUIDظ
    E_Login_NewAccountTooMany=   16,                    -- ˺̫Ժ
    E_Login_LoginTypeError  =   17,                     -- ½ʹ
    E_Login_CreateAccountError=   18,                   -- ˺ʧ
    E_Login_GatewayError    =   19,                     -- ش


    E_Login_Plat_Sign       =   1000 + 2,               -- SignУʧ
    E_Login_Plat_GameID     =   1000 + 3,               -- ȱGameId
    E_Login_Plat_GameID2    =   1000 + 4,               -- GameIdЧ
    E_Login_Plat_Session    =   1000 + 5,               -- ȱSession
    E_Login_Plat_Session2   =   1000 + 6,               -- Sessionʽ
    E_Login_Plat_Session    =   1000 + 5,               -- ȱSession
    E_Login_Plat_ServerID   =   1000 + 8,               -- ȱServerId
    E_Login_Plat_ServerID2  =   1000 + 9,               -- ServerIdЧ
    E_Login_Plat_SelfChannel=   1000 + 10,              -- ȱSelfChannel
    E_Login_Plat_SelfChannel2=   1000 + 11,             -- SelfChannelЧ
    E_Login_Plat_Ip         =   1000 + 12,              -- ȱIp
    E_Login_Plat_DeviceID   =   1000 + 13,              -- ȱDeviceId
    E_Login_Plat_Other      =   1000 + 99,              -- 

    E_Login_Reject_Base     =   1500,                   -- Żֵ
    E_Login_Reject_AccountSafeAbnor=   1501,            -- ʺŰȫ쳣
    E_Login_Reject_GameDataAbnor=   1502,               -- Ϸ쳣
    E_Login_Reject_UseThirdSoft=   1503,                -- õ
    E_Login_Reject_SpreadForbidChat=   1504,            -- Υ
    E_Login_Reject_CirticalEvent=   1505,               -- ¼ϵ
    E_Login_Reject_OtherReason=   1599,                 -- ԭͣ


    E_Login_KillOff_DS_ShutDown=   2000 + 1,            -- DS崻
    E_Login_KillOff_GS_ShutDown=   2000 + 2,            -- GS崻
    E_Login_KillOff_RS_ShutDown=   2000 + 3,            -- RS崻

    E_Login_ServerRestart   =   3000 +1,                -- ;


    E_Login_Locojoy_Login_Connect_lost=   4000 + 1,     -- 

})

--Ϣ
CMD_STRUCT("tagMsgServerInfo", {
    { "nClientShowServerId", tag.int },
    { "szClientShowServerName", tag.string, 32 },       --
    { "nServerStatus", tag.int },                       --״̬
})

-------------------------------------------------------------------------------
-- ͻӵһϢ֤.ͨΪϷû
-------------------------------------------------------------------------------
CMD_START("NC_EnterLogin", {
    { "szVersion", tag.string, 64 },
})

CMD_START("NS_EnterLogin", {
    { "nErrorCode", tag.int },
})

-------------------------------------------------------------------------------
-- ʺͨlocojoyƽ̨½
-------------------------------------------------------------------------------
CMD_START("NC_LocojoyLoginSession", {
    { "nChannelID", tag.int },                          -- ͻ˰,˺
    { "szAccountId", tag.string, 64 },                  -- ƽ̨ʺID
    { "szIp", tag.string, 128 },                        -- IP
    { "szDeviceId", tag.string, 128 },                  -- 豸
    { "szSession", tag.string, 1024 },                  -- session
})

-------------------------------------------------------------------------------
-- ʺŵ½
-------------------------------------------------------------------------------
CMD_START("NC_LoginVerfiy", {
    { "nLoginType", tag.byte },                         --ELoginType
    { "szAccountName", tag.string, 64 },                --˺
    { "szPassword", tag.string, 64 },                   --
    { "szBotFlag", tag.string, 32 },                    --˱λ
})

CMD_START("NS_LoginVerfiy", {
    { "nErrorCode", tag.int },                          -- E_Login_*
    { "nGUID", tag.int64 },                             --ID
    { "szAccountName", tag.string, 64 },                --˺
    { "szPassword", tag.string, 64 },                   --
    { "nLastServerId", tag.int },                       --ϴηID
    { "szGatewayDomainName", tag.string, 64 },          --
    { "szGatewayPort", tag.int },                       --ض˿
    { "nLoginType", tag.byte },                         --ELoginType
})

CMD_START("NC_ServerList", {
    { "nClientSessionId", tag.int64 },                  --ͻsessionIdãͻ˲ùܣ
})

CMD_START("NS_ServerList", {
    { "nClientSessionId", tag.int64 },                  --ͻsessionIdãͻ˲ùܣ
    { "recommendServerInfo", tag.tagMsgServerInfo },    --ƼϢ
    { "serverInfo", tag.tagMsgServerInfo, tag.array },  --Ϣ
})

--------------------------------------------------------------------------
--------------------------------------------------------------------------
--------------------------------------------------------------------------





-------------------------------------------------------------------------------
-- ʹУsessionе¼
-- 
-------------------------------------------------------------------------------

CMD_START("NC_LoginSession", {
    { "nChannelID", tag.int },                          -- ͻ
    { "szUserName", tag.string, 32 },                   -- ʺ
    { "szPassWord", tag.string, 32 },                   -- 
    { "szIp", tag.string, 128 },                        -- IP
    { "szDeviceId", tag.string, 128 },                  -- 豸
    { "szSession", tag.string, 1024 },                  -- session
})

CMD_START("NS_KickPlayer", {
    { "nGuid", tag.int64 },
    { "nReason", tag.int },                             -- ԭ		EKickPlayerReason
})


-------------------------------------------------------------------------------
-- ҸϢУ
-- 
-------------------------------------------------------------------------------
CMD_START("NC_PlayerIdCard", {
    { "nGuid", tag.int64 },
    { "szName", tag.string, 16 },                       -- 
    { "szIDCard", tag.string, 30 },                     -- ֤
})

-------------------------------------------------------------------------------
-- У
-- 
-------------------------------------------------------------------------------
CMD_START("NS_PlayerIdCard", {
    { "nGuid", tag.int64 },
    { "nReturn", tag.int },                             -- -1:֤0:Уɹˣ1:Уʧܣδ; 2:Ϊȫ
})

-------------------------------------------------------------------------------
-- У
-- 
-------------------------------------------------------------------------------
CMD_START("NS_PlayerRemainderTime", {
    { "nGuid", tag.int64 },
    { "nCheckState", tag.char },                        -- УȷϢ 0:Уͨ 1: δУ, 2:δͨУ
    { "nPlayerRemainderTime", tag.int },                -- ʣʱ -1ýзƣڵ 0 ƣʣʱ䣩
})

-------------------------------------------------------------------------------
-- Ѷƽ̨ĵ¼
-------------------------------------------------------------------------------
CMD_START("NC_LoginTencent", {
    { "szOpenID", tag.string, 64 },                     -- ͻ
    { "szOpenKey", tag.string, 64 },                    -- ʺ
    { "szseqid", tag.string, 64 },                      -- ζ¼
    { "szUserIp", tag.string, 64 },                     -- ҵIP
    { "szDeviceId", tag.string, 64 },                   -- 豸
})

-- Ѷƽ̨صĴϢԭظͻ	ȷ᷵ظͻ
CMD_START("NS_LoginTencentError", {
    { "nError", tag.int },                              -- ظͻ˵ѶϢ Ϊ0json 
    { "szErroMsg", tag.string, 128 },                   -- ظͻ˵ѶϢʾ
})

-- Ѷƽ̨openkey
CMD_START("NC_TencentOpenKeyRenew", {
    { "nGuid", tag.int64 },
    { "szOpenID", tag.string, 64 },                     -- ͻ
    { "szOpenKey", tag.string, 64 },                    -- ʺ
    { "szUserIp", tag.string, 32 },                     -- IP
})

-- Ѷƽ̨openkey
CMD_START("NS_TencentOpenKeyRenew", {
    { "nReturn", tag.int },                             -- ظͻ˵Ѷ룬0ʶɹ
    { "szErroMsg", tag.string, 128 },                   -- ظͻ˵ѶϢʾ
})

-- Ѷƽ̨
CMD_START("NC_TencentBlueVip", {
    { "nGuid", tag.int64 },
    { "szOpenID", tag.string, 64 },                     -- ͻ
    { "szOpenKey", tag.string, 64 },                    -- ʺ
    { "szUserIp", tag.string, 64 },                     -- IP
})

-- Ѷƽ̨
CMD_START("NS_TencentBlueVip", {
    { "is_blue_vip", tag.int },                         -- Ƿ꣬ 1ʾǣ0ʾ
    { "is_blue_year_vip", tag.int },                    -- Ƿꣻ1ʾǣ0ʾ
    { "is_super_blue_vip", tag.int },                   -- Ƿꣻ1ʾǣ0ʾ
    { "is_expand_blue_vip", tag.int },                  -- Ƿ񳬼ꣻ1ʾǣ0ʾ
    { "blue_vip_level", tag.int },                      -- ȼ
    { "is_have_growth", tag.int },                      -- Ƿ߱ɳֵ1ʾǣ0ʾ
    { "is_mobile_blue_vip", tag.int },                  -- Ƿֻꣻ1ʾǣ0ʾ
    { "server_time", tag.int },                         -- ʱ䣬ڱȽ꿪ͨʱ͵ʱ䣬unixʱλΪ
    { "vip_reg_time", tag.int },                        -- 꿪ͨʱ䣬unixʱλΪ
    { "year_vip_reg_time", tag.int },                   -- 꿪ͨʱ䣬unixʱλΪ
    { "super_vip_reg_time", tag.int },                  -- 꿪ͨʱ䣬unixʱλΪ
    { "expand_vip_reg_time", tag.int },                 -- 꿪ͨʱ䣬unixʱλΪ
    { "vip_valid_time", tag.int },                      -- 굽ʱ䣬unixʱλΪ
    { "year_vip_valid_time", tag.int },                 -- 굽ʱ䣬unixʱλΪ
    { "super_vip_valid_time", tag.int },                -- 굽ʱ䣬unixʱλΪ
    { "expand_vip_valid_time", tag.int },               -- 굽ʱ䣬unixʱλΪ
})

-- Ѷֵ
CMD_START("NC_CreateTencentOrder", {
    { "nGuid", tag.int64 },                             --
    { "szOpenID", tag.string, 64 },                     --
    { "szOpenKey", tag.string, 64 },                    --
    { "szIp", tag.string, 32 },                         -- IP
    { "szOrderID", tag.string, 30 },                    -- ID
    { "szDeviceInfo", tag.string, 256 },                -- ֱȡmac, idfa(׿android_id)imei, ùܵ|ַָ
    { "szPfkey", tag.string, 64 },                      --
    { "szManyouID", tag.string, 64 },                   -- ID;		-- 
})

CMD_START("NS_CreateTencentOrder", {
    { "nGuid", tag.int64 },                             --
    { "nRet", tag.int },                                -- صĴ
    { "szMsg", tag.string, 128 },                       -- صĶ
    { "szToken", tag.string, 64 },                      -- token
    { "szUrlParmas", tag.string, 1024 },                -- Ʒurl
})

-- ȡȡѶ״̬
CMD_START("NC_LoadTencentGiftState", {
    { "nGuid", tag.int64 },                             --
})

CMD_START("NS_LoadTencentGiftState", {
    { "bNewPlayerGift", tag.char },                     -- Ƿȡ
    { "bBlueGift", tag.char },                          -- Ƿȡ
    { "bYearGift", tag.char },                          -- Ƿȡ
    { "bSupperGift", tag.char },                        -- Ƿȡճ
    { "nReceiveLvGiftNum", tag.int },                   -- Ѿȡҵȼ
    { "nPlayerLv", tag.int, 1 },                        -- Ѿȡĵȼȼ
})

-- Ѷ
CMD_ENUM("ENumTencentGiftType", 
{
    E_TentGiftType_NewPlayer=   0,
    E_TentGiftType_BlueVip  =   1,
    E_TentGiftType_Year     =   2,
    E_TentGiftType_Super    =   3,
    E_TentGiftType_PlayerLv =   4,
})

-- ȡѶ
CMD_START("NC_ReceiveTencentGift", {
    { "nGuid", tag.int64 },                             --
    { "nGiftType", tag.int },                           -- Ѷ	0., 1.ÿ꣬1.ÿ,2.ÿճ,3.ҵȼ
    { "nGiftID", tag.int },                             -- IDҵȼID
})

CMD_START("NS_ReceiveTencentGift", {
    { "nErrorID", tag.int },                            -- ȡID1:Ѿȡ2:ûȨȡ, 3.-1,ϵͳ
    { "nGiftType", tag.int },                           -- Ѷ
    { "nGiftData", tag.int },                           -- ȡĸݣȡĵȼȼ
})

-- ȡеѶݣȡ곬
CMD_START("NC_ReceiveTencentGiftAll", {
    { "nGuid", tag.int64 },                             --
})

CMD_START("NS_ReceiveTencentGiftAll", {
    { "nErrorID", tag.int },                            -- ȡID0,ɹ1ûпȡ,2ûȨȡ3-1ϵͳ
    { "bBlueGift", tag.char },                          -- Ƿȡ
    { "bYearGift", tag.char },                          -- Ƿȡ
    { "bSupperGift", tag.char },                        -- Ƿȡճ
})

-------------------------------------------------------------------------------
-- Ϸ
-------------------------------------------------------------------------------
CMD_START("NC_EnterSns", {
})

CMD_START("NS_EnterSns", {
    { "nError", tag.int },
})

-------------------------------------------------------------------------------
-- QQ
-------------------------------------------------------------------------------
CMD_START("NC_RequestQQFriend", {
    { "nGuid", tag.int64 },                             --
    { "szOpenID", tag.string, 33 },
    { "szOpenKey", tag.string, 33 },
})

-------------------------------------------------------------------------------
-- QQ
-------------------------------------------------------------------------------
CMD_STRUCT("tagQQFriendOpenIDData", {
    { "szOpenID", tag.string, 33 },
})

CMD_START("NS_RequestQQFriend", {
    { "nGuid", tag.int64 },                             --
    { "sQQFriendOpenID", tag.tagQQFriendOpenIDData, tag.array },
})

-- qqѷصĴϢ
CMD_START("NS_RequestQQFriendReturn", {
    { "nReturn", tag.int },
    { "szErrorMsg", tag.string, 512 },                  -- صĴϢ
})


-- SnsIpͶ˿ڷ͸ͻ
CMD_START("NS_SendSnsData2Player", {
    { "szIp", tag.string, 32 },
    { "nPort", tag.int },
})





