local FullBoxView = class("FullBoxView", cc.load("mvc").LayoutBase)
FullBoxView.RESOURCE_FILENAME = "Box.FullBoxView"

function FullBoxView:onCreate()
    self.adCoolDown = {}
end

function FullBoxView:onEnter()
    self.ui.OK:onSetText(static.language[10001][device.language])
    self.ui.Cancel:onSetText(static.language[10002][device.language])
end

function FullBoxView:setCDS(cd1, cd2, cd3, cd4)
    self.adCoolDown = {}
    table.insert(self.adCoolDown, cd1)
    table.insert(self.adCoolDown, cd2)
    table.insert(self.adCoolDown, cd3)
    table.insert(self.adCoolDown, cd4)
end

function FullBoxView:onExit()

end

function FullBoxView:setkey(id)
    self.time = 0
    self.id = id
    self.curbox = nil
    for _,v in pairs(static.box) do
        if id == v.id then
            self.time = math.ceil(v.cdTime/60)
            self.curbox = v
        end
    end
    self.ui.Cost:setString(self.curbox.boxOpenNum)
    if self.curbox.boxLevel == 1 then
        self.ui.Box:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
    elseif self.curbox.boxLevel == 2 then
        self.ui.Box:loadTexture("Image/donghua/png/saolei/chest2_0.png",0)
    elseif self.curbox.boxLevel == 3 then
        self.ui.Box:loadTexture("Image/donghua/png/saolei/chest3_0.png",0)
    else
        self.ui.Box:loadTexture("Image/donghua/png/saolei/chest4_0.png",0)
    end
    mdt.curboxid = id
end

-- Event for Yes callback (addClickEventListener)
function FullBoxView:OnClick(node, eventType, userdata)
    if tonumber(userdata) == 1 then
        if mdt.player.diamond < self.curbox.boxOpenNum then
            util.showDialog(nil,'Common.NotEnough'):setkey(3)
        else   
   
            self:checkADToOpenBox(self.id)

            util.playClose(self)
        end
    else
        net.msg.NC_OpenOvertopBox(self.id,0)
        util.playClose(self)
    end
end

function FullBoxView:checkADToOpenBox(boxid)
    local adid = 0
    for k, v in pairs(self.adCoolDown) do
        if v == 0 then
            adid = k
            break
        end
    end

    if adid == 0 or not AdManager:isADAvailable(99) then --ûп
        net.msg.NC_OpenOvertopBox(boxid, 1)
    else
        local view = util.showDialog('Dialog', 'Common.ADBoxDialog')
            view:setPageType(mdt.ADS_COOLDOWN_ID["BOX"], function () 
            net.msg.NC_OpenOvertopBox(boxid, 1, adid)
            end, function () 
            mdt.curboxid = boxid
            net.msg.NC_OpenOvertopBox(boxid, 1)
            end)
    end
end

return FullBoxView
