local CellAction = class("CellAction", cc.load("mvc").LayoutBase)
CellAction.RESOURCE_FILENAME = "Cell.CellAction"

function CellAction:onCreate()

end

function CellAction:onEnter()
    
end

function CellAction:onExit()
    if self.closeListener then
        self.closeListener()
    end
end

function CellAction:setState(state)
    if state==0 then
        self:play('Wait', true)
    elseif state==1 then
        self:play('Click', false)
    elseif state==2 then
        self:play('Sweep', false)
    elseif state==3 then
        self:play('Wrong', false)
    end
end

function CellAction:setCloseListener(func)
    self.closeListener = func
end

-- Event for Click callback (addClickEventListener)
function CellAction:onClose(node, eventType, userdata)

end

-- Event for ui frame animation
function CellAction:onEnd(node, frame)

end

return CellAction
