local CellChallenge = class("CellChallenge", cc.load("mvc").LayoutBase)
CellChallenge.RESOURCE_FILENAME = "Challenge.CellChallenge"

function CellChallenge:onCreate()
    self:addEvent('NS_ChallengePointInfo')
end

function CellChallenge:onEnter()

end

function CellChallenge:onExit()

end

function CellChallenge:setLocation(x, y)
    self.x=x
    self.y=y
    self:setPosition(x*mdt.CW, y*mdt.CW)
    local fo = mdt.getChallenge(self.x, self.y)
    local data = fo.data
    if data and data.nPlayerId.v~=0 then
        self.ui.name:setString(data.nPlayerName)
        self.ui.Pic:setInfo(data.nPlayerId, data.nPlayerHeadUrlIndex, data.nCountryIndex)
    else
        self.ui.name:setString('------')
    end
    
    util.scheduleNode(30, function()
        net.msg.NC_ChallengePointInfo(self.x, self.y)
    end, self)
    net.msg.NC_ChallengePointInfo(self.x, self.y)
end

function CellChallenge:NS_ChallengePointInfo(ev, ns)
--    dump(ns)
    if ns.nPosX==self.x and ns.nPosY==self.y then
        if ns.nPlayerId.v~=0 then
            self.ui.name:setString(ns.nPlayerName)
        else
            self.ui.name:setString('------')
        end
        self.ui.Pic:setInfo(ns.nPlayerId, ns.nPlayerHeadUrlIndex, ns.nCountryIndex)
    end
end

-- Event for btnChallenge callback (addClickEventListener)
function CellChallenge:onClick(node, eventType, userdata)
    if mdt.isclickchallenge == nil then
        mdt.isclickchallenge = true
    end
    if mdt.isclickchallenge then
        util.showDialog('Dialog', 'Challenge.ChallengeInfo'):setLocation(self.x, self.y)
    end
end

return CellChallenge
