local ChallengeUI = class("ChallengeUI", cc.load("mvc").LayoutBase)
ChallengeUI.RESOURCE_FILENAME = "Themes.Theme0.ChallengeUI"

function ChallengeUI:onCreate()
    self:addEvent('NS_SyncBaseInfo')
    self:addEvent('NS_SyncLifeInfo')
    self:addEvent('NS_ChallengeUiInfo')
    self:addEvent('NS_ChallengeGridStateChange')
    self:addEvent('NS_ChallengeComplete')
    self:addEvent('NS_BuyChallengeLife')
    self:addEvent('NS_RequestChallengeLastTime')
    self:addEvent('ChangeChallengeFace')
--    if mdt.mode==2 then
--        self.ui.Shave:setSelected(true)
--    else
--        self.ui.Shave:setSelected(false)
--    end
    self:NS_SyncBaseInfo()
    self:NS_SyncLifeInfo()
    self:runAnimation()
    if mdt.chainfo ~= nil then
        self:Onsetinfo()
    end
    
    util.scheduleNode(1, function()
        if self.nLastTimeSecond then
            if self.isStart then
                self.nLastTimeSecond = self.nLastTimeSecond-1
                if self.nLastTimeSecond<0 then
                    self.nLastTimeSecond = 0
                end
            end
            self.ui.Times:setString(self.nLastTimeSecond)
        end
    end, self)
    self.ui.Times:setString('------')
end

function ChallengeUI:onEnter()
    self.lifeCooldown = "err"
    net.msg.NC_RequestAllCoolDownItem()
end

function ChallengeUI:onExit()

end

function ChallengeUI:ChangeChallengeFace(ev,key)
    if self.delay ~= nil then
        util.unschedule(self.delay)
    end
    if key == 1 then
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_03.png",0)
    else
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_02.png",0)
    end
    self.delay = util.delay(0.3, function()
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_01.png",0)
    end)
end

function ChallengeUI:NS_RequestChallengeLastTime(ev,ns)
    self.nLastTimeSecond = ns.nLastTime
    self.ui.Times:setString(ns.nLastTime)   
    self.isStart = true
end

function ChallengeUI:Onsetinfo()
    self.nLastTimeSecond = mdt.chainfo.nLastTime
    self.ui.Times:setString(mdt.chainfo.nLastTime)
    if mdt.chainfo ~= nil then
        net.msg.NC_RequestChallengeLastTime()
    end
    self.ui.Mines:setString(mdt.chainfo.nLastBombNum)
end

--ʾǷս
function ChallengeUI:Call_ShowBuyConfirm(ns)
        if util.isShowDialog('Common.ConfirmDialog') then return end
        local view = util.showDialog('Dialog','Common.ConfirmDialog')
        view:setkey(ns.nReliveDiamond,function ()
            if mdt.player.diamond < ns.nReliveDiamond then
                util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
            else
                mdt.challengelife = ns.nReliveDiamond
                net.msg.NC_BuyChallengeLife(ns.nReliveDiamond, 0)
                if tonumber(ns.nReliveDiamond) == 100 then 
                    if mdr.ChallengePayF == nil then
                        mdr.ChallengePayF = false
                        mdr.save()
                    end
                    if not mdr.ChallengePayF then
                        sdkManager.talkingdata:setEvent("57",{CBuy1Num = "CBuy1Num"})
                        sdkManager.appsflyer:setEvent("57",{CBuy1Num = "CBuy1Num"})
                        mdr.ChallengePayF = true
                        mdr.save()
                    end
                    sdkManager.talkingdata:setEvent("56",{CBuy1 = "CBuy1"})
                    sdkManager.appsflyer:setEvent("56",{CBuy1 = "CBuy1"})
                elseif tonumber(ns.nReliveDiamond) == 200 then
                    if mdr.ChallengePayS == nil then
                        mdr.ChallengePayS = false
                        mdr.save()
                    end
                    if not mdr.ChallengePayS then
                        sdkManager.talkingdata:setEvent("60",{CBuy2Num = "CBuy2Num"})
                        sdkManager.appsflyer:setEvent("60",{CBuy2Num = "CBuy2Num"})
                        mdr.ChallengePayS = true
                        mdr.save()
                    end
                    sdkManager.talkingdata:setEvent("58",{CBuy2 = "CBuy2"})
                    sdkManager.appsflyer:setEvent("58",{CBuy2 = "CBuy2"})
                else
                    if mdr.ChallengePayT == nil then
                        mdr.ChallengePayT = false
                        mdr.save()
                    end
                    if not mdr.ChallengePayT then
                        sdkManager.talkingdata:setEvent("61",{CBuy3Num = "CBuy3Num"})
                        sdkManager.appsflyer:setEvent("61",{CBuy3Num = "CBuy3Num"})
                        mdr.ChallengePayT = true
                        mdr.save()
                    end
                    sdkManager.talkingdata:setEvent("59",{CBuy3 = "CBuy3"})
                    sdkManager.appsflyer:setEvent("59",{CBuy3 = "CBuy3"})
                end

                util.closeDialog('Common.ConfirmDialog')
            end
        end,
        3,30109,true)

end

function ChallengeUI:NS_ChallengeComplete(ev, ns)
    self.isStart = false
    if ns.nCompleteType == 1 and ns.nUserTime <= 600 then
        event.dispatch('onShake')
        audio.playEffect('boom')
        event.dispatch('onPlayBoom')
        if ns.nReliveDiamond ~= 0 then
            if ns.nReliveDiamond == 10 and AdManager:isADAvailable(99) then
                if not util.isShowDialog('Common.ADDialog') then 
                    local view = util.showDialog('Dialog', 'Common.ADDialog')
                    view:saveTempData(ns, 2)
                    return
                end
            end

            self:Call_ShowBuyConfirm(ns)
        else
           self.isComplete = true 
        end
    else
        self.isComplete = true 
    end
end

function ChallengeUI:NS_BuyChallengeLife(ev,ns)
    if ns.nReturnStatus == 0 then
        if mdr.ChallengePay == nil then
            mdr.ChallengePay = false
            mdr.save()
        end
        if not mdr.ChallengePay then
            sdkManager.talkingdata:setEvent("62",{Ctotal = "Ctotal"})
            sdkManager.appsflyer:setEvent("62",{Ctotal = "Ctotal"})
            mdr.ChallengePay = true
            mdr.save()
        end
        self.isStart = true
    end
end

function ChallengeUI:NS_ChallengeUiInfo(ev, ns)
    self.ui.Mines:setString(ns.nLastBombNumber)
    self.nLastTimeSecond = ns.nLastTimeSecond
    if not self.isStart then
        self.ui.Times:setString(self.nLastTimeSecond)
    end
end

function ChallengeUI:NS_ChallengeGridStateChange(ev, ns)
    self.isStart = true
end

-- Event for Menu callback (addClickEventListener)
function ChallengeUI:onMenu(node, eventType, userdata)
    ctr.player.showMessageBox(static.language[30082][device.language], 2, function(ok)
        if ok then
            net.msg.NC_LoadMap()
            net.msg.NC_ExitChallenge()
        end
    end)
end

-- Event for Shave callback (addEventListener)
function ChallengeUI:onShave(node, eventType, userdata)
    if eventType==0 then
        mdt.mode=2
    else
        mdt.mode=1
    end
    event.dispatch('onRefreshCell')
end

function ChallengeUI:NS_SyncBaseInfo()
--    self.ui.myFlagsSet:setString(mdt.findBlobs)
--    self.ui.myCellsOpen:setString(mdt.openGrids)
end

function ChallengeUI:NS_SyncLifeInfo()
--    mdt.life = mdt.life or 0
--    if self.life and self.life>mdt.life then
--        --self:play('lifedown')
--        self.ui.HeartSprite:setAnimation(1, 'animation', false)
--    end
--    self.life = mdt.life
--    self.ui.myLife:setString(mdt.life)
--    self.psHeart:setPercentage(cc.clampf(mdt.life, 0, 5)*20)
--    self:refreshTM()
end

return ChallengeUI
