local AniBtn = class("AniBtn", cc.load("mvc").LayoutBase)
AniBtn.RESOURCE_FILENAME = "Common.Button.ButtonGreen"

local clicked = false

function AniBtn:onCreate()

end

function AniBtn:onEnter()
    util.delay(0, function()
        if self.UserData then
            self.ui.btn:setTitleText(self.UserData[1])
        end
    end)
    self:runAnimation()
    self.parent = self:getParent()
    self.parent:addClickEventListener(function(node,eventType)
        self:onClick(self, nil)
    end)
end

function AniBtn:onExit()
    clicked = false
end

-- Event for Image_1 callback (addClickEventListener)
function AniBtn:onClick(node, eventType, userdata)
--    print(clicked)
--print(eventType)
    if eventType==nil then
        if clicked then return end
        clicked = true
        self:play('click')
    else
        if self.parent and self.parent.__callback then
            self.parent.__callback(self.parent, eventType)
        end
        util.delay(0.4, function() clicked = false end)
    end
end

function AniBtn:onSetText(textname)
    self.ui.btn:setTitleText(textname)
end

function AniBtn:onBright(buttontype)
    self.ui.btn:setBright(buttontype)
end

function AniBtn:onEnabled(buttontype)
    self.ui.btn:setEnabled(buttontype)
    self.parent:setEnabled(buttontype)
end

function AniBtn:onImageHide()
    if self.ui.Image_1 then
        self.ui.Image_1:setVisible(false)
    end
end

return AniBtn
