local AniBtnText = class("AniBtnText", cc.load("mvc").LayoutBase)
AniBtnText.RESOURCE_FILENAME = "Common.Button.ButtonGreen"

function AniBtnText:onCreate()

end

function AniBtnText:onEnter()   
    self:onReset()
end

function AniBtnText:onReset(textname)
    self.ui.State:setVisible(false)
    self.ui.Image_3:setVisible(false)
    self.ui.Coin:setVisible(false)
    self.ui.Image_1:setVisible(false)
    self.ui.Coin_1:setVisible(false)
    self.ui.Image_2:setVisible(false)
    self.ui.Text_1:setVisible(false)
    self.ui.Text_2:setVisible(false)
    self.ui.Flag_Back:setVisible(false)
end

function AniBtnText:onExit()

end

function AniBtnText:onSetStateText(textname)
    self.ui.State:setVisible(true)
    self.ui.State:setString(textname)
end

function AniBtnText:onSetTexture(pic,text)
    self.ui.Image_3:setTexture(pic)
    self.ui.Image_3:setVisible(true)
    self.ui.Coin:setString(text)
    self.ui.Coin:setVisible(true)
    self.ui.Coin_1:setVisible(false)
end

function AniBtnText:onSetColor(color)
    self.ui.Coin:setTextColor(color)
end

function AniBtnText:onDisSetText()
    self.ui.Image_3:setVisible(false)
    self.ui.Coin:setVisible(false)
    self.ui.Image_2:setVisible(false)
    self.ui.Coin_1:setVisible(false)
end

function AniBtnText:onSetShop(pic)
    self.ui.Flag:loadTexture(pic,0)
    self.ui.Flag_Back:setVisible(true)
    self.ui.Flag:setVisible(true)
end

function AniBtnText:onSetBuyLife(num)
    self.ui.Image_1:setVisible(true)
    self.ui.Coin_1:setVisible(true)
    self.ui.Coin_1:setString(num)
end

function AniBtnText:onSetBuyLifetype(pic,num)
    self.ui.Image_1:setVisible(true)
    self.ui.Coin_1:setVisible(true)
    self.ui.Image_1:setTexture(pic)
    self.ui.Coin_1:setString(num)
end

function AniBtnText:onSetAD(aaa,time)
    self.ui.Image_2:setVisible(true)
    self.ui.Text_2:setVisible(true)
    if aaa == 1 then
        self.ui.Text_2:setString(static.language[30171][device.language])
        self.ui.Image_2:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
    elseif aaa == 0 then
        self.ui.Text_2:setString(static.language[20008][device.language])
        self.ui.Image_2:loadTexture("Image/menu/share_icon.png",0)
    elseif aaa == 2 then
        self.ui.Text_2:setString(time)
    end
end

function AniBtnText:onAD()
    self.ui.Image_4:setVisible(true)
    self.ui.Text_2:setVisible(true)
    self.ui.Text_2:setString(static.language[30171][device.language])
end

function AniBtnText:onSetNum(num)
    self.ui.Num:setVisible(true)
    self.ui.Num:setString(num)
end

function AniBtnText:onDisNum()
    self.ui.Num:setVisible(false)
end

function AniBtnText:onSetText(text)
    self.ui.Text_1:setString(text)
    self.ui.Text_1:setVisible(true)
end

return AniBtnText
