local ChangeName = class("ChangeName", cc.load("mvc").LayoutBase)
ChangeName.RESOURCE_FILENAME = "Common.ChangeName"

function ChangeName:onCreate()
    self:addEvent('NS_ChangeRoleName')
end

function ChangeName:onEnter()
    local num = mdt.changenemecount
    self.ui.Text_1:setString(static.language[30099][device.language])
    self.ui.Text_1_0:setString(static.language[30098][device.language])
     self.ui.txtInput:setPlaceHolder(static.language[30098][device.language])
    self.ui.Cancel.ui.btnText:onSetText(static.language[10002][device.language])
    if num == 0 then
        self.ui.Text_1:setVisible(true)
        self.ui.OK.ui.btnText:onReset()
        self.ui.OK.ui.btnText:onSetText(static.language[10001][device.language])
    else
        self.ui.Text_1:setVisible(false)
        self.ui.OK.ui.btnText:onReset()
        self.ui.OK.ui.btnText:onSetBuyLifetype("Image/Diamond.png",20)
--        if mdt.player.diamond < 20 then
--            self.ui.OK:onEnabled(false)
--            self.ui.OK:onBright(false)
--        end
    end
    self.ui.Text_2:setString(static.language[10014][device.language])
    self:RandomName()
     self.lastInput = self.ui.txtInput:getString()
    self.isfrist = false
end

function ChangeName:onExit()

end

function ChangeName:RandomName()
    if device.language ~= 'cn' and device.language ~= 'tw' then
        device.language = 'en'
    end
    local LN = static.UI.LANGNAME
    local first = LN.FirstName[device.language][math.random(1, #LN.FirstName[device.language])]
    local last = LN.LastName[device.language][math.random(1, #LN.LastName[device.language])]
    local name = first..(last or '')
     self.ui.txtInput:setText(name)
end

function ChangeName:NS_ChangeRoleName(ev,ns)
    dump(ns:copyTo())
    if ns.nErrorCode == 1 or ns.nErrorCode == 2 then
        mdt.player.sMineMapData.szName = ns.szRoleName
        mdt.changenemecount = mdt.changenemecount + 1
        sdkManager.talkingdata:setEvent("42",{ChangeName = "ChangeName"})
        sdkManager.appsflyer:setEvent("42",{ChangeName = "ChangeName"})
        util.closeDialog("Common.ChangeName")
    elseif ns.nErrorCode == 3 then
        ctr.player.showMessageBox(static.language[30100][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 4 then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
    elseif ns.nErrorCode == 5 then
        ctr.player.showMessageBox(static.language[30101][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 6 then
        ctr.player.showMessageBox(static.language[30106][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 7 then
        ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

-- Event for BG callback (addClickEventListener)
function ChangeName:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function ChangeName:onOK(node, eventType, userdata)
    local str = self.ui.txtInput:getString()
    if string.len(str) > 0 then
        if string.find(str,"%p") == nil then
            if string.find(str,"%s") == nil then
--                for i = 1 , #static.forbid do
--                    if string.find(str,static.forbid[i].forbid) then
--                        ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
--                            util.closeDialog('Common.MessageBox')
--                        end)
--                        return
--                    end
--                end
                net.msg.NC_ChangeRoleName(str)
            else
                ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
                    util.closeDialog('Common.MessageBox')
                end)
            end
        else
            ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
                util.closeDialog('Common.MessageBox')
            end)
        end
    else
         ctr.player.showMessageBox(static.language[30101][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

-- Event for txtInput callback (addEventListener)
function ChangeName:onCutInput(node, eventType, userdata)
     if eventType == 0 and not self.isfrist then
         self.ui.txtInput:setText('')
         self.lastInput = self.ui.txtInput:getString()
         self.isfrist = true
     end
 --    if status=="changed" then
 --        self.lastinput = self.ui.txtinput:getString()
 --        if string.len(content)>15 then
 --            self.ui.txtinput:setString( self.lastinput )
 --        else
 --            self.lastinput = content
 --        end
 --        print('1111111111111111111111')
 --    end
 --    print('node================='..status)
 --    print('event==============='..eventType)
     local content = self.ui.txtInput:getString()
     self.lastInput = self.ui.txtInput:getString()
     if string.len(content)>20 then
         self.ui.txtInput:setText( self.lastInput )
     else
         self.lastInput = content
     end
end

-- Event for Button_1 callback (addClickEventListener)
function ChangeName:OnRandomName(node, eventType, userdata)
    self:RandomName()
    self.isfrist = false
end

return ChangeName
