local ExchangeDialog = class("ExchangeDialog", cc.load("mvc").ViewBase)
ExchangeDialog.RESOURCE_FILENAME = "Common.ExchangeDialog"

function ExchangeDialog:onCreate()

end

function ExchangeDialog:onEnter()
    self.ui.TextField_1:setPlaceHolder(static.language[30114][device.language])
    self.ui.Button1:onSetText(static.language[10001][device.language])
    self.ui.Text_2:setString(static.language[30247][device.language])
    self.ui.Exchange:setString(static.language[30245][device.language])
end

function ExchangeDialog:onExit()

end

-- Event for Panel_start callback (addClickEventListener)
function ExchangeDialog:onOK(node, eventType, userdata)
    local code = self.ui.TextField_1:getString()
    net.msg.NC_GetExchangeCode(code)
    util.closeDialog('Common.ExchangeDialog')
end

-- Event for TextField_1 callback (addEventListener)
function ExchangeDialog:onCutInput(node, eventType, userdata)
    if tonumber(eventType) == 0 then
        self.ui.TextField_1:setPlaceHolder('')
    elseif tonumber(eventType) == 1 then
        if string.len(self.ui.TextField_1:getString()) <= 0 then
            self.ui.TextField_1:setPlaceHolder(static.language[30114][device.language])
        else
            self.ui.TextField_1:setPlaceHolder('')
        end
    end
end

-- Event for BG callback (addClickEventListener)
function ExchangeDialog:onClose(node, eventType, userdata)

end

return ExchangeDialog
