local FirstRechage = class("FirstRechage", cc.load("mvc").LayoutBase)
FirstRechage.RESOURCE_FILENAME = "Common.FirstRechage"

function FirstRechage:onCreate()

end

function FirstRechage:onEnter()
    self.ui.Name:setString(static.language[30248][device.language])
    self.ui.Button1:onImageHide()
    if static.isHaiWai then
        self.ui.Button1:onSetText('$0.99')
    else
        self.ui.Button1:onSetText('6元')
    end
    self.item = nil
    for k,v in pairs(static.diamond) do
        if not static.isHaiWai then
            if tonumber(v.code) == 40102 then
                self.item = v
                break
            end
        else
            if util.isIOS() then
                if tonumber(v.code) == 40207 then
                    self.item = v
                    break
                end
            elseif util.isAndroid() then
                if tonumber(v.code) == 40307 then
                    self.item = v
                    break
                end
            end
        end
    end
    if static.isHaiWai then
        self.ui.Back.ui.back:loadTexture('Image/firstrechage_en.jpg',0)
    end
end

function FirstRechage:onExit()

end

-- Event for btnClose callback (addClickEventListener)
function FirstRechage:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function FirstRechage:onOK(node, eventType, userdata)

end

-- Event for Panel_quit callback (addClickEventListener)
function FirstRechage:OnBuy(node, eventType, userdata)
    mdt.FristCharge = true
    mdt.payinfo = {}
    if util.isIOS() then
        local orderId = string.format("%s-%s-%d",mdt.player.nGUID.a,self.item.iapId,os.time())
        sdkManager.talkingdata:setPay(orderId) 
        mdt.payinfo['payid'] = orderId
        mdt.payinfo['price'] = self.item.cost
        mdt.payinfo['iapid'] = self.item.iapId
        local tab = {productId = self.item.iapId,Serverid = static.SERVER_LIST[mdlogin.getCurLoginServerID()].serverid,roleid = mdt.accountid, extraData='{serverId:'..mdlogin.getLastlistServerID()..'}'}
        dump(tab)
        if static.isHaiWai then
            sdkManager.locojoybj:Pay(tab)
        else
            ctr.player.showWaiting()
            local price = self.item.cost
            sdkManager.talkingdata:setPay(orderId,self.item.iapId,price)
            sdkManager.talkingdata:setPay("Sandbox-"..orderId,self.item.iapId,price)
            sdkManager.applepay:pay(self.item.iapId,function(isSuccess,info)
                if true == isSuccess then
                    ctr.player.doValidateOrder(info)
                    local Sandbox = ""
                    if string.find(info,"Sandbox") then
                        Sandbox = "Sandbox"
                        orderId = string.format("%s-%s",Sandbox,orderId)
                    end
                    sdkManager.talkingdata:setPaySuccess(orderId)
                    sdkManager.talkingdata:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                    sdkManager.appsflyer:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                    sdkManager.appsflyer:setPaySuccess(orderId,mdt.payinfo.iapId,price)
                    if not static.isHaiWai then
                        local data = {}
                        data['account'] = tostring(mdt.player.nGUID.a)
                        data['orderId'] = mdt.payinfo.iapId
                        data['amount'] = price
                        if static.isHaiWai then
                            data['currencyType'] = 'USD'
                        else
                            data['currencyType'] = 'CNY'
                        end                       
                        data['payType'] = 'Apple Pay'
                        sdkManager.tdadtracking:setpay(data)
                        if mdt.FristCharge ~= nil and mdt.FristCharge then
                            mdt.nFirstChargeGiftIsBuy = 1
                            event.dispatch('updateFristCharge')
                            mdt.FristCharge = false
                        end
                    end
                else
                    if mdt.FristCharge ~= nil and mdt.FristCharge then
                        mdt.FristCharge = false
                    end
                end
                print("���餓���뜻��:",isSuccess,orderId)
                ctr.player.hideWaiting()
                --util.closeDialog('Common.FirstRechage')
            end)
        end
    else
    --if util.isAndroid() then
        -- local orderId = string.format("%s-%s-%d",mdt.player.nGUID.a,self.item.iapId,os.time())
        -- local price = self.item.cost
        -- sdkManager.talkingdata:setPay(orderId, self.item.iapId, price)
       -- 其他渠道by ypn
        if  mdt.player.loginType ==  7 then
                local serverId = mdr.lastServer
                 local playerId = mdt.player.nGUID.a
                 local productId = self.item.iapId
                 local ip = "http://103.36.31.24:8080/MineShareServer/HuaweiPayGenerateOrderId?"
                 local url = "serverId="..serverId.."&playerId="..playerId.."&productId="..productId
                 print("Huawei"..ip..url)
                  util.HttpManagerPOST(ip, url, function (result)
                        dump()
                       local orderId = result["orderId"]
                       local productId = result["productId"]
                       -- local amount = result["amount"]
                       -- local accountId = result["accountId"]
                       --  local notifyUrl = result["notifyUrl"]
                       --  local cpOrderId = result["cpOrderId"]
                       local amount = self.item.cost
                       local productName = self.item.name
                       local productDesc = self.item.iapName 
                       print("Huawei222"..amount..productName..productDesc)
                        sdkManager.huawei:setPay(orderId,amount,productName,productDesc)
                       -- print("收到服务器的了!!"..amount.."================"..notifyUrl)
                       mdt.payinfo['payid'] = orderId
                         mdt.payinfo['price'] = self.item.cost
                        mdt.payinfo['iapid'] = self.item.iapId
                        util.closeDialog('Common.FirstRechage')
                    end)
        elseif  mdt.player.loginType ==  6 then
                 print("UCCCCCCCCCCCCCC")
                -- --ypn修改SDK
                -- local dialog = util.showDialog(nil, "Common.RechargeType")
                -- dialog:setData(self.item)
                -- --
                 --local ip = http://127.0.0.1:8080/MineShareServer/UcPayChargeSign?serverId=1&playerId=1111&productId=safsdf&amount=2&accountId=2222
                 local serverId = mdr.lastServer
                 local playerId = mdt.player.nGUID.a
                 local productId = self.item.iapId
                -- local amount = "0.01"
                 local amount = self.item.cost
                 local accountId = mdt.player.accountId
                 -- local ip = "http://127.0.0.1:8080/MineShareServer/UcPayChargeSign?serverId="..serverId.."&playerId="..playerId.."&productId="..productId.."&amount="..amount.."&accountId="..accountId
                 -- print("UCCCCCCCCCCCCCC"..ip)
                 -- local url = ""
                 local ip = "http://103.36.31.24:8080/MineShareServer/UcPayChargeSign?"
                 local url = "serverId="..serverId.."&playerId="..playerId.."&productId="..productId.."&amount="..amount.."&accountId="..accountId
                 print("UCCCCCCCCCCCCCC"..ip..url)
                  util.HttpManagerPOST(ip, url, function (result)
                        dump()
                        local callBackInfo = result["callbackInfo"]
                       local signType = result["signType"]
                       local sign = result["sign"]
                       local amount = result["amount"]
                       local accountId = result["accountId"]
                        local notifyUrl = result["notifyUrl"]
                        local cpOrderId = result["cpOrderId"]
                        sdkManager.uc:setPay(amount,notifyUrl,cpOrderId,accountId,signType,sign,callBackInfo)
                        print("收到服务器的了!!"..amount.."================"..notifyUrl)


                    end)

        end
        -- local param = {["sku"] = self.item.iapId}
        -- local args={json.encode(param)}

        --原来的
        -- mdt.payinfo['payid'] = orderId
        -- mdt.payinfo['price'] = self.item.cost
        -- mdt.payinfo['iapid'] = self.item.iapId

        if static.isHaiWai then
            sdkManager.locojoybj:Pay({sku = self.item.iapId, serverid = static.SERVER_LIST[mdlogin.getCurLoginServerID()].serverid, gameServer = mdlogin.getLastlistServerID()})
        else
            -- local dialog = util.showDialog(nil, "Common.RechargeType")
            -- dialog:setData(self.item)
        end
    end
    util.closeDialog('Common.FirstRechage')
end

return FirstRechage
