local HeadIcon = class("HeadIcon", cc.load("mvc").LayoutBase)
HeadIcon.RESOURCE_FILENAME = "Common.HeadIcon"

function HeadIcon:onCreate()

end

function HeadIcon:onEnter()

end

function HeadIcon:onExit()

end

function HeadIcon:setInfo(nGUID, headIndex,countryIndex,flagIndex)
    self.nGUID = nGUID
    if nGUID==nil then return end
    async.create(function()
        if self.ui then
            self.ui.icon:setVisible(false)
            if nil~=headIndex then
                local iconName = http.account.asyncGetIconName(nGUID, headIndex)
                self.ui.icon:loadTexture(iconName)
                self.ui.icon:setVisible(true)
            elseif nil~=flagIndex then
                local flagName = http.account.asyncGetFlagName(nGUID, flagIndex)
                self.ui.icon:loadTexture(flagName)
                self.ui.icon:setVisible(true)
            end
            if countryIndex and countryIndex ~= 0 then
                local countryIcon = "res/Image/country/DEFAULT.png" 
                if countryIndex>0 then
                    countryIcon = string.format("res/Image/country/%s.png",static.country[countryIndex].nameID)
                end
                self.ui.Country:loadTexture(countryIcon)
                self.ui.Country:setVisible(true)
            else
                self.ui.Country:setVisible(false)
            end
        end
    end)
end

return HeadIcon
