local MessageBox = class("MessageBox", cc.load("mvc").LayoutBase)
MessageBox.RESOURCE_FILENAME = "Common.MessageBox"

function MessageBox:onCreate()
    self:play('info1')

end

function MessageBox:onEnter()
    self.ui.Button1:onSetText(static.language[10001][device.language])
    self.ui.Button2:onSetText(static.language[10002][device.language])
end

function MessageBox:onExit()

end

function MessageBox:setText(txt)
    self.ui.Msg:setString(txt)
end

function MessageBox:setOKListener(okListener)
    self.okListener = okListener
end

function MessageBox:setType(msgType)
    if msgType==2 then
        self:play('info2')
    else
        self:play('info1')
    end
end

-- Event for btnClose callback (addClickEventListener)
function MessageBox:onClose(node, eventType, userdata)
    if self.okListener then
        self.okListener(false)
    end
    if mdlogin.getIsNewbieBeging(mdlogin.getCurLoginServerID()) then
        if ctr.login.isFacebookAccount() == false then           
            if mdt.changenemecount ~= nil and mdt.changenemecount <= 0 then
                if mdt.ismenunewbie == nil or not mdt.ismenunewbie then
                    util.showDialog('Dialog','Common.ChangeName')
                end
            end
        end
        mdlogin.setIsNewbieBeging(mdlogin.getCurLoginServerID(), false)
    end
    if mdlogin.getNewbieagainFalse(mdlogin.getCurLoginServerID()) == false then
        sdkManager.talkingdata:setEvent("64",{BottleReplyPlayer = "NewGuideFalse"})
        sdkManager.appsflyer:setEvent("64",{BottleReplyPlayer = "NewGuideFalse"})
        mdlogin.setNewbieagainFalse(mdlogin.getCurLoginServerID(), true)
    end
end

-- Event for OK callback (addClickEventListener)
function MessageBox:onOK(node, eventType, userdata)
    local callback = self.okListener
    util.playClose(self)
    if callback then
        callback(true)
    end
end

return MessageBox
