local NotEnough = class("NotEnough", cc.load("mvc").LayoutBase)
NotEnough.RESOURCE_FILENAME = "Common.NotEnough"

function NotEnough:onCreate()

end

function NotEnough:onEnter()
    
    self.ui.OK:onSetText(static.language[10001][device.language])
    self.ui.Cancel:onSetText(static.language[10002][device.language])
    self.ui.OK2:onSetText(static.language[10001][device.language])
end

function NotEnough:onExit()

end

function NotEnough:setkey(type,isbuy)
    self.type = type
    if type == 1 then
        self.ui.NotEnough:setString(static.language[30104][device.language])
        self.ui.Buy:setString(static.language[30103][device.language])
        self.ui.Sprite_13:setTexture("Image/coin.png")
        self.ui.Panel_start:setVisible(true)
        self.ui.Panel_start_0:setVisible(true)
        self.ui.Panel_start_1:setVisible(false)
        self:play('info1')
        self.type = 2
    elseif type == 2 then
        self.ui.Buy:setString(static.language[30103][device.language])
        if isbuy ~= nil and isbuy == true then
            self.ui.NotEnough:setString(static.language[30112][device.language])
        else
            self.ui.NotEnough:setString(static.language[30107][device.language])
        end
        self.ui.Sprite_13:setTexture("Image/pvp/pvp.png")
        self.ui.Panel_start:setVisible(false)
        self.ui.Panel_start_0:setVisible(false)
        self.ui.Panel_start_1:setVisible(true)
        self:play('info2')
    elseif type == 3 then
        self.ui.NotEnough:setString(static.language[30104][device.language])
        self.ui.Buy:setString(static.language[30103][device.language])
        self.ui.Sprite_13:setTexture("Image/Diamond.png")
        self.ui.Panel_start:setVisible(true)
        self.ui.Panel_start_0:setVisible(true)
        self.ui.Panel_start_1:setVisible(false)
        self:play('info1')
        self.type = 1
    end
end

-- Event for BG callback (addClickEventListener)
function NotEnough:onClose(node, eventType, userdata)
    util.closeDialog('Common.NotEnough')
end

-- Event for Panel_start callback (addClickEventListener)
function NotEnough:onOK(node, eventType, userdata)
    if util.isShowDialog('Recharge.Recharge') then
        event.dispatch('SetChangeType1',self.type)
    else
        local Recharge = util.showDialog('Dialog2', 'Recharge.Recharge')
        Recharge:chooseMode(self.type)
    end
    util.closeDialog('Common.NotEnough')
end

return NotEnough
