local ServerListItem = class("ServerListItem", cc.load("mvc").LayoutBase)
ServerListItem.RESOURCE_FILENAME = "Common.ServerListItem"

function ServerListItem:onCreate()
end

function ServerListItem:onEnter()
    
end

function ServerListItem:onExit()

end

function ServerListItem:setTarget(target)
    self.target = target
end

function ServerListItem:setItemData(data)
--    if data.nServerStatus == 0 then
--        self.ui.Image_14:setVisible(true)
--    elseif data.nServerStatus == 2 then
--        self.ui.Image_13:loadTexture("Image/cover/serverpoint1.png",0)
--    elseif data.nServerStatus == 3 then
--        self.ui.Image_13:loadTexture("Image/cover/serverpoint3.png",0)
--    elseif data.nServerStatus == 4 or data.nServerStatus == 5 then
--        self.ui.Image_13:loadTexture("Image/cover/serverpoint4.png",0)
--    end

    if data.nServerStatus == net.enum.EServerStatus_New or data.nServerStatus == net.enum.EServerStatus_Recommend
        or data.nServerStatus == net.enum.EServerStatus_Normal then --green
        self.ui.ms:setString(static.language[30194][device.language])
        self.ui.ms:setTextColor({r = 0, g = 211, b = 99})
    elseif data.nServerStatus == net.enum.EServerStatus_Full or data.nServerStatus == net.enum.EServerStatus_ChallengeMap then --red
        self.ui.ms:setString(static.language[30195][device.language])
        self.ui.ms:setTextColor({r = 253, g = 62, b = 57})
    elseif data.nServerStatus == net.enum.EServerStatus_Stop then --gray
        self.ui.ms:setString(static.language[30193][device.language])
        self.ui.ms:setTextColor({r = 171, g = 171, b = 171})
    end

    self.serverData = data
    self.ui.serverTxt:setString(data.szClientShowServerName)

    if self.recommendServerInfo and self.recommendServerInfo.szClientShowServerName ~= "" and self.recommendServerInfo.nClientShowServerId ~= 0 then
        print(" ------ the selected server is recommendServer ")
        serverName = self.recommendServerInfo.szClientShowServerName
        gameServerID = self.recommendServerInfo.nClientShowServerId
    end

    print("listItemid = "..data.nClientShowServerId)
    
    if mdt.recommendServerID and mdt.recommendServerID ~= 0 and mdt.recommendServerID == data.nClientShowServerId then
        print("run here")
        self.ui.Image_14:setVisible(true)
    else
        self.ui.Image_14:setVisible(false)
    end 
end


-- Event for SelectServer callback (addClickEventListener)
function ServerListItem:onselect(node, eventType, userdata)
    self.target:OnItemSelect()
    self.target:setCurrentSelect(self.serverData)
    self.ui.Button_Server:setBright(false)

    self.target:makeChoose()
end

function ServerListItem:resetstate()
    self.ui.Button_Server:setBright(true)
end

return ServerListItem
