local UpdateDialog = class("UpdateDialog", cc.load("mvc").LayoutBase)
UpdateDialog.RESOURCE_FILENAME = "Common.UpdateDialog"

function UpdateDialog:onCreate()
    self:addEvent('NS_ShopItemLevelUp')
    self:addEvent('RemoveUpEffeck')
end

function UpdateDialog:onEnter()
    self.ui.txtUpgrade:setString(static.language[30121][device.language])
    mdt.clickupdate = true
end

function UpdateDialog:onExit()

end

function UpdateDialog:setkey(oldID,newID,costtype,cost,canLvup)
    self.id = newID
    self.item = nil
    self.upid = newID
    self.oldid = oldID
    self.costtype = costtype
    local olditem = nil
    local newitem = nil
    for k,_ in pairs(static.item) do
        if static.item[k].id == oldID then
            olditem = static.item[k]
        elseif static.item[k].id == newID then
            newitem = static.item[k]
        end
        if olditem ~= nil and newitem ~= nil then
            break
        end
    end
    for k,_ in pairs(static.shop) do
        if static.shop[k].itemCode == self.id then
            self.upid = static.shop[k].code
            self.item = static.shop[k]
            break
        end
    end
    self.ui.Begin:loadTexture(olditem.imageId,0)
    self.ui.After:loadTexture(newitem.imageId,0)
    if tonumber(self.item.costType) == 1 then
        self.ui.Image_1:setTexture("Image/coin.png")
--        self.ui.OK:onBright(cost <= mdt.player.gold)
--        self.ui.OK:onEnabled(cost <= mdt.player.gold)
        self.money = mdt.player.gold
    elseif tonumber(self.item.costType) == 2 then
        self.ui.Image_1:setTexture("Image/pvp/pvp.png")
--        self.ui.OK:onBright(cost <= mdt.mypvpcoin)
--        self.ui.OK:onEnabled(cost <= mdt.mypvpcoin)
        self.money = mdt.mypvpcoin
    elseif tonumber(self.item.costType) == 3 then
        self.ui.Image_1:setTexture("Image/diamond/diamond1.png")
--        self.ui.OK:onBright(cost <= mdt.player.diamond)
--        self.ui.OK:onEnabled(cost <= mdt.player.diamond)
        self.money = mdt.player.diamond
    end
    self.cost = self.item.cost
    self.ui.Coin:setString(self.cost)

    self.ui.Buy:setString(static.language[30010][device.language])
    self.ui.OK:onSetText(static.language[10001][device.language])
    self.ui.Cancel:onSetText(static.language[10002][device.language])
    self.ui.OK:onBright(canLvup)
    self.ui.OK:onEnabled(canLvup)
end

function UpdateDialog:NS_ShopItemLevelUp(ev,ns)
    if ns.nErrorCode == 0 then
        self.eff = self:getApp():createView('spine.Shengji')
        self.eff:setPosition(0,0)
        self.ui.Node_1:addChild(self.eff)
    end
end

function UpdateDialog:RemoveUpEffeck()
--    if self.eff ~= nil then
--        util.delay(0.1,function ()
--            self.ui.Node_2:removeChild(self.eff)
--            self.eff=nil
--        end,self)      
--    end
    util.closeDialog('Common.UpdateDialog')
end

-- Event for BG callback (addClickEventListener)
function UpdateDialog:onClose(node, eventType, userdata)
    util.closeDialog('Common.UpdateDialog')
end

-- Event for Panel_start callback (addClickEventListener)
function UpdateDialog:onOK(node, eventType, userdata)
    if self.money >= self.cost then
        print(self.upid)

        if mdt.clickupdate then
            net.msg.NC_ShopItemLevelUp(self.upid)
            mdt.clickupdate = false
        end
        --util.closeDialog('Common.UpdateDialog')
    else
        util.showDialog('Dialog3','Common.NotEnough'):setkey(2)
    end   
end

return UpdateDialog
