local XNFacebook = class("XNFacebook", cc.load("mvc").LayoutBase)
XNFacebook.RESOURCE_FILENAME = "Cover.XNFacebook"

function XNFacebook:onCreate()

end

function XNFacebook:onEnter()

end

function XNFacebook:onExit()

end

function XNFacebook:setOKListener(okListener)
    self.okListener = okListener
    return self
end

-- Event for BG callback (addClickEventListener)
function XNFacebook:onClose(node, eventType, userdata)

end

-- Event for UserName callback (addEventListener)
function XNFacebook:onTextChange(node, eventType, userdata)

end

-- Event for Button_1 callback (addClickEventListener)
function XNFacebook:onOK(node, eventType, userdata)
    local callback = self.okListener
    local ret = {}
    ret.thirdPlatformId = self.ui.UserName:getString()      
    ret.thirdPlatformName = self.ui.NickName:getString()    
    ret.thirdPlatformIconUrl = self.ui.URL:getString()                   
    ret.thirdPlatformType = 2
    util.playClose(self)
    if callback then
        callback(ret)
    end
    
end

-- Event for Button_1_0 callback (addClickEventListener)
function XNFacebook:onCancel(node, eventType, userdata)
    local callback = self.okListener
    local ret = {}
    ret.canceled = true
    util.playClose(self)
    if callback then
        callback(ret)
    end
end

return XNFacebook
