local MainUI = class("MainUI", cc.load("mvc").LayoutBase)
MainUI.RESOURCE_FILENAME = "Themes.Theme0.MainUI"

function MainUI:onCreate()
    self:addEvent('NS_SyncBaseInfo')
    self:addEvent('NS_SyncLifeInfo')
    self:addEvent('NS_ApplyBuyLife')
    self:addEvent('NS_BuyLife')
    self:addEvent('RefreshLife')
    self:addEvent('NS_GetBoxAchievement')
    self:addEvent('NS_ReachAchievement')
    self:addEvent('BeaconRotate')
    self:addEvent('Beaconappear')
    self:addEvent('NS_DriftBottleHaveReply')
    self:addEvent('NS_NotifyClickBigMapGetDriftBottle')
    self:addEvent('ClosseRedP')
    self:addEvent('NS_GMSendReward')
    self:addEvent('NS_GetReward')
    self:addEvent('SetOpenstate')
    self:addEvent('NS_SyncMainUiOpenGridInfo')
    self:addEvent('ShowPlayerInfo')
    self:addEvent('CloseInfo')
    self:addEvent('ChangeFace')
    self:addEvent('getach')
    self:addEvent('NS_Ping')
    self:addEvent('singlelost')
    self:addEvent('CloseInfoRedP')
    self:addEvent('ShowBoomEffect')
    self:addEvent('RemoveBoomEffect')
    self:addEvent('NS_NowChangeMineMap')
    self:addEvent('CloseChangeMap')
    self:addEvent('NS_OpenBoxAchievement')
    self:addEvent('NS_RequestDayChallengeReward')
    self:addEvent('NS_GetDayChallengeReward')
    self:addEvent('BoxTimeOver')
    self:addEvent('NS_ClickGrid')
    self:addEvent('NS_FlagGrid')
    self:addEvent('updateItemCount')
    self:addEvent('CloseUseItem')
    self:addEvent('CloseUseBoom')
    self:addEvent('ItemOpen')
    self:addEvent('updateFristCharge')

--    self:addEvent('NS_GetSpecialBoxForCoolDown')

--    if mdt.mode==2 then
--        self.ui.Shave:setSelected(true)
--    else
--        self.ui.Shave:setSelected(false)
--    end
--    self.psHeart = util.createProgressTimer(self.ui.psHeart, true)
--    self.psHeart:setMidpoint(cc.p(0,0))
--    self.psHeart:setBarChangeRate(cc.p(0, 1))
    self:NS_SyncBaseInfo()
    self:NS_SyncMainUiOpenGridInfo()
    self:NS_SyncLifeInfo()
    self:runAnimation()

    self:onUpdate(function(dt)
        if mdt.lifeRecoveryTM and mdt.lifeRecoveryTM>0 then
            mdt.lifeRecoveryTM = mdt.lifeRecoveryTM - dt
            if mdt.lifeRecoveryTM<0 then mdt.lifeRecoveryTM=0 end
        end
        if mdt.adCooldowntime and mdt.adCooldowntime>0 then
            mdt.adCooldowntime = mdt.adCooldowntime - dt
            if mdt.adCooldowntime<0 then mdt.adCooldowntime=0 end
        end
        if mdt.wudiCD and mdt.wudiCD > 0 then
            mdt.wudiCD = mdt.wudiCD - dt
            if mdt.wudiCD<0 then
	     	mdt.wudiCD=0
	     	event.dispatch('CloseUseItem',false) 
	     end
            self:setwudiCD()
            
        end
        if self.comboPanel then
            self.comboPanel:checkPanel(dt)
        end
    end)

    util.scheduleNode(1, function()
        self:refreshTM()
    end, self)
    --net.msg.NC_ApplyBuyLife()
--    self.ui.HeartSprite:setVisible(false)
    mdt.isplayerinfo = false
--    self.ui.Beacon:setVisible(false)
    if mdr.infoP == nil then
        mdr.infoP = false
        mdr.save()
    end
    self.ui.redtip2:setVisible(mdt.avilable)
    --self.ui.cool :setVisible(false)
    self.ui.Box1:setVisible(false)
    self.ui.BoxBtn:setVisible(true)
    mdt.UseItemBoom = false
    mdt.UseItemTwo = false
    mdt.itemboomcd = false
    self.ui.PitchOn1:setVisible(false)
    self.ui.PitchOn2:setVisible(false)
    if mdt.facebookdata ~= nil then
        ctr.login.bind(mdt.facebookdata)
    end

    if not mdr.forceUpload then
        ctr.login.uploadHead()
    end

    if static.isTestFR then
        self.ui.FirstRecharge:setVisible(true)
    else
        self.ui.FirstRecharge:setVisible(mdt.nFirstChargeGiftIsBuy == 0)
    end

    if mdt.appDown and not mdt.receiveReward then
        print("MORE GAME MAIN UI request get reward")
        net.msg.NC_IntegralWallAddMoney()
    end
end

function MainUI:onEnter()
    self.ui.ping:setVisible(false)
    self.ui.ms:setVisible(false)
    self.ui.ItemTime:setVisible(false)
    self.isrank = false
    self.ui.Gift:setVisible(false)
    self.ui.Gift:setTouchEnabled(false)
    if mdt.CanPickReward ~= nil then
        self.ui.Gift:setVisible(#mdt.CanPickReward > 0)
        self.ui.Gift:setTouchEnabled(#mdt.CanPickReward > 0)
    end
    self.ui.DCReward:setVisible(false)
    self.ui.DCReward:setTouchEnabled(false)
    if mdt.CanPickDayReward ~= nil then
        self.ui.DCReward:setVisible(#mdt.CanPickDayReward > 0)
        self.ui.DCReward:setTouchEnabled(#mdt.CanPickDayReward > 0)
    end
    self.ui.ms:setString(static.language[30163][device.language])
    self.isopen = false
    --self.ui.Panel_3:setVisible()
    self.ui.Emoji01:loadTexture("Image/emoji/emoji_01.png",0)
    self.ui.ComboPanel:setVisible(false)
    self:getach()
    self:updateItemCount() 
    self.lastComboLevel = 0

    self.comboPanel = util.createView("donghua.combo")
    self.comboPanel:setPosition(self.ui.ComboPanel:getPosition())
    self.ui.ComboPanel:getParent():addChild(self.comboPanel)
    self.ui.ItemPanel:setVisible(true)
    self.ui.redtip:setVisible(mdt.haveach)

    self.lastComboScoreLevel = 0

    self.effwudi = self:getApp():createView('donghua.wudi')
    self.effwudi:setPosition(display.width/2,display.height/2)
    self.ui.Node_4:add(self.effwudi)
    local X = display.width/1080
    local Y = display.height/1920
    self.effwudi:setScaleX(X)
    self.effwudi:setScaleY(Y)
    self.effwudi:play('wudi',true)
    self.ui.Node_4:setVisible(false)
end

function MainUI:onExit()

end

function MainUI:updateFristCharge()
    if not static.isTestFR then
        self.ui.FirstRecharge:setVisible(false)
    end
end

function MainUI:updateItemCount()
    if mdt.itemCount == nil then
        self.ui.ItemCount1:setString('0')
        self.ui.ItemCount2:setString('0')
    else
        if mdt.itemCount[50001] ~= nil then
            self.ui.ItemCount1:setString(mdt.itemCount[50001])
        else
            self.ui.ItemCount1:setString('0')
        end
        if mdt.itemCount[50002] ~= nil then
            self.ui.ItemCount2:setString(mdt.itemCount[50002])
        else
            self.ui.ItemCount2:setString('0')
        end
    end
end

function MainUI:NS_OpenBoxAchievement(ev, ns)

    local view = util.showDialog('Dialog2', 'Box.BoxOpen')
    view:setkey(ns.sOpenBox)


end


function MainUI:NS_NowChangeMineMap()
    local view = self:getApp():createView('Common.Waiting_Map')
    view:setAnchorPoint(0.5,0.5)
    self.ui.Node_2:setPosition(display.width/2,display.height/2)
    self.ui.Node_2:addChild(view)
end

function MainUI:NS_ClickGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    local nErr = ns.nErrorCode
    local combo = ns.nComboNum
    local comLevel = ns.nComboLevel
    local score = ns.nCurClickScore
    local clickSore = ns.nClickGridScore
    print("MAIN UI NS_ClickGrid combo = " .. combo)
    print("MAIN UI NS_ClickGrid comLevel = " .. comLevel)
    print("MAIN UI NS_ClickGrid score = " .. score)
    self.comboPanel:checkComboLevel(combo, comLevel, score)
    ctr.game.clickGrid(x,y,nErr, ns.nGUID)

    self:checkScoreShow(score)

    -- sdkManager.locojoybj:callNotify("qqqq", 30)
end

function MainUI:checkScoreShow(score)
    -- sdkManager.locojoybj:requestGotScore()

    if score < static.comboScore[1].range then
        self.lastComboScoreLevel = 0
        return 
    end

    local showScore = false
    for k, value in pairs(static.comboScore) do
        if score > value.range and value.id > self.lastComboScoreLevel then
            self.lastComboScoreLevel = value.id
            showScore = true
            break
        end
    end

    if showScore then
        self.ui.ComboScore:setVisible(true)
        self.ui.ComboScore.ui.ComboScore:setString(score)
        self.ui.ComboScore:play("shuzi")
        audio.playEffect(static.comboScore[self.lastComboScoreLevel].sound)
    end
end

function MainUI:NS_FlagGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    local nErr = ns.nErrorCode
    local combo = ns.nComboNum
    local comLevel = ns.nComboLevel
    local score = ns.nCurClickScore
    local clickSore = ns.nClickGridScore
    print("MAIN UI NS_FlagGrid combo = " .. combo)
    print("MAIN UI NS_FlagGrid comLevel = " .. comLevel)
    print("MAIN UI NS_FlagGrid score = " .. score)
    self.comboPanel:checkComboLevel(combo, comLevel, score)
    ctr.game.flagGrid(x,y,nErr, ns.nGUID)

    self:checkScoreShow(score)
end 

function MainUI:CloseChangeMap()
    self.ui.Node_2:removeAllChildren()
end

function MainUI:CloseInfoRedP()
    self.ui.redtip2:setVisible(mdt.avilable)
end

function MainUI:BoxTimeOver()
    if not util.isShowDialog('Box.BoxView') then
        self.ui.Box1:setVisible(true)
        self.ui.BoxBtn:setVisible(false)
    end
end

function MainUI:NS_Ping(ev,ns)
    if mdt.delay ~= nil then
        util.unschedule(mdt.delay)
    end
    local time = math.floor(socket.gettime()*1000-mdt.nctime*1000)
    if time <= 300 then
        self.ui.net:loadTexture('Image/net/net1.png',0)
    elseif time>300 and time <=600 then
        self.ui.net:loadTexture('Image/net/net2.png',0)
    else
        self.ui.net:loadTexture('Image/net/net3.png',0)
    end
end

function MainUI:singlelost()
    self.ui.ping:setString('999')
     self.ui.net:loadTexture('Image/net/net3.png',0)
end

function MainUI:getach()
    if mdt.reachAch~=nil and #mdt.reachAch>0 then
        self.ui.redtip:setVisible(true)
    else
        self.ui.redtip:setVisible(false)
    end
end

function MainUI:ChangeFace(ev,key)
    --self.ui.cool :setVisible(false)
    if self.delay ~= nil then
        util.unschedule(self.delay)
    end
    if key == 1 then
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_03.png",0)
    elseif key == 2 then
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_02.png",0)
        --self.ui.cool :setVisible(true)
    else
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_04.png",0)
    end
    self.delay = util.delay(0.5, function()
        self.ui.Emoji01:loadTexture("Image/emoji/emoji_01.png",0);
        --self.ui.cool :setVisible(false)
    end)
end

function MainUI:refreshTM()
    if mdt.lifeRecoveryTM and mdt.lifeRecoveryTM>0 then
        local time = os.date('%M:%S', mdt.lifeRecoveryTM+0.99)
        self.ui.LifeTime:setString(time)
    else
        self.ui.LifeTime:setString(static.language[30011][device.language])
    end
--    self.ui.Diamond:setString(mdt.player.diamond)
end

function MainUI:refreshComboBar()
    
end

function MainUI:SetOpenstate()
    self.isopen = false
end

function MainUI:NS_DriftBottleHaveReply(ev,ns)
    self.ui.redpoint_1:setVisible(true)
end

function MainUI:ClosseRedP()
    if mdt.Replybottle == nil or #mdt.Replybottle <= 0 then
        self.ui.redpoint_1:setVisible(false)
    else
        self.ui.redpoint_1:setVisible(true)
    end
    
    if mdt.Newbottle == nil or #mdt.Newbottle <= 0 then
        self.ui.redpoint_2:setVisible(false)
    else
        self.ui.redpoint_2:setVisible(true)
    end
end

--function MainUI:BeaconRotate(ev,rotate)
--    local inner = ctr.game.Inner
--    local size = inner:getParent():getContentSize()
--    local curmypos = self:convertToNodeSpace(rotate.mypos)
--    local curpos = self:convertToNodeSpace(rotate.pos)
--    local currotate = cc.pToAngleSelf(cc.pSub(curpos,curmypos))
--    local angle = math.deg(0-currotate)
--    self.ui.Beacon:setRotation(angle)
--    self.ui.Image_4:setRotation(0-angle)
--    if tonumber(rotate.pos.pointType) == 0 then
--        self.ui.Image_4:loadTexture("Image/challenge/challenge_small.png",0)
--    else
--        self.ui.Image_4:loadTexture("Image/challenge/challenge_big.png",0)
--    end
--    local p1,p2,p3,p4 = inner:convertToNodeSpace({x=0,y=0}),inner:convertToNodeSpace({x=size.width,y=0}),inner:convertToNodeSpace({x=size.width,y=size.height}),inner:convertToNodeSpace({x=0,y=size.height})
--    curmypos={x=rotate.mypos.x*120,y=rotate.mypos.y*120}
--    curpos={x=rotate.pos.x*120,y=rotate.pos.y*120}

--    self.ui.Beacon:setVisible(false)
--    if cc.pIsSegmentIntersect(p1,p4,curmypos,curpos) then
--        self.ui.Beacon:setVisible(true)
--        local pos = cc.pGetIntersectPoint(p1,p4,curmypos,curpos)
--        pos=inner:convertToWorldSpace(pos)
--        pos=self:convertToNodeSpace(pos)
--        pos={x=pos.x+self.ui.Beacon:getContentSize().width,y=pos.y}
--        self.ui.Beacon:setPosition(pos)
--    end
--    if cc.pIsSegmentIntersect(p2,p3,curmypos,curpos) then
--        self.ui.Beacon:setVisible(true)
--        local pos = cc.pGetIntersectPoint(p2,p3,curmypos,curpos)
--        pos=inner:convertToWorldSpace(pos)
--        pos=self:convertToNodeSpace(pos)
--        pos={x=pos.x-self.ui.Beacon:getContentSize().width,y=pos.y}
--        self.ui.Beacon:setPosition(pos) 
--    end
--    if cc.pIsSegmentIntersect(p1,p2,curmypos,curpos) then
--        self.ui.Beacon:setVisible(true)
--        local pos = cc.pGetIntersectPoint(p1,p2,curmypos,curpos)
--        pos=inner:convertToWorldSpace(pos)
--        pos=self:convertToNodeSpace(pos)
--        pos={x=pos.x,y=pos.y+self.ui.Beacon:getContentSize().height}
--        self.ui.Beacon:setPosition(pos)
--    end
--    if cc.pIsSegmentIntersect(p3,p4,curmypos,curpos) then 
--        self.ui.Beacon:setVisible(true)
--        local pos = cc.pGetIntersectPoint(p3,p4,curmypos,curpos)
--        pos=inner:convertToWorldSpace(pos)
--        pos=self:convertToNodeSpace(pos)
--        pos={x=pos.x,y=pos.y-self.ui.Beacon:getContentSize().height}
----        dump(pos)
--        self.ui.Beacon:setPosition(pos)
--    end
--end

--function MainUI:Beaconappear(ev,isappear)
--    self.ui.Beacon:setVisible(isappear)
--end

function MainUI:ShowPlayerInfo()
    if mdt.isplayerinfo ~= nil and not mdt.isplayerinfo then
        mdt.isplayerinfo = true
        self.playerinfo = self:getApp():createView('Cell.PlayerInfp')
        self.playerinfo:setPosition({x=mdt.clickpos.x*120+60-self.playerinfo:getContentSize().width/2,y=mdt.clickpos.y*120+60})
        ctr.game.Inner:addChild(self.playerinfo)
        self.playerinfo:setkey(mdt.pointPlayerInfo[mdt.clickpos.y][mdt.clickpos.x])
    end
end

function MainUI:ShowBoomEffect()
    self.eff = self:getApp():createView('spine.Baozha')
    self.eff:setPosition({x=mdt.boomx*120+60,y=mdt.boomy*120+60})
    ctr.game.Inner:add(self.eff)
end

function MainUI:RemoveBoomEffect()
    if self.eff ~= nil then
        util.delay(0.1,function ()
            ctr.game.Inner:removeChild(self.eff)
            self.eff=nil
        end,self)      
    end
end

function MainUI:CloseInfo()
    if self.playerinfo ~= nil then
        ctr.game.Inner:removeChild(self.playerinfo)
        self.playerinfo=nil
        mdt.isplayerinfo = false
    end
end

-- Event for Menu callback (addClickEventListener)
function MainUI:onMenu(node, eventType, userdata)
    self:CloseInfo()
    util.showDialog('Dialog', 'Menu.Menu')
end

-- Event for Shave callback (addClickEventListener)
function MainUI:onShave(node, eventType, userdata)
    if eventType==0 then
        mdt.mode=2
    else
        mdt.mode=1
    end
    event.dispatch('onRefreshCell')
end

-- Event for Map callback (addClickEventListener)
function MainUI:onMap(node, eventType, userdata)
    util.showDialog('Dialog', 'Map.Map')
end

function MainUI:NS_SyncBaseInfo()
    if mdt.findBlobsDay and mdt.findBlobs then self.ui.myFlagsSet:setString(mdt.findBlobsDay.."("..mdt.findBlobs..")") end
--    if mdt.openGridsDay and mdt.openGrids then self.ui.myCellsOpen:setString(mdt.openGridsDay.."("..mdt.openGrids..")") end
end

function MainUI:NS_SyncMainUiOpenGridInfo()
    self.ui.myFlagsSet:setString(mdt.findBlobs)
end

function MainUI:NS_SyncLifeInfo()
    mdt.life = mdt.life or 0
    if self.life and self.life>mdt.life then
        --self:play('lifedown')
--        self.ui.HeartSprite:setVisible(true)
--        self.ui.HeartSprite:setAnimation(1, 'animation', false)
    end
    self.life = mdt.life
    self.ui.myLife:setString(mdt.life)
--    self.psHeart:setPercentage(cc.clampf(mdt.life, 0, 5)*20)
    self:refreshTM()
end

function MainUI:NS_ApplyBuyLife(ev,ns)
    mdt.nextcost = ns.nNewItemCost
end

function MainUI:NS_BuyLife(ev,ns)
    if ns.nErrorCode == 0 then
        if mdt.mycostype == 'gold' then
            sdkManager.talkingdata:setEvent("11",{BuyLifeCoin = mdt.buylifenextcost})
            sdkManager.appsflyer:setEvent("11",{BuyLifeCoin = mdt.buylifenextcost})
        elseif mdt.mycostype == 'diamond' then
            sdkManager.talkingdata:setEvent("12",{BuyLifeDiamond = "10"})
            sdkManager.appsflyer:setEvent("12",{BuyLifeDiamond = "10"})
        end
        mdt.life = ns.nLifeNum
        self:RefreshLife()
    end
end

function MainUI:RefreshLife()
    self.ui.myLife:setString(mdt.life)
--    self.psHeart:setPercentage(cc.clampf(mdt.life, 0, 5)*20)
    self:refreshTM()
end

function MainUI:NS_GetBoxAchievement(ev,ns)
    if util.isShowDialog('MsgBoard.BottleFish') then
        util.delay(3,function ()
            local view = util.showDialog('Dialog2', 'Box.Box')
            view:setId(ns.nBoxID)
        end)
    else
        local view = util.showDialog('Dialog2', 'Box.Box')
        view:setId(ns.nBoxID)
    end
    
end

function MainUI:NS_NotifyClickBigMapGetDriftBottle()
    if util.isShowDialog('Common.ContinueDialog') then
        util.closeDialog('Common.ContinueDialog')
    end
    util.showDialog('Dialog', 'Common.ContinueDialog')
    self.ui.redpoint_2:setVisible(true)
end

function MainUI:NS_ReachAchievement(ev,ns)
    self.ReachAchievement = nil
    for k , _ in pairs(static.achievement) do
        if static.achievement[k].code == tonumber(ns.nRank) then
            self.ReachAchievement = static.achievement[k]
            break
        end
    end
    self.ui.SuccessTxt:setString(static.language[tonumber(self.ReachAchievement.name)][device.language])
    self.ui.Image_17:loadTexture(self.ReachAchievement.image,0)
    self.ui.Image_9:setVisible(true)
    self:play('success',false)
    util.delay(5,function ()
        self.ui.Image_9:setVisible(false)
    end)
    self.ui.redtip:setVisible(true)

    if self.ReachAchievement.googleAch ~= "0" and util.isAndroid() then
        sdkManager.locojoybj:googleAchievement(self.ReachAchievement.googleAch)
    end
end

function MainUI:NS_GMSendReward(ev,ns)
    self.ui.Gift:setVisible(#mdt.CanPickReward > 0)
    self.ui.Gift:setTouchEnabled(#mdt.CanPickReward > 0)
end

function MainUI:NS_RequestDayChallengeReward(ev,ns)
    self.ui.DCReward:setVisible(#mdt.CanPickDayReward > 0)
    self.ui.DCReward:setTouchEnabled(#mdt.CanPickDayReward > 0)
end

function MainUI:NS_GetReward(ev,ns)
    if ns.nIsSuccess then
        local list = {}
        if mdt.CanPickReward[1].nTypeId_1~= 0 then
            local item = {}
            if mdt.CanPickReward[1].nTypeId_1 == 6 then
                local lv = 0
                for k,v in pairs(static.item) do
                    if tonumber(v.id) == mdt.CanPickReward[1].nParam_1_1 then
                        lv = k
                        break
                    end
                end
                item = {id = mdt.CanPickReward[1].nTypeId_1,value = lv,num = mdt.CanPickReward[1].nParam_1_2}
            elseif mdt.CanPickReward[1].nTypeId_1 == 4 then
                item = {id = mdt.CanPickReward[1].nTypeId_1,value =tonumber(mdt.CanPickReward[1].nParam_1_1)-50000,num = mdt.CanPickReward[1].nParam_1_2}
            else
                item = {id = mdt.CanPickReward[1].nTypeId_1,num = mdt.CanPickReward[1].nParam_1_2,value = 0}
            end
            list[#list+1] = item
        end
        if mdt.CanPickReward[1].nTypeId_2~= 0 then
            local item = {}
            if mdt.CanPickReward[1].nTypeId_2 == 6 then
                local lv = 0
                for k,v in pairs(static.item) do
                    if tonumber(v.id) == mdt.CanPickReward[1].nParam_2_1 then
                        lv = k
                        break
                    end
                end
                item = {id = mdt.CanPickReward[1].nTypeId_2,value = lv,num = mdt.CanPickReward[1].nParam_2_2}
            elseif  mdt.CanPickReward[1].nTypeId_2 == 4 then
                item = {id = mdt.CanPickReward[1].nTypeId_2,value =tonumber(mdt.CanPickReward[1].nParam_2_1)-50000,num = mdt.CanPickReward[1].nParam_2_2}
            else
                item = {id = mdt.CanPickReward[1].nTypeId_2,num = mdt.CanPickReward[1].nParam_2_2,value = 0}
            end
            list[#list+1] = item
        end
        if mdt.CanPickReward[1].nTypeId_3~= 0 then
            local item = {}
            if mdt.CanPickReward[1].nTypeId_3 == 6 then
                local lv = 0
                for k,v in pairs(static.item) do
                    if tonumber(v.id) == mdt.CanPickReward[1].nParam_3_1 then
                        lv = k
                        break
                    end
                end
                item = {id = mdt.CanPickReward[1].nTypeId_3,value = lv,num = mdt.CanPickReward[1].nParam_3_2}
            elseif  mdt.CanPickReward[1].nTypeId_3 == 4 then
                item = {id = mdt.CanPickReward[1].nTypeId_3,value =tonumber(mdt.CanPickReward[1].nParam_3_1)-50000,num = mdt.CanPickReward[1].nParam_3_2}
            else
                item = {id = mdt.CanPickReward[1].nTypeId_3,num = mdt.CanPickReward[1].nParam_3_2}
            end
            list[#list+1] = item
        end
        local view = util.showDialog('Dialog2', 'Common.RewardDialog2')
        view:setkey(list) 
    end
    table.remove(mdt.CanPickReward,1)
    event.dispatch('updateItemCount')
    self.ui.Gift:setVisible(#mdt.CanPickReward > 0)
    self.ui.Gift:setTouchEnabled(#mdt.CanPickReward > 0)
end

function MainUI:NS_GetDayChallengeReward(ev,ns)
    if ns.nReturnStatus == 0 then
        for k,v in pairs(mdt.CanPickDayReward) do
            if v.nTableId == ns.nTableId then
                local view = util.showDialog('Dialog2', 'Common.ChallengeRewardDialog')
                view:setkey(v.nAddScore) 
                table.remove(mdt.CanPickDayReward,k)
            end
            break
        end
        --mdt.mypvpcoin = mdt.mypvpcoin + ns.nAddScore
        self.ui.DCReward:setVisible(#mdt.CanPickDayReward > 0)
        self.ui.DCReward:setTouchEnabled(#mdt.CanPickDayReward > 0)
    end
end

-- Event for RankToday callback (addTouchEventListener)
function MainUI:onTouchRank(node, eventType, userdata)
    if eventType == ccui.TouchEventType.ended and self.ui.RankToday:getPositionX() > 1005 and self.isrank == false then
        self.isrank = true
        self.ui.RankToday:runAction(cc.MoveBy:create(0.3, cc.p(-550, 0)))
        self.ui.Image_5:setFlippedX(false)
        net.msg.NC_LoadRanking(6 ,1 ,5)
        --self.ui.Panel_3:setVisible(true)
    end

    if eventType == ccui.TouchEventType.ended and self.ui.RankToday:getPositionX() < 1005 and self.isrank == true then
        self.isrank = false
        self.ui.RankToday:runAction(cc.MoveBy:create(0.3, cc.p(550, 0)))
        self.ui.Image_5:setFlippedX(true)
       -- self.ui.Panel_3:setVisible(false)
    end
    self.ui.Text_6:setString(static.language[30062][device.language])
end

-- Event for MsgBoard callback (addClickEventListener)
function MainUI:onMsgBoard(node, eventType, userdata)
    util.showDialog('Dialog', 'MsgBoard.MsgBoard')
end

-- Event for Gift callback (addClickEventListener)
function MainUI:OnReward(node, eventType, userdata)
    net.msg.NC_GetReward(mdt.CanPickReward[1].nTableId)
end

-- Event for Notice callback (addClickEventListener)
function MainUI:onGongGao(node, eventType, userdata)
    util.showDialog('Dialog3','Notice.Notice')
end

-- Event for BuyCoin_0 callback (addClickEventListener)
function MainUI:onCharge(node, eventType, userdata)
    if not self.isopen then
        self.isopen = true
        local view = util.showDialog('Dialog', 'Shop.Shop')
        view:MainUICharge()
    end
end

-- Event for Panel_1 callback (addClickEventListener)
function MainUI:OnClickFace(node, eventType, userdata)
    event.dispatch('ChangeFace',3)
end

-- Event for DCReward callback (addClickEventListener)
function MainUI:OnDayReward(node, eventType, userdata)
    net.msg.NC_GetDayChallengeReward(mdt.CanPickDayReward[1].nTableId)
end



-- Event for BoxReward callback (addClickEventListener)
function MainUI:OnBoxReward(node, eventType, userdata)
    self.ui.Box1:setVisible(false)
    self.ui.BoxBtn:setVisible(true)
    util.showDialog('Dialog', 'Box.BoxView')
end


-- Event for Item1 callback (addClickEventListener)
function MainUI:OnUseItem(node, eventType, userdata)
    if mdt.life <= 0 then
        util.showDialog('Dialog', 'Common.BuyLife')   --弹出购买生命弹板
        return
    end
    local count = self.ui['ItemCount'..userdata]:getString()
    if tonumber(count) <= 0 then print('item'..50000+tonumber(userdata)..' is null!!!!!!!!!!!!!!') return end
    if tonumber(userdata) == 1 then
        if mdt.itemboomcd == false then
            mdt.UseItemBoom = not mdt.UseItemBoom
            self.ui.PitchOn1:setVisible(mdt.UseItemBoom)
        end
    elseif tonumber(userdata) == 2 then
        if not mdt.UseItemTwo then
            net.msg.NC_ApplyUseItem(50002)
        end
    end
end

function MainUI:CloseUseItem(ev,bo)
    if not bo then        
        local to1 = cc.ProgressTo:create(10, 100)
        local left = cc.ProgressTimer:create(cc.Sprite:create("Image/darkUI/wudi.png"))
        left:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
        left:setPosition(cc.p(0,0))
        left:runAction(to1)
        left:setScale(1.3)
	    self.ui.Node_3:addChild(left)  

        self.ui.Item2:loadTexture("Image/darkUI/wudi_cd.png",0)   

        self.ui.ItemTime:setVisible(false) 

        util.delay(10,function ()           
            self.ui.Item2:loadTexture("Image/darkUI/wudi.png",0) 
            self.ui.Node_3:removeChild(left)
        end)  
        if self.effwudi ~= nil then
            self.ui.Node_4:setVisible(false)
        end
        event.dispatch('playMusic')
    else
        event.dispatch('playWudi')
        self.ui.Node_4:setVisible(true)
        mdt.wudiCD = 10
        self.ui.ItemTime:setString(math.ceil(mdt.wudiCD))
        self.ui.ItemTime:setVisible(true)
--        self.schedule = util.scheduleNode(1,function()            
--            time = time - 1
--            if time <= 0 then
--                time = 0
--            end
--            self.ui.ItemTime:setString(time)
--        end)
    end
    self.ui.PitchOn2:setVisible(bo)
end

function MainUI:setwudiCD()
    self.ui.ItemTime:setString(math.ceil(mdt.wudiCD))
end

function MainUI:CloseUseBoom(ev,bo)
    if bo then   
        audio.playEffect('boom')     
        local to1 = cc.ProgressTo:create(10, 100)
        local left = cc.ProgressTimer:create(cc.Sprite:create("Image/darkUI/bomb.png"))
        left:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
        left:setPosition(cc.p(0,0))
        left:runAction(cc.RepeatForever:create(to1))
        left:setScale(1.3)
	    self.ui.Node_3_0:addChild(left)  
        self.ui.Item1:loadTexture("Image/darkUI/bomb_cd.png",0)    
        util.delay(10,function ()           
            self.ui.Item1:loadTexture("Image/darkUI/bomb.png",0) 
            self.ui.Node_3_0:removeChild(left)
        end)  
        self.eff = self:getApp():createView('spine.Baozha')
        self.eff:setPosition({x=mdt.useboomx*120+60,y=mdt.useboomy*120+60})
        self.eff:setScale(5)
        ctr.game.Inner:add(self.eff)
        util.delay(1,function ()
            ctr.game.Inner:removeChild(self.eff)
            self.eff=nil
        end,self)
    end
      
    self.ui.PitchOn1:setVisible(false)
end

-- Event for Image_9 callback (addClickEventListener)
function MainUI:OnClickAch(node, eventType, userdata)
    self.ui.Image_9:setVisible(false)
    local view = util.showDialog('Dialog', 'Success.Success')
    view:setListPosition(self.ReachAchievement.achID)
end

-- Event for Rank callback (addClickEventListener)
function MainUI:onRank(node, eventType, userdata)
    util.showDialog('Dialog', 'Rank.Rank')
end

function MainUI:ItemOpen()
    self.ui.ItemPanel:setVisible(mdt.ItemModsOpen == 1)
end

-- Event for FirstRecharge callback (addClickEventListener)
function MainUI:OnFirstRecharge(node, eventType, userdata)
    util.showDialog('Dialog','Common.FirstRechage')
end

return MainUI
