local MainScene = class("MainScene", cc.load("mvc").ViewBase)
MainScene.RESOURCE_FILENAME = "MainScene"

function MainScene:onCreate()
    self:addEvent('onShake')
    self:addEvent('onThemeChanged')
    self:addEvent('NG2GWS_SendFindBlobsToAll')
    self:addEvent('NS_InformSwitchMap')
    self:addEvent('onLoadMain')      -- ÇÐÈëÌôÕ½Ä£Ê½
    self:addEvent('onLoadChallenge')      -- ÇÐÈëÌôÕ½Ä£Ê½
    self:addEvent('onLoadNewbie')
    self:addEvent('zoumadengappear')
    self:addEvent('NS_SendAllRunningHorseLantern')
    self:addEvent("NS_LoginContinueChallenge") ------TODO

    self:addEvent('NS_RequestAllCoolDownItem')

    self:addEvent('playMusic')
    self:addEvent('playWudi')
    
    self.noticelist = {}
    self.gmnoticelist = {}
    self.noticelistsp = {}
    
end

function MainScene:NS_RequestAllCoolDownItem(env,ns)
    local cdtimes, minTime = mdt.getCooldownTimeByID(mdt.ADS_COOLDOWN_ID.SUPPOT)

    self.avilable = false

    if cdtimes then
        for _, v in ipairs(cdtimes) do
            if v.CoolDownTime == 0 and AdManager:isADAvailable(v.ADID) then
                self.avilable = true
                break
            end
        end
    end

    if not self.avilable then
        self.countDownAD = minTime
    end
    mdt.avilable = self.avilable
    event.dispatch('CloseInfoRedP')
end

function MainScene:onEnter()
    sdkManager.talkingdata:setAccountInfos(tostring(mdt.player.nGUID.a),mdt.player.sMineMapData.szName,0,0,mdlogin.getCurLoginServerID(),mdlogin.getLastlistServerID()) --TODO
    local view = util.createView('Main.Main')
    self.ui.Main:add(view)
    self:runAnimation()
    if audio.isMusicEnable() then
        audio.playMusic('start', function()
            self:playMusic()
        end)
    else
        self:playMusic()
    end
    -- util.schedule(10,function()
    --     net.msg.NC_RequestAllCoolDownItem()
    -- end)
    self:onThemeChanged()
    self.ui.Spine_1:setVisible(false)
    self.ui.Spine_1_0:setVisible(false)
    self.ui.Spine_1_1:setVisible(false)
    self.ui.Zoumadeng:setVisible(false)
    self.ui.Zoumadeng2:setVisible(false)
    self.ui.Zoumadengsp:setVisible(false)

    if util.isShowDialog('Common.Waiting') then
        util.closeDialog('Common.Waiting')
    end
    if mdt.chainfo == nil then

        mdt.Newbieagain = false
        mdlogin.setIsNewbieComplete(mdlogin.getCurLoginServerID(), true)

        if mdlogin.getIsNewbieBeging(mdlogin.getCurLoginServerID()) then
            ctr.player.showMessageBox(static.language[30152][device.language], 2, function(ok)
                if ok then
                    --mdt.ismenunewbie = true
                    event.dispatch('onLoadNewbie')
                    mdt.NewbieagainTrue = true
                    if mdr.NewbieagainTrue == nil then
                        mdr.NewbieagainTrue = false
                    end
                    if not mdr.NewbieagainTrue then
                        sdkManager.talkingdata:setEvent("63",{BottleReplyPlayer = "NewGuideTrue"})
                        sdkManager.appsflyer:setEvent("63",{BottleReplyPlayer = "NewGuideTrue"})
                        mdr.NewbieagainTrue = true
                        mdr.save()
                    end
                end
            end)
        else
            if ctr.login.isFacebookAccount() == false then           
                if mdt.changenemecount <= 0 then
                    if mdt.ismenunewbie == nil or not mdt.ismenunewbie then
                        util.showDialog('Dialog','Common.ChangeName')
                    end
                end
            end
        end
    else
        self:refreshChallengeInfo()
    end
    self.iszoumadeng = true

    self:doRequestProducts()
    net.msg.NC_GetSysRewardList()

    mdt.isInGame = true

    net.msg.NC_RequestAllCoolDownItem()

    util.scheduleNode(1, function()
        if not self.avilable and self.countDownAD then
            self.countDownAD = self.countDownAD - 1
            if self.countDownAD <= 0 then
                self.countDownAD = 0
                net.msg.NC_RequestAllCoolDownItem()
            end
        end
    end, self)

    
end

function MainScene:checkBoxAvilable()
    return self.avilable
end

function MainScene:onExit()

end

function MainScene:doRequestProducts()
    if util.isIOS() then
        if false == sdkManager.applepay:isRequestedProducts() then
            local productsList = {}
            local paytype = 0
            if static.isHaiWai then
                paytype = 2 
            else
                paytype = 1
            end
            for k,v in pairs(static.diamond) do
                if v.type == paytype then --type=1 已经废弃
                    table.insert(productsList,v.iapId)
                end
            end
            -- ctr.player.showWaiting()
            sdkManager.applepay:requestProducts(productsList,function (isSuccess)
                -- ctr.player.hideWaiting()
            end)
        end
    end
end

function MainScene:refreshChallengeInfo()
    local ns = mdt.chainfo
    event.dispatch('onLoadChallenge')
    mdt.point = {}
    mdt.pointInfo = {}
    mdt.x = math.floor(ns.nMapWidth/2)
    mdt.y = math.floor(ns.nMapHeight/2)    
    mdt.w = ns.nMapWidth
    mdt.h = ns.nMapHeight
--        for j=0,ns.nMapHeight-1 do
--            local pj = {}
--            mdt.point[j] = pj
--            for i=0,ns.nMapWidth-1 do
--                pj[i] = net.enum.EBigMapGridStatus_UNOPEN
--            end
--        end

    local a = 1
    local zero = false
    local nflag = 0
    for i = 1 , ns.nMapHeight do
        local pj = {}
        for j = 1 , ns.nMapWidth do
            local x = j-1
            local y = i-1
            local p = mdt.point[y]
            if not p then
                p = {}
                mdt.point[y] = p
            end
            local px = p[x]

            if px~=ns.statusList[a] then
                p[x] = ns.statusList[a]   
                --mdt.effect[#mdt.effect+1] = { x=x, y=y, state=ns.statusList[a]==10 and 2 or 1 }
                if ns.statusList[a]==0 then
                    zero = true
                end
            end

            if ns.statusList[a]==10 then
                nflag=nflag+1
                mdt.setFlagset(mdt.flagindex, x, y)
            end
            pj[j-1] = ns.statusList[a]
            a=a+1
        end
        mdt.point[i-1] = pj
    end
end

function MainScene:NS_LoginContinueChallenge(env,ns)
    self:refreshChallengeInfo()
end

function MainScene:playMusic()
    local play = nil
    play = function()
        local idx = math.random(1, 4)
        audio.playMusic('bgm'..idx, function()
            util.delay(0, play)
        end)
    end
    play()
end

function MainScene:playWudi()
    local play = nil
    play = function()
        local idx = math.random(1, 7)
        audio.playMusic('wudi', function()
            util.delay(0, play)
        end)
    end
    play()
end

function MainScene:onShake()
    self:play('shake')
end

function MainScene:onThemeChanged()
    self.ui.MainUI:removeAllChildren()
    local view = nil
    if mdt.isChallenge then
        view = util.createView('Challenge.ChallengeUI', 'Themes.Theme'..mdt.theme..'.ChallengeUI')
    else
        view = util.createView('Main.MainUI', 'Themes.Theme'..mdt.theme..'.MainUI')
        --view = util.createView('Main.MainUI', 'Themes.Theme0.MainUI')
    end
    self.ui.MainUI:add(view)
end

function MainScene:zoumadengappear()
    self.iszoumadeng = true
end

function MainScene:NG2GWS_SendFindBlobsToAll(ev,ns)
    dump(ns:copyTo())
    if ns.nType == 1 then
        if self.iszoumadeng ~= nil and self.iszoumadeng then
            self.ui.Zoumadeng:setVisible(true)
        end
        table.insert(self.noticelist,ns.szName)
        while (#self.noticelist > 0) do
            local ui = self.ui.ZouText:clone()
            local msg = ''

            if ns.nFindNum == 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                dump(str,ns.szName)
                msg = string.format(str,ns.szName)
            elseif ns.nFindNum > 0 and string.len(ns.szName) > 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.nFindNum)
            elseif ns.nFindNum > 0 and string.len(ns.szName) <= 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.nFindNum)
            elseif ns.nFindNum_2 > 0 and ns.szName_Old == '' then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.szName,ns.nFindNum,ns.nFindNum_2)
            elseif ns.nFindNum_2 > 0 and ns.szName_Old ~= '' then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.szName,ns.szName_Old,ns.nFindNum,ns.nFindNum_2)
            else
                msg:setString(static.zoumadeng[ns.nCode].text)
            end
            ui:setString(msg)
            local size = ui:getContentSize();
            local panelSize = self.ui.Zoumadeng:getContentSize()
            local px = panelSize.width
            if self.lastTxt then
                local jiange = 75
                local lastposX = self.lastTxt:getPositionX() 
                local lastSize = self.lastTxt:getContentSize()
                local px2 = lastposX + 1280 + jiange
                px = math.max(px, px2)
            end
            local py = panelSize.height/2
            ui:setPosition(px, py)
            local speed = 150
            local time = (px + size.width)/speed
            self.ui.Zoumadeng:addChild(ui)
            local action = cc.Sequence:create(cc.MoveTo:create(time, cc.p(-size.width,py)) , 
                cc.CallFunc:create(function() 
                    if self.lastTxt == ui then
                        self.lastTxt = nil
                        self.ui.Zoumadeng:setVisible(false)
                    end
                    ui:removeFromParent()
                end))
            ui:runAction(action)
            table.remove(self.noticelist,1)
        
            self.lastTxt = ui
        end
    else
        if self.iszoumadeng ~= nil and self.iszoumadeng then
            self.ui.Zoumadengsp:setVisible(true)
            self.ui.Spine_1:setVisible(true)
            self.ui.Spine_1_0:setVisible(true)
            self.ui.Spine_1_1:setVisible(true)     
            self:play('fire',true)
        end
        table.insert(self.noticelistsp,ns.szName)
        while (#self.noticelistsp > 0) do
            local ui = self.ui.ZouTextsp:clone()
            local msg = ''

            if ns.nFindNum == 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.szName)
            elseif ns.nFindNum > 0 and string.len(ns.szName) > 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.nFindNum)
            elseif ns.nFindNum > 0 and string.len(ns.szName) <= 0 and ns.nFindNum_2 <= 0 then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.nFindNum)
            elseif ns.nFindNum_2 > 0 and ns.szName_Old == '' then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.szName,ns.nFindNum,ns.nFindNum_2)
            elseif ns.nFindNum_2 > 0 and ns.szName_Old ~= '' then
                local str = static.language[tonumber(static.zoumadeng[ns.nCode].text)][device.language]
                msg = string.format(str,ns.szName,ns.szName_Old,ns.nFindNum,ns.nFindNum_2)
            else
                msg:setString(static.zoumadeng[ns.nCode].text)
            end
            ui:setString(msg)
            local size = ui:getContentSize();
            local panelSize = self.ui.Zoumadengsp:getContentSize()
            local px = panelSize.width
            if self.lastTxtsp then
                local jiange = 75
                local lastposX = self.lastTxtsp:getPositionX() 
                local lastSize = self.lastTxtsp:getContentSize()
                local px2 = lastposX + lastSize.width + jiange
                px = math.max(px, px2)
            end
    
            local py = panelSize.height/2
            ui:setPosition(px, py)
            local speed = 150
            local time = (px + size.width)/speed
            self.ui.Zoumadengsp:addChild(ui)
            local action = cc.Sequence:create(cc.MoveTo:create(time, cc.p(-size.width,py)) , 
                cc.CallFunc:create(function() 
                    if self.lastTxtsp == ui then
                        self.lastTxtsp = nil
                        self.ui.Zoumadengsp:setVisible(false)
                        self.ui.Spine_1:setVisible(false)
                        self.ui.Spine_1_0:setVisible(false)
                        self.ui.Spine_1_1:setVisible(false)
                    end
                    ui:removeFromParent()
                end))
            ui:runAction(action)
            table.remove(self.noticelistsp,1)
        
            self.lastTxtsp = ui
        end
    end
end

function MainScene:NS_SendAllRunningHorseLantern(ev,ns)
    if self.iszoumadeng ~= nil and self.iszoumadeng then
        self.ui.Zoumadeng2:setVisible(true)
    end
    table.insert(self.gmnoticelist,ns.szPlayerFeedback)
    while (#self.gmnoticelist > 0) do
        local ui = self.ui.ZouText2:clone()
        local msg = ns.szPlayerFeedback
        ui:setString(msg)
        local size = ui:getContentSize();
        local panelSize = self.ui.Zoumadeng2:getContentSize()
        local px = panelSize.width
        if self.lastTxt2 then
            local jiange = 75
            local lastposX = self.lastTxt2:getPositionX() 
            local lastSize = self.lastTxt2:getContentSize()
            local px2 = lastposX + lastSize.width + jiange
            px = math.max(px, px2)
        end
    
        local py = panelSize.height/2
        ui:setPosition(px, py)
        local speed = 150
        local time = (px + size.width)/speed
        self.ui.Zoumadeng2:addChild(ui)
        local action = cc.Sequence:create(cc.MoveTo:create(time, cc.p(-size.width,py)) , 
            cc.CallFunc:create(function() 
                if self.lastTxt2 == ui then
                    self.lastTxt2 = nil
                    self.ui.Zoumadeng2:setVisible(false)
                end
                ui:removeFromParent()
            end))
        ui:runAction(action)
        table.remove(self.gmnoticelist,1)
        
        self.lastTxt2 = ui
    end
end

function MainScene:NS_InformSwitchMap(ev, ns)
    util.showDialog('Dialog', 'End.EndDialog')
end

function MainScene:onLoadChallenge(ev, ns)
    self.ui.Main:removeAllChildren()
    local view = util.createView('Challenge.Challenge')
    self.ui.Main:add(view)
    self:onThemeChanged()
end

function MainScene:onLoadNewbie(ev,ns)
    util.showDialog(nil,'Newbie.Guide')
--    self.ui.Main:removeAllChildren()
--    self.ui.MainUI:removeAllChildren()
--    local view = util.createView('Newbie.Newbie')
--    self.ui.Main:add(view)
--    local uiview = util.createView('Challenge.ChallengeUI', 'Themes.Theme'..mdt.theme..'.ChallengeUI')
--    self.ui.MainUI:add(uiview)
end

function MainScene:onLoadMain()
    if mdt.isChallenge or mdt.isNewbie then
        mdt.isChallenge = false
        mdt.isNewbie = false
        self.ui.Main:removeAllChildren()
        local view = util.createView('Main.Main')
        self.ui.Main:add(view)
        self:onThemeChanged()
    end
end

return MainScene