local MapListItem = class("MapListItem", cc.load("mvc").LayoutBase)
MapListItem.RESOURCE_FILENAME = "Map.MapListItem"

function MapListItem:onCreate()

end

function MapListItem:onEnter()

end

function MapListItem:onExit()

end

function MapListItem:setKey(key,index)
	self.key=key
	self:refreshUI()
end

function MapListItem:refreshUI()
	if self.key then
--        dump(self.key)
		self.ui.txtPlayerName:setString(self.key.nPlayerName=="" and "------" or self.key.nPlayerName)
		self.ui.txtRecordValue:setString(self.key.nChallengeTime)
		self.ui.ndHead:setInfo(mdt.player.nGUID, self.key.nPlayerHeadUrlIndex,self.key.nPlayerCountryIndex)
		-- self.ui.ndHead:setInfo(mdt.player.nGUID,"icon1.png")
		self:setTypeImage(self.key.nPointType)
        self.ui.txtRecord:setString(static.language[30002][device.language])
        self.ui.btnChallenge:setTitleText(static.language[10006][device.language])
--        if self.key.nPlayerHeadUrlIndex ~= 0 and self.key.nPlayerCountryIndex ~= 0 then
--            self.ui.Head:setInfo(self.key.nPlayerId, self.key.nPlayerHeadUrlIndex,self.key.nPlayerCountryIndex)
--        end
	end
end

-- Event for Button_1 callback (addClickEventListener)
function MapListItem:onChallenge(node, eventType, userdata)
	if self.key then
		event.dispatch("onMapGo", cc.p(self.key.nPosX,self.key.nPosY))
		event.dispatch("onMapClose")
	end
end

function MapListItem:setTypeImage(typeIndex)
	if self.ui.lyIndexType then
		local children = self.ui.lyIndexType:getChildren()
		local childrenCount = self.ui.lyIndexType:getChildrenCount()
		for i=1,childrenCount do 
			children[i]:setVisible(i==(typeIndex+1))
		end
	end
end

return MapListItem