local Menu = class("Menu", cc.load("mvc").LayoutBase)
Menu.RESOURCE_FILENAME = "Menu.Menu"

function Menu:onCreate()
    self:addEvent('getach')
end

function Menu:onEnter()
    self.ui.Name:setString(static.language[20015][device.language])

--    self.ui.SoundButton:setSelected(mdr.settings.music)
--    self.ui.SoundButton:setBright(mdr.settings.music)
--    self.ui.VoiceButton:setSelected(mdr.settings.sound)
--    self.ui.VoiceButton:setBright(mdr.settings.sound)
    self.ui.Panel_FB:setVisible(false)
    self.ui.Text_11:setString(static.language[20006][device.language])
    self.ui.Text_11_0:setString(static.language[20010][device.language])
    self.ui.Text_11_1:setString(static.language[20011][device.language])
    self.ui.Text_11_2:setString(static.language[20020][device.language])
    self.ui.Text_11_3:setString(static.language[20013][device.language])
    self.ui.Text_11_4:setString(static.language[20012][device.language])
    self.ui.Text_11_5:setString(static.language[20007][device.language])
    self.ui.Text_11_6:setString(static.language[10018][device.language])
--    self.ui.Text_3:setString(static.language[20008][device.language])
    self.ui.Share.ui.btnText:onSetAD(0,0)
    self.ui.AD.ui.btnText:onSetAD(1,0)
    self.ui.AD:setVisible(false)
    
--    self.ui.Sound:setString(static.language[30044][device.language])
--    self.ui.Voice:setString(static.language[30045][device.language])
--    if mdt.mode==2 then
--        self.ui.Shave:setSelected(true)
--    else
--        self.ui.Shave:setSelected(false)
--    end
    self:getach()
    self.ui.redtip2:setVisible(mdt.avilable)
    if static.isHaiWai then
        self.ui.Panel_FB:setVisible(mdt.LastLoginType ~= 'Facebook')
    else
        self.ui.Panel_FB:setVisible(false)
    end
    self.ui.redtip:setVisible(mdt.haveach)
end


function Menu:onExit()

end

function Menu:getach()
    if mdt.reachAch~=nil and #mdt.reachAch>0 then
        self.ui.redtip:setVisible(true)
    else
        self.ui.redtip:setVisible(false)
    end
end

-- Event for BG callback (addClickEventListener)
function Menu:onClose(node, eventType, userdata)

end

-- Event for Rank callback (addClickEventListener)
function Menu:onRank(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_0:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_0:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_0:setTextColor({r = 0, g = 0, b = 0})
        util.showDialog('Dialog', 'Rank.Rank')
    end
end

-- Event for Info callback (addClickEventListener)
function Menu:onInfo(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_1:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_1:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_1:setTextColor({r = 0, g = 0, b = 0})
        if not mdr.infoP then
            event.dispatch('CloseInfoRedP')
            mdr.infoP = true
            mdr.save()
            self.ui.redtip2:setVisible(false)
        end
        util.showDialog('Dialog', 'Info.Info')
    end
end

-- Event for Share callback (addClickEventListener)
function Menu:onShare(node, eventType, userdata)
    util.showDialog('Dialog', 'Share.Share')
end

-- Event for Rules callback (addClickEventListener)
function Menu:onGuide(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_5:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_5:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_5:setTextColor({r = 0, g = 0, b = 0})
        util.showDialog('Dialog', 'Guide.Guide')
    end
end

-- Event for Themes callback (addClickEventListener)
function Menu:onShop(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        local Recharge = util.showDialog('Dialog','Recharge.Recharge')
        Recharge:chooseMode(1)
        self.ui.Text_11:setTextColor({r = 0, g = 0, b = 0})
    end
end
-- Event for Panel_Charge callback (addClickEventListener)
function Menu:onRecharge(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_2:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_2:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        local shop= util.showDialog('Dialog', 'Shop.Shop')
        shop:chooseMode(userdata)
        self.ui.Text_11_2:setTextColor({r = 0, g = 0, b = 0})
    end
end
-- Event for SoundButton callback (addEventListener)
function Menu:onSetMusic(node, eventType, userdata)
    mdr.setMusic(eventType==0)
    mdr.setSound(eventType==0)
    self.ui.SoundButton:setSelected(mdr.settings.music)
    self.ui.SoundButton:setBright(mdr.settings.music)
--    self.ui.VoiceButton:setSelected(mdr.settings.sound)
--    self.ui.VoiceButton:setBright(mdr.settings.sound)
end

-- Event for VoiceButton callback (addEventListener)
function Menu:onSetSound(node, eventType, userdata)
    mdr.setSound(eventType==0)
--    self.ui.VoiceButton:setSelected(mdr.settings.sound)
--    self.ui.VoiceButton:setBright(mdr.settings.sound)
end


-- Event for Success callback (addClickEventListener)
function Menu:onSuccess(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_4:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_4:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_4:setTextColor({r = 0, g = 0, b = 0})
        util.showDialog('Dialog', 'Success.Success')
    end
end

-- Event for Panel_Button_5 callback (addClickEventListener)
function Menu:onFeedback(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_3:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_3:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_3:setTextColor({r = 0, g = 0, b = 0})
       -- util.showDialog('Dialog', 'Feedback.Feedback')
    end
end

-- Event for Shave callback (addEventListener)
function Menu:onShave(node, eventType, userdata)
    if eventType==0 then
        mdt.mode=2
    else
        mdt.mode=1
    end
    ctr.game.refreshCell()
end

-- Event for Button_29 callback (addClickEventListener)
function Menu:OnNewbie(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_5:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_5:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_5:setTextColor({r = 0, g = 0, b = 0})
--        util.showDialog('Dialog', 'Guide.Guide')
        mdt.ismenunewbie = true
        event.dispatch('onLoadNewbie')
        mdt.Newbieagain = true
    end
end

-- Event for Button_1 callback (addClickEventListener)
function Menu:OnTips(node, eventType, userdata)
    local view = util.showDialog('Dialog','Common.TipDialog')
    view:setkey(2)
end


-- Event for Panel_Setting callback (addClickEventListener)
function Menu:OnSetting(node, eventType, userdata)
    if eventType == 0 then
        self.ui.Text_11_6:setTextColor({r = 255, g = 255, b = 255})
    elseif eventType == 1 then
        self.ui.Text_11_6:setTextColor({r = 0, g = 0, b = 0})
    elseif eventType == 2 then
        self.ui.Text_11_6:setTextColor({r = 0, g = 0, b = 0})
--        util.showDialog('Dialog', 'Guide.Guide')
        util.showDialog('Dialog', 'Setting.Setting')
    end
end


-- Event for Panel_AD callback (addClickEventListener)
function Menu:onAD(node, eventType, userdata)
    -- local view = util.showDialog('Dialog', 'Common.ADBoxDialog')
    -- view:setPageType(mdt.ADS_COOLDOWN_ID["SUPPOT"])
    -- mdt.avilable = false
    -- self.ui.redtip2:setVisible(mdt.avilable)
    -- event.dispatch('CloseInfoRedP')
end

-- Event for ButtonFB callback (addTouchEventListener)
function Menu:onFB(node, eventType, userdata)
    local luaj = require "cocos.cocos2d.luaj"
    local classname = "org/cocos2dx/lua/AppActivity"
    local args = {nil}
    local sigs = "()V"

    local ok, ret = luaj.callStaticMethod(classname, "binAccount", args, sigs)
end

-- Event for Panel_FB callback (addClickEventListener)
function Menu:onFBLogin(node, eventType, userdata)
    sdkManager.locojoybj:bind()
end

return Menu
