local BottleInfoItem = class("BottleInfoItem", cc.load("mvc").LayoutBase)
BottleInfoItem.RESOURCE_FILENAME = "MsgBoard.BottleInfoItem"

function BottleInfoItem:onCreate()

end

function BottleInfoItem:onEnter()

end

function BottleInfoItem:onExit()

end

function BottleInfoItem:setTitle(t)
    self.ui.txtName:setString(t.szPlayerName)
    self.ui.txtContent:setString(t.szContent)
    local time = os.date("*t",t.nBriefInfo.nCreateTime)
    local hourstr = ''
    if tonumber(time.hour) < 10 then
        hourstr = '0'..time.hour
    else
        hourstr = time.hour
    end
    local minstr = ''
    if tonumber(time.min) < 10 then
        minstr = '0'..time.min
    else
        minstr = time.min
    end
    local secstr = ''
    if tonumber(time.sec) < 10 then
        secstr = '0'..time.sec
    else
        secstr = time.sec
    end
    self.ui.txtTime:setString(time.year..'/'..time.month..'/'..time.day..' '..hourstr..':'..minstr..':'..secstr)
--    self.ui.Head:setInfo(mdt.player.nGUID,t.szPlayerHead)
--    self:resize()
    self.ui.Head:setInfo(mdt.player.nGUID,t.nPlayerHeadIndex,t.nPlayerCountryIndex)
    return self
end

function BottleInfoItem:setReply(r)
    self.ui.txtName:setString(r.szPlayerName)
    self.ui.txtContent:setString(r.szReplyContent) 
    --self.ui.txtTime:setString(os.date("%c",r.nReplyTime))
    local time = os.date("*t",r.nReplyTime)
    local hourstr = ''
    if tonumber(time.hour) < 10 then
        hourstr = '0'..time.hour
    else
        hourstr = time.hour
    end
    local minstr = ''
    if tonumber(time.min) < 10 then
        minstr = '0'..time.min
    else
        minstr = time.min
    end
    local secstr = ''
    if tonumber(time.sec) < 10 then
        secstr = '0'..time.sec
    else
        secstr = time.sec
    end
    self.ui.txtTime:setString(time.year..'/'..time.month..'/'..time.day..' '..hourstr..':'..minstr..':'..secstr)
--    self.ui.Head:setInfo(r.nPlayerId,r.szPlayerHead)
--    self:resize()
    self.ui.Head:setInfo(r.nPlayerId,r.nPlayerHeadIndex,r.nPlayerCountryIndex)
    return self
end

function BottleInfoItem:resize()
    local sizeV = util.getLabelSize(self.ui.txtContent)
    local sizeMe = self:getContentSize()
    sizeMe.height = sizeV.height + sizeMe.height - self.ui.txtContent:getContentSize().height
    self.ui.txtContent:setContentSize(sizeV)
    self:setContentSize(sizeMe)
end

return BottleInfoItem
