local BottleList = class("BottleList", cc.load("mvc").LayoutBase)
BottleList.RESOURCE_FILENAME = "MsgBoard.BottleList"

function BottleList:onCreate()
    self:addEvent('NS_LoadAllDriftBottleBrief')
    self:addEvent('NS_CreateDriftBottle')
    self:addEvent('NS_DeleteAttentionDriftBottle')
    self:addEvent('NS_FishDriftBottle')

end

function BottleList:onEnter()
    if mdt.msgboard.bottle==nil then
        net.msg.NC_LoadAllDriftBottleBrief()
    else
        self:NS_LoadAllDriftBottleBrief()
    end
end

function BottleList:onExit()

end

-- ˢƯƿб
function BottleList:refreshBottleList()
    self.ui.list2:removeAllChildren()
    for _, bottle in pairs(mdt.msgboard.bottle) do
        local view = util.createView('MsgBoard.BottleItem')
        view:setData(bottle)
        self.ui.list2:add(view)
    end
end
function BottleList:NS_LoadAllDriftBottleBrief()
    self:refreshBottleList()
end

function BottleList:NS_CreateDriftBottle()
    self:refreshBottleList()
end

function BottleList:NS_DeleteAttentionDriftBottle()
    self:refreshBottleList()
end

function BottleList:NS_FishDriftBottle()
    self:refreshBottleList()
end

-- Event for btnFish callback (addClickEventListener)
function BottleList:onFish(node, eventType, userdata)
     util.showDialog('Dialog2', 'MsgBoard.BottleWrite')
end

-- Event for btnWrite callback (addClickEventListener)
function BottleList:onWrite(node, eventType, userdata)
    net.msg.NC_FishDriftBottle()
end

return BottleList
