local MsgBoard = class("MsgBoard", cc.load("mvc").LayoutBase)
MsgBoard.RESOURCE_FILENAME = "MsgBoard.MsgBoard"

function MsgBoard:onCreate()
    self:addEvent('NS_LoadDriftBottle')
    self:addEvent('SetBtnstate')
    self:addEvent('ReturnHomePage')
    self:addEvent('onClose')
end

function MsgBoard:onEnter()
    if mdt.msgboard.prompt == nil then
        mdt.msgboard.prompt = {}
    end
    self.ui.Panel_Retrun:setVisible(false)
    self.ui.Name:setString(static.language[20017][device.language])
    util.delay(0.4, function() self:switchTable(1) end)
end

function MsgBoard:onExit()

end

function MsgBoard:NS_LoadDriftBottle(ev, ns)
    if ns.nReturnType==0 then
        local bottle = ns.driftBottle
        self:showBottleInfo(bottle)
    end
end

function MsgBoard:SetBtnstate(ev,isvisible)
    self.ui.Panel_Retrun:setVisible(isvisible)
end

function MsgBoard:switchTable(page)
    self.page = page
    if page==1 then
        self.ui.Panel1:setVisible(true)
        self.ui.Panel2:setVisible(false)
        self.ui.Panel3:setVisible(false)
--    elseif page==2 then
--        self.ui.Panel1:setVisible(false)
--        self.ui.Panel2:setVisible(true)
--        self.ui.Panel3:setVisible(false)
    elseif page==3 then
        self.ui.Panel1:setVisible(false)
        self.ui.Panel2:setVisible(false)
        self.ui.Panel3:setVisible(true)        
    end
end

function MsgBoard:ReturnHomePage()
    self:switchTable(1)
    self.ui.Panel_Retrun:setVisible(false)
end

function MsgBoard:showBottleInfo(bottle)
    self:switchTable(3)
    self.ui.bottleInfo:setData(bottle)
end

-- Event for BG callback (addClickEventListener)
function MsgBoard:onClose(node, eventType, userdata)
    self.ui.Panel1:setVisible(false)
    self.ui.Panel2:setVisible(false)
    self.ui.Panel3:setVisible(false)  
    self.ui.Panel_Retrun:setVisible(false)  
end

-- Event for btn1 callback (addClickEventListener)
function MsgBoard:onTable(node, eventType, userdata)
    self:switchTable(tonumber(userdata))
    net.msg.NC_LoadAllDriftBottleBrief()
    self.ui.Panel_Retrun:setVisible(false)
end

-- Event for Panel_Retrun callback (addClickEventListener)
function MsgBoard:onReturnPage(node, eventType, userdata)
    event.dispatch('ReturnHomePage')
    net.msg.NC_LoadAllDriftBottleBrief()
end

-- Event for Button_1 callback (addClickEventListener)
function MsgBoard:OnTips(node, eventType, userdata)
    local view = util.showDialog('Dialog','Common.TipDialog')
    view:setkey(3)
end

return MsgBoard
