local Guide = class("Guide", cc.load("mvc").LayoutBase)
Guide.RESOURCE_FILENAME = "Newbie.Guide"

function Guide:onCreate()
    self:addEvent('onItemGuide')
    self.ui.NewGuide:addEventListener(function(...) self:onBoxEvent(...) end)
    self.ui.ItemGuide:addEventListener(function(...) self:onitemBoxEvent(...) end)
end

function Guide:onEnter()
    self.ui.Text_1:setString(static.language[30201][device.language])
    self.ui.Text_11:setString(static.language[30202][device.language])
    self.ui.Text_21:setString(static.language[30203][device.language])
    self.ui.Text_22:setString(static.language[30204][device.language])
    self.ui.ItemTxt1:setString(static.language[30205][device.language])
    self.ui.ItemTxt2:setString(static.language[30206][device.language])
--    self.ui.Text_7:setString(static.language[30180][device.language])
--    self.ui.Text_7:setString(static.language[30180][device.language])
--    self.ui.Name:setString(static.language[20002][device.language])
    self.ui.Item:onSetText(static.language[30208][device.language])
    self.ui.NewGuideButton:onSetText(static.language[30207][device.language])
    self.ui.btnClose3:onSetText(static.language[30209][device.language])
--    self.ui.NewGuidePanel:setVisible(mdt.ItemModsOpen == 1)
--    self.ui.ItemPanel:setVisible(mdt.ItemModsOpen == 1)
    self.ui.NewGuide:setVisible(true)
    self.ui.ItemGuide:setVisible(false)
end

function Guide:onExit()

end

function Guide:onBoxEvent(node, eventType, userdata)
    local page = self.ui.NewGuide:getCurrentPageIndex()  
    if tonumber(page) == 3 then
        self:newbiesave()
        util.delay(0.1,function()
            util.closeDialog('Newbie.Guide')
        end)
    end
end

function Guide:onitemBoxEvent(node, eventType, userdata)
    local page = self.ui.ItemGuide:getCurrentPageIndex()  
    if tonumber(page) == 1 then
        self:newbiesave()
        util.delay(0.1,function()
            util.closeDialog('Newbie.Guide')
        end)
    end
end

-- Event for Panel_Close callback (addClickEventListener)
function Guide:onClose(node, eventType, userdata)
    self:newbiesave()
end

function Guide:newbiesave()
    mdr.isNewbieComplete = true
    mdr.isnewbiebegin = false
    mdr.save()
    mdt.Newbieagain = false
    if mdr.accounttype ~= 2 then
        if mdt.changenemecount <= 0 then
            if mdt.ismenunewbie == nil or not mdt.ismenunewbie then
                util.showDialog('Dialog','Common.ChangeName')
            end
        end
    end
    mdlogin.setIsNewbieBeging(mdlogin.getCurLoginServerID(), false)
end

-- Event for ItemPanel callback (addClickEventListener)
function Guide:onItem(node, eventType, userdata)
    self:onItemGuide()
end

-- Event for NewGuidePanel callback (addClickEventListener)
function Guide:onNewGuide(node, eventType, userdata)
    self.ui.NewGuide:setVisible(true)
    self.ui.ItemGuide:setVisible(false)
end

function Guide:onItemGuide()
    self.ui.NewGuide:setVisible(false)
    self.ui.NewGuide:scrollToPage(0)
    self.ui.ItemGuide:setVisible(true)
end

return Guide
