local Newbie = class("Newbie", cc.load("mvc").LayoutBase)
Newbie.RESOURCE_FILENAME = "Newbie.Newbie"

local clickpos = {step1={x=5,y=6},
                 -- step2={x=2,y=4},
                  step2={x=3,y=5},
                  step3={x=8,y=4},
--                  step5={x=6,y=2},
                 }

function Newbie:onCreate()
    self:addEvent('onNextNewbieStep')
    ctr.game.init(self.ui.Inner)
end

function Newbie:onEnter()
    mdt.isNewbie = true
    mdr.isNewbieComplete = false
    mdr.save()
    self:onLoadMap()
    ctr.game.createCell()   
    util.delay(0, function()
        ctr.game.refreshCell()
        ctr.game.LoadMap()    
        ctr.game.Inner:setPosition(display.width/2 - mdt.w/2*mdt.CW , display.height/2 - mdt.h/2*mdt.CW)
    end)
    self.newbieStep = 1
    self.txtStep = 1
    self.s = 1
    self.ui.btnChallenge:setVisible(false)
    self.ui.txtPanel:setVisible(false)
    self.ui.Cancel:onSetText(static.language[10019][device.language])
    self.ui.OK:onSetText(static.language[10001][device.language])
    self.ui.btnChallenge:setPosition(self.ui.Inner:getPosition())
    self:CreateText()
end

function Newbie:onExit()

end

function Newbie:CreateText()
    self.ui.txtPanel:setVisible(true)
    self.ui.Panel_start_0:setVisible(false)
    self.ui.Text_1:setString(static.language[static.UI.NewbieTxt['txt'..self.txtStep]['s'..self.s].str][device.language])
    --self:play('pos'..static.UI.NewbieTxt['txt'..self.txtStep]['s'..self.s].pos)
    if self.txtStep == 4 and self.s == 2 then
        self.ui.Panel_start_0:setVisible(true)
    end
--    if self.txtStep == 1 and self.s == 1 then
--        self.ui.Panel_start_1:setVisible(true)
--    else
--        self.ui.Panel_start_1:setVisible(false)
--    end
end

function Newbie:CreateClipPanel()
    self.ui.txtPanel:setVisible(false)
    self.clip = cc.ClippingNode:create()
    self.clip:setInverted(true)
    self.clip:setAlphaThreshold(0.0)
    self.clip:setName('Clip')
    self.ui.Inner:addChild(self.clip,50)
    local layerColor = cc.LayerColor:create(cc.c4b(0,0,0,102),3000,3000)
    self.clip:addChild(layerColor)
    local nodef = cc.Node:create()    
    local close = cc.Sprite:create(static.UI.ClipSprite['step'..self.newbieStep])
    nodef:addChild(close)
    if self.newbieStep == 1 then
        nodef:setPosition({x=5*120 + 60,y=6*120 + 60}) 
        --self.effect:setVisible(true)
        self.effect = self:getApp():createView('Newbie.Click')
        self.ui.Inner:addChild(self.effect) 
        self.effect:setLocalZOrder(100)  
        self.effect:setPosition({x=5*120 + 60,y=6*120 + 60}) 
        self.effect:play('dianji',true)
--    elseif self.newbieStep == 2 then
--        self.effect:setVisible(true)
--        self.effect:setPosition({x=2*120 + 60,y=4*120 + 60})
--        self.effect:play('dianji',true)
--        nodef:setPosition({x=2*120 + 60,y=4*120 + 60})
    elseif self.newbieStep == 2 then
        self.effect:setVisible(true)
        self.effect:setPosition({x=3*120 + 60,y=5*120 + 60})
        self.effect:play('dianji',true)
        nodef:setPosition({x=3*120 + 60,y=5*120 + 60}) 
    elseif self.newbieStep == 3 then
        self.effect:setVisible(true)
        self.effect:setPosition({x=8*120 + 60,y=4*120 + 60})
        self.effect:play('changan',true)
        nodef:setPosition({x=8*120 + 60,y=4*120 + 60}) 
--    elseif self.newbieStep == 5 then
--        self.effect:setVisible(true)
--        self.effect:setPosition({x=6*120 + 60,y=2*120 + 60})
--        self.effect:play('dianji',true)
        --nodef:setPosition({x=6*120 + 60,y=2*120 + 60}) 
    else
--        self.effect2 = self:getApp():createView('Newbie.Click')
--        self.ui.btnChallenge:addChild(self.effect2) 
--        self.effect2:setLocalZOrder(100)  
--        self.effect2:setPosition({x=self.ui.btnChallenge:getContentSize().width/2,y=self.ui.btnChallenge:getContentSize().height/4})
--        self.effect2:play('dianji',true)
--        nodef:setPosition({x=close:getContentSize().width/2,y=close:getContentSize().height/2}) 
    end
    self.clip:setStencil(nodef)
    self.s = 1
end

function Newbie:onLoadMap()
    local width = 10
    local height = 10
    mdt.point = {}
    mdt.pointInfo = {}
    mdt.x = math.floor(width/2)
    mdt.y = math.floor(height/2)    
    mdt.w = width
    mdt.h = height

    for j=0,height-1 do
        local pj = {}
        mdt.point[j] = pj
        for i=0,width-1 do
            pj[i] = net.enum.EBigMapGridStatus_UNOPEN
        end
    end
end

function Newbie:onNextNewbieStep()
    if mdr.NewbieagainStep == nil then
        mdr.NewbieagainStep = false
        mdr.save()
    end
    if not mdr.NewbieagainStep then
        sdkManager.talkingdata:setEvent("65",{BottleReplyPlayer = "NewGuide"..self.newbieStep})
        sdkManager.appsflyer:setEvent("65",{BottleReplyPlayer = "NewGuide"..self.newbieStep})
        if self.newbieStep == 3 then
            mdr.NewbieagainStep = true
            mdr.save()
        end
    end
    local list = static.UI.NewbieStep['step'..self.newbieStep]
    local zero = false
    for _, v in pairs(list) do
        local x = v.x
        local y = v.y
        local p = mdt.point[y]
        if not p then
            p = {}
            mdt.point[y] = p
        end
        local px = p[x]

        if px~=v.state then
            p[x] = v.state   
            mdt.effect[#mdt.effect+1] = { x=x, y=y, state=v.state==10 and 2 or 1 }
            if v.state==0 then
                zero = true
            end
        end

        if v.state==10 then
            mdt.setFlagset(1, x, y)
        end
    end
    ctr.game.refreshCell()
    ctr.game.refreshEffect()

    self.ui.Inner:removeChild(self.clip)
    self.effect:setVisible(false)
    self.newbieStep = self.newbieStep+1
    self.txtStep = self.txtStep+1
    self:CreateText()
--    if self.newbieStep == 6 then
--        self.ui.Inner:removeChild(self.effect)
--        self.ui.btnChallenge:setVisible(true)
--        self.ui.btnChallenge:setTouchEnabled(true)
--        self.ui.btnChallenge:setPosition(self.ui.Inner:getPosition())
--    end
end

function Newbie:onRefreshCell()
    ctr.game.refreshCell()
end

-- Event for GameView callback (addTouchEventListener)
function Newbie:onTouch(node, eventType, userdata)
    local function click(bp, ep, mode)
        if self.bClicked then return end
        if self.newbieStep < 5 then
            local px, py = self.ui.Inner:getPosition()
            local x = math.floor((ep.x - px)/mdt.CW)
            local y = math.floor((ep.y - py)/mdt.CW)
            if x==clickpos['step'..self.newbieStep].x and y==clickpos['step'..self.newbieStep].y then
                mode = mode or 1
                self.bClicked = true
                if self.newbieStep ~= 4 and mode == 1 then
--                    if self.newbieStep == 2 then
--                        event.dispatch('onShake')
--                        audio.playEffect('boom')
--                        ctr.game.addEffect(x, y, 3)
--                    end
                    ctr.game.click(bp, ep, mode)
                elseif self.newbieStep == 3 and mode == 2 then
                    ctr.game.click(bp, ep, mode)
                end
            end
        else
            mode = mode or 1
                self.bClicked = true
                if self.newbieStep ~= 4 and mode == 1 then
                    ctr.game.click(bp, ep, mode)
                elseif self.newbieStep == 4 and mode == 2 then
                    ctr.game.click(bp, ep, mode)
                end
        end
    end
    if eventType == 0 then
        self.beganPos = node:getTouchBeganPosition()
        self.lastTouchPos = self.beganPos
        self.bMove = false
        self.bClicked = false
        self.doubleAct = util.delay(0.3, function() 
            if self.bMove then return end
            click(self.beganPos, self.lastTouchPos, 2)
        end, self)
    elseif eventType==1 then
        local mp = node:getTouchMovePosition()
        local dis = cc.pGetDistance(self.beganPos, mp)
        if dis>50 then
            self.bMove = true
        end
        local dp = cc.pSub(mp, self.lastTouchPos)
        local size = self.ui.GameView:getContentSize()
        --ctr.game.moveMap(dp.x, dp.y, size)
        self.lastTouchPos = mp

    elseif eventType==2 then
        if not self.bMove then
            local ep = node:getTouchEndPosition()
            click(self.beganPos, ep)
        end
        util.unschedule(self.doubleAct)
    else
        util.unschedule(self.doubleAct)
    end
end

-- Event for btnChallenge callback (addClickEventListener)
function Newbie:onClick(node, eventType, userdata)
    self.newbieStep = self.newbieStep+1
    self.txtStep = self.txtStep+1
    self.ui.Inner:removeChild(self.clip)
    self.ui.btnChallenge:removeChild(self.effect2)
    self:CreateText()
end

-- Event for Button_1 callback (addClickEventListener)
function Newbie:OnReturnMap(node, eventType, userdata)
    if mdr.NewbieagainReturn == nil then
        mdr.NewbieagainReturn = false
    end
    if not mdr.NewbieagainReturn then
        sdkManager.talkingdata:setEvent("66",{BottleReplyPlayer = "NewGuideSkip"})
        sdkManager.appsflyer:setEvent("66",{BottleReplyPlayer = "NewGuideSkip"})
        mdr.NewbieagainReturn = true
    end
    mdr.isNewbieComplete = true
    mdr.isnewbiebegin = false
    mdr.save()
    mdt.Newbieagain = false
    if mdr.accounttype ~= 2 then
        if mdt.changenemecount <= 0 then
            if mdt.ismenunewbie == nil or not mdt.ismenunewbie then
                util.showDialog('Dialog','Common.ChangeName')
            end
        end
    end
    net.msg.NC_LoadMap()
end

-- Event for txtPanel callback (addClickEventListener)
function Newbie:OnClickTxt(node, eventType, userdata)
    self.s = self.s+1
    if static.UI.NewbieTxt['txt'..self.txtStep]['s'..self.s] ~= nil then
        self:CreateText()
    elseif self.newbieStep <= 3 then
        self.ui.txtPanel:setVisible(false)
        self:CreateClipPanel()
    end
end

-- Event for Button_5 callback (addClickEventListener)
function Newbie:OnClickReturn(node, eventType, userdata)
    mdr.isNewbieComplete = true
    mdr.isnewbiebegin = false
    mdr.save()
    mdt.Newbieagain = false
    if mdr.accounttype ~= 2 then
        if mdt.changenemecount <= 0 then
            if mdt.ismenunewbie == nil or not mdt.ismenunewbie then
                util.showDialog('Dialog','Common.ChangeName')
            end
        end
    end
    net.msg.NC_LoadMap()
end

return Newbie
