local Rank_0 = class("Rank_0", cc.load("mvc").LayoutBase)
Rank_0.RESOURCE_FILENAME = "Rank.Rank_0"

function Rank_0:onCreate()
    self:addEvent('NS_MineMapRecordNormalRank')  
    self:addEvent('NS_LoadCountryRankGrid')
    self:addEvent('NS_LoadCountryRankBomb')

    self.m_pageIndex = 1
    self.m_tabIndex = 0
    self:clearRankData()
    self.normalFontSize = 44
    self.focusFontSize = 56
    self.m_ColorBtnFocus = {r = 0, g = 0, b = 0}
    self.m_ColorBtnNormal = {r = 218, g = 218, b = 218}
    self.m_personLastIndex = 1
    self.m_contryLastIndex = 1
    self.m_comboLastIndex = 1
    self.m_currentMaxRank = 0
    self.m_onceAdd = 10
    self.m_listViewHeight = 0

    self.m_requestPageType = {[1] = {[1] = 5,[2] = 6}, [2] = {[1] = 1, [2] = 0, [3] = 2}}

    self.m_limitRequest = false

    self.mapID = 0

    self.haveself = true
end

function Rank_0:onEnter()
    self.ui.RankView:setVisible(false)
    self.ui.RankView1:setVisible(false)

    --Լɫĵ
    self.listSelfItem = util.createView("Rank.RankSelf")
    self.ui.Panel_RankSelf:add(self.listSelfItem)
    self.listSelfItem:setVisible(false)
    --ֳʼ
    self.ui.TenNew:setBright(false)
    --
    self.ui.RankView:onScroll(function(event)
        if event.name == "AUTOSCROLL_ENDED" then
            local innerHeight = self.ui.RankView:getInnerContainerSize().height
            local innerContainerY = self.ui.RankView:getInnerContainerPosition().y
            if innerContainerY < 100 and innerContainerY >= 0 then
                self:loadData(self.m_pageIndex, self.m_tabIndex, self.m_currentMaxRank + 1, self.m_currentMaxRank + self.m_onceAdd)
            end
        end
        self:checkShowSelfRank(self.ui.RankView)
    end)

    self.ui.RankView1:onScroll(function(node)
        if event.name == "AUTOSCROLL_ENDED" then
            self:checkShowSelfRank(self.ui.RankView1)
        end
    end)

    self.customRankTab = {self.ui.TenM, self.ui.OneH, self.ui.TenNew}
    self.personalRankTab = {self.ui.Button_Mine, self.ui.Button_Cell, self.ui.Button_Fail}
    self.comboRankTab = {self.ui.Button_combo,self.ui.Button_fraction}
    self.countryRankTab = {self.ui.Button_Mine_1, self.ui.Button_Cell_1}

    self.ui.RankView:setScrollBarEnabled(false)
    self.ui.RankView1:setScrollBarEnabled(false)

    self.ui.Name:setString(static.language[20010][device.language])
    self.ui.Text_6:setString(static.language[30049][device.language])
    self.ui.Text_6_New:setString(static.language[30051][device.language])
    self.ui.Text_6_0:setString(static.language[30048][device.language])
    self.ui.Text_1_1:setString(static.language[30032][device.language])
    self.ui.Text_1_2:setString(static.language[30033][device.language])
    self.ui.Text_1_3:setString(static.language[30035][device.language])
    self.ui.Text_21:setString(static.language[30032][device.language])
    self.ui.Text_20:setString(static.language[30033][device.language])
    self.ui.RankTip:setString(static.language[30158][device.language])
    self.ui.Text_1_11:setString(static.language[30223][device.language])
    self.ui.Text_1_31:setString(static.language[30224][device.language])
end

function Rank_0:onExit()

end

function Rank_0:setMapID(id)
    self.mapID = id
    self:ShowPage(1, 1)
end

function Rank_0:clearRankData()
    self.m_dataCache = {  
        [1] = {[1] = {["data"] = {}, ["ownRank"] = 0, ["sum"] = 0},
                [2] = {["data"] = {}, ["ownRank"] = 0, ["sum"] = 0 },},    --combo 
        [2] = {[1] = {["data"] = {}, ["ownRank"] = 0, ["sum"] = 0 },    --
                [2] = {["data"] = {}, ["ownRank"] = 0, ["sum"] = 0 },   --
                [3] = {["data"] = {}, ["ownRank"] = 0, ["sum"] = 0 } }, --
        [3] = {[1] = {["data"] = {} }, [2] = {["data"] = {} } }         --Ұ
        } 
end

function Rank_0:ShowPage(pageIndex, tabIndex)
    self.listSelfItem:setVisible(false)
    self.ui.RankView:removeAllChildren()
    self.ui.RankView1:removeAllChildren()
    self:clearRankData()
    self.m_pageIndex = pageIndex
    self.m_tabIndex = tabIndex
    self.m_currentMaxRank = 0
    self.m_listViewHeight = 0
    self.listSelfItem:clear()
    self:modifyUIShow(pageIndex, tabIndex)
    self:loadData(pageIndex, tabIndex, 1, self.m_onceAdd)
end

function Rank_0:modifyUIShow(pageIndex, tabIndex)
    self.ui.RankTip:setVisible(pageIndex == 1)
    if pageIndex == 1 then
        self:setButtonStatus(self.customRankTab, self.ui.TenNew, true)
        self:setButtonStatus1(self.comboRankTab, self.comboRankTab[tabIndex], true)
 
        self.ui.Panel_Player:setVisible(true)
        self.ui.Panel_45:setVisible(false)
        self.ui.Panel_combo:setVisible(true)
        self.ui.Panel_Country:setVisible(false)
        self.m_comboLastIndex = tabIndex
    elseif pageIndex == 2 then
        
        self:setButtonStatus(self.customRankTab, self.ui.TenM, true)
        self:setButtonStatus1(self.personalRankTab, self.personalRankTab[tabIndex], true)

        self.ui.Panel_Player:setVisible(true)
        self.ui.Panel_Country:setVisible(false)
        self.ui.Panel_45:setVisible(true)
        self.ui.Panel_combo:setVisible(false)

        self.m_personLastIndex = tabIndex
    elseif pageIndex == 3 then
        self.ui.Panel_Player:setVisible(false)
        self.ui.Panel_Country:setVisible(true)

        self:setButtonStatus(self.customRankTab, self.ui.OneH, true)
        self:setButtonStatus1(self.countryRankTab, self.countryRankTab[tabIndex], true)
        self.m_contryLastIndex = tabIndex
    end
end

function Rank_0:setButtonStatus(buttons, btn, visible)
    for k, v in pairs(buttons) do
        v:setBright(true)
        v:setVisible(visible)
        v:setTitleColor(self.m_ColorBtnNormal)
        v:setTitleFontSize(self.normalFontSize)
        v:setEnabled(true)
        if btn and v == btn then
            v:setBright(false)
            v:setTitleColor(self.m_ColorBtnFocus)
            v:setTitleFontSize(self.focusFontSize)
            v:setEnabled(false)
        end
    end
end

function Rank_0:setButtonStatus1(buttons, btn, visible)
    for k, v in pairs(buttons) do
        v:setBright(true)
        v:setVisible(visible)
        v:setTitleColor({r = 60, g = 60, b = 60})
        v:setTitleFontSize(self.normalFontSize)
        v:setEnabled(true)
        if btn and v == btn then
            v:setBright(false)
            v:setTitleColor({r = 255, g = 255, b = 255})
            v:setTitleFontSize(self.normalFontSize)
            v:setEnabled(false)
        end
    end
end

-- Event for OneH callback (addTouchEventListener)
function Rank_0:OnChangeType(node, eventType, userdata)
    if eventType == ccui.TouchEventType.ended then
        local pageIndex = 1
        if tonumber(userdata) == 2 then
            pageIndex = self.m_personLastIndex
        elseif tonumber(userdata) == 3 then
            pageIndex = self.m_contryLastIndex
        else
            pageIndex = self.m_comboLastIndex
        end
        self:ShowPage(tonumber(userdata), pageIndex)
    end 
end

-- Event for Button_Fail callback (addClickEventListener)
function Rank_0:onClickPlayerBtn(node, eventType, userdata)
    self:ShowPage(2, tonumber(userdata))
end

-- Event for Button_fraction callback (addClickEventListener)
function Rank_0:onClickCombo(node, eventType, userdata)
    self:ShowPage(1, tonumber(userdata))
end

-- Event for Button_Cell_1 callback (addClickEventListener)
function Rank_0:onClickCountryBtn(node, eventType, userdata)
    self:ShowPage(3, tonumber(userdata))
end

function Rank_0:checkDataExist(page, tab, rank)
    local isExist = false

    local dataCache = self.m_dataCache[page][tab]["data"]

    for _, v in pairs(dataCache) do 
        if v.nRankIndex == rank then
            isExist = true
            break
        end
    end

    return isExist
end

function Rank_0:loadData(page, tab, from, to)

    if self.m_limitRequest then
        print("Rank:loadData  limit")
        return
    end
        

    if page == 3 then
        if tab == 1 then
            net.msg.NC_MineMapRecordNormalRank(self.mapID,4, from ,to)
        else
            net.msg.NC_MineMapRecordNormalRank(self.mapID,3, from ,to)
        end
    else
        net.msg.NC_MineMapRecordNormalRank(self.mapID,self.m_requestPageType[page][tab], from ,to)
    end

    self.m_limitRequest = true
--    end
end

--շݲֵ
function Rank_0:NS_MineMapRecordNormalRank(ev, ns)
    print("total num = "..ns.nAllNum)


    if ns.nAllNum ~= 0 then
        self:receiveData(self.m_pageIndex, self.m_tabIndex, ns)
    end

    self.m_limitRequest = false

end

function Rank_0:NS_LoadCountryRankGrid(ev, ns)
    print("total num = "..ns.sum)

    if ns.sum ~= 0 then
        self:receiveData(self.m_pageIndex, self.m_tabIndex, ns)
    end

    self.m_limitRequest = false
end

function Rank_0:NS_LoadCountryRankBomb(ev, ns)
    print("total num = "..ns.sum)

    if ns.sum ~= 0 then
        self:receiveData(self.m_pageIndex, self.m_tabIndex, ns)
    end

    self.m_limitRequest = false
end

function Rank_0:addDataToCache(page, tab, data)
    local dataCache = self.m_dataCache[page][tab]["data"]
    local isSaved = false
    for _, v in pairs(dataCache) do 
        if (page == 1 or page == 2) and v.nId == data.nId then
            isSaved = true
            break
        elseif page == 3 and v.ranking == data.ranking then
            isSaved = true
            break
        end
    end
    if not isSaved then
        table.insert(self.m_dataCache[page][tab]["data"], data)
    end
end

function Rank_0:receiveData(page, tab, ns)
    local data = nil
    data = ns.sMineRecordRank
    self.m_dataCache[page][tab]["sum"] = ns.nAllNum
    for _, v in ipairs (data) do
        self:addDataToCache(page, tab, v)
    end

    if page == 1 or page == 2 then
        self:appendListItems(self.ui.RankView, data, 0)
    else
        self:appendListItems(self.ui.RankView1, data, 1)
    end

    self:checkShowSelfRank(self.ui.RankView)
end

function Rank_0:appendListItems(ListView, data, rankType)
    self.haveself = false
    for i = 1, #data do
        local listItem = nil
        if i % 2 == 1 then
            listItem = util.createView("Rank.RankItem1")
        elseif i % 2 == 0 then 
            listItem = util.createView("Rank.RankItem2")
        end
        if data[i].nId == mdt.player.nGUID then
            self.haveself = true
            listItem:loadRankTextureI(3)
            listItem:setTag(88888)
            self.listSelfItem:setRecordOwnInfo(data[i])
        elseif 1 % 2 == 1 then
            listItem:loadRankTextureI(1)
        else
            listItem:loadRankTextureI(2)
        end

        if data[i].nRankIndex and data[i].nRankIndex > self.m_currentMaxRank then
            self.m_currentMaxRank = data[i].nRankIndex
        end

        if rankType == 0 then
            listItem:setRecordMainInfo(data[i])
        elseif rankType == 1 then
            listItem:setRecordMainInfo1(data[i], static.country)
        end

        ListView:add(listItem) 
    end

    ListView:setVisible(true)

    local percent = self.m_listViewHeight / ListView:getChildrenCount() * 100

    ListView:jumpToPercentVertical(percent)

    self.m_listViewHeight = ListView:getChildrenCount()
end

function Rank_0:checkShowSelfRank(ListView)
    local selfRankItem = ListView:getChildByTag(88888)
    if selfRankItem then
        local worldPos = selfRankItem:convertToWorldSpace({selfRankItem:getPositionX(), selfRankItem:getPositionY()})
        if worldPos.y >=0 and worldPos.y < ListView:getContentSize().height - selfRankItem:getContentSize().height then
            self.listSelfItem:setVisible(false)
        else
            if self.haveself then
                self.listSelfItem:setVisible(true)
            end
        end

    else
        if self.haveself then
            self.listSelfItem:setVisible(true)
        end
    end
end

-- Event for Panel_Close callback (addClickEventListener)
function Rank_0:onClose(node, eventType, userdata)

end

return Rank_0
