local FlagItem = class("FlagItem", cc.load("mvc").LayoutBase)
FlagItem.RESOURCE_FILENAME = "Shop.FlagItem"

--state: 0--------未购买
--       1--------已购买
--       2--------已装备

--errorcode ： 0-------失败,已拥有
--             1-------失败，系统错误
--             2-------失败，金币不够
--             3-------成功

function FlagItem:onCreate()
    self:addEvent('NS_BuyItem')
    self:addEvent('NS_EquipItem')
    self:addEvent('NS_UpdateLife')
    self:addEvent('NS_GoogleRechargeRequest')
    self:addEvent('NS_GoogleRechargeComplete')
end

function FlagItem:onEnter()

end

function FlagItem:NS_BuyItem(ev,ns)
    if ns.nItemID == self.id then
        if ns.errorcode == '0' then
            print('失败'..ns.errorcode)
        elseif ns.errorcode == '1' then
            print('失败'..ns.errorcode)
        elseif ns.errorcode == '2' then
            print('失败'..ns.errorcode)
        else 
            self.state = 1
            self.list[self.index].state = 1
--            self.ui.Coin:setVisible(false)
--            self.ui.Image_3:setVisible(false)
            self.ui.Button_1.ui.btnText:onDisSetText()
--            self.ui.State:setVisible(true) 
--            self.ui.State:setString(static.language[10013][device.language])
            self.ui.Button_1.ui.btnText:onSetStateText(static.language[10013][device.language])
            self.ui.Lvup:setVisible(tonumber(self.item.nextID) ~= 0)
            self.ui.Button_1.ui.btnText:onDisNum()
        end
    end
end

function FlagItem:NS_UpdateLife(ev,ns)
    if ns.nOldItemID == self.id then
        if ns.errorcode == '0' then
            print('失败'..ns.errorcode)
        elseif ns.errorcode == '1' then
            print('失败'..ns.errorcode)
        elseif ns.errorcode == '2' then
            print('失败'..ns.errorcode)
        else 
            self.id = ns.nItemID
            self.item = static.shop[self.id]
--            self.ui.Falg:loadTexture(self.item.imageId,0)
            self.ui.Button_1.ui.btnText:onSetShop(self.item.imageId)
            self.ui.Lvup:setVisible(tonumber(self.item.nextID) ~= 0)
--            if self.id < 20000 and self.state ~= 0 then
--                mdt.flagindex = self.id
--            end
            if mdr.OneUpdatePlayer == nil then
                mdr.OneUpdatePlayer = false
            end
            if mdr.TwoUpdatePlyaer == nil then
                mdr.TwoUpdatePlyaer = false
            end
            if static.shop[ns.nOldItemID].level == 1 then
                if not mdr.OneUpdatePlayer then
                    sdkManager.talkingdata:setEvent("28",{OneUpdatePlayer = "1"})
                    sdkManager.appsflyer:setEvent("28",{OneUpdatePlayer = "1"})
                    mdr.OneUpdatePlayer = true
                    mdr.save()
                end
                sdkManager.talkingdata:setEvent("26",{OneUpdate = tostring(ns.nOldItemID)})
                sdkManager.appsflyer:setEvent("26",{OneUpdate = tostring(ns.nOldItemID)})
            elseif static.shop[ns.nOldItemID].level == 2 then
                if not mdr.TwoUpdatePlyaer then
                    sdkManager.talkingdata:setEvent("29",{TwoUpdatePlyaer = "2"})
                    sdkManager.appsflyer:setEvent("29",{TwoUpdatePlyaer = "2"})
                    mdr.TwoUpdatePlyaer = true
                    mdr.save()
                end
                sdkManager.talkingdata:setEvent("27",{TwoUpdate = tostring(ns.nOldItemID)})
                sdkManager.appsflyer:setEvent("27",{TwoUpdate = tostring(ns.nOldItemID)})
            end
        end
    end
end

function FlagItem:NS_EquipItem(ev,ns)
    if ns.nNewItemID == self.id then
        if ns.errorcode == '0' then
            print('失败'..ns.errorcode)
        else 
            self.state = 2
            self.list[self.index].state = 2
--            self.ui.Coin:setVisible(false)
--            self.ui.Image_3:setVisible(false)
            self.ui.Button_1.ui.btnText:onDisSetText()
--            self.ui.State:setVisible(true) 
--            self.ui.State:setString(static.language[10012][device.language])
            self.ui.Button_1.ui.btnText:onSetStateText(static.language[10012][device.language])
            self.ui.Button_1:onBright(false)
            self.ui.Button_1:onEnabled(false)
            self.ui.Lvup:setVisible(tonumber(self.item.nextID) ~= 0)
            self.ui.Button_1.ui.btnText:onDisNum()
--            if self.id < 20000 then
--                mdt.flagindex = self.id
--            end
        end
    end 

    if ns.nOldItemID == self.id then
        if ns.errorcode == '0' then
            print('失败')
        else 
            self.state = 1
            self.list[self.index].state = 1
--            self.ui.Coin:setVisible(false)
--            self.ui.Image_3:setVisible(false)
            self.ui.Button_1.ui.btnText:onDisSetText()
--            self.ui.State:setVisible(true) 
--            self.ui.State:setString(static.language[10013][device.language])
            self.ui.Button_1.ui.btnText:onSetStateText(static.language[10013][device.language])
            self.ui.Button_1:onBright(true)
            self.ui.Button_1:onEnabled(true)
            self.ui.Lvup:setVisible(tonumber(self.item.nextID) ~= 0)
            self.ui.Button_1.ui.btnText:onDisNum()
        end   
    end
end

function FlagItem:setkey(list,i,PlayerCoin)
    self.ui.Button_1.ui.btnText:onReset()
    self.curitemtype = 'else'
    self.ui.Num:setVisible(false)
    self.PlayerCoin = PlayerCoin
    self.list = list
    self.index = i
    self.id = list[i].id
    self.state = list[i].state
    self.item = static.shop[self.id]
    self.ui.Lvup:setVisible(tonumber(self.item.nextID) ~= 0)
--    self.ui.Falg:loadTexture(self.item.imageId,0)
    self.ui.Button_1.ui.btnText:onSetShop(self.item.imageId)
    self.ui.Button_1.ui.btnText:onDisNum()
--    self.ui.Coin:setString(self.item.cost)
    local pic
    if self.item.costType == 1 then
        pic = "Image/coin.png"
    elseif self.item.costType == 2 then
        pic = "Image/pvp/pvp.png"
    elseif self.item.costType == 3 then
        pic = "Image/diamond/diamond1.png"
    end
    self.ui.Button_1.ui.btnText:onSetTexture(pic,self.item.cost)
    self.ui.Button_1.ui.btnText:onSetColor({r=255,g=255,b=255})
--    self.ui.Coin:setVisible(true)
--    self.ui.Image_3:setVisible(true)
    if self.state == 0 then
        self.ui.State:setVisible(false) 
        self.ui.Button_1:onBright(true)
        self.ui.Button_1:onEnabled(true)  
        self.ui.Coin:setVisible(true)
        self.ui.Image_3:setVisible(true)    
        self.ui.Button_1.ui.btnText:onDisNum()
    elseif self.state == 1 then
--        self.ui.Coin:setVisible(false)
--        self.ui.Image_3:setVisible(false)
        self.ui.Button_1.ui.btnText:onDisSetText()
--        self.ui.State:setVisible(true)
--        self.ui.State:setString(static.language[10013][device.language])
        self.ui.Button_1.ui.btnText:onSetStateText(static.language[10013][device.language])
        self.ui.Button_1:onEnabled(true)        
        self.ui.Button_1.ui.btnText:onDisNum()
    else
--        self.ui.Coin:setVisible(false)
--        self.ui.Image_3:setVisible(false)
        self.ui.Button_1.ui.btnText:onDisSetText()
--        self.ui.State:setVisible(true)
--        self.ui.State:setString(static.language[10012][device.language]) 
        self.ui.Button_1.ui.btnText:onSetStateText(static.language[10012][device.language])
        self.ui.Button_1:onEnabled(false)
        self.ui.Button_1:onBright(false)
        self.ui.Button_1.ui.btnText:onDisNum()
    end
    local num = 0
    if self.item.costType == 1 then
        num = tonumber(mdt.player.gold)
    elseif self.item.costType == 2 then
        num = tonumber(mdt.mypvpcoin)
    elseif self.item.costType == 3 then
        num = tonumber(mdt.player.diamond)
    end
--    if tonumber(self.item.cost) > num then
--        self.ui.Coin:setTextColor({r=255,g=0,b=0})
--        self.ui.Button_1.ui.btnText:onSetColor({r=255,g=0,b=0})
--        self.ui.Button_1:onEnabled(false)
--        self.ui.Button_1:onBright(true)
--    end
end

function FlagItem:setkeydiamond(id)
    self.ui.Button_1.ui.btnText:onReset()
    self.curitemtype = 'diamond'
    self.idtype = id.type
    if id.type == 'diamond' then
        self.item = static.diamond[id.key]
    else
        self.item = static.money[id.key]
    end
    self.ui.Lvup:setVisible(false)
--    self.ui.Falg:loadTexture(self.item.imageId,0)
    self.ui.Button_1.ui.btnText:onSetShop(self.item.imageId)
--    self.ui.Num:setVisible(true)
--    self.ui.Num:setString(self.item.getNum)
    self.ui.Button_1.ui.btnText:onSetNum(self.item.getNum)
    self.ui.Button_1:onBright(true)
    self.ui.Button_1:onEnabled(true)
    self.ui.Button_1.ui.btnText:onSetColor({r=255,g=255,b=255})
    if id.type == 'diamond' then 
--        self.ui.Coin:setVisible(false)
--        self.ui.Image_3:setVisible(false)
        self.ui.Button_1.ui.btnText:onDisSetText()
--        self.ui.State:setVisible(true)
--        self.ui.State:setString('$'..self.item.cost)
        self.ui.Button_1.ui.btnText:onSetStateText('¥'..self.item.cost)
    else
--        self.ui.State:setVisible(false)
--        self.ui.Coin:setVisible(true)
--        self.ui.Image_3:setVisible(true)
--        self.ui.Image_3:setTexture("Image/diamond/diamond1.png") 
--        self.ui.Coin:setString(self.item.cost) 
        self.ui.Button_1.ui.btnText:onSetTexture("Image/diamond/diamond1.png",self.item.cost)
    end
    local num = 0
    if self.item.costType == 1 then
        num = tonumber(mdt.player.gold)
    elseif self.item.costType == 2 then
        num = tonumber(mdt.mypvpcoin)
    elseif self.item.costType == 3 then
        num = tonumber(mdt.player.diamond)
    end
--    if tonumber(self.item.cost) > num and tonumber(self.item.costType) ~= 4 then
--        self.ui.Button_1.ui.btnText:onSetColor({r=255,g=0,b=0})
--        self.ui.Button_1:onEnabled(false)
--        self.ui.Button_1:onBright(true)
--    end
end

function FlagItem:onExit()

end

-- Event for Buy callback (addClickEventListener)
function FlagItem:OnBuy(node, eventType, userdata)
    if self.curitemtype == 'else' then
        if self.state == 1 then
            net.msg.NC_EquipItem(self.id)
        else
            local num = 0
            if self.item.costType == 1 then
                num = tonumber(mdt.player.gold)
            elseif self.item.costType == 2 then
                num = tonumber(mdt.mypvpcoin)
            elseif self.item.costType == 3 then
                num = tonumber(mdt.player.diamond)
            end
            if tonumber(self.item.cost) > num then
                util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item.costType,true)
            else
                if self.state == 0 then
                    local view = util.showDialog(nil, 'Common.ConfirmDialog')
                    view:setkey(
                    self.item.cost,
                    function()
                        net.msg.NC_BuyItem(self.id)
                    end ,
                    self.item.costType,30010)
                end
            end
        end
    else
        if self.item.costType == 4 then
            if util.isAndroid() then
                local luaj = require "cocos.cocos2d.luaj"
                local classname = "org/cocos2dx/lua/AppActivity"
                local args = {nil}
                local sigs = "()I"

                local ok, ret = luaj.callStaticMethod(classname, "GetRechargeType", args, sigs)

                net.msg.NC_GoogleRechargeRequest(ret, self.item.code, self.item.cost, self.item.getNum)
            else
                net.msg.NC_ExceteTopUp(self.item.code)
            end
        else
--            if mdt.player.diamond >= self.item.cost then
--                local view = util.showDialog(nil, 'Common.ConfirmDialog')
--                view:setkey(
--                self.item.cost,
--                function()
--                    net.msg.NC_ExceteTopUp(self.item.code)
--                    mdt.Exceteid = self.item.code
--                end ,
--                nil,
--                self.item.costType)
--            else
--                util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item.costType)
--            end
            if self.idtype == 'diamond' then
                net.msg.NC_SimulationCharge(self.item.code)
            else
                net.msg.NC_DiamondExchangeMoney(self.item.code)
            end
        end
    end
end

-- Event for Lvup callback (addClickEventListener)
function FlagItem:OnLvup(node, eventType, userdata)
    if tonumber(self.item.nextID) ~= 0 then
        local nextitem = static.shop[self.item.nextID]
        local canLvup = true
        if self.state == 0 then
            canLvup = false
        end
        local view = util.showDialog('Dialog', 'Common.UpdateDialog')       
        view:setkey(self.id,self.item.nextID,nextitem.updateCost,nextitem.costNum,canLvup)
    end
end


function FlagItem:NS_GoogleRechargeRequest(ev, ns)
    if ns.nReturnStatus == 0 and ns.nShopItemId == self.item.code then
        if util.isAndroid() then
            -- talkingdata
            print("ns.nSelfOrderId:" .. ns.nSelfOrderId.v)
            local luaj = require "cocos.cocos2d.luaj"
            local classname = "org/cocos2dx/lua/TalkingData"
            local args = { ns.nSelfOrderId.v, self.item.cost, self.item.getNum }
            local sigs = "(IFI)V"

            local ok, ret = luaj.callStaticMethod(classname, "onCharge", args, sigs)

            if ns.nRechargeType == 3 then
                local luaj = require "cocos.cocos2d.luaj"
                local classname = "org/cocos2dx/lua/AliPay"
                local args = { ns.szDataInfo }
                local sigs = "(Ljava/lang/String;)V"

                local ok, ret = luaj.callStaticMethod(classname, "Purchase", args, sigs)                                     
            else
                local luaj = require "cocos.cocos2d.luaj"
                local classname = "org/cocos2dx/lua/GoogleIab"
                local args = { ns.nShopItemId }
                local sigs = "(I)V"

                local ok, ret = luaj.callStaticMethod(classname, "PurchaseFlow", args, sigs)
            end

            local function onIabPurchaseFinished(msg)
                if ns.nRechargeType == 3 then
                    net.msg.NC_GoogleRechargeComplete(ns.nRechargeType, self.item.code, ns.nSelfOrderId, self.item.cost, self.item.getNum, msg)
                else
                    net.msg.NC_GoogleRechargeComplete(ns.nRechargeType, self.item.code, ns.nSelfOrderId, self.item.cost, self.item.getNum, msg)
                end
            end

            util.SendLuaFuncID2Java(onIabPurchaseFinished)
        end
    end
end

function FlagItem:NS_GoogleRechargeComplete(ev, ns)
--    print("ns.nReturnType:"..ns.nReturnType.." ItemID:"..ns.nShopItemId.." code:"..self.item.code .. " ns.nSelfOrderId:"..ns.nSelfOrderId.v)
    if ns.nReturnType == 0 and ns.nShopItemId == self.item.code then
        if util.isAndroid() then
--            print("net.msg.NC_ExceteTopUp("..self.item.code..")")
--            net.msg.NC_ExceteTopUp(self.item.code)

            -- talkingdata
            local luaj = require "cocos.cocos2d.luaj"
            local classname = "org/cocos2dx/lua/TalkingData"
            local args = { ns.nSelfOrderId.v }
            local sigs = "(I)V"

            local ok, ret = luaj.callStaticMethod(classname, "onChargeSuccess", args, sigs)

            sdkManager.talkingdata:setEvent("39",{diamondBuy = tostring(ns.nShopItemId)})
            sdkManager.appsflyer:setEvent("39",{diamondBuy = tostring(ns.nShopItemId)})
        end
    end
end

return FlagItem


