local SkinItem = class("SkinItem", cc.load("mvc").LayoutBase)
SkinItem.RESOURCE_FILENAME = "Shop.SkinItem"

function SkinItem:onCreate()
    self:addEvent('NS_ShopItemLevelUp')
    self:addEvent('NS_BuyShopItem')
    self:addEvent('NS_ExchangeFlag')
    self:addEvent('NS_ExchangeCursor')
end

function SkinItem:onEnter()
    self.isClickLevelUp=false--仅作为开关用
    self.isLevelUp=false--实际升级了！
    self.isBuy=false--实际买了
    self.isClickHasBuyGoods=false--仅作为开关用
    self.lv=1
    self.isBGUI=false--仅作开关使用？
    self.isEquit=false--实际穿上了
    self.ui.Text_1:setString(static.language[10012][device.language])
    self.ui.Text_4:setString(static.language[10013][device.language])
    self.ui.Text_4:setVisible(false)
end

function SkinItem:onExit()

end

-- Event for Panel callback (addClickEventListener)
function SkinItem:OnBuy(node, eventType, userdata)
    if(self.item~=nil)  then   
--        if self.item.code < 50000 then
            local num = 0
            if self.item.costType == 1 then
                num = tonumber(mdt.player.gold)
            elseif self.item.costType == 2 then
                num = tonumber(mdt.mypvpcoin)
            elseif self.item.costType == 3 then
                num = tonumber(mdt.player.diamond)
            end
            if tonumber(self.item.cost) > num then
                util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item.costType,true) 
            else  
                local view = util.showDialog(nil, 'Common.ConfirmDialog')
                view:setkey(
                self.item.cost,
                function()
                    self.isClickHasBuyGoods = true
                    net.msg.NC_BuyShopItem(self.item.code)
                    mdt.buyitemcode = self.newitem.id
                end ,
                self.item.costType,30010)
            end
--        else
--            util.showDialog(nil,'Shop.BuyItemDialog')
--        end
    else
        local num = 0
        if self.item1.costType == 1 then
            num = tonumber(mdt.player.gold)
        elseif self.item1.costType == 2 then
            num = tonumber(mdt.mypvpcoin)
        elseif self.item1.costType == 3 then
            num = tonumber(mdt.player.diamond)
        end
        if tonumber(self.item1.cost) > num then
            util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item1.costType,true) 
        else  
            local view = util.showDialog(nil, 'Common.ConfirmDialog')
            view:setkey(
            self.item1.cost,
            function()
                self.isClickHasBuyGoods = true
                print(self.item1.code)
                net.msg.NC_BuyShopItem(self.item1.code)
                mdt.buyitemcode = self.newitem1.id
            end ,
            self.item1.costType,30010)
        end
    end
end

-- Event for Select callback (addClickEventListener)
function SkinItem:onSelect(node, eventType, userdata)
    if(self.item~=nil)  then
        net.msg.NC_ExchangeCursor(self.item.itemCode)
        mdt.exchangecursor = mdt.cursorindex
    else
        net.msg.NC_ExchangeFlag(self.item1.itemCode)
        mdt.exchangeflag = mdt.flagindex
    end
end

function SkinItem:NS_ExchangeFlag(ev,ns)     
    if ns.nErrorCode == 0 then
        local isSelected = (self.item1.itemCode == ns.nFlagId)
        self.isBGUI=isSelected
        self.ui.Text_1:setVisible(isSelected)
        self.ui.Select:setVisible(not isSelected)
        self:OnCurChooseId1()
    else
        print('SkinItem旗子装备失败,nErrorCode='..ns.nErrorCode)
    end
end

function SkinItem:NS_ExchangeCursor(ev,ns)
    if ns.nErrorCode == 0 then
        if self.item.itemCode == mdt.exchangecursor then
           self.isBGUI=false
            self.ui.Select:setVisible(true)
            self.ui.Buy:setVisible(false)
            self.ui.Text_1:setVisible(false)
            self:OnCurChooseId()
        end
        if self.item.itemCode == ns.nCursorId then
            self.isBGUI=true
            self:OnCurChooseId()
            mdt.cursorindex = ns.nCursorId
        end
    else
        print('标志装备失败,nErrorCode='..ns.nErrorCode)
    end
end

function SkinItem:setitemkey(key)
    self.ui.BuyNum:setVisible(true)
    self.ui.BuyNum:setString('X '..key.itemNum)
    self.item = key
    self.newitem = nil
    for i=1,#static.item do
        if static.item[i].id == self.item.itemCode then
            self.newitem = static.item[i]
            break
        end
    end
    self.isBuy=false
    self:setItemUI()
end

function SkinItem:setItemUI()
    self.ui.Diamond:loadTexture(self.newitem.imageId)
    self.ui.Dollar:setString(self.item.cost)
    if(self.item.costType==1) then
        self.ui.Image_3:setTexture("Image/coin.png") 
    elseif (self.item.costType==2)then
        self. ui.Image_3:setTexture("Image/Diamond.png") 
    end
    self.ui.Image_BG:setVisible(false)
    self.ui.Select:setVisible(false)
    self.ui.Buy:setVisible(true)
    self.ui.Text_1:setVisible(false)
end

function SkinItem:OnCurChooseId()
    if self.isBGUI==true then
        self.isEquit=true
        self.ui.Image_BG:setVisible(true)
        self.ui.Select:setVisible(false)
        self.ui.Buy:setVisible(false)
        self.ui.Text_1:setVisible(true)
        self.ui.Text_1:setString(static.language[10012][device.language])
        self.isBGUI=false
    else
        self.isEquit=false
        self.ui.Image_BG:setVisible(false)
--        self.ui.Select:setVisible(true)
--        self.ui.Text_1:setVisible(false)
        if self.isBuy then
            self.ui.Text_4:setVisible(true)
        end
    end

end

function SkinItem:OnCurChooseId1()
    if self.isBGUI==true then
        self.isEquit=true
        self.ui.Image_BG:setVisible(true)
        self.ui.Select:setVisible(false)
        self.ui.Buy:setVisible(false)
        self.ui.Text_1:setVisible(true)
        self.ui.Text_4:setVisible(false)
        self.isBGUI=false
    else
        self.isEquit=false
        self.ui.Image_BG:setVisible(false)
        self.ui.Select:setVisible(true)
        if self.isBuy then
            self.ui.Text_4:setVisible(true)
        end
        self.ui.Text_1:setVisible(false)
    end

end

function SkinItem:NS_BuyShopItem(ev,ns)
    if ns.nErrorCode == 0 then
        if mdt.buyitemcode < 50000 then
            if(self.item~=nil) then
                if mdt.buyitemcode == self.item.id then
                    self.isBuy=true
                    sdkManager.talkingdata:setEvent("17",{BuyItem = tostring(self.item.itemCode)})
                    sdkManager.appsflyer:setEvent("17",{BuyItem = tostring(self.item.itemCode)})
                end
                if self.isClickHasBuyGoods == true then   
                    print("收钱了！！！！！！！！！！！！！",ns.nItemID)     
                    table.insert(self.refreshData,self.item.itemCode)    
                    self:setkey(self.item,self.refreshData)   
                    self.ui.Buy:setVisible(false)      
                    self.isClickHasBuyGoods = false
                end
            else
                if mdt.buyitemcode == self.item1.code then
                    self.isBuy=true
                    sdkManager.talkingdata:setEvent("17",{BuyItem = tostring(self.item1.itemCode)})
                    sdkManager.appsflyer:setEvent("17",{BuyItem = tostring(self.item1.itemCode)})
                end
                if self.isClickHasBuyGoods == true then
                    print("收钱了！！！！！！！！！！！！！",ns.nItemID) 
                    table.insert(self.refreshData1,self.item1.itemCode)  
                    self:setkey1(self.item1,self.refreshData1)    
                    self.ui.Buy:setVisible(false)     
                    self.isClickHasBuyGoods = false
                end
            end
        end
        event.dispatch("OnRefreshGoldOrDiamond")
    else
        print('购买失败,nErrorCode='..ns.nErrorCode)
    end
end
function SkinItem:NS_ShopItemLevelUp(ev,ns)
    self.isLevelUp=true
    if self.isClickLevelUp == true and mdt.player.gold-self.item1[self.lv].cost>=0 then
        self.lv=self.lv+1
        table.insert(self.refreshData1,ns.nOldItemID+1 )
        self:setkey1(self.item1,self.refreshData1) 
        self.isClickLevelUp = false

        if static.shop[ns.nOldItemID].level == 1 then
            if not mdr.OneUpdatePlayer then
                sdkManager.talkingdata:setEvent("28",{OneUpdatePlayer = "1"})
                sdkManager.appsflyer:setEvent("28",{OneUpdatePlayer = "1"})
                mdr.OneUpdatePlayer = true
                mdr.save()
            end
            sdkManager.talkingdata:setEvent("26",{OneUpdate = tostring(ns.nOldItemID)})
            sdkManager.appsflyer:setEvent("26",{OneUpdate = tostring(ns.nOldItemID)})
        elseif static.shop[ns.nOldItemID].level == 2 then
            if not mdr.TwoUpdatePlyaer then
                sdkManager.talkingdata:setEvent("29",{TwoUpdatePlyaer = "2"})
                sdkManager.appsflyer:setEvent("29",{TwoUpdatePlyaer = "2"})
                mdr.TwoUpdatePlyaer = true
                mdr.save()
            end
            sdkManager.talkingdata:setEvent("27",{TwoUpdate = tostring(ns.nOldItemID)})
            sdkManager.appsflyer:setEvent("27",{TwoUpdate = tostring(ns.nOldItemID)})
        end
    end
end

-- Event for Lvup callback (addClickEventListener)
function SkinItem:OnLvup(node, eventType, userdata)  
    if tonumber(self.newitem1.nextID) ~= 0 then
        mdt.updataid = self.newitem1.nextID
        local view = util.showDialog('Dialog', 'Common.UpdateDialog')      
        view:setkey(self.item1.itemCode,self.newitem1.nextID,self.item1.costType,self.item1.cost,self.isBuy)
    end      
end

function SkinItem:setkey(key,refreshData)
     self.item = key
     self.newitem = nil
        for i=1,#static.item do
            if static.item[i].id == self.item.itemCode then
                self.newitem = static.item[i]
                break
            end
        end
     self.refreshData=refreshData

    if refreshData then
        --判断当前成就数据是否满足自己的id
        
        for i=1,#refreshData do
            if refreshData[i] == self.item.itemCode then
                self.curI=i
                self.isBuy=true
                break
            end    
        end
        self:refreshNormalPartData()
    end
    if self.item.itemCode == mdt.cursorindex then
        self.isBGUI = true
        self.ui.Select:setVisible(false)
        self.ui.Buy:setVisible(false)
        self.ui.Text_1:setVisible(true)
        self.isEquit = true
    end
    self:OnCurChooseId()
--    if self.isEquit == true then
--        self.ui.Select:setVisible(false)
--        self.ui.Buy:setVisible(false)
--        self.ui.Text_1:setVisible(true)
--    end
end

function SkinItem:refreshNormalPartData()
    self.ui.Diamond:loadTexture(self.newitem.imageId)
    self.ui.Dollar:setString(self.item.cost)
    if(self.item.costType==1) then
        self.ui.Image_3:setTexture("Image/coin.png") 
    elseif (self.item.costType==2)then
        self. ui.Image_3:setTexture("Image/Diamond.png") 
    end
    
    if(self.isBuy==true or self.item.itemCode==30101 or self.item.itemCode==20101) then
        self.ui.Buy:setVisible(false)
        self.ui.Select:setVisible(true)
        self.ui.Text_1:setVisible(false)
    elseif self.isBuy == false then
        self.ui.Buy:setVisible(false)
        self.ui.Select:setVisible(false)
        self.ui.Text_1:setVisible(true)
        self.ui.Text_1:setString(static.language[20027][device.language])
    end
end
function SkinItem:setkey1(key,refreshData)--key:本地，refresh,服务器发送的所有已有商品
    self.item1 = key
    self.newitem1 = nil
    for i=1,#static.item do
        if static.item[i].id == self.item1.itemCode then
            self.newitem1 = static.item[i]
            break
        end
    end
    self.refreshData1= refreshData
    if(nil~=self.refreshData1)  then
    end
    if refreshData then
        for i=1,#refreshData do
            if refreshData[i] == self.item1.itemCode then
                print("执行依赖服务器数据的UI刷新",self.item1.itemCode)
                self.curI=i
                self.isBuy=true
                break
            end  
        end
        self:refreshSpecialPartData()
    end
    if self.item1.itemCode == mdt.flagindex then
        self.isBGUI = true
        self.isEquit = true
    end
    self:OnCurChooseId1()
end

function SkinItem:refreshSpecialPartData()
 -- print("当前图片ID为：",self.item1[self.lv].imageId)
    self.ui.Diamond:loadTexture(self.newitem1.imageId)
    self.ui.Dollar:setString(self.item1.cost)
    if(self.item1.costType==1)  then
        self.ui.Image_3:setTexture("Image/coin.png") 
    elseif(self.item1.costType==3)  then
        self.ui.Image_3:setTexture("Image/Diamond.png") 
    else
        self.ui.Image_3:setTexture("Image/pvp/pvp.png") 
    end
            
    self.ui.Dollar:setString(self.item1.cost)
    if(self.isBuy==true or self.item1.itemCode==10101   ) then
        self.ui.Select:setVisible(true)
        self.ui.Buy:setVisible(false)
    end
    if(tonumber(self.newitem1.nextID) ~= 0) then
        self.ui.Lvup:setVisible(true)
        for i = 1 , #self.refreshData1 do
            if self.refreshData1[i] == self.newitem1.nextID then
                self.ui.Lvup:setVisible(false)
                break
            end
        end        
    end         
--    if(self.item1.nextID~=0 and self.isBuy==true) then
--        print("下一级等级为",self.item1[self.lv].nextID)
--        self.ui.Lvup:setVisible(true)
--    end
end



return SkinItem
