local SuccessItem = class("SuccessItem", cc.load("mvc").LayoutBase)
SuccessItem.RESOURCE_FILENAME = "Success.SuccessItem"

SuccessItem["curKey"]=nil
SuccessItem["curStaticData"]=nil
SuccessItem["curISkinData"]=nil
local curid = 0
local deletekey = 0
function SuccessItem:onCreate()
    self:addEvent('NS_GetAchievement') --点击领取成就
    self:addEvent('UpdateKey')
end

function SuccessItem:onEnter()
    self.ui.Reward:setString(static.language[20019][device.language]..':')
    self.isPress=false
    self.curISkinData=static.item
end

function SuccessItem:onExit()

end

--enum class ENS_ACHIEVEMENTGETREWARDRETURN
--{
--	ENS_ACHIEVEMENTGETREWARDRETURN_NULL = 0,					//0.系统错误
--	ENS_ACHIEVEMENTGETREWARDRETURN_SUCCESE,						//1.领取奖品成功，flag置上了
--	ENS_ACHIEVEMENTGETREWARDRETURN_SUCCESE_OWNITEM,				//2.领取奖品成功，flag置上了,但是玩家已拥有该物品，奖品通过折现方式兑换
--	ENS_ACHIEVEMENTGETREWARDRETURN_LOWLEVELNOTRECEIVE,			//3.由于未按照顺序领取奖品，还有比该奖品等级低的奖品未领取
--	ENS_ACHIEVEMENTGETREWARDRETURN_NOTREACH						//4.由于未达成该成就，无法领取（正常情况不会出这种问题，此情况只为增强检测用）
--};

function SuccessItem:UpdateKey()
    if self.k ~= nil then
        if self.k > deletekey then
            self.k = self.k-1
        end
    end
end

-- uint32_t                nAchievementID;                         // 成就id
--     uint64_t                nGUID;                                  // 成就列表所属的角色ID
--     uint32_t                nTypeID;                                // 成就种类ID
--     uint32_t                nParam;                                 // 成就具体数值
--     uint32_t                nGetReward;                 0:weidacheng 1:dachengweilingqu 2:lingqule             // 领取过的奖品记录
--     uint32_t                nGetRewardDate;                         // 领取过的等级3奖品记录的时间

function SuccessItem:setkey(key,refreshData)
    self.curKey=key
    self.refreshData=refreshData
    --print("=========================>>>>>>>>",self.refreshData[1],self.curKey.code)
    
    if refreshData then
        --判断当前成就数据是否满足自己的id
        for i=1,#refreshData do
            if refreshData[i].nAchievementID == self.curKey.code then    
                self.curI=i
                if refreshData[i].nGetReward == 1 then
                    self.ui.Image_3:setVisible(false)
                    self.ui.Panel_Reward:setVisible(true)
                    self.ui.redpoint_1:setVisible(true)
                    self.ui.Button_Reward:onSetText(static.language[10005][device.language])
                elseif refreshData[i].nGetReward == 2 then
                    self.ui.Image_3:setVisible(false)
                    self.ui.Panel_Reward:setVisible(false)
                    self.ui.AlreadyGet:setVisible(true)
                else
                    self.ui.Image_3:setVisible(true)
                end
                break
            end
        end
    end
    self:onSuccessItemRefresh()
    self:onRefreshBar()
    if mdt.reachAch~=nil then
        for k,v in pairs(mdt.reachAch) do
            if v.nRank == self.curKey.code then
                self.k = k
                break
            end
        end
    end
end

function SuccessItem:onSuccessItemRefresh()
    if(self.curISkinData)==nil then

             self.curISkinData=static.item
    end
--    self.ui.Image_5:setVisible(false)
    if(self.curKey.achGet==4) then
         self.ui.Image_4:setTexture("Image/coin.png")
    elseif  (self.curKey.achGet==5) then
        self.ui.Image_4:setTexture("Image/Diamond.png")
    else
        for  i=1,#self.curISkinData do
            if self.curISkinData[i].id== self.curKey.item1 then
                 self.ui.Image_4:setTexture(self.curISkinData[i].imageId)
                 self.ui.Image_4:setScale(0.5)
--                 self.ui.Image_5:setVisible(true)
                   --   self.ui.Button_GetReward:setVisible(false)
                   -- self.ui.Text_GetReward:setString("不可领取")
                   -- self:onRefreshBar()
            end
        end
       
    end
         self.ui.Text_2:setString("X "..self.curKey.num1)
        --print("描述序号为：",self.curKey.desc)
                --self.ui.Describe:setString(static.language[60201][device.language])
                --self.ui.Describe:setString(static.language[tonumber(self.curKey.desc)][device.language])
        local str = static.language[tonumber(self.curKey.desc)][device.language]
        local a = string.sub(str,0,1)
        if string.byte(a) >= 65 and string.byte(a) <= 90 or string.byte(a) >= 97 and string.byte(a) <= 122 then 
            self.ui.Describe_0:setString(a)
            self.ui.Describe:setString(string.sub(str,2,string.len(str)))
        else
            self.ui.Describe_0:setString('!')
            self.ui.Describe:setString(str)
        end
end

function SuccessItem:onRefreshBar()
--print("=========================>>>>>>>>",self.refreshData) --刷新进度条
if(self.refreshData~=nil) then
    --print("=========================>>>>>>>>",self.refreshData[self.curI].nParam) --刷新进度条
    if self.ui.Image_3 ~= nil then
            if self.curI ~=nil then
            local percent = self.refreshData[self.curI].nParam/self.curKey.achNum * 100
            if percent > 0 then
                self.ui.loading_left:setVisible(true)
            else
                self.ui.loading_left:setVisible(false)
            end
            if percent == 100 then
                self.ui.loading_right:setVisible(true)
            else 
                self.ui.loading_right:setVisible(false)
            end
            self.ui.Ach_Bar:setPercent(percent)
            self.ui.Schedule:setString(self.refreshData[self.curI].nParam.."/"..self.curKey.achNum)
            
            else
             self.ui.Ach_Bar:setPercent(0)
             self.ui.Schedule:setString("0 ".." / "..self.curKey.achNum)
             self.ui.loading_left:setVisible(false)
         end
    end

end
end

function SuccessItem:onRefreshImage() --刷新图片
--     self.ui.RewardPic:loadTexture(self.curKey.image)
--     self.ui.Ach_Sprite:setTexture(self.curKey.image)

end
function SuccessItem:onRefreshReward()
     
    -- body
end

-- Event for Panel_4 callback (addClickEventListener)
function SuccessItem:OnClickItem(node, eventType, userdata)
    if self.isGet then
        curid = self.id
        --net.msg.NC_GetAchievement(static.achievement[self.id].achID,static.achievement[self.id].achLevel)
        audio.playEffect('achGet')
        if tonumber(static.achievement[self.id].achGet) ~= 0 then
            local view = util.showDialog('Dialog', 'Common.RewardDialog')
            local reward = static.achievement[self.id]
            local id = 0 
            if reward.achGet == 5 then
                id = 1
            elseif reward.achGet == 4 then
                id = 2
            else
                id = reward.item1
            end
            local item = {id=id,num=reward.num1}
            view:setkey(item)
        end
    end
end

-- Event for Button_GetReward callback (addClickEventListener)
function SuccessItem:onClickGetReward(node, eventType, userdata)
    net.msg.NC_GetAchievement(self.curKey.code,1)
    print("点击了领奖按钮！！")
    self.isPress=true
    self.ui.redpoint_1:setVisible(false)
    deletekey = self.k
    table.remove(mdt.reachAch,self.k)
    mdt.haveach = #mdt.reachAch > 0 and true or false
    event.dispatch('UpdateKey')
    event.dispatch('getach')
end
-- ENS_ACHIEVEMENT_GETREWARD_RETURN_NULL = 0,                  //0.系统错误
--     ENS_ACHIEVEMENT_GETREWARD_RETURN_SUCCESE,                       //1.领取奖品成功，flag置上了
--     ENS_ACHIEVEMENT_GETREWARD_RETURN_SUCCESE_OWNITEM,               //2.领取奖品成功，flag置上了,但是玩家已拥有该物品，奖品通过折现方式兑换
--     ENS_ACHIEVEMENT_GETREWARD_RETURN_LOWLEVELNOTRECEIVE,            //3.由于未按照顺序领取奖品，还有比该奖品等级低的奖品未领取
--     ENS_ACHIEVEMENT_GETREWARD_RETURN_NOTREACH                       //4.由于未达成该成就，无法领取（正常情况不会出这种问题，此情况只为增强检测用
function SuccessItem:NS_GetAchievement(env,ns)
   -- dump(ns)
        if tonumber(ns.nOpen)==  1 or tonumber(ns.nOpen)==2 then
            if self.isPress==true  then
                 self.ui.Image_3:setVisible(false)
--                                self.ui.Panel_GetReward:setVisible(true)
                                self.ui.Panel_Reward:setVisible(false)
--                                self.ui.Text_GetReward:setString(static.language[10012][device.language])
                self.ui.AlreadyGet:setVisible(true)
                self.ui.isPress=false
                self.isPress=false
                 -- 
                 if self.curKey.achGet~= 0 then 
                    print("加载界面弹板！！！")
                        local view = util.showDialog('Dialog', 'Common.RewardDialog') 
                        local id = 0
                           if self.curKey.achGet == 4 then
                                  id = 1
                         elseif self.curKey.achGet == 5 then
                                id = 2
                         else
                                 id =self.curKey.item1
                        end
                        local item = {id=id,num=self.curKey.num1}
                        view:setkey(item)

                end

            end
        end
end

return SuccessItem
