
-- 0 - disable debug info, 1 - less debug info, 2 - verbose debug info
DEBUG = 2

-- use framework, will disable all deprecated API, false - use legacy API
CC_USE_FRAMEWORK = true

-- show FPS on screen
CC_SHOW_FPS = false

-- disable create unexpected global variable
CC_DISABLE_GLOBAL = true

-- show net msg
CC_SHOW_NET_MSG = true
CC_NO_UPDATOR = true
CC_MAX_MAPID = 18

-- download
CC_DOWNLOAD_PATH = "download/update"

-- for module display
CC_DESIGN_RESOLUTION = {
    width = 1080,
    height = 1920,
    --autoscale = "NO_BORDER",
    autoscale = "NO_BORDER",
    callback = function(framesize)
        local ratio = framesize.width / framesize.height
        if ratio > 0.7 then
            -- iPad 768*1024(1536*2048) is 4:3 screen
            return {autoscale = "NO_BORDER", width=1296, height=1296/ratio}
        else
            return {autoscale = "NO_BORDER", width=1920*ratio, height=1920}
        end
    end
}
