-- 新建一个table，包含CreateCustomNode和GetBaseType方法。
local container = {}
-- 新建根节点Node，目前这个方法的名字为固定的，必须为CreateCustomNode。
-- 方法的最后一句必须是一个return语句，把新建的结点返回。
function container.CreateCustomNode(json, atlas)
    if __NotEditor then
        local rootNode = sp.SkeletonAnimation:create(json, atlas, 1)
        return rootNode
    end
    local rootNode = cc.Node:create()
    return rootNode
end

function container.GetSetSkeletonDataFile(root)
    return ''
end


function container.SetSkeletonDataFile(root, value, resType)

	if root.sk_ then
    	root.sk_:removeFromParent()
	end
    --if cc.FileUtils:getInstance():isFileExist(value) then
        local sk = sp.SkeletonAnimation:create(value, string.sub(value, 0, string.len(value)-4)..'atlas', 1)
        root.sk_ = sk
		container.Play(root)
        root:addChild(sk)

    --    end  
end

function container.SetAnimation(root, value)
	root.ani_ = value
	container.Play(root)
end

function container.SetLoop(root, value)
	root.loop_ = value
	container.Play(root)
end

function container.Play(root)
	if root.sk_ then
		root.sk_:setAnimation(1, root.ani_, root.loop_)
	end
end

function container.GetBaseType()
    return 'LuaSpine'
end

return container
