local name = {
    id = 1,                             -- 编号
    level = 2,                          -- 等级
    range = 3,                          -- 数量范围
    rate = 4,                           -- 提升倍率
    cdTime = 5,                         -- cd时间
    itemType = 6,                       -- 奖励物品种类
    itemId = 7,                         -- 物品id
    itemNum = 8,                        -- 物品数量
    sound = 9,                          -- 音效
}

local data = {
{ 1, "E", 1, 80, 9000, 0, 0, 0, "combo1", },
{ 2, "D", 25, 85, 9000, 0, 0, 0, "combo2", },
{ 3, "C", 75, 90, 8000, 0, 0, 0, "combo3", },
{ 4, "B", 250, 95, 7000, 6, 50001, 1, "combo4", },
{ 5, "A", 700, 100, 6000, 6, 50001, 1, "combo5", },
{ 6, "S", 2000, 130, 5000, 6, 50002, 1, "combo5", },
{ 7, "SS", 5000, 170, 4000, 6, 50003, 1, "combo5", },
{ 8, "SSS", 99999, 250, 3000, 6, 50004, 1, "combo5", },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
