local name = {
    id = 1,                             -- 编号
    range = 2,                          -- 数量范围
    sound = 3,                          -- 音效
}

local data = {
{ 1, 300, "combo1", },
{ 2, 800, "combo2", },
{ 3, 1300, "combo2", },
{ 4, 1700, "combo3", },
{ 5, 2000, "combo3", },
{ 6, 2400, "combo4", },
{ 7, 2800, "combo4", },
{ 8, 3500, "combo5", },
{ 9, 4000, "combo5", },
{ 10, 4500, "combo5", },
{ 11, 5000, "combo5", },
{ 12, 5500, "combo5", },
{ 13, 6000, "combo5", },
{ 14, 6500, "combo5", },
{ 15, 7000, "combo5", },
{ 16, 7500, "combo5", },
{ 17, 8000, "combo5", },
{ 18, 8500, "combo5", },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
