local name = {
    id = 1,                             -- 编号
    range = 2,                          -- 奖励范围
    type1 = 3,                          -- 类型1
    value1 = 4,                         -- 值1
    times1 = 5,                         -- 数量1
    type2 = 6,                          -- 类型2
    value2 = 7,                         -- 值2
    times2 = 8,                         -- 数量2
    type3 = 9,                          -- 类型3
    value3 = 10,                        -- 值3
    times3 = 11,                        -- 数量3
}

local data = {
{ 1, 1, 4, 50003, 1, 5, 50002, 4, 1, 0, 900, },
{ 2, 10, 4, 50003, 1, 5, 50002, 2, 1, 0, 700, },
{ 3, 100, 4, 50002, 1, 5, 50001, 4, 1, 0, 500, },
{ 4, 1000, 4, 50002, 1, 5, 50001, 2, 1, 0, 300, },
{ 5, 9999, 4, 50001, 1, 0, 0, 0, 0, 0, 0, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
