local name = {
    id = 1,                             -- 序号
    nameID = 2,                         -- 简称
    name = 3,                           -- 名字
    value1 = 4,                         -- 值1
    State = 5,                          -- 州
}

local data = {
{ 1, "AC", "阿森松岛", 0, 99, },
{ 2, "AD", "安道尔", 1, 2, },
{ 3, "AE", "阿联酋", 1, 1, },
{ 4, "AF", "阿富汗", 1, 1, },
{ 5, "AG", "安提瓜和巴布达", 1, 3, },
{ 6, "AI", "安圭拉", 0, 3, },
{ 7, "AM", "亚美尼亚", 1, 1, },
{ 8, "AO", "安哥拉", 1, 5, },
{ 9, "AR", "阿根廷", 1, 4, },
{ 10, "AT", "奥地利", 1, 2, },
{ 11, "AU", "澳大利亚", 1, 6, },
{ 12, "AW", "阿鲁巴", 1, 3, },
{ 13, "AZ", "阿塞拜疆", 1, 1, },
{ 14, "BA", "波斯尼亚和黑塞哥维那", 1, 2, },
{ 15, "BB", "巴巴多斯", 1, 3, },
{ 16, "BD", "孟加拉", 1, 1, },
{ 17, "BE", "比利时", 1, 2, },
{ 18, "BF", "布基纳法索", 1, 5, },
{ 19, "BG", "保加利亚", 1, 2, },
{ 20, "BH", "巴林", 1, 1, },
{ 21, "BI", "布隆迪", 1, 5, },
{ 22, "BJ", "贝宁", 1, 5, },
{ 23, "BM", "百慕大", 1, 3, },
{ 24, "BN", "汶莱", 1, 1, },
{ 25, "BO", "玻利维亚", 0, 4, },
{ 26, "BR", "巴西", 1, 4, },
{ 27, "BS", "巴哈马", 1, 3, },
{ 28, "BT", "不丹", 1, 1, },
{ 29, "BV", "布威岛", 0, 99, },
{ 30, "BW", "博茨瓦纳", 1, 5, },
{ 31, "BY", "白俄罗斯", 1, 2, },
{ 32, "BZ", "伯利兹", 0, 3, },
{ 33, "CA", "加拿大", 1, 3, },
{ 34, "CD", "刚果(金)", 1, 5, },
{ 35, "CF", "中非", 1, 5, },
{ 36, "CG", "刚果(布)", 1, 5, },
{ 37, "CH", "瑞士", 1, 2, },
{ 38, "CI", "科特迪瓦", 1, 5, },
{ 39, "CK", "科克群岛", 1, 6, },
{ 40, "CL", "智利", 1, 4, },
{ 41, "CM", "喀麦隆", 1, 5, },
{ 42, "CN", "中国", 1, 1, },
{ 43, "CO", "哥伦比亚", 1, 4, },
{ 44, "CR", "哥斯达黎加", 1, 3, },
{ 45, "CU", "古巴", 1, 3, },
{ 46, "CV", "佛得角", 0, 5, },
{ 47, "CY", "塞浦路斯", 1, 1, },
{ 48, "CZ", "捷克", 1, 2, },
{ 49, "DE", "德国", 1, 2, },
{ 50, "DJ", "吉布提", 1, 5, },
{ 51, "DK", "丹麦", 1, 2, },
{ 52, "DM", "多米尼克", 1, 3, },
{ 53, "DO", "多米尼加", 1, 3, },
{ 54, "DZ", "阿尔及利亚", 1, 5, },
{ 55, "EC", "厄瓜多尔", 1, 4, },
{ 56, "EE", "爱沙尼亚", 1, 2, },
{ 57, "EG", "埃及", 1, 5, },
{ 58, "EH", "西撒哈拉", 0, 99, },
{ 59, "ER", "厄立特里亚", 1, 5, },
{ 60, "ES", "西班牙", 1, 2, },
{ 61, "ET", "埃塞俄比亚", 1, 5, },
{ 62, "FI", "芬兰", 1, 2, },
{ 63, "FJ", "斐济", 1, 6, },
{ 64, "FK", "福克兰群岛", 0, 4, },
{ 65, "FM", "密克罗尼西亚联邦", 1, 6, },
{ 66, "FO", "法罗群岛", 1, 2, },
{ 67, "FR", "法国", 1, 2, },
{ 68, "GA", "加蓬", 1, 5, },
{ 69, "GB", "英国", 1, 2, },
{ 70, "GD", "格林纳达", 1, 3, },
{ 71, "GE", "格鲁吉亚", 1, 1, },
{ 72, "GF", "法属圭亚那", 0, 4, },
{ 73, "GG", "根西岛", 1, 2, },
{ 74, "GH", "加纳", 1, 5, },
{ 75, "GI", "直布罗陀", 1, 2, },
{ 76, "GL", "格陵兰", 1, 3, },
{ 77, "GM", "冈比亚", 1, 5, },
{ 78, "GN", "几内亚", 1, 5, },
{ 79, "GR", "希腊", 1, 2, },
{ 80, "GT", "危地马拉", 1, 3, },
{ 81, "GW", "几内亚比绍", 0, 5, },
{ 82, "GY", "圭亚那", 0, 4, },
{ 83, "CN", "中国", 1, 1, },
{ 84, "HM", "赫德和麦克唐纳群岛", 0, 99, },
{ 85, "HN", "洪都拉斯", 1, 3, },
{ 86, "HR", "克罗地亚", 1, 2, },
{ 87, "HT", "海地", 0, 3, },
{ 88, "HU", "匈牙利", 1, 2, },
{ 89, "ID", "印度尼西亚", 1, 1, },
{ 90, "IE", "爱尔兰", 1, 2, },
{ 91, "IL", "以色列", 1, 1, },
{ 92, "IN", "印度", 1, 1, },
{ 93, "IQ", "伊拉克", 1, 1, },
{ 94, "IR", "伊朗", 1, 1, },
{ 95, "IS", "冰岛", 1, 2, },
{ 96, "IT", "意大利", 1, 2, },
{ 97, "JE", "泽西岛", 1, 2, },
{ 98, "JM", "牙买加", 1, 3, },
{ 99, "JO", "约旦", 1, 1, },
{ 100, "JP", "日本", 1, 1, },
{ 101, "KE", "肯尼亚", 1, 5, },
{ 102, "KG", "吉尔吉斯斯坦", 1, 1, },
{ 103, "KH", "柬埔寨", 1, 1, },
{ 104, "KI", "基里巴斯", 1, 6, },
{ 105, "KM", "科摩罗", 0, 5, },
{ 106, "KN", "圣基茨和尼维斯", 1, 3, },
{ 107, "KP", "朝鲜", 1, 1, },
{ 108, "KR", "韩国", 1, 1, },
{ 109, "KW", "科威特", 1, 1, },
{ 110, "KY", "开曼群岛", 1, 3, },
{ 111, "KZ", "哈萨克斯坦", 1, 1, },
{ 112, "LA", "老挝", 1, 1, },
{ 113, "LB", "黎巴嫩", 1, 1, },
{ 114, "LC", "圣卢西亚", 1, 3, },
{ 115, "LI", "列支敦士登", 1, 2, },
{ 116, "LK", "斯里兰卡", 1, 1, },
{ 117, "LR", "利比里亚", 1, 5, },
{ 118, "LS", "莱索托", 1, 5, },
{ 119, "LT", "立陶宛", 1, 2, },
{ 120, "LU", "卢森堡", 1, 1, },
{ 121, "LV", "拉脱维亚", 1, 2, },
{ 122, "LY", "利比亚", 1, 5, },
{ 123, "MA", "摩洛哥", 1, 5, },
{ 124, "MC", "摩纳哥", 1, 2, },
{ 125, "MD", "摩尔多瓦", 1, 2, },
{ 126, "MG", "马达加斯加", 1, 5, },
{ 127, "MH", "马绍尔群岛", 1, 6, },
{ 128, "MK", "马其顿", 1, 2, },
{ 129, "ML", "马里", 1, 5, },
{ 130, "MM", "缅甸", 1, 1, },
{ 131, "MN", "蒙古", 1, 1, },
{ 132, "CN", "中国", 1, 1,},
{ 133, "MQ", "马提尼克", 1, 3, },
{ 134, "MR", "毛里塔尼亚", 1, 5, },
{ 135, "MT", "马耳他", 1, 2, },
{ 136, "MU", "毛里求斯", 1, 5, },
{ 137, "MV", "马尔代夫", 1, 1, },
{ 138, "MW", "马拉维", 1, 5, },
{ 139, "MX", "墨西哥", 1, 3, },
{ 140, "MY", "马来西亚", 1, 1, },
{ 141, "MZ", "莫桑比克", 1, 5, },
{ 142, "NA", "纳米比亚", 1, 5, },
{ 143, "NE", "尼日尔", 1, 5, },
{ 144, "NG", "尼日利亚", 1, 5, },
{ 145, "NI", "尼加拉瓜", 0, 3, },
{ 146, "NL", "荷兰", 1, 2, },
{ 147, "NO", "挪威", 1, 2, },
{ 148, "NP", "尼泊尔", 1, 1, },
{ 149, "NR", "瑙鲁", 1, 6, },
{ 150, "NU", "纽埃", 0, 6, },
{ 151, "NZ", "新西兰", 1, 6, },
{ 152, "PA", "巴拿马", 1, 3, },
{ 153, "PE", "秘鲁", 1, 4, },
{ 154, "PF", "法属波利尼西亚", 0, 6, },
{ 155, "PG", "巴布亚新几内亚", 1, 6, },
{ 156, "PH", "菲律宾", 1, 1, },
{ 157, "PK", "巴基斯坦", 1, 1, },
{ 158, "PL", "波兰", 1, 2, },
{ 159, "PR", "波多黎各", 1, 3, },
{ 160, "PS", "巴勒斯坦", 1, 1, },
{ 161, "PT", "葡萄牙", 1, 2, },
{ 162, "PW", "帕劳", 1, 6, },
{ 163, "PY", "巴拉圭", 1, 4, },
{ 164, "QA", "卡塔尔", 1, 1, },
{ 165, "RO", "罗马尼亚", 1, 2, },
{ 166, "RU", "俄罗斯", 1, 2, },
{ 167, "RW", "卢旺达", 1, 5, },
{ 168, "SA", "沙特阿拉伯", 1, 1, },
{ 169, "SB", "所罗门群岛", 1, 6, },
{ 170, "SC", "塞舌尔", 1, 5, },
{ 171, "SD", "苏丹", 1, 5, },
{ 172, "SE", "瑞典", 1, 2, },
{ 173, "SG", "新加坡", 1, 1, },
{ 174, "SH", "圣赫勒拿", 0, 6, },
{ 175, "SI", "斯洛文尼亚", 1, 2, },
{ 176, "SJ", "斯瓦尔巴岛和扬马延岛", 0, 2, },
{ 177, "SK", "斯洛伐克", 1, 2, },
{ 178, "SL", "塞拉利昂", 1, 5, },
{ 179, "SM", "圣马力诺", 1, 2, },
{ 180, "SN", "塞内加尔", 1, 5, },
{ 181, "SO", "索马里", 1, 5, },
{ 182, "SR", "苏里南", 1, 4, },
{ 183, "ST", "圣多美和普林西比", 0, 5, },
{ 184, "SV", "萨尔瓦多", 1, 3, },
{ 185, "SY", "叙利亚", 1, 1, },
{ 186, "SZ", "斯威士兰", 1, 5, },
{ 187, "TD", "乍得", 1, 5, },
{ 188, "TG", "多哥", 1, 5, },
{ 189, "TH", "泰国", 1, 1, },
{ 190, "TJ", "塔吉克斯坦", 1, 1, },
{ 191, "TK", "托克劳", 1, 6, },
{ 192, "TL", "东帝汶", 0, 1, },
{ 193, "TM", "土库曼斯坦", 1, 1, },
{ 194, "TN", "突尼斯", 0, 5, },
{ 195, "TO", "汤加", 1, 6, },
{ 196, "TR", "土耳其", 1, 1, },
{ 197, "TT", "特立尼达和多巴哥", 1, 3, },
{ 198, "TV", "图瓦卢", 0, 6, },
{ 199, "CN", "中国", 1, 1, },
{ 200, "TZ", "坦桑尼亚", 1, 5, },
{ 201, "UA", "乌克兰", 1, 2, },
{ 202, "UG", "乌干达", 1, 5, },
{ 203, "UM", "美国本土外小岛屿", 1, 6, },
{ 204, "US", "美国", 1, 3, },
{ 205, "UY", "乌拉圭", 1, 4, },
{ 206, "UZ", "乌兹别克斯坦", 1, 1, },
{ 207, "VC", "圣文森特和格林纳丁斯", 1, 3, },
{ 208, "VE", "委内瑞拉", 1, 4, },
{ 209, "VN", "越南", 1, 1, },
{ 210, "WF", "瓦利斯和富图纳", 1, 6, },
{ 211, "WS", "萨摩亚", 1, 6, },
{ 212, "YE", "也门", 1, 1, },
{ 213, "YT", "马约特", 0, 5, },
{ 214, "YU", "南斯拉夫", 1, 2, },
{ 215, "ZA", "南非", 1, 5, },
{ 216, "ZM", "赞比亚", 1, 5, },
{ 217, "ZW", "津巴布韦", 1, 5, },
{ 218, "CN", "局域网", 1, 99, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
