local name = {
    code = 1,                           -- 编号
    name = 2,                           -- 奖励名称
    image = 3,                          -- 奖励图标
    itemType = 4,                       -- 奖励type
    itemCode = 5,                       -- 奖励code
    num = 6,                            -- 奖励数量
    isAD = 7,                           -- 是否能看广告
}

local data = {
{ 1, "金币", "/", 1, 0, 100, 0, },
{ 2, "旗子", "/", 4, 50002, 1, 0, },
{ 3, "金币", "/", 1, 0, 100, 1, },
{ 4, "生命", "/", 2, 0, 2, 1, },
{ 5, "钻石", "/", 5, 0, 5, 0, },
{ 6, "金币", "/", 1, 0, 50, 1, },
{ 7, "主题", "/", 4, 50003, 1, 0, },
{ 8, "生命", "/", 2, 0, 2, 1, },
{ 9, "金币", "/", 1, 0, 50, 1, },
{ 10, "钻石", "/", 5, 0, 10, 0, },
{ 11, "生命", "/", 2, 0, 2, 1, },
{ 12, "生命", "/", 2, 0, 2, 1, },
{ 13, "金币", "/", 1, 0, 50, 1, },
{ 14, "生命", "/", 2, 0, 2, 1, },
{ 15, "钻石", "/", 5, 0, 10, 0, },
{ 16, "金币", "/", 1, 0, 50, 1, },
{ 17, "金币", "/", 1, 0, 50, 1, },
{ 18, "生命", "/", 2, 0, 2, 1, },
{ 19, "生命", "/", 2, 0, 2, 1, },
{ 20, "钻石", "/", 5, 0, 15, 0, },
{ 21, "生命", "/", 2, 0, 3, 1, },
{ 22, "金币", "/", 1, 0, 50, 1, },
{ 23, "金币", "/", 1, 0, 50, 1, },
{ 24, "生命", "/", 2, 0, 2, 1, },
{ 25, "钻石", "/", 5, 0, 15, 0, },
{ 26, "金币", "/", 1, 0, 50, 1, },
{ 27, "生命", "/", 2, 0, 3, 1, },
{ 28, "金币", "/", 1, 0, 100, 1, },
{ 29, "金币", "/", 1, 0, 100, 1, },
{ 30, "钻石", "/", 5, 0, 20, 0, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    idx = data[i][1]
    ret[idx] = tab
end
return ret
