local name = {
    id = 1,                             -- 编号
    name = 2,                           -- 组名
    giftType = 3,                       -- 礼包类型
    type1 = 4,                          -- 类型1
    value1 = 5,                         -- 值1
    times1 = 6,                         -- 数量1
    type2 = 7,                          -- 类型2
    value2 = 8,                         -- 值2
    times2 = 9,                         -- 数量2
    type3 = 10,                         -- 类型3
    value3 = 11,                        -- 值3
    times3 = 12,                        -- 数量3
}

local data = {
{ 80001, "首充礼包", 1, 1, 0, 200, 5, 0, 100, 6, 50001, 10, },
{ 80002, "iOS付费礼包", 2, 1, 0, 100, 5, 0, 100, 6, 50001, 10, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
