local name = {
    code = 1,                           -- 编号
    costType = 2,                       -- 货币种类
    cost = 3,                           -- 售卖价格
}

local data = {
{ 1, 1, 20, },
{ 2, 1, 40, },
{ 3, 1, 60, },
{ 4, 1, 80, },
{ 5, 1, 100, },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
