local name = {
    code = 1,                           -- 编号
    map = 2,                            -- 地图路径
}

local data = {
{ 1, "Image/map/1.png", },
{ 2, "Image/map/2.png", },
{ 3, "Image/map/3.png", },
{ 4, "Image/map/4.png", },
{ 5, "Image/map/5.png", },
{ 6, "Image/map/6.png", },
{ 7, "Image/map/7.png", },
{ 8, "Image/map/8.png", },
{ 9, "Image/map/9.png", },
{ 10, "Image/map/10.png", },
{ 11, "Image/map/11.png", },
{ 12, "Image/map/12.png", },
{ 13, "Image/map/13.png", },
{ 14, "Image/map/14.png", },
{ 15, "Image/map/15.png", },
{ 16, "Image/map/16.png", },
{ 17, "Image/map/17.png", },
{ 18, "Image/map/18.png", },
}

local index = {
    __index = function(t, k)
        local idx2 = name[k]
        if idx2 then
            return data[t.idx][idx2]
        end
        return nil
    end
}

local ret = {}
for i=1, #data do
    local tab = { idx = i }
    setmetatable(tab, index)
	local idx = i
    ret[idx] = tab
end
return ret
