--
-- Author: MrC
-- Date: 2016-05-11 11:23:48
--
--AppLovin 视频广告
local SDKAppLovin = class("SDKAppLovin",sdkManager:getSDK("sdkBase"))

	SDKAppLovin["id"]="applovin"
	SDKAppLovin["isReady"]=false
	SDKAppLovin["cmd"]={
		SHOW_ADS=1001, -- 播放广告

	    CHECK_ADS=1002, -- 检查广告是否获取成功

		CB_SHOW_ADS=2010, -- [回调]播放广告
	}


	--[[显示广告]]
	function SDKAppLovin:showAds(callback)
		if self:isAndroid() or self:isIOS() then
		    self:setCallback(self.cmd.SHOW_ADS,callback)
		    sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SHOW_ADS))
		end
	end
	--[[获取当前广告播放状态]]
	function SDKAppLovin:isAdsReady()
		local result = false
	    local adsInfo = sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CHECK_ADS))

	    print("AppLovin isAdsReady")
	   	dump(adsInfo)

	    if type(adsInfo) == "table" and adsInfo["isAdsReady"] then

	    	result = (true == adsInfo["isAdsReady"] or "true" ==adsInfo["isAdsReady"] )
	    end
	    return result
	end
	--[[看完广告处理]]
	function SDKAppLovin:processCompleted(cbInfo)
		local callback = self:getCallback(self.cmd.SHOW_ADS)
		if type(callback) == "function" then
			callback(cbInfo)
		end
	end
	--[[广告回调处理]]
	function SDKAppLovin:handler(response)
		local cmd=response["cmd"]
		if type(cmd)=="number" then
	        if cmd==self.cmd.CB_SHOW_ADS then
	        	print("【广告(AppLovin)已经关闭！】")
                sdkManager.talkingdata:setEvent("35",{AD3 = "AD4"})
                sdkManager.appsflyer:setEvent("35",{AD3 = "AD4"})
	            self:processCompleted(response.param)
			end
		end
	end

return SDKAppLovin