local SDKHuawei = class("SDKHuawei",sdkManager:getSDK("sdkBase"))

    SDKHuawei["id"] = "huawei"
    SDKHuawei["cmd"] = {
        SET_ACCOUNT_INFOS = 1001, --设置Account 参数:playerID,playerName
        SET_PAY = 1002, --设置玩家支付
        SET_PAY_SUCCESS = 1003, --设置玩家支付成功
        SET_EVENT = 1004, --设置自定义事件
        SET_LOGIN = 2001,
        SET_LOGIN_OUT = 2002,
        CB_SET_LOGIN = 2010,
        CB_SET_LOGIN_OUT = 2011,
        CB_PAY_SUCCESS = 8888,
        SET_INIT = 9999,
    }
    --[[初始化SDK]]
    function SDKHuawei:initHuaweiSdkToJava()
        if self:isIOS() or self:isAndroid() then
            sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_INIT,param))
            print("999999999999999999")
        end
    end

    --[[设置玩家信息]]
    function SDKHuawei:setAccountInfos(playerId,playerName,gender,age,server,channel)
        -- if self:isIOS() or self:isAndroid() then
        --  if type(playerId) == "string" then
        --      local param = {}
        --      param["playerId"] = playerId
        --      if type(playerName) == "string" then
        --          param["playerName"] = playerName 
        --      end
        --      if not (type(gender) == "number" and (gender==0 or gender == 1 or gender == 2)) then --0:unknow 1:male 2:female
        --          param["gender"] = 0
        --      end
        --      param["gender"] = gender
        --      if type(age) ~= "number" then
        --          param["age"] = 0
        --      end
        --      param["age"] = age
        --      param["server"] = server
        --      param["channel"] = channel
        --      dump(param)
        --      sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_ACCOUNT_INFOS,param))
        --  end
        -- end
    end
    --[[设置支付]]
    function SDKHuawei:setPay(orderId,amount,productName,productDesc)
        --currencyType =  currencyType or "CNY"
        if self:isIOS() or self:isAndroid() then
            -- if type(notifyUrl) == "string" and type(cpOrderId) == "string" and type(price) == "number" then
            print("Huaweipay")
                local param = {["orderId"] = tostring(orderId),["amount"] = tostring(amount) ,["productName"] = productName ,["productDesc"] = productDesc}
           -- print("UCCCpay222")
                --mdt.payOrderID = orderId
                sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY,param))
            -- end
            end
    end
    --[[设置支付成功]]
    function SDKHuawei:setPaySuccess(orderId)
        -- if self:isIOS() or self:isAndroid() then
        --  if type(orderId) == "string" then
        --      local param = {["orderId"] = orderId}
        --      sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY_SUCCESS,param))
        --  end
        -- end
    end
    --[[设置事件]]
    function SDKHuawei:setEvent(eventId,eventInfo)
        -- if nil ~= eventId then
        --  eventId = tostring(eventId)
        --  if self:isIOS() or self:isAndroid() then
        --      local param = {["eventId"] = eventId,["eventInfo"] = eventInfo}
        --      sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_EVENT,param))
        --  end
        --  printInfo("【设置埋点】: %s",eventId)
        -- end
    end
    --[[设置登录回调]]
    function SDKHuawei:handler(response)
        --print("【UC登录回调！！】")
        local cmd=response["cmd"]
        if type(cmd)=="number" then
                 if cmd==self.cmd.CB_SET_LOGIN then
                            --self:processCompleted(response.param)
                        mdt.player.loginType = 7
                        mdt.player.accountId = response["accountId"]
                        mdt.player.sdkId = "huawei"
                        print("【Huawei登录回调！！】唯一标识为："..mdt.player.accountId)
                end
                  if cmd==self.cmd.CB_SET_LOGIN_OUT then
                            --self:processCompleted(response.param)
                       --logoutCallback()
                       print("登出回调处理！")
                        mdt.session = nil
                        mdr.token = nil
                        mdr.save()
                        mdlogin.setAccountAndPassward(mdlogin.getCurLoginServerID(), "", "")
                      ctr.player.restart()
                end
                 if cmd==self.cmd.CB_PAY_SUCCESS then
                            --self:processCompleted(response.param)
                       --logoutCallback()
                       print("登出回调处理！")
                    if mdt.FristCharge ~= nil and mdt.FristCharge then
                           mdt.nFirstChargeGiftIsBuy = 1
                            event.dispatch('updateFristCharge')
                            mdt.FristCharge = false
                    end
                  
                end
        end
    end
     function SDKHuawei:logOut()
        print("【HUAWEI注销！！】")
          sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_LOGIN_OUT,param))
          --self.logoutCallback = logoutCallback   
    end

return SDKHuawei