
--
-- Author: MrC
-- Date: 2016-05-11 11:23:48
--
--AppLovin
local SDKLocojoyBJ = class("SDKLocojoyBJ",sdkManager:getSDK("sdkBase"))
	
    SDKLocojoyBJ["id"]="locojoybj"
	SDKLocojoyBJ["cmd"]={
        SDK_INIT = 1000,
		LOGIN_GUEST = 1001,
        LOGIN_FACEBOOK = 1002,
        LOGIN_TOKEN = 1003,

        STAR = 1004,

        SDK_WECHAT_INIT = 1005,
        LOGIN_GN_WECHAT = 1006,
        LOGIN_GN_GUEST = 1007,

        PAY_WECHAT = 1008,
        PAY_AliPAY = 1009,

        PAY = 1010,
        QUERY = 1011,
        GOOGLE_ACHIEVEMENT = 1012,

        SHARE = 1020,

        FACEBOOKINFO = 1030,

        BIND = 1040,
        LOGOUT = 1041,

        MORE_GAME = 1050,
        MORE_GAME_CHECK = 1051,
        MORE_GAME_REWARD = 1052,

        SDK_CMD_CB_INIT = 2000,
        SDK_CMD_CB_LOGIN = 2001,
        SDK_CMD_CB_PAY = 2002,  
        SDK_CMD_CB_SHARE = 2003,
        SDK_CMD_CB_FACEBOOKINFO = 2004,
        SDK_CMD_CB_BIND = 2005,
        SDK_CMD_CB_LOGOUT = 2006,


        CMD_CB_STAR = 2007,

        CMD_CB_WECHATINFO = 2008,

        CMD_NOTIFY = 3001,
        CMD_NOTIFY_CANCEL = 3002,

        CMD_SHOW_QUIT = 3003,

        CMD_CB_REWARD_CHECK = 3010,
        CMD_CB_REWARD_GOT = 3011,

	}

    function SDKLocojoyBJ:requestGotScore()
        local callback = function ( data )
            print("star call back")

            if data.choose == "never" then --不再提示
                mdr.assess = data.choose
                mdr.save()
                mdt.allowRate = false
            end
        end

        self:setCallback(self.cmd.CMD_CB_STAR, callback)

        local tab = {title = static.language[30241][device.language], message = static.language[30232][device.language], ok = static.language[30233][device.language], 
            cancel = static.language[30235][device.language], refuse = static.language[30234][device.language]}
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.STAR, tab))
    end

    function SDKLocojoyBJ:callNotify(key, countDown)
        print("sdk call notify")
        local callback =  function(response)
        end
        local tab = {title = static.language[30241][device.language], content = static.language[30240][device.language], boxkey = key, time = countDown}
        self:setCallback(self.cmd.CMD_NOTIFY, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.CMD_NOTIFY, tab))
    end

    function SDKLocojoyBJ:cancelNotify(key)
        local callback =  function(response)

        end
        local tab = {boxkey = key}
        self:setCallback(self.cmd.CMD_NOTIFY_CANCEL, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.CMD_NOTIFY_CANCEL, tab))
    end


    function SDKLocojoyBJ:loginGuest()
        print("guest login")
        local callback =  function(data)
                print("guest login callback")
                dump(data)
                if util.isShowDialog('Common.Waiting') then
                    util.closeDialog('Common.Waiting')
                end

                if data.code == '1' then
                    mdt.session = data.session
                    mdr.token = data.token
                    mdt.LastLoginType = data.LastLoginType
                    mdt.accountid = data.accountid
                    mdr.save()
                    if data.bind.facebook == '1' then
                        mdt.LastLoginType = 'Facebook'
                        --self:Facebookinfo()
                    else
                        mdt.LastLoginType = 'Guest'
                    end
                    util.delay(1, function() ctr.login.onStart() end)
                    -- ctr.login.onStart()
                else
                    mdt.session = nil
                    mdr.token = nil 
                    mdr.save()
                    util.delay(1, function() 
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() self:loginGuest() end, 30014)
                    
                    end)
                end
            end

        if not util.isShowDialog("Common.Waiting") then
            util.showDialog(nil, "Common.Waiting")
        end
        
        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)

        sdkManager:luaBridge(self:createParameter(self.id,self.cmd.LOGIN_GUEST))
    end

    function SDKLocojoyBJ:loginFacebook()
        print("facebook login")

        local callback =  function(data)
                print("fb login callback")

                if util.isShowDialog('Common.Waiting') then
                    util.closeDialog('Common.Waiting')
                end

                if data.code == '1' then
                    mdt.session = data.session
                    mdr.token = data.token
                    mdt.LastLoginType = 'Facebook'
                    mdt.accountid = data.accountid
                    mdr.save()
                    self:Facebookinfo()
                    sdkManager.talkingdata:setEvent("43",{FBLogin = "FBLogin"})
                    sdkManager.appsflyer:setEvent("43",{FBLogin = "FBLogin"})
                    util.delay(1, function() ctr.login.onStart() end) 
                    -- ctr.login.onStart()
                else
                    mdt.session = nil
                    mdr.token = nil 
                    mdr.save()
                    util.delay(1, function() 
                    
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() print("facebook login failed") end, 30014)
                    
                     end)
                end
            end

            if not util.isShowDialog("Common.Waiting") then
                util.showDialog(nil, "Common.Waiting")
            end
        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)

        sdkManager:luaBridge(self:createParameter(self.id,self.cmd.LOGIN_FACEBOOK))
    end

    function SDKLocojoyBJ:TokenLogin()
        print("token login")


        local callback =  function(data)
            print("token login callback")
            dump(data)

            if data.code == '1' then
                mdt.session = data.session
                mdt.LastLoginType = data.LastLoginType
                -- if mdt.LastLoginType == 'Facebook' then
                --     self:Facebookinfo()
                -- end
                mdt.accountid = data.accountid
                util.delay(1, function() ctr.login.onStart() end)

                -- ctr.login.onStart()

                if data.bind.facebook == '1' then
                    mdt.LastLoginType = 'Facebook'
                    --self:Facebookinfo()
                else
                    mdt.LastLoginType = 'Guest'
                end
            else
                mdt.session = nil
                mdr.token = nil 
                mdr.save()
                util.delay(1, function() 
                
                    local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                    dis:setDislogInfo(function() ctr.login.onStart() end, 30014)

                end)
            end
        end
        
        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)

        sdkManager:luaBridge(self:createParameter(self.id,self.cmd.LOGIN_TOKEN))
    end

    function SDKLocojoyBJ:Pay(data)
        local callback =  function(response)
            dump(response)
            if response.code == '1' then
                event.dispatch('OnRefreshGoldOrDiamondRecharge')
                sdkManager.talkingdata:setPaySuccess(mdt.payinfo.payid)
                sdkManager.appsflyer:setPaySuccess(mdt.payinfo.payid,mdt.payinfo.iapid,mdt.payinfo.price)
                sdkManager.talkingdata:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                sdkManager.appsflyer:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.nFirstChargeGiftIsBuy = 1
                    event.dispatch('updateFristCharge')
                    mdt.FristCharge = false
                    --util.closeDialog('Common.FirstRechage')
                end
            else
                util.delay(1, function() 
                    if not util.isShowDialog('Common.DisconnectDialog') then
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() print("pay failed") end, 30150)
                    end

                end)
                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.FristCharge = false
                end
            end
        end
        
        self:setCallback(self.cmd.SDK_CMD_CB_PAY, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.PAY, data))
    end

    function SDKLocojoyBJ:QUERY()
        local callback =  function(response)
  
        end
        
        self:setCallback(self.cmd.QUERY, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.QUERY))
    end

    function SDKLocojoyBJ:Share()
        local callback =  function(response)
            --event.dispatch('OnRefreshGoldOrDiamondRecharge')
            dump(response)
            if response.code == '1' then
                -- ctr.player.showMessageBox(static.language[30211][device.language], 1, function(ret)
                --     if ret then
                --         ctr.player.restart()
                --     end
                -- end)   
                net.msg.NC_Share()
                mdt.ShareInfo.nDayIsShared = '1'
                mdt.ShareInfo.nShareNum = mdt.ShareInfo.nShareNum + 1
            end
        end

        local tab = {}

        if static.isHaiWai then
            tab = {link = tostring(mdt.ShareInfo.szShareDownUrl), content = "Multiplayer online minesweeper, you are not alone anymore.", title = "Minesweeper Online", extension = "http://update.locojoy.us/minesweeper/imgs/broadShare.jpg"}
        else
            tab = {link = tostring(mdt.ShareInfo.szShareDownUrl), content = "Multiplayer online minesweeper you are not alone anymore.", title = "天天爱扫雷", extension = "http://update.locojoy.us/minesweeper/imgs/broadShare.jpg"}
        end

        self:setCallback(self.cmd.SDK_CMD_CB_SHARE, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.SHARE, tab))
    end

    function SDKLocojoyBJ:Facebookinfo()
        local callback =  function(response)
            --event.dispatch('OnRefreshGoldOrDiamondRecharge')
            dump(response)
            if response.data == nil then
                print("1111111122222222222222223333333333333")
                local data =  {}
                data.thirdPlatformId = response.id
                data.thirdPlatformType = 2 --fb登录
                data.thirdPlatformName = response.name
                data.thirdPlatformIconUrl = response.picture.data.url
                mdt.facebookdata = data

                dump(mdt.facebookdata)
            else
                print('fbinfo is null!!!!!!!!!!!!!')
            end
        end
        self:setCallback(self.cmd.SDK_CMD_CB_FACEBOOKINFO, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.FACEBOOKINFO))
    end

    function SDKLocojoyBJ:bind()
        local callback =  function(response)
            --event.dispatch('OnRefreshGoldOrDiamondRecharge')
            dump(response)
            if response.code == '1' then
                sdkManager.talkingdata:setEvent("43",{FBLogin = "FBLogin"})
                sdkManager.appsflyer:setEvent("43",{FBLogin = "FBLogin"})
                ctr.player.showMessageBox(static.language[30211][device.language], 1, function(ret)
                    if ret then
                        ctr.player.restart()
                    end
                end)   
            else
                ctr.player.showMessageBox(static.language[30212][device.language], 1, function(ret)
                    
                end)              
            end
        end
        self:setCallback(self.cmd.SDK_CMD_CB_BIND, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.BIND))
    end

    function SDKLocojoyBJ:logout()
        local callback =  function(response)
            --event.dispatch('OnRefreshGoldOrDiamondRecharge')
        end
        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.LOGOUT))
        mdt.session = nil
        mdr.token = nil
        mdr.save()
        mdlogin.setAccountAndPassward(mdlogin.getCurLoginServerID(), "", "")
        ctr.player.restart()
    end

    function SDKLocojoyBJ:callCmdInitSDK()
        if static.isHaiWai then
            local callback =  function(response)
                local result = response.code
                mdt.version = response.appversion
                if result == "1" then
                    mdt.SDKINIT_RESULT = "ok"
                    print("SDKLocojoyBJ: result = 1 to check login")
                    require("app.views.CoverScene"):callSDKLogin()
                else

                    print("handleSdkInitError show dialog to retry")
                    local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                    dis:setDislogInfo(function() self:callCmdInitSDK() end, 30014)
                end
            end
            self:setCallback(self.cmd.SDK_CMD_CB_INIT, callback)       
            sdkManager:luaBridge(self:createParameter(self.id, self.cmd.SDK_INIT))
        else
            local callback =  function(response)
                mdt.isWXInstall = true
                local isInstall = response.wxInstall
                if isInstall == "0" then
                    mdt.isWXInstall = false
                end

                mdt.SDKINIT_RESULT = "ok"
                require("app.views.CoverScene"):callSDKLogin()
            end

            self:setCallback(self.cmd.SDK_CMD_CB_INIT, callback)  
            sdkManager:luaBridge(self:createParameter(self.id, self.cmd.SDK_WECHAT_INIT))


        end


    end

    function SDKLocojoyBJ:googleAchievement(id)
        local callback =  function(response)

        end
        local arg = {achievement = id}
        self:setCallback(self.cmd.GOOGLE_ACHIEVEMENT, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.GOOGLE_ACHIEVEMENT, arg))
    end

	function SDKLocojoyBJ:handler(response)
        print("enter locojoybj handler")
		local cmd=response["cmd"]
		if type(cmd)=="number" then
            print("type(cmd)==number")
                local callback = self:getCallback(cmd)
		        if type(callback) == "function" then
                    util.delay(0.1, function() callback(response.param) end)
		        end
		end
	end

    function SDKLocojoyBJ:showQuit()
        local callback =  function(response)

        end
        local tab = {title = static.language[30241][device.language], message = static.language[30244][device.language], ok = static.language[10001][device.language], 
        cancel = static.language[10002][device.language]}
        self:setCallback(self.cmd.CMD_SHOW_QUIT, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.CMD_SHOW_QUIT, tab))

    end

    function SDKLocojoyBJ:showMoreGame()
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.MORE_GAME))
    end


    function SDKLocojoyBJ:loginGNWeChat()
        
        local callback =  function(data)
            print("wechaat login callback")

            if util.isShowDialog('Common.Waiting') then
                util.closeDialog('Common.Waiting')
            end

            if data.code == '1' then
                local openid = data.openid

                mdt.player.szUserName = "W_"..openid
                mdt.player.szPassWord = ""
                mdt.player.loginType = 5

                util.delay(1, function() ctr.login.onStart() end)
            else
                util.delay(1, function() 
                        if not util.isShowDialog('Common.DisconnectDialog') then
                            local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                            dis:setDislogInfo(function() print("loginGNWeChat failed") end, 30014)
                        end

                end)
 
            end
       end

        if not util.isShowDialog("Common.Waiting") then
            util.showDialog(nil, "Common.Waiting")
        end


        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)

        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.LOGIN_GN_WECHAT))
        self:getWechatInfo()
    end

    function SDKLocojoyBJ:loginGNGuest()

        local callback =  function(data)
            print("loginGNGuest login callback")

            if util.isShowDialog('Common.Waiting') then
                util.closeDialog('Common.Waiting')
            end

            if data.code == '1' then
                local uuid = data.uuid

                mdt.player.szUserName = "D_"..uuid
                mdt.player.szPassWord = ""
                mdt.player.loginType = 4

                print("loginGNGuest callback mdt.player.szUserName = " .. mdt.player.szUserName)

                util.delay(1, function() ctr.login.onStart() end)
            else
                 util.delay(1, function() 
                    if not util.isShowDialog('Common.DisconnectDialog') then
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() print("loginGNGuest failed") end, 30014)
                    end

                    
                end)
            end
       end

        if not util.isShowDialog("Common.Waiting") then
            util.showDialog(nil, "Common.Waiting")
        end

        self:setCallback(self.cmd.SDK_CMD_CB_LOGIN, callback)

        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.LOGIN_GN_GUEST))
    end

    function SDKLocojoyBJ:getWechatInfo()
        local callback =  function(response)
            --event.dispatch('OnRefreshGoldOrDiamondRecharge')
            dump(response)
            if response.data == nil then
                local data =  {}
                data.thirdPlatformId = '1'
                data.thirdPlatformType = 5 --fb登录
                data.thirdPlatformName = mdt.player.szUserName
                data.thirdPlatformIconUrl = response.headurl
                mdt.facebookdata = data
            else
                print('fbinfo is null!!!!!!!!!!!!!')
            end
        end
        self:setCallback(self.cmd.CMD_CB_WECHATINFO, callback)      
    end

    function SDKLocojoyBJ:PayWechat(data)


        
        local callback =  function(response)

            if response.code == '0' then

                util.delay(1, function()
                    if not util.isShowDialog('Common.DisconnectDialog') then
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() print("pay failed") end, 30150)
                    end

                end)

                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.FristCharge = false
                end
            else
                sdkManager.talkingdata:setPaySuccess(mdt.payinfo.payid)
                sdkManager.appsflyer:setPaySuccess(mdt.payinfo.payid,mdt.payinfo.iapid,mdt.payinfo.price)
                sdkManager.talkingdata:setEvent("39",{DiamondBuy = 'WXSandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                sdkManager.appsflyer:setEvent("39",{DiamondBuy = 'WXSandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.nFirstChargeGiftIsBuy = 1
                    event.dispatch('updateFristCharge')
                    mdt.FristCharge = false
                    --util.closeDialog('Common.FirstRechage')
                end
            end

        end
        --data.cost
        local tab = {adr = static.SERVER_LIST[mdlogin.getCurLoginServerID()].uploadURL, body = data.name, total_fee = data.cost * 100, id = mdt.player.nGUID.v, productId = data.iapId,
            channel="1", phone_type="1",server_id = mdlogin.getLastlistServerID()}
        self:setCallback(self.cmd.SDK_CMD_CB_PAY, callback)
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.PAY_WECHAT, tab))
        if mdt.FristCharge ~= nil and mdt.FristCharge then
            mdt.isFristCharge = true
        end
    end

    function SDKLocojoyBJ:PayAliPay(data)


        local callback =  function(response)

            if response.code == '0' then

                util.delay(1, function() 
                    if not util.isShowDialog('Common.DisconnectDialog') then
                        local dis = util.showDialog(nil, 'Common.DisconnectDialog')
                        dis:setDislogInfo(function() print("pay failed") end, 30150)
                    end
                end)
                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.isFristCharge = false
                    mdt.FristCharge = false
                end
            else
                sdkManager.talkingdata:setPaySuccess(mdt.payinfo.payid)
                sdkManager.appsflyer:setPaySuccess(mdt.payinfo.payid,mdt.payinfo.iapid,mdt.payinfo.price)
                sdkManager.talkingdata:setEvent("39",{DiamondBuy = 'ZFBSandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                sdkManager.appsflyer:setEvent("39",{DiamondBuy = 'ZFBSandbox'.."DiamondBuy"..mdt.payinfo.iapid})
                if mdt.FristCharge ~= nil and mdt.FristCharge then
                    mdt.nFirstChargeGiftIsBuy = 1
                    event.dispatch('updateFristCharge')
                    mdt.FristCharge = false
                    --util.closeDialog('Common.FirstRechage')
                end
            end
        end
        local tab = {adr = static.SERVER_LIST[mdlogin.getCurLoginServerID()].uploadURL, body = data.name, total_fee = data.cost, id = mdt.player.nGUID.v, productId = data.iapId,
            channel="1", phone_type="1",server_id = mdlogin.getLastlistServerID()}
        self:setCallback(self.cmd.SDK_CMD_CB_PAY, callback)
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.PAY_AliPAY, tab))
    end

    function SDKLocojoyBJ:checkSDKReward()
--            MORE_GAME_CHECK = 1051,
--        MORE_GAME_REWARD = 1052,
        print("checkSDKReward 0000")

        local callback =  function(response)
            print("checkSDKReward")
            dump(response)
            if response.code == '1' then
                util.showDialog(nil, "Common.SDKDialog")
            end
        end
        self:setCallback(self.cmd.CMD_CB_REWARD_CHECK, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.MORE_GAME_CHECK))

    end

    function SDKLocojoyBJ:showSDKReward()

        local callback =  function(response)
            --send get reward
            print("MORE GAME APP DOWNLOAD")

            mdt.appDown = true
            if mdt.adReward and mdt.adReward == 0 then
                print("MORE GAME REQUEST REWARD")
                mdt.appDown = true
                net.msg.NC_IntegralWallAddMoney()
            end
        end

        self:setCallback(self.cmd.CMD_CB_REWARD_GOT, callback)       
        sdkManager:luaBridge(self:createParameter(self.id, self.cmd.MORE_GAME_REWARD))

    end

return SDKLocojoyBJ
--endregion
