cc.exports.mdr = mdr or {}

require('json')

function mdr.init()
    mdr.settings = { 
        sound = true,
        music = true,
        lang = device.language,
    }

    audio.enableMusic(mdr.settings.music)
    audio.enableEffect(mdr.settings.sound)
end

function mdr.initupdate()

end

function mdr.load()
    local key = 'ROM_DATA'
    local data = cc.UserDefault:getInstance():getStringForKey(key)
    local m = json.decode(data)
    for k,v in pairs(m) do
        mdr[k]=v
    end

    mdr.initupdate()

    audio.enableMusic(mdr.settings.music)
    audio.enableEffect(mdr.settings.sound)
end

function mdr.isHasSaveData(num)
    local key = 'ROM_DATA'
    local data = cc.UserDefault:getInstance():getStringForKey(key)
    return data~=""
end

--function mdr.clearSaveData()
--    local key = 'ROM_DATA'
--    cc.UserDefault:getInstance():setStringForKey(key, '')
--end

function mdr.save()
    local key = 'ROM_DATA'
    local data = json.encode(mdr)
    cc.UserDefault:getInstance():setStringForKey(key, data)
end


function mdr.setMusic(enable)
    mdr.settings.music = enable
    audio.enableMusic(mdr.settings.music)
    mdr.save()
    --event.dispatch('onSound')
end

function mdr.setSound(enable)
    mdr.settings.sound = enable
    audio.enableEffect(mdr.settings.sound)
    mdr.save()
    --event.dispatch('onSound')
end

function mdr.setLanguage(lang)
    mdr.settings.lang = lang
    event.dispatch('onLanguage')
    mdr.save()
end

--һε¼ķID
function mdr.setLastServerID(serverID)
    mdr.serverInfo.lastServerID = serverID
    mdr.save()
end

--ȡһε¼ID
function mdr.getLastServerID()
    return mdr.serverInfo.lastServerID
end

return mdr