cc.exports.static = static or {}

local UI = 'data/const/UI'
local lang = 'data/config/language'
local box = 'data/config/box'

static.isInnerTest = true


static.isHaiWai = false
static.isTestFR = false  --首冲测试

--外网列表
static.SERVER_LIST  =
{
-- --    s0 = { name=110007, adr='103.36.31.20', port=6666,downloadURL='103.36.31.20:8080',downloadFlagURL='103.36.31.20:8080',uploadURL='103.36.31.20:8080',validateOrder='103.36.31.20:8080',serverid='9999'},

--  --GN
  s0 = { name=110007, adr='minesweepercn1serverlist.locojoy.com', port=6666,downloadURL='minesweepercn1serverlist.locojoy.com:8080',downloadFlagURL='minesweepercn1serverlist.locojoy.com:8080',uploadURL='minesweepercn1serverlist.locojoy.com:8080',validateOrder='minesweepercn1serverlist.locojoy.com:8080',serverid='2'},
-- --    s1 = { name='外网-小敏', adr='60.30.108.163', port=18900 },
-- --    s0 = { name=110001, adr='minesweepergs02serverlist.locojoy.us', port=6665, downloadURL='minesweepergs02serverlist.locojoy.us:8080',downloadFlagURL='minesweepergs02serverlist.locojoy.us:8080',uploadURL='minesweepergs02serverlist.locojoy.us:8080',validateOrder='minesweepergs02serverlist.locojoy.us:8080',serverid='1'},
}

 -- static.SERVER_LIST = {
 --     s0 = { name=110001, adr='13.229.196.58', port=6666,downloadURL='10.82.1.21:8000',downloadFlagURL='10.82.1.21:8000',uploadURL='10.82.1.21:8000',validateOrder=''},
 --    -- s0 = { name=110001, adr='192.168.2.209', port=6666,downloadURL='10.82.1.21:8000',downloadFlagURL='10.82.1.21:8000',uploadURL='10.82.1.21:8000',validateOrder=''},
 --     -- s1 = { name=110002, adr='10.21.1.59', port=6666,downloadURL='10.82.1.21:8000',downloadFlagURL='10.82.1.21:8000',uploadURL='10.82.1.21:8000',validateOrder=''},
 --     -- s2 = { name=110003, adr='10.21.1.14', port=6666,downloadURL='10.82.1.21:8000',downloadFlagURL='10.82.1.21:8000',uploadURL='10.82.1.21:8000',validateOrder=''},
 --     -- s3 = { name=110004, adr='10.21.1.65', port=6666,downloadURL='10.82.1.21:8000',downloadFlagURL='10.82.1.21:8000',uploadURL='10.82.1.21:8000',validateOrder=''},
 -- }


static.MapWidth = 600
static.MapHeight = 800

static.textlistserver = 1

local datalist = {
    UI = 'data/const/UI',
}

local datasort = {
	--BUILDING = 'data/build/BUILDING',
}

function static.init()

	for key, v in pairs(datalist) do
		local obj = require(v)
		static[key] = obj
	end

	for key, v in pairs(datasort) do
		local obj = require(v)
		static[key] = obj[1]
        static.sort[key] = obj[2]
	end
    static.initUI()

    local config = require('data.config_init')
    if config then
        config.init()
    end

--     -- 开发模式 检查资源
--    if cc.FileUtils:getInstance():isFileExist(".project") then
--        static.checkData()
--    end
end

function static.initUI()
    package.loaded[UI] = nil
	local obj = require(UI)
	static['UI'] = obj
    package.loaded[lang] = nil
	local obj = require(lang)
	static['language'] = obj
    package.loaded[box] = nil
	local obj = require(box)
	static['box'] = obj

end

--根据serverID获取服务器信息
function static.getServerInfo(serverID)
    return static.SERVER_LIST[serverID]
end

--获取所有服务器数据
function static.getAllServerData()
    return static.SERVER_LIST
end

return static
