local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM



CMD_ENUM("GridState", 
{
    EBigMapGridStatus_ZERO  =   0,
    EBigMapGridStatus_ONE   =   1,
    EBigMapGridStatus_TWO   =   2,
    EBigMapGridStatus_THREE =   3,
    EBigMapGridStatus_FOUR  =   4,
    EBigMapGridStatus_FIFE  =   5,
    EBigMapGridStatus_SIX   =   6,
    EBigMapGridStatus_SEVEN =   7,
    EBigMapGridStatus_EIGHT =   8,
    EBigMapGridStatus_UNOPEN=   9,
    EBigMapGridStatus_MARK  =   10,
    EBigMapGridStatus_EXPLOSION=   11,
})

------------------------------------------------------------------------------
-- سʼͼ
------------------------------------------------------------------------------
CMD_START("NC_LoadMap", {
    { "nGUID", tag.int64 },
})  

CMD_START("NS_LoadMap", {
    { "nMapId", tag.int },
    { "nWidth", tag.int },
    { "nHeight", tag.int },
})  

------------------------------------------------------------------------------
-- һ
------------------------------------------------------------------------------
CMD_START("NC_ClickGrid", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_ENUM("NS_CLICK_ERR_CODE", 
{
    NS_CLICK_SUCCESS        =   0,                      --ɹ
    NS_CLICK_FAILED         =   1,                      --ʧ
    NS_CLICK_LIFE           =   2,                      --ܵû
    NS_CLICK_COMPLETE       =   3,                      --ͼȫ
})

CMD_START("NS_ClickGrid", {
    { "nErrorCode", tag.int },                          --NS_CLICK_ERR_CODE
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nComboNum", tag.int },                           -- 
    { "nComboLevel", tag.int },                         -- ȼ
    { "nCurClickScore", tag.int },                      -- 
    { "nClickGridScore", tag.int },                     -- ǰ
})

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_LoadRect", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },                               -- ½
    { "nPosY", tag.int },                               -- ½
    { "nWidth", tag.int },
    { "nHeight", tag.int },
})  

CMD_ENUM("NS_LOAD_ERR_CODE", 
{
    NS_LOAD_SUCCESS         =   0,
    NS_LOAD_FAILED          =   1,
})
CMD_START("NS_LoadRect", {
    { "nErrorCode", tag.int },
})  

------------------------------------------------------------------------------
-- λ
------------------------------------------------------------------------------
CMD_START("NC_SetPos", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_START("NS_SetPos", {
    { "nErrorCode", tag.int },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

------------------------------------------------------------------------------
-- Ǹ
------------------------------------------------------------------------------
CMD_START("NC_FlagGrid", {
    { "nGUID", tag.int64 },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

CMD_ENUM("NS_FLAG_GRID_ERR_CODE", 
{
    NS_FLAG_SUCCESS         =   0,
    NS_FLAG_FAILED          =   1,
    NS_FLAG_LIFE            =   2,
})

CMD_START("NS_FlagGrid", {
    { "nErrorCode", tag.int },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nComboNum", tag.int },
    { "nComboLevel", tag.int },
    { "nCurClickScore", tag.int },
    { "nClickGridScore", tag.int },                     -- ǰ
})  

------------------------------------------------------------------------------
-- ״̬
------------------------------------------------------------------------------
CMD_START("NS_GridStateChange", {
    { "gridData", tag.tagMineMapGridInfoWithPos, tag.array },
})  

-- 2. վ
CMD_START("NS_RectGridChange", {
    { "nPosX", tag.int },
    { "nPosY", tag.int },
    { "nWidth", tag.int },
    { "nHeight", tag.int },
    { "gridData", tag.tagMineMapGridInfo, tag.array },
})  

------------------------------------------------------------------------------
-- ηΧڸ״̬
------------------------------------------------------------------------------
CMD_START("NC_LoadThumbnail", {
    { "nGUID", tag.int64 },
    { "nIndex", tag.byte },
})  

CMD_START("NS_LoadThumbnail", {
    { "nIndex", tag.int },
    { "byState", tag.string, tag.array },
})  

------------------------------------------------------------------------------
-- UIɨ׸Ϣ
------------------------------------------------------------------------------
CMD_START("NS_SyncMainUiOpenGridInfo", {
    { "nOpenBombSuccessNum", tag.int },                 --ȷ׵
})  

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NS_SyncLifeInfo", {
    { "nCurLife", tag.short },                          --ǰ
    { "nRecoveryTM", tag.int },                         --ָʱ
})  

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
CMD_START("NC_RandomPos", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_RandomPos", {
    { "nErrorCode", tag.int },
    { "nPosX", tag.int },
    { "nPosY", tag.int },
})  

------------------------------------------------------------------------------
-- Եͼ׵ʣͿٷֱ
------------------------------------------------------------------------------
CMD_START("NC_ReaminBlobs", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_ReaminBlobs", {
    { "nNotOpenBombNum", tag.int },                     --ûп
    { "nOpenPercent", tag.byte },                       --ͼİٷֱ
})  

------------------------------------------------------------------------------
--	ʱ
------------------------------------------------------------------------------
CMD_START("NC_OnlineTM", {
    { "nGUID", tag.int64 },
}) 

CMD_START("NS_OnlineTM", {
    { "nOnlineTM", tag.int },                           -- ʱ
})  

------------------------------------------------------------------------------
--	֪ͨлͼ
------------------------------------------------------------------------------
CMD_START("NS_NowChangeMineMap", {
})  

------------------------------------------------------------------------------
--	֪ͨлͼ
------------------------------------------------------------------------------
CMD_START("NS_ChangeMineMapComplete", {
})  


