local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM



CMD_ENUM("EMsgDriftBottleReturn", 
{
    EMsgDriftBottleReturn_Success=   0,
    EMsgDriftBottleReturn_Fail=   1,
    EMsgDriftBottleReturn_FailFishGold=   2,            --̽Ҳ
    EMsgDriftBottleReturn_Fail=   1,
})

--Ưƿ޺Ͳȵ״̬
CMD_ENUM("EMsgDriftBottleLikeHateStatus", 
{
    EMsgDriftBottleLikeHateStatus_Null=   0,
    EMsgDriftBottleLikeHateStatus_Liked=   1,
    EMsgDriftBottleLikeHateStatus_Hated=   2,
})

--Ưƿ޺Ͳȵ״̬
CMD_ENUM("EMsgFishDriftBottleGetType", 
{
    EMsgFishDriftBottleGetType_Null=   0,
    EMsgFishDriftBottleGetType_DriftBottle=   1,
    EMsgFishDriftBottleGetType_Box=   2,
})

local MSG_DRIFT_BOTTLE_TILE_MAX_LEN = 150
local MSG_DRIFT_BOTTLE_CONTENT_MAX_LEN = 450
local MSG_DRIFT_BOTTLE_REPLY_MAX_LEN = 250

--ҪϢ
CMD_STRUCT("tagMsgDriftBottleBrief", {
    { "nId", tag.int64 },
    { "szTitle", tag.string, MSG_DRIFT_BOTTLE_TILE_MAX_LEN },
    { "nCreateTime", tag.int },                         --ʱ
    { "nLastTime", tag.int },                           --ʣʱ
    { "nIsLikeOrHate", tag.byte },                      --Ƿ޻߲  EMsgDriftBottleLikeHateStatus
    { "nLikeNum", tag.int },                            --޸
    { "nHateNum", tag.int },                            --ȸ
    { "nPlayerId", tag.int },                           --ID
    { "nPlayerHead", tag.int },                         --ͷ
    { "nPlayerCountry", tag.int },                      --ҹ
})

CMD_STRUCT("tagMsgDriftBottleReply", {
    { "nPlayerId", tag.int64 },                         -- ID
    { "szPlayerName", tag.string, 30 },                 -- 
    { "nPlayerHeadIndex", tag.int },                    -- ͷ
    { "nPlayerCountryIndex", tag.int },                 -- 
    { "szReplyContent", tag.string, MSG_DRIFT_BOTTLE_REPLY_MAX_LEN },-- һظ
    { "nReplyTime", tag.int },                          --ظʱ
})

--ϸϢĬϼظ
CMD_STRUCT("tagMsgDriftBottle", {
    { "nBriefInfo", tag.tagMsgDriftBottleBrief },
    { "szPlayerName", tag.string, 30 },                 --
    { "nPlayerHeadIndex", tag.int },                    --ͷ
    { "nPlayerCountryIndex", tag.int },                 --ҹ
    { "szContent", tag.string, MSG_DRIFT_BOTTLE_CONTENT_MAX_LEN },
    { "nReply", tag.tagMsgDriftBottleReply, tag.array },
})

-------------------------------------------------------------------------------
-- ƯƿҪ
-------------------------------------------------------------------------------	
CMD_START("NC_LoadAllDriftBottleBrief", {
    { "nGUID", tag.int64 },
})

CMD_START("NS_LoadAllDriftBottleBrief", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nFishNum", tag.int },                            --̴
    { "driftBottle", tag.tagMsgDriftBottleBrief, tag.array },
})

-------------------------------------------------------------------------------
-- Ưƿ
-------------------------------------------------------------------------------	
CMD_START("NC_LoadDriftBottle", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
})

CMD_START("NS_LoadDriftBottle", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "driftBottle", tag.tagMsgDriftBottle },
})


-------------------------------------------------------------------------------
-- Ưƿظ
-------------------------------------------------------------------------------	
CMD_START("NC_LoadDriftBottleReply", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
    { "nStartIndex", tag.int },
    { "nEndIndex", tag.int },
})

CMD_START("NS_LoadDriftBottleReply", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nStartIndex", tag.int },
    { "nReply", tag.tagMsgDriftBottleReply, tag.array },
})

-------------------------------------------------------------------------------
-- Ưƿ
-------------------------------------------------------------------------------	
CMD_START("NC_LikeDriftBottle", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
})

CMD_START("NS_LikeDriftBottle", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nDriftBottleId", tag.int64 },
})

-------------------------------------------------------------------------------
-- Ưƿ
-------------------------------------------------------------------------------	
CMD_START("NC_HateDriftBottle", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
})

CMD_START("NS_HateDriftBottle", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nDriftBottleId", tag.int64 },
})

-------------------------------------------------------------------------------
-- ظƯƿ
-------------------------------------------------------------------------------	
CMD_START("NC_ReplyDriftBottle", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
    { "szreplyContent", tag.string, MSG_DRIFT_BOTTLE_REPLY_MAX_LEN },
})

CMD_START("NS_ReplyDriftBottle", {
    { "nReturnType", tag.int },
    { "nReplyIndex", tag.int },                         --ظǵڼϢ
})

-------------------------------------------------------------------------------
-- Ưƿ
-------------------------------------------------------------------------------	
CMD_START("NC_FishDriftBottle", {
    { "nGUID", tag.int64 },
})

CMD_START("NS_FishDriftBottle", {
    { "nReturnType", tag.int },
    { "nDayFishNum", tag.int },                         --̴
    { "nCostGlod", tag.short },                         --ѽ
    { "nGetType", tag.short },                          --		EMsgFishDriftBottleGetType
    { "nDriftBottle", tag.tagMsgDriftBottleBrief },
})

-------------------------------------------------------------------------------
-- ɾעƯƿ
-------------------------------------------------------------------------------	
CMD_START("NC_DeleteAttentionDriftBottle", {
    { "nGUID", tag.int64 },
    { "nDriftBottleId", tag.int64 },
})

CMD_START("NS_DeleteAttentionDriftBottle", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nDriftBottleId", tag.int64 },
})

-------------------------------------------------------------------------------
-- Ưƿ
-------------------------------------------------------------------------------	
CMD_START("NC_CreateDriftBottle", {
    { "nGUID", tag.int64 },
    { "szTitle", tag.string, MSG_DRIFT_BOTTLE_TILE_MAX_LEN },
    { "szContent", tag.string, MSG_DRIFT_BOTTLE_CONTENT_MAX_LEN },
})

CMD_START("NS_CreateDriftBottle", {
    { "nReturnType", tag.int },                         --EMsgDriftBottleReturn
    { "nDriftBottle", tag.tagMsgDriftBottle },
})

-------------------------------------------------------------------------------
-- ֪ͨƯƿлظ
-------------------------------------------------------------------------------	
CMD_START("NS_DriftBottleHaveReply", {
    { "nDriftBottleId", tag.int64 },
})

-------------------------------------------------------------------------------
-- ֪ͨҵӻƯƿ
-------------------------------------------------------------------------------	
CMD_START("NS_NotifyClickBigMapGetDriftBottle", {
    { "nDriftBottleId", tag.int64 },
})

--__NDPROTOCOL_MSG_DRIFT_BOTTLE_H__