local net = ndpnet
local tag = net.tag
local CMD_START = net.tagNetCmd.CMD_START
local CMD_STRUCT = net.tagNetCmd.CMD_STRUCT
local CMD_ENUM = net.tagNetCmd.CMD_ENUM
-------------------------------------------------------------------------------
-- filename: msg_c_gs_mine_map_record.h
-- author: shichengliang
-- actor:
-- data: 2017-07-31
-- last: 2017-07-31
-- brief: ͼ¼Ϣ
-------------------------------------------------------------------------------




--ͼ¼
CMD_START("NC_EnterMineMapRecordUI", {
    { "nPlayerId", tag.int64 },
})

CMD_START("NS_EnterMineMapRecordUI", {
    { "nPlayerId", tag.int64 },
    { "sMineRecord", tag.tagMineMapRecordPlayerMsgInfo, tag.array },
})

--ͼ¼ͨа
CMD_START("NC_MineMapRecordNormalRank", {
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
    { "nRankType", tag.int },
    { "nFromIndex", tag.int },
    { "nToIndex", tag.int },
})

CMD_START("NS_MineMapRecordNormalRank", {
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
    { "nRankType", tag.int },
    { "nAllNum", tag.int },
    { "nStartIndex", tag.int },
    { "sMineRecordRank", tag.tagMineMapRecordNormalRankMsgInfo, tag.array },
})

--ͼ¼׶а
CMD_START("NC_MineMapRecordDedicationRank", {
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
    { "nFromIndex", tag.int },
    { "nToIndex", tag.int },
})

CMD_START("NS_MineMapRecordDedicationRank", {
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
    { "nAllNum", tag.int },
    { "nStartIndex", tag.int },
    { "sMineRecordRank", tag.tagMineMapRecordDedicationRankMsgInfo, tag.array },
})

--ȡͼ¼
CMD_START("NC_GetMineMapRecordReward", {
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
})

CMD_STRUCT("tagMsgMineMapRecordRewardBoxInfo", {
    { "nItemType", tag.int, tag.array },
    { "nItemParam1", tag.int, tag.array },
})

CMD_ENUM("EGetMineMapRecordRewardReturn", 
{
    EGetMineMapRecordRewardReturn_Success=   0,         -- ɹ
    EGetMineMapRecordRewardReturn_Fail=   1,            -- ʧ
    EGetMineMapRecordRewardReturn_HaveGet=   2,         -- ȡ
    EGetMineMapRecordRewardReturn_NotHave=   3,         -- 
})

CMD_START("NS_GetMineMapRecordReward", {
    { "nErrorCode", tag.int },                          --EGetMineMapRecordRewardReturn
    { "nPlayerId", tag.int64 },
    { "nMapId", tag.int },
    { "nRewardId", tag.int },                           --ID
    { "boxInfo", tag.tagMsgMineMapRecordRewardBoxInfo, tag.array },--Ϣ
})

--__NDSERVER_SHARE_MSG_C2GS_MINE_MAP_RECORD_H__