local net = ndpnet
local tag = net.tag
local msg = net.msg
-------------------------------------------------------------------------------
-- filename: msg_c_gs_talent.h
-- author: zhengronglin
-- actor:
-- data: 2017-06-01
-- last: 2017-06-01
-- brief: 佻
-------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- رб
------------------------------------------------------------------------------
function msg.NC_LoadBox(data)
--     { "nGUID", tag.int64 },
    local nc = net.tag.NC_LoadBox:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_LoadBox(ns)
--     { "nCoolDownTime_4_1", tag.int },
--     { "nCoolDownTime_4_2", tag.int },
--     { "nCoolDownTime_4_3", tag.int },
--     { "nCoolDownTime_4_4", tag.int },
--     { "sBox", tag.tagPlayerBoxSlot, tag.array },
end


------------------------------------------------------------------------------
--  nUnlockStatus:1⿪ 0⿪ʧ
------------------------------------------------------------------------------
function msg.NC_UnlockBox(data)
--     { "nGUID", tag.int64 },
--     { "nBoxID", tag.int },
    local nc = net.tag.NC_UnlockBox:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_UnlockBox(ns)
--     { "nUnlockStatus", tag.int },

end


------------------------------------------------------------------------------
-- һ
------------------------------------------------------------------------------
function msg.NC_OpenBox(id, diamond, adid)
--     { "nGUID", tag.int64 },
--     { "nSlotID", tag.int },
--     { "isNeedDiamond", tag.int },
--     { "nCooldownID", tag.int },
--     { "nADId", tag.int },
    local nc = net.tag.NC_OpenBox:create()
    nc.nGUID = mdt.player.nGUID
    nc.nSlotID = id
    nc.isNeedDiamond = diamond
	nc.nADId = adid or 0
    nc.nCooldownID = 4
    if nc.nADId == 0 then
        nc.nCooldownID = 0
    end
    net.send(nc)
    print("nc.nADId"..nc.nADId)
end

function msg.NS_OpenBox(ns)
--     { "nLifeNum", tag.int },
--     { "nErrorCode", tag.int },
--     { "sOpenBox", tag.tagPlayerOpenBox, tag.array },
    if ns.nErrorCode == 0 then
        local view = util.showDialog('Dialog2', 'Box.BoxOpen')
        view:setkey(ns.sOpenBox)
        event.dispatch('updateItemCount')
    end
end


------------------------------------------------------------------------------
-- ȴ
------------------------------------------------------------------------------
function msg.NC_OpenBoxForCoolDown(data)
--     { "nGUID", tag.int64 },
--     { "nBoxID", tag.int },
--     { "nOpenNum", tag.int },
    local nc = net.tag.NC_OpenBoxForCoolDown:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_OpenBoxForCoolDown(ns)
--     { "nOpenState", tag.int },

end


------------------------------------------------------------------------------
-- õ
------------------------------------------------------------------------------
function msg.NC_GetBox(data)
--     { "nGUID", tag.int64 },
    local nc = net.tag.NC_GetBox:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_GetBox(ns)
--     { "nGUID", tag.int64 },
--     { "nSlotID", tag.int },
--     { "nBoxID", tag.int },
--     { "nOpenNeedTime", tag.int },
    local view = util.showDialog('Dialog2', 'Box.Box')
    view:setId(ns.nBoxID)
    if mdt.BoxTime ~= nil then
        mdt.BoxTime[ns.nSlotID][1] = os.time()
        mdt.BoxTime[ns.nSlotID][2] = ns.nOpenNeedTime

        local key = "box_countDown_"..ns.nOpenNeedTime
        mdt.BoxTime[ns.nSlotID][3] = key
        sdkManager.locojoybj:callNotify(key, ns.nOpenNeedTime)


    end
end

function msg.NS_GetOvertopBox(ns)
--     { "nGUID", tag.int64 },
--     { "nBoxID", tag.int },
--     { "nCoolDownTime_4_1", tag.int },
--     { "nCoolDownTime_4_2", tag.int },
--     { "nCoolDownTime_4_3", tag.int },
--     { "nCoolDownTime_4_4", tag.int },
    local view = util.showDialog('Dialog2','Box.FullBoxView')
	view:setCDS(ns.nCoolDownTime_4_1, ns.nCoolDownTime_4_2, ns.nCoolDownTime_4_3, ns.nCoolDownTime_4_4)
    view:setkey(ns.nBoxID)
end


------------------------------------------------------------------------------
-- ʱرб
------------------------------------------------------------------------------
function msg.NC_LoginLoadBox(data)
--     { "nGUID", tag.int64 },
    local nc = net.tag.NC_LoginLoadBox:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_LoginLoadBox(ns)
--     { "sBox", tag.tagPlayerBoxSlot, tag.array },
    mdt.BoxTime = {}
    for i=1,#ns.sBox do
        local time = {}
        time[1] = os.time()
        if ns.sBox[i].nBox_ID ~= nil and ns.sBox[i].nBox_ID ~= 0 then
            time[2] = ns.sBox[i].nBox_CD

            if time[2] > 0 then
                local key = "box_countDown_"..time[2]
                time[3] = key
                sdkManager.locojoybj:callNotify(key, time[2])
            end

        else
            time[2] = -1
        end
        mdt.BoxTime[ns.sBox[i].nSlot_ID] = time
    end 
end


------------------------------------------------------------------------------
-- һ NS_OpenBox->nErrorCode: 1ʱδ 2ÿûб 3ڵı
------------------------------------------------------------------------------
function msg.NC_OpenOvertopBox(boxid, id, adid)
--     { "nGUID", tag.int64 },
--     { "nBoxID", tag.int },
--     { "isOpen", tag.int },
--     { "nCooldownID", tag.int },
--     { "nADId", tag.int },
    local nc = net.tag.NC_OpenOvertopBox:create()
    nc.nGUID = mdt.player.nGUID
    nc.nBoxID = boxid
    nc.isOpen = id
    nc.nCooldownID = 4
    nc.nADId = adid or 0
    if nc.nADId == 0 then
        nc.nCooldownID = 0
    end
    net.send(nc)
end


------------------------------------------------------------------------------
-- һ NS_OpenBox->nErrorCode: 1ʱδ 2ÿûб 3ڵı
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- ûλʱõ
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- һ NS_OpenBox->nErrorCode: 1ʱδ 2ÿûб 3ڵı 4ʯ
------------------------------------------------------------------------------
