local net = ndpnet
local tag = net.tag
local msg = net.msg
-------------------------------------------------------------------------------
-- filename: msg_c_gs_invitation_code
-- author: liuchang
-- actor:
-- data: 2017-04-01
-- last: 2017-04-01
-- brief: 
-------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- 
------------------------------------------------------------------------------
function msg.NC_GetInvitationCode(data)
--     { "nGUID", tag.int64 },
    local nc = net.tag.NC_GetInvitationCode:create()
    nc.nGUID = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_GetInvitationCode(ns)
--     { "nGUID", tag.int64 },
--     { "szInvitationCode", tag.string, 128 },
--     { "m_nAreaID", tag.int },
--     { "m_nServerID", tag.int },

end

function msg.NC_LoginByInvitationCode(id,code)
--     { "nGUID", tag.int64 },
--     { "InviterGUID", tag.int64 },
--     { "szInvitationCode", tag.string, 128 },
    local nc = net.tag.NC_LoginByInvitationCode:create()
    nc.nGUID = mdt.player.nGUID
    nc.InviterGUID = id
    nc.szInvitationCode = code
    net.send(nc)
end

function msg.NS_SendInvitationReward(ns)
--     { "nGUID", tag.int64 },
--     { "InvitationRewardInfo", tag.tagPlayerInvitationReward, tag.array },--Ʒ
    if mdt.InviteReward == nil then
        mdt.InviteReward = {}
    end
    for _,v in pairs(ns.InvitationRewardInfo) do
        mdt.InviteReward[#mdt.InviteReward+1] = v
    end
end

function msg.NC_GetInvitationReward(id)
--     { "Guid", tag.int64 },                              --guid
--     { "nTableId", tag.int },                            --Ʒid
    local nc = net.tag.NC_GetInvitationReward:create()
    nc.Guid = mdt.player.nGUID
    nc.nTableId = id
    net.send(nc)
end

function msg.NS_GetInvitationReward(ns)
--     { "Guid", tag.int64 },                              --guid
--     { "nTableId", tag.int },                            --Ʒid
--     { "nIsSuccess", tag.bool },                         --Ƿɹ
    if ns.nIsSuccess then
        local id = 0
        for i = #mdt.InviteReward,1,-1 do
            if mdt.InviteReward[i].nTableId == ns.nTableId then
                id = i
                break
            end
        end
        local list = {}
        if mdt.InviteReward[id].nTypeId_1~= 0 then
            local item = {}
            item = {id = mdt.InviteReward[id].nTypeId_1,num = mdt.InviteReward[id].nParam_1_1}
            list[#list+1] = item
        end
        if mdt.InviteReward[id].nTypeId_2~= 0 then
            local item = {}
            item = {id = mdt.InviteReward[id].nTypeId_2,num = mdt.InviteReward[id].nParam_2_1}
            list[#list+1] = item
        end
        if mdt.InviteReward[id].nTypeId_3~= 0 then
            local item = {}
            item = {id = mdt.InviteReward[id].nTypeId_3,num = mdt.InviteReward[id].nParam_3_1}
            list[#list+1] = item
        end
        local view = util.showDialog('Dialog2', 'Common.RewardDialog2')
        view:setkey(list) 
        table.remove(mdt.InviteReward,id)
    end
end

