local net = ndpnet
local tag = net.tag
local msg = net.msg
-------------------------------------------------------------------------------
-- filename: msg_c_gs_mine_map_record.h
-- author: shichengliang
-- actor:
-- data: 2017-07-31
-- last: 2017-07-31
-- brief: ͼ¼Ϣ
-------------------------------------------------------------------------------
function msg.NC_EnterMineMapRecordUI(data)
--     { "nPlayerId", tag.int64 },
    local nc = net.tag.NC_EnterMineMapRecordUI:create()
    nc.nPlayerId = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_EnterMineMapRecordUI(ns)
--     { "nPlayerId", tag.int64 },
--     { "sMineRecord", tag.tagMineMapRecordPlayerMsgInfo, tag.array },

end

function msg.NC_MineMapRecordNormalRank(mapid,ranktype,from,to)
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
--     { "nRankType", tag.int },
--     { "nFromIndex", tag.int },
--     { "nToIndex", tag.int },
    local nc = net.tag.NC_MineMapRecordNormalRank:create()
    nc.nPlayerId = mdt.player.nGUID
    nc.nMapId = mapid
    nc.nRankType = ranktype
    nc.nFromIndex = from
    nc.nToIndex = to
    net.send(nc)
end

function msg.NS_MineMapRecordNormalRank(ns)
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
--     { "nRankType", tag.int },
--     { "nAllNum", tag.int },
--     { "nStartIndex", tag.int },
--     { "sMineRecordRank", tag.tagMineMapRecordNormalRankMsgInfo, tag.array },

end

function msg.NC_MineMapRecordDedicationRank(data)
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
--     { "nFromIndex", tag.int },
--     { "nToIndex", tag.int },
    local nc = net.tag.NC_MineMapRecordDedicationRank:create()
    nc.nPlayerId = mdt.player.nGUID

    net.send(nc)
end

function msg.NS_MineMapRecordDedicationRank(ns)
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
--     { "nAllNum", tag.int },
--     { "nStartIndex", tag.int },
--     { "sMineRecordRank", tag.tagMineMapRecordDedicationRankMsgInfo, tag.array },

end

function msg.NC_GetMineMapRecordReward(id)
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
    local nc = net.tag.NC_GetMineMapRecordReward:create()
    nc.nPlayerId = mdt.player.nGUID
    nc.nMapId = id
    net.send(nc)
end

function msg.NS_GetMineMapRecordReward(ns)
--     { "nErrorCode", tag.int },                          --EGetMineMapRecordRewardReturn
--     { "nPlayerId", tag.int64 },
--     { "nMapId", tag.int },
--     { "nRewardId", tag.int },                           --ID
--     { "boxInfo", tag.tagMsgMineMapRecordRewardBoxInfo, tag.array },--Ϣ
    if mdt.mapreward == nil then
        mdt.mapreward = {}
    end

    for i = 1 , #ns.boxInfo do
        local list = {}
        for j = 1 , #ns.boxInfo[i].nItemType do           
            local item = {nCodeID = ns.boxInfo[i].nItemType[j],nCodeNum = ns.boxInfo[i].nItemParam1[j]}
            list[#list+1]=item
        end
        mdt.mapreward[#mdt.mapreward+1] = list
    end
end

