local PlayerInfp = class("PlayerInfp", cc.load("mvc").LayoutBase)
PlayerInfp.RESOURCE_FILENAME = "Cell.PlayerInfp"

function PlayerInfp:onCreate()
    self:addEvent('NS_GetOtherPlayerBriefInfo')
end

function PlayerInfp:onEnter()
--    self.ui.bg:loadTexture("Image/board4"..mdt.theme..".png")
--    if mdt.theme == 2 then
--        self.ui.Name:setColor({r = 73, g = 42, b = 6})
--    else
--        self.ui.Name:setColor({r = 255, g = 255, b = 255})
--    end
end

function PlayerInfp:onExit()

end

function PlayerInfp:NS_GetOtherPlayerBriefInfo(ev,ns)
    if ns.nErrorCode == 0 then
        self.ui.Name:setString(ns.szFindName)
        self.i[mdt.clickpos.x] = ns:copyTo()
    end
    self.ui.Head:setInfo(ns.nFindGUID, ns.nFindHeadIndex,ns.nFindCountryIndex)

    local countryIcon = "res/Image/country/DEFAULT.png" 
    if ns.nFindCountryIndex>0 then
        countryIcon = string.format("res/Image/country/%s.png",static.country[ns.nFindCountryIndex].nameID)
    end
    self.ui.Country:loadTexture(countryIcon)
    self.ui.Country:setVisible(true)
end

function PlayerInfp:setkey(info)
    if info.playerid.v == 0 then
        event.dispatch('CloseInfo')
        return
    end
    if mdt.pointplayer == nil then
        mdt.pointplayer = {}
    end
    self.i = mdt.pointplayer[mdt.clickpos.y]
    if not self.i then
        self.i = {}
        mdt.pointplayer[mdt.clickpos.y] = self.i
    end
    if self.i[mdt.clickpos.x] == nil then
        net.msg.NC_GetOtherPlayerBriefInfo(info.playerid)
    else
        local curinfo = mdt.pointplayer[mdt.clickpos.y][mdt.clickpos.x] 
        if curinfo.nFindGUID == mdt.player.nGUID then
            self.ui.Name:setString(mdt.player.sMineMapData.szName)
        else
            self.ui.Name:setString(curinfo.szFindName)
        end
        local countryIcon = "res/Image/country/DEFAULT.png" 
        if curinfo.nFindCountryIndex>0 then
            countryIcon = string.format("res/Image/country/%s.png",static.country[curinfo.nFindCountryIndex].nameID)
        end
        self.ui.Country:loadTexture(countryIcon)
        self.ui.Country:setVisible(true)
        self.ui.Head:setInfo(curinfo.nFindGUID, curinfo.nFindHeadIndex, curinfo.nFindCountryIndex)
    end
end

-- Event for btnClose callback (addClickEventListener)
function PlayerInfp:onClose(node, eventType, userdata)

end

-- Event for Panel_3 callback (addClickEventListener)
function PlayerInfp:OnClick(node, eventType, userdata)
    event.dispatch('CloseInfo')
end

return PlayerInfp
