local ChallengeInfo = class("ChallengeInfo", cc.load("mvc").LayoutBase)
ChallengeInfo.RESOURCE_FILENAME = "Challenge.ChallengeInfo"

function ChallengeInfo:onCreate()
    self:addEvent('NS_ChallengePointInfo')
end

function ChallengeInfo:onEnter()
   -- self.ui.Master:setString(static.language[30001][device.language])
    self.ui.set_3:setString(static.language[30002][device.language])
--    self.ui.set_4:setString(static.language[30003][device.language])
    self.ui.set_5:setString(static.language[30004][device.language])
    self.ui.Button1:onSetText(static.language[20001][device.language])
    if mdr.ismodetips == nil then
        mdr.ismodetips = false
        mdr.save()
    end
    if mdr.ismodetips == false then
        local view = util.showDialog('Dialog','Common.TipDialog')
        view:setkey(1)
        mdr.ismodetips = true
        mdr.save()
    end
end

function ChallengeInfo:onExit()

end

function ChallengeInfo:setLocation(x, y)
    self.x = x
    self.y = y
    local info = mdt.getChallenge(x, y)
    if info and info.data then
        self:NS_ChallengePointInfo(nil, info.data)
    end
    net.msg.NC_ChallengePointInfo(x, y)
end

function ChallengeInfo:NS_ChallengePointInfo(ev, ns)
--dump(ns)
    if ns.nPosX~=self.x or ns.nPosY~=self.y then return end
    local guid = ns.nPlayerId
    if guid.v==0 then
        self.ui.PlayerName:setString('------')
        --self.ui.Pic:setInfo(nil, '------')
        self.ui.TotalTime:setString('------')
--        self.ui.Location:setString(ns.nPosX..', '..ns.nPosY)
        self.ui.CTimes:setString(ns.nCurPlayerChallengeNum)
    else
        self.ui.PlayerName:setString(ns.nPlayerName)
        self.ui.Head:setInfo(ns.nPlayerId, ns.nPlayerHeadUrlIndex,ns.nCountryIndex)
        local str = ''
        if ns.nChallengeTime - ns.nOriginalChallengeTime ~= 0 then
            str = '(+'..math.abs(ns.nChallengeTime - ns.nOriginalChallengeTime)..')'
        end
        self.ui.TotalTime:setString(ns.nOriginalChallengeTime..str)
--        self.ui.Location:setString(ns.nPosX..', '..ns.nPosY)
        self.ui.CTimes:setString(ns.nCurPlayerChallengeNum)
    end
end

-- Event for BG callback (addClickEventListener)
function ChallengeInfo:onClose(node, eventType, userdata)

end

-- Event for Disband callback (addClickEventListener)
function ChallengeInfo:onChallenge(node, eventType, userdata)
    if mdt.isclickchallenge == nil then
        mdt.isclickchallenge = true
    end
    if mdt.isclickchallenge then
        net.msg.NC_EnterChallenge(self.x, self.y)   
        mdt.isclickchallenge = false
    end
    util.playClose(self)
end

-- Event for Button_1 callback (addClickEventListener)
function ChallengeInfo:OnTips(node, eventType, userdata)
    local view = util.showDialog('Dialog','Common.TipDialog')
    view:setkey(1)
end

return ChallengeInfo
