local Complete = class("Complete", cc.load("mvc").LayoutBase)
Complete.RESOURCE_FILENAME = "Challenge.Complete"

function Complete:onCreate()
    self:addEvent('OnShowInfo')
end

function Complete:onEnter()
--    self.ui.Text_13:setString(static.language[30086][device.language])
    --self:play('loop',false)
end

function Complete:onExit()

end

function Complete:setData(ns)
    --self.ui.Info:setVisible(true)
    self.ns = ns
    local completeType = ns.nCompleteType
    self.completetype = completeType
    self.ui.title:setString(title)
    self.ui.InfoBoard:setVisible(false)
    if completeType==0 then
        self.effect = self:getApp():createView('Challenge.shengli')
        self.ui.Panel_2:addChild(self.effect)
        self.effect:setPosition(self.ui.Panel_2:getPositionX(),self.ui.Panel_2:getPositionY())
        self.effect:play('shenglistart',false)    
        audio.playEffect('win')
        --sdkManager.talkingdata:setEvent("40",{Success = tostring(1)})
--        self.ui.Fail:setVisible(false)
--        self.ui.Success:setVisible(true)
    else
        self.effect = self:getApp():createView('Challenge.shibai')
        self.ui.Panel_2:addChild(self.effect)
        self.effect:setPosition(self.ui.Panel_2:getPositionX(),self.ui.Panel_2:getPositionY()) 
        self.effect:play('shenglistart',false)   
        audio.playEffect('fail')
    end
    self.ui.set_3:setString(static.language[30007][device.language])
    self.ui.set_4:setString(static.language[30002][device.language])
    self.ui.set_5:setString(static.language[30008][device.language])
    self.ui.Button1:onSetText(static.language[10001][device.language])
end

function Complete:OnShowInfo(ev,key)
    self.ui.InfoBoard:setVisible(true)
    if key == 1 then
        self.ui.title:setString(static.language[30005][device.language])
    else
        self.ui.title:setString(static.language[30006][device.language])
    end
    local str = ''
    if self.ns.nOldUserTime - self.ns.nOldUserOriginalTime ~= 0 then
        str = '(+'..math.abs(self.ns.nOldUserTime - self.ns.nOldUserOriginalTime)..')'
    end
    self.ui.myTime:setString(self.ns.nUserTime)
    self.ui.oldTime:setString(self.ns.nOldUserOriginalTime..str)
    self.ui.score:setString(self.ns.nAddChallengeScore+10)
    if self.completetype == 0 then
        if self.ns.nUserTime ~=0 and self.ns.nUserTime < self.ns.nOldUserTime then
            if mdr.ChallengeBreak == nil then
                mdr.ChallengeBreak = false
                mdr.save()
            end
            if not mdr.ChallengeBreak then
                sdkManager.talkingdata:setEvent("51",{BigBreakNum = "BigBreakNum"})
                sdkManager.appsflyer:setEvent("51",{BigBreakNum = "BigBreakNum"})
                mdr.ChallengeBreak = true
                mdr.save()
            end
            sdkManager.talkingdata:setEvent("50",{BigBreak = "BigBreak"})
            sdkManager.appsflyer:setEvent("50",{BigBreak = "BigBreak"})
        end
    end
end

-- Event for BG callback (addClickEventListener)
function Complete:onClose(node, eventType, userdata)
--    self.ui.Info:setVisible(false)
    net.msg.NC_LoadMap()
end

-- Event for btnOK callback (addClickEventListener)
function Complete:onOK(node, eventType, userdata)
    util.playClose(self)
--    self.ui.Info:setVisible(false)
    net.msg.NC_ExitChallenge()
    net.msg.NC_LoadMap()
end

function Complete:onSpinChuxian()
    self.ui.Success:setAnimation(1, 'xunhuan', true)
end

return Complete
