local ConnectingDialog = class("ConnectingDialog", cc.load("mvc").LayoutBase)
ConnectingDialog.RESOURCE_FILENAME = "Common.ConnectingDialog"

function ConnectingDialog:onCreate()
    self:addEvent('onConnectTimeOut')
end

function ConnectingDialog:onEnter()
    self.ui.Continue:setString(static.language[30012][device.language])
    self.ui.Button1:onSetText(static.language[10017][device.language])
    self:play('wait', true)
    ctr.login.connect()
end

function ConnectingDialog:onExit()

end

-- Event for OK callback (addClickEventListener)
function ConnectingDialog:onOK(node, eventType, userdata)
    self:play('wait', true)
    
    ctr.login.connectToGameServer(mdt.login.szGatewayIP, mdt.login.nGatewayPort)
end

function ConnectingDialog:onConnectGameServer()
    util.playClose(self)
end

function ConnectingDialog:onConnectTimeOut()
    self:play('show')
end

-- Event for btnClose callback (addClickEventListener)
function ConnectingDialog:onClose(node, eventType, userdata)

end

return ConnectingDialog
