local InviteDialog = class("InviteDialog", cc.load("mvc").LayoutBase)
InviteDialog.RESOURCE_FILENAME = "Common.InviteDialog"

function InviteDialog:onCreate()
    self:addEvent('NS_SendInvitationReward')
end

function InviteDialog:onEnter()
    if mdt.InviteReward == nil then
        mdt.InviteReward = {}
    end
    self.ui.InvitePanel:setVisible(true)
    self.ui.RewardPanel:setVisible(false)
    self.ui.Pick:setBright(#mdt.InviteReward > 0)
    self.ui.Pick:setTouchEnabled(#mdt.InviteReward > 0)
    self.ui.Mycode:setString(mdt.player.sMainData.szInvitationCode)
end

function InviteDialog:onExit()

end

function InviteDialog:NS_SendInvitationReward(ev,ns)
    self.ui.Pick:setBright(#mdt.InviteReward > 0)
    self.ui.Pick:setTouchEnabled(#mdt.InviteReward > 0)
end

-- Event for InvitePanelBtn callback (addClickEventListener)
function InviteDialog:ChangePanel(node, eventType, userdata)
    if tonumber(userdata) == 1 then
        self.ui.InvitePanel:setVisible(true)
        self.ui.RewardPanel:setVisible(false)
    else
        self.ui.InvitePanel:setVisible(false)
        self.ui.RewardPanel:setVisible(true)
    end
end

-- Event for InviteBtn callback (addClickEventListener)
function InviteDialog:ShareCode(node, eventType, userdata)
    print('ShareCode!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!')
end

-- Event for Pick callback (addClickEventListener)
function InviteDialog:onPickReward(node, eventType, userdata)
    net.msg.NC_GetInvitationReward(mdt.InviteReward[1].nTableId)
end

-- Event for Yes callback (addClickEventListener)
function InviteDialog:onYes(node, eventType, userdata)
    local text = self.ui.TextField:getString()
    self.code = string.sub(text,8,14)
    if self.code ~= nil then
        net.msg.NC_LoginByInvitationCode(self.code,text)
    end
end

-- Event for TextField callback (addEventListener)
function InviteDialog:onCutInput(node, eventType, userdata)

end

-- Event for TextField callback (addEventListener)
function InviteDialog:onCutInput2(node, eventType, userdata)

end

-- Event for Panel_1 callback (addClickEventListener)
function InviteDialog:onClose(node, eventType, userdata)
    util.closeDialog("Common.InviteDialog")
end

return InviteDialog
