local RechargeType = class("RechargeType", cc.load("mvc").LayoutBase)
RechargeType.RESOURCE_FILENAME = "Common.RechargeType"

function RechargeType:onCreate()

end

function RechargeType:onEnter()

end

function RechargeType:onExit()

end

function RechargeType:setData(data)
	self.data = data
end

-- Event for BG callback (addClickEventListener)
function RechargeType:onClose(node, eventType, userdata)
    mdt.FristCharge = false
end

-- Event for WXButton callback (addClickEventListener)
function RechargeType:onWXBuy(node, eventType, userdata)
	sdkManager.locojoybj:PayWechat(self.data)
	self:OnADTracking()
	util.closeDialog("Common.RechargeType")
end

-- Event for ZFBButton callback (addClickEventListener)
function RechargeType:onZFBBuy(node, eventType, userdata)
	sdkManager.locojoybj:PayAliPay(self.data)
	self:OnADTracking()
	util.closeDialog("Common.RechargeType")
end

function RechargeType:OnADTracking()
	local data = {}
	data['account'] = tostring(mdt.player.nGUID.a)
	data['orderId'] = self.data.iapId
	data['amount'] = self.data.cost
	data['currencyType'] = 'CNY'                
	data['payType'] = 'Apple Pay'
	sdkManager.tdadtracking:setpay(data)
end

return RechargeType
