﻿local EndDialog = class("EndDialog", cc.load("mvc").LayoutBase)
EndDialog.RESOURCE_FILENAME = "End.EndDialog"

function EndDialog:onCreate()
    self.ui.OK:setVisible(false)
    self.ui.layLoading:setVisible(true)
    self.ui.Button1:onSetText(static.language[20010][device.language])
    self.ui.loading:setString(static.language[30017][device.language])
    util.scheduleNode(1, function()
        if not mdt.InformSwitchMap then
            self.ui.OK:setVisible(true)
            self.ui.layLoading:setVisible(false)
            self.ui.loading:setString(static.language[30110][device.language])
        end
    end, self)  
end

function EndDialog:onEnter()
    audio.playEffect('gameEnd')
end

function EndDialog:onExit()

end


-- Event for OK callback (addClickEventListener)
function EndDialog:onClose(node, eventType, userdata)
    if mdt.InformSwitchMap then
        return true
    end
end

-- Event for Rank callback (addTouchEventListener)
function EndDialog:clickRank(node, eventType, userdata)
        util.showDialog('Dialog', 'Rank.Rank_end')
end

-- Event for forward_0 callback (addTouchEventListener)
function EndDialog:OnTouchSelect(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function EndDialog:onShare(node, eventType, userdata)

end

return EndDialog
