local Feedback = class("Feedback", cc.load("mvc").LayoutBase)
Feedback.RESOURCE_FILENAME = "Feedback.Feedback"

function Feedback:onCreate()

end

function Feedback:onEnter()
    self.ui.Name:setString(static.language[20013][device.language])
    self.ui.FeedTXT:setString(static.language[30018][device.language])
    self.ui.TextField_1:setPlaceHolder(static.language[30114][device.language])
    self.ui.TextField_2:setPlaceHolder(static.language[30114][device.language])
    self.ui.ContectTXT:setString(static.language[30019][device.language])
    self.lastInput1 = self.ui.TextField_1:getString()
    self.lastInput2 = self.ui.TextField_2:getString()
    self.ui.ButtonSend:onSetText(static.language[10003][device.language])
end

function Feedback:onExit()

end

--function Feedback:Update()
--    local txt = self.ui.TextField_1:getString()
--    print(txt)
--    self.ui.Text_1:setString(txt)
--end

-- Event for BG callback (addClickEventListener)
function Feedback:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function Feedback:onOK(node, eventType, userdata)
    local str1 = self.ui.TextField_1:getString()
    local str2 = self.ui.TextField_2:getString()
    print("str1:======================"..str1)
    print("str2:======================"..str2)
    if string.len(str1) > 0 and string.len(str2) > 0 then
        if str1 ~= '' and str2 ~= nil then
            net.msg.NC_AddPlayerFeedback(str1..'|'..str2)
            ctr.player.showMessageBox(static.language[30157][device.language], 1, function()
                util.closeDialog('Common.MessageBox')
            end)
            util.closeDialog( 'Feedback.Feedback')
        end
    else
        ctr.player.showMessageBox(static.language[30156][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

-- Event for TextField_1 callback (addEventListener)
function Feedback:onCutInput1(node, eventType, userdata)
    local content = self.ui.TextField_1:getString()
    if string.len(content)>440 then
        self.ui.TextField_1:setText( self.lastInput1 )
    else
        self.lastInput1 = content
    end
end

-- Event for TextField_2 callback (addEventListener)
function Feedback:onCutInput2(node, eventType, userdata)
    local title = self.ui.TextField_2:getString()
    if string.len(title)>100 then
        self.ui.TextField_2:setText( self.lastInput2 )
    else
        self.lastInput2 = title
    end
end

return Feedback
