local Info = class("Info", cc.load("mvc").LayoutBase)
Info.RESOURCE_FILENAME = "Info.Info"

require ('json')

function Info:onCreate()
    self:addEvent('NS_ChallengePlayerInfo')
    self:addEvent('NS_OpenPlayerShowInfo')
    self:addEvent('NS_OnlineTM')
    self:addEvent('NS_BindAccount')
    self:addEvent('NS_ChangeRoleName')
    self:addEvent('NS_EnterMineMapRecordUI')
    self:addEvent('NS_GetMineMapRecordReward')
    self:addEvent('OpenRewardBox')
end

function Info:onEnter()
    --self:NS_Statistics()
    --self:NS_OnlineTM()
    self:NS_ChallengePlayerInfo()
    --net.msg.NC_ChallengePlayerInfo()
    net.msg.NC_EnterMineMapRecordUI()
    net.msg.NC_OpenPlayerShowInfo()
    net.msg.NC_OnlineTM()
    self.ui.PlayerName:setString(mdt.player.sMineMapData.szName)
--    self.ui.GuestName:setString(mdt.player.sMineMapData.szName)
    if mdr.nHeadIndex == nil then
        mdr.nHeadIndex = 0
        mdr.save()
    end
    self.ui.Head:setInfo(mdt.player.nGUID,mdt.player.headindex,mdt.player.country)
--    if ctr.login.isLocalAccount() then
--        self:showGuest()
--        self.ui.txtFlagSet:setString(static.language[30070][device.language])
--        self.ui.CareerBtn:setVisible(false)
--        self.ui.MapBtn:setVisible(false)
--    elseif ctr.login.isFacebookAccount() then
        self:showInfo()
--        self.ui.CareerBtn:setEnabled(true)
--        self.ui.MapBtn:setEnabled(true)
        self:setBtnstate(1)
--    end
    
    self.ui.ButtonRank:onSetText(static.language[20010][device.language])
    self.ui.ButtonGet:onSetText(static.language[10005][device.language])
    self.ui.Text_4:setString(static.language[30030][device.language])
    self.ui.Text_1:setString(static.language[30031][device.language])
    self.ui.PlayerId:setString(static.language[30111][device.language]..mdt.player.nGUID.a)
    self.ui.set:setString(static.language[30032][device.language])
    self.ui.set_0:setString(static.language[30033][device.language])
    self.ui.set_1:setString(static.language[30034][device.language])
    self.ui.set_2:setString(static.language[30035][device.language])
    self.ui.set_3:setString(static.language[30036][device.language])
    self.ui.set_4:setString(static.language[30037][device.language])
    self.ui.Text_38:setString(static.language[30159][device.language])
    self.ui.CareerBtn:setTitleText(static.language[20025][device.language])
    self.ui.MapBtn:setTitleText(static.language[20026][device.language])
    self.ui.MinTime:setString(static.language[30039][device.language])
    self.ui.Num:setString(static.language[30038][device.language])
    self.ui.Win:setString(static.language[30040][device.language])
    self.ui.set_2_0:setString(static.language[20023][device.language])
    self.ui.set_2_1:setString(static.language[20024][device.language])
    self.ui.Num_0:setString(static.language[20022][device.language])
--    self.ui.Name:setString(static.language[20011][device.language])
    self.ui.ButtonFB:onSetText("   "..static.language[30122][device.language])
    self.ui.txtReward:setString(static.language[20019][device.language])
--    print("   "..static.language[30122][device.language])
--    self.ui.ReName:onSetText(static.language[10014][device.language])
    self.ui.ReName2:onSetText(static.language[10014][device.language])
    self.ui.Panel_Career:setVisible(true)
    self.ui.Panel_Map:setVisible(false)
    self.ui.MapPageView:addEventListener(function(...) self:onBoxEvent(...) end)
    self.page = 1
    self.ui.MapBtn:setTouchEnabled(false)
    mdt.HistoryPage = self.page
end

function Info:onExit()

end

function Info:setReward(key)--key为排名
    self.boxlist = {}
    self.boxindex = 1
    self.list = {}
    self.ui.Reward1:setVisible(true)
    self.ui.Reward2:setVisible(true)
    self.ui.Reward3:setVisible(true)
    self.boom = 0
    self.wudi = 0
    local reward = nil
    for k,v in pairs(static.completeReward) do
        if key <= v.range then
            reward = static.completeReward[k]
            break
        end
    end
    if reward.type1 ~= 0 then
        local id = 0
        local lv = 0
        if reward.type1 == 1 then
            self.ui.RewardPic1:loadTexture("Image/coin.png",0)
            id = 1
        elseif reward.type1 == 2 then
            self.ui.RewardPic1:loadTexture("Image/pvp/pvp.png",0)
            id = 3
        elseif reward.type1 == 3 then
            self.ui.RewardPic1:loadTexture("Image/Diamond.png",0)
            id = 5
        elseif reward.type1 == 4 then
            local box = nil
            for _,v in pairs(static.box) do
                if tonumber(v.id) == reward.value1 then
                    box = v
                    break
                end
            end
            if box.boxLevel == 1 then
                self.ui.RewardPic1:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
            elseif box.boxLevel == 2 then
                self.ui.RewardPic1:loadTexture("Image/donghua/png/saolei/chest2_0.png",0)
            elseif box.boxLevel == 3 then
                self.ui.RewardPic1:loadTexture("Image/donghua/png/saolei/chest3_0.png",0)
            else
                self.ui.RewardPic1:loadTexture("Image/donghua/png/saolei/chest4_0.png",0)
            end
            lv = box.boxLevel
            id = 4
            for i=1,reward.times1 do
                self.boxlist[#self.boxlist+1]=reward.value1
            end
        elseif reward.type1 == 5 then
            local item = nil
            for k,v in pairs(static.item) do
                if tonumber(v.id) == reward.value1 then
                    item = v
                    lv = k
                    break
                end
            end
            if tonumber(item.id) == 50001 then
                self.boom = self.boom+reward.times1
            elseif tonumber(item.id) == 50002 then
                self.wudi = self.wudi+reward.times1
            end
            self.ui.RewardPic1:loadTexture(item.imageId,0)
            id = 6
        end
        self.ui.RewardNum1:setString('X '..reward.times1)
        local item = {id =id ,num = reward.times1,value = lv}
        self.list[#self.list+1]=item
    else
        self.ui.Reward1:setVisible(false)
    end
    if reward.type2 ~= 0 then
        local id = 0
        local lv = 0
        if reward.type2 == 1 then
            self.ui.RewardPic2:loadTexture("Image/coin.png",0)
            id = 1
        elseif reward.type2 == 2 then
            self.ui.RewardPic2:loadTexture("Image/pvp/pvp.png",0)
            id = 3
        elseif reward.type2 == 3 then
            self.ui.RewardPic2:loadTexture("Image/Diamond.png",0)
            id = 5
        elseif reward.type2 == 4 then
            local box = nil
            for _,v in pairs(static.box) do
                if tonumber(v.id) == reward.value2 then
                    box = v
                    break
                end
            end
            if box.boxLevel == 1 then
                self.ui.RewardPic2:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
            elseif box.boxLevel == 2 then
                self.ui.RewardPic2:loadTexture("Image/donghua/png/saolei/chest2_0.png",0)
            elseif box.boxLevel == 3 then
                self.ui.RewardPic2:loadTexture("Image/donghua/png/saolei/chest3_0.png",0)
            else
                self.ui.RewardPic2:loadTexture("Image/donghua/png/saolei/chest4_0.png",0)
            end
            lv = box.boxLevel
            id = 4
            for i=1,reward.times2 do
                self.boxlist[#self.boxlist+1]=reward.value2
            end
        elseif reward.type2 == 5 then
            local item = nil
            for k,v in pairs(static.item) do
                if tonumber(v.id) == reward.value2 then
                    item = v
                    lv = k
                    break
                end
            end
            self.ui.RewardPic2:loadTexture(item.imageId,0)
            if tonumber(item.id) == 50001 then
                self.boom = self.boom+reward.times2
            elseif tonumber(item.id) == 50002 then
                self.wudi = self.wudi+reward.times2
            end
            id = 6
        end
        self.ui.RewardNum2:setString('X '..reward.times2)
        local item = {id =id ,num = reward.times2 ,value = lv}
        self.list[#self.list+1]=item
    else
        self.ui.Reward2:setVisible(false)
    end
    if reward.type3 ~= 0 then
        local id = 0
        local lv = 0
        if reward.type3 == 1 then
            self.ui.RewardPic3:loadTexture("Image/coin.png",0)
            id = 1
        elseif reward.type3 == 2 then
            self.ui.RewardPic3:loadTexture("Image/pvp/pvp.png",0)
            id = 3
        elseif reward.type3 == 3 then
            self.ui.RewardPic3:loadTexture("Image/Diamond.png",0)
            id = 5
        elseif reward.type3 == 4 then
            local box = nil
            for _,v in pairs(static.box) do
                if tonumber(v.id) == reward.value3 then
                    box = v
                    break
                end
            end
            if box.boxLevel == 1 then
                self.ui.RewardPic3:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
            elseif box.boxLevel == 2 then
                self.ui.RewardPic3:loadTexture("Image/donghua/png/saolei/chest2_0.png",0)
            elseif box.boxLevel == 3 then
                self.ui.RewardPic3:loadTexture("Image/donghua/png/saolei/chest3_0.png",0)
            else
                self.ui.RewardPic3:loadTexture("Image/donghua/png/saolei/chest4_0.png",0)
            end
            lv = box.boxLevel
            id = 4
            for i=1,reward.times3 do
                self.boxlist[#self.boxlist+1]=reward.value3
            end
        elseif reward.type3 == 5 then
            local item = nil
            for k,v in pairs(static.item) do
                if tonumber(v.id) == reward.value3 then
                    item = v
                    lv = k
                    break
                end
            end
            self.ui.RewardPic3:loadTexture(item.imageId,0)
            if tonumber(item.id) == 50001 then
                self.boom = self.boom+reward.times3
            elseif tonumber(item.id) == 50002 then
                self.wudi = self.wudi+reward.times3
            end
            id = 6
        end
        self.ui.RewardNum3:setString('X '..reward.times3)
        local item = {id =id ,num = reward.times3,value = lv}
        self.list[#self.list+1]=item
    else
        self.ui.Reward3:setVisible(false)
    end
end

function Info:NS_GetMineMapRecordReward(ev,ns)
    if ns.nErrorCode == 0 then
        self.record[self.page].nRewardIsGet = 1
        self.ui.ButtonGet:setVisible(false)
        self.ui.AlreadyGet:setVisible(true)
        local view = util.showDialog('Dialog2', 'Common.RewardDialog2')
        if mdt.itemCount[50001] == nil then
            mdt.itemCount[50001] = 0
        end
        if mdt.itemCount[50002] == nil then
            mdt.itemCount[50002] = 0
        end
        mdt.itemCount[50001] = mdt.itemCount[50001]+self.boom
        mdt.itemCount[50002] = mdt.itemCount[50002]+self.wudi
        event.dispatch('updateItemCount')
        view:setkey(self.list) 
        event.dispatch('OpenRewardBox')
    end
end

function Info:OpenRewardBox()
    if mdt.mapreward[self.boxindex]~=nil then
        local view = util.showDialog('Dialog2', 'Box.Box')
        view:setMapId(self.boxlist[self.boxindex],mdt.mapreward[self.boxindex])
        self.boxindex = self.boxindex+1
    else
        self.boxindex = 1
        self.boxlist = {}
        mdt.mapreward = {}
    end
end

function Info:NS_EnterMineMapRecordUI(ev,ns)

    self.record = {}
    for k,v in pairs(ns.sMineRecord) do
        if v.nRankIndex ~= 0 then
            self.record[#self.record+1] = v
        end
    end

    table.sort(self.record,function (a,b)
        return a.nMapId < b.nMapId
    end)
    dump(self.record)
    mdt.HistoryPageTB=self.record
    if #self.record <= 0 then
        self.ui.MapBtn:setTouchEnabled(false)
    else
        self.ui.MapBtn:setTouchEnabled(true)
        for i = 1,#self.record do
            local item = util.createView('Info.MapItem')
            item:setPosition(0,0)
            item:setkey(self.record[i].nMapId)
            self.ui.MapPageView:addPage(item)
        end
        self.ui.Contribution:setString(string.format("%.2f",(self.record[1].nDedication / 480000))..'%')
        
        if self.record[1].nRewardIsGet == 0 then
            self.ui.ButtonGet:setVisible(true)
            self.ui.AlreadyGet:setVisible(false)
        else
            self.ui.ButtonGet:setVisible(false)
            self.ui.AlreadyGet:setVisible(true)
        end
        self:setReward(self.record[1].nRankIndex)
        self.pagecount = self.ui.MapPageView:getChildrenCount()
        self.ui.Image_zuo:setVisible(false)
        if self.pagecount > 1 then
            self.ui.Image_you:setVisible(true)
        else
            self.ui.Image_you:setVisible(false)
        end
    end
end

function Info:onBoxEvent(node, eventType, userdata)
    self.page = self.ui.MapPageView:getCurrentPageIndex()
    if self.page <= 0 then
        self.ui.Image_you:setVisible(true)
        self.ui.Image_zuo:setVisible(false)
    else
        if self.page+1 >= self.pagecount then
            self.ui.Image_you:setVisible(false)
        else
            self.ui.Image_you:setVisible(true)
        end
        self.ui.Image_zuo:setVisible(true)
    end
    self.ui.Contribution:setString(string.format("%.2f",(self.record[self.page+1].nDedication / 480000))..'%')
    if self.record[self.page+1].nRewardIsGet == 1 then
        self.ui.ButtonGet:setVisible(false)
        self.ui.AlreadyGet:setVisible(true)
    else
        self.ui.ButtonGet:setVisible(true)
        self.ui.AlreadyGet:setVisible(false)
    end
    self:setReward(self.record[self.page+1].nRankIndex)
    self.page = self.page+1
    mdt.HistoryPage = self.page
end

function Info:NS_ChangeRoleName(ev,ns)
    if ns.nErrorCode == 1 or ns.nErrorCode == 2 then
        self.ui.PlayerName:setString(ns.szRoleName)
--        self.ui.GuestName:setText(ns.szRoleName)
    end
end

function Info:showGuest()
    self.ui.GuestBoard:setVisible(true)
    self.ui.InfoBoard:setVisible(false)
end

function Info:showInfo()
    self.ui.GuestBoard:setVisible(false)
    self.ui.InfoBoard:setVisible(true)
end

function Info:NS_OpenPlayerShowInfo(ev,ns)
    self.ui.FlagSet:setString(ns.nOpenBombSuccessNumAll)
    self.ui.CellsOpen:setString(ns.nOpenGridSuccessNumAll)
    self.ui.MinesOpend:setString(ns.nOpenBombFailNumAll)
    self.ui.FlagsFailed:setString(ns.nOpenGridFailNumAll)
    self.ui.MinesOpend2:setString(ns.nMaxSuccessClickGridNum)
    self.ui.MinesOpend3:setString(ns.nBestMapDedication)
    self.ui.Location:setString(mdt.x ..', '..mdt.y)
    self.ui.ChallengeMinTime:setString(ns.nChallengeMinNum)
    self.ui.ChallengeNum:setString(ns.nChallengeAllNum)
    self.ui.ChallengeNum2:setString(ns.nChallengeWinNum)
    local win  
    if ns.nChallengeAllNum == 0 then
        win = 0 
    else
        win = ns.nChallengeWinNum / ns.nChallengeAllNum * 100
    end
    self.ui.ChallengeWin:setString(string.format("%.1f",win) .. "%")
end

function Info:NS_OnlineTM()
    local t = mdt.player.info.nOnlineTM or 0
    local time = os.date('%M:%S', t)
    local hour = math.floor(t / 3600)
    if hour<10 then 
        hour = '0'..hour
    end
    self.ui.TotalTime:setString(hour..':'..time)
end

-- Event for BG callback (addClickEventListener)
function Info:onClose(node, eventType, userdata)

end

-- Event for Bind callback (addClickEventListener)
function Info:onBind(node, eventType, userdata)
    async.create(function()
        ctr.player.showWaiting()
        net.msg.NC_RequestUploadHead()
        async.waitForEvent('NS_RequestUploadHead')
        if util.isIOS() then
            mdt.isLoginInThirdPlatform = true
            sdkManager.facebook:login(function(thirdPlatformInfo)
                local data = {}
                data.thirdPlatformId = thirdPlatformInfo.facebookID
                data.thirdPlatformType = 2 --fb登录
                data.thirdPlatformName = thirdPlatformInfo.facebookName
                data.thirdPlatformIconUrl = thirdPlatformInfo.facebookAvatarUrl
                ctr.login.bind(data)
            end)
        elseif util.isAndroid() then
             local luaj = require "cocos.cocos2d.luaj"
             local classname = "org/cocos2dx/lua/AppActivity"
             local args = {nil}
             local sigs = "()V"
             local ok,ret = luaj.callStaticMethod(classname, "FB_Login", args, sigs)
             local function SendMsgToServer(msg)
                local newmsg = string.gsub(msg, "\\/", "/")
                 local jsondata = json.decode(newmsg)
                 local name = jsondata["name"]
                 local id = jsondata["id"]
                 local token = jsondata["token"]
                local icon = jsondata["icon"]
                 local data = {}
                 data.thirdPlatformId = id
                 data.thirdPlatformType = 2 --fb登录
                 data.thirdPlatformName = name
                data.thirdPlatformIconUrl = icon
                 ctr.login.bind(data)
             end
             util.SendLuaFuncID2Java(SendMsgToServer)
        else
            local data = { }
            data.thirdPlatformId = "fb"..os.time()
            data.thirdPlatformType = 2-- fb登录
            data.thirdPlatformName = "ZhanYangYu"
            data.thirdPlatformIconUrl = "http://10.21.1.7/snake/icon1.png"
            ctr.login.bind(data)
        end
        ctr.player.hideWaiting()
        sdkManager.talkingdata:setEvent("43",{FBLogin = "FBLogin"})
        sdkManager.appsflyer:setEvent("43",{FBLogin = "FBLogin"})
    end)
end

function Info:NS_BindAccount(nv, ns)

end

-- Event for Disband callback (addClickEventListener)
function Info:onDisband(node, eventType, userdata)
    if util.isIOS() then

    elseif util.isAndroid() then
        local luaj = require "cocos.cocos2d.luaj"
        local classname = "org/cocos2dx/lua/AppActivity"
        local args = { nil }
        local sigs = "()V"

        local ok, ret = luaj.callStaticMethod(classname, "FB_Logout", args, sigs)

        ctr.login.disband()
    else

    end
end

function Info:NS_ChallengePlayerInfo(ev,ns)
--    self.ui.ChallengeMinTime:setString(mdt.player.sChallengeData.nChallengeMinTime)
--    self.ui.ChallengeNum:setString(mdt.player.sChallengeData.nChallengeTotalNumAll)
--    self.ui.ChallengeNum2:setString(mdt.player.sChallengeData.nChallengeWinNumAll)
    local win  
    if mdt.player.sChallengeData.nChallengeTotalNumAll == 0 then
        win = 0 
    else
        win = mdt.player.sChallengeData.nChallengeWinNumAll / mdt.player.sChallengeData.nChallengeTotalNumAll * 100
    end
    --self.ui.ChallengeWin:setString(string.format("%.1f",win) .. "%")
end

-- Event for Panel_ReName callback (addClickEventListener)
function Info:onReName(node, eventType, userdata)
    util.showDialog('Dialog','Common.ChangeName')
end

-- Event for CareerBtn callback (addClickEventListener)
function Info:OnCareer(node, eventType, userdata)
    self.ui.Panel_Career:setVisible(true)
    self.ui.Panel_Map:setVisible(false)
    self:setBtnstate(1)
end

-- Event for MapBtn callback (addClickEventListener)
function Info:OnMap(node, eventType, userdata)
    self.ui.Panel_Career:setVisible(false)
    self.ui.Panel_Map:setVisible(true)
    self:setBtnstate(2)
end

function Info:setBtnstate(key)
    if key ~= 1 then
        --self.ui.MapBtn:loadTextureDisabled("Image/menu/sheet23.png",0)
        self.ui.MapBtn:setBright(false)
        self.ui.MapBtn:setTouchEnabled(false)
        self.ui.CareerBtn:setTitleColor({r = 218, g = 218, b = 218})
        self.ui.CareerBtn:setTitleFontSize(44)
        --self.ui.CareerBtn:loadTextureNormal("Image/label_0.png",0)
        self.ui.CareerBtn:setBright(true)
        self.ui.CareerBtn:setTouchEnabled(true)
        self.ui.CareerBtn:setLocalZOrder(50)
        self.ui.MapBtn:setLocalZOrder(100)
        self.ui.MapBtn:setTitleColor({r = 0, g = 0, b = 0})
        self.ui.MapBtn:setTitleFontSize(56)
    else
        --self.ui.CareerBtn:loadTextureDisabled("Image/label_1.png",0)
        self.ui.CareerBtn:setBright(false)
        self.ui.CareerBtn:setTouchEnabled(false)
        self.ui.CareerBtn:setTitleColor({r = 0, g = 0, b = 0})
        self.ui.CareerBtn:setTitleFontSize(56)
        self.ui.MapBtn:setBright(true)
        self.ui.MapBtn:setTouchEnabled(true)
        self.ui.MapBtn:setTitleColor({r = 218, g = 218, b = 218})
        self.ui.MapBtn:setTitleFontSize(44)
        self.ui.CareerBtn:setLocalZOrder(100)
        self.ui.MapBtn:setLocalZOrder(50)
    end
end

-- Event for ButtonGet callback (addClickEventListener)
function Info:OnPick(node, eventType, userdata)
    print(self.record[self.page].nMapId)
    net.msg.NC_GetMineMapRecordReward(self.record[self.page].nMapId)
end

-- Event for Button_Contribution callback (addClickEventListener)
function Info:onSeasonRank(node, eventType, userdata)
    local view = util.showDialog('Dialog', 'Rank.Rank_0')
    view:setMapID(self.record[self.page].nMapId)
    self.ui.MapPageView:scrollToPage(self.page-1)
end

return Info
