local LogIn = class("LogIn", cc.load("mvc").LayoutBase)
LogIn.RESOURCE_FILENAME = "LogIn.LogIn"

function LogIn:onCreate()
    self:addEvent('NS_GetDayReward')
end

function LogIn:onEnter()

end

function LogIn:onExit()

end

function LogIn:Getday(day)
    self.day = day
    local sign = 1
    local layout = nil
    for i = 1 , 30 do
        local LoginItem = util.createView('LogIn.LoginItem')
        LoginItem:setAnchorPoint(0,0)
        if sign%5 == 1 then
            layout = ccui.Layout:create()
            layout:setAnchorPoint(0,0)
            layout:setTouchEnabled(false)
            layout:setContentSize(self.ui.RewardPanel:getContentSize().width,LoginItem:getContentSize().height)
            self.ui.RewardPanel:add(layout)
        end
        if sign%5 == 1 then
            LoginItem:setAnchorPoint(0,0)
            LoginItem:setPosition(0,0)
        elseif sign%5 == 2 then
            LoginItem:setAnchorPoint(0.25,0)
            LoginItem:setPosition(layout:getContentSize().width/4,0)
        elseif sign%5 == 3 then
            LoginItem:setAnchorPoint(0.5,0)
            LoginItem:setPosition(layout:getContentSize().width/2,0)
        elseif sign%5 == 4 then
            LoginItem:setAnchorPoint(0.75,0)
            LoginItem:setPosition(layout:getContentSize().width*3/4,0)
        else
            LoginItem:setAnchorPoint(1,0)
            LoginItem:setPosition(layout:getContentSize().width,0)
        end
        layout:addChild(LoginItem)
        LoginItem:setkey(i)
        sign = sign + 1
    end
    self.day = day
    if mdt.isPack ~= nil and mdt.isPack == true then
        self.ui.Btnget:onBright(true)
        self.ui.Btnget:onEnabled(true)
    else
        self.ui.Btnget:onBright(false)
        self.ui.Btnget:onEnabled(false)
    end

    self.ui.Title:setString(static.language[20005][device.language])
    self.ui.Btnget:onSetText(static.language[10005][device.language])
    self.ui.Ad.ui.btnText:onReset()
    self.ui.Ad.ui.btnText:onSetAD(1)
--    print(static.days[self.day].isAD)
--    print(os.time().." "..mdt.AdCD[1].." "..static.ad[1].cd)
--    print(os.time().." "..mdt.funCD[3].." "..static.adfunction[3].cd)
--    if static.days[self.day].isAD == 1 and 
--    mdt.AdCD[1] - os.time() <= 0 and
--    mdt.funCD[3] - os.time() <= 0 then
--        self:play("info2")
--    else
        self:play("info1")
--    end
    self.double = 1
end

-- Event for Btnget callback (addClickEventListener)
function LogIn:OnPick(node, eventType, userdata)
    net.msg.NC_GetDayReward(self.day,0)
    mdt.isPack = false
end

function LogIn:NS_GetDayReward(ev,ns)
    if ns.nIsSuccess then
--        event.dispatch('animcomplete')
--        async.create(function()
--            async.waitForEvent('animstop')           
            local reward = static.days[self.day]
            local id = 0 
            if reward.itemType == 1 then
                id = 1
            elseif reward.itemType == 2 then
                id = 2
            elseif reward.itemType == 3 then
                id = reward.itemCode
            elseif reward.itemType == 4 then
                util.closeDialog('LogIn.LogIn')
                return
            elseif reward.itemType == 5 then
                id = 5
            end
            local item = {id=id,num=reward.num*self.double}
            local view = util.showDialog('Dialog2', 'Common.RewardDialog')
            view:setkey(item)
            util.closeDialog('LogIn.LogIn')
--        end)
    end
end

-- Event for BG callback (addClickEventListener)
function LogIn:onClose(node, eventType, userdata)

end

-- Event for Panel_start_1 callback (addClickEventListener)
function LogIn:onAD(node, eventType, userdata)
--    if util.isAndroid() then
--        local luaj = require "cocos.cocos2d.luaj"
--	    local classname = "org/cocos2dx/lua/AppActivity"
--	    local args = {1}
--	    local sigs = "(I)V"

--	    local ok,ret = luaj.callStaticMethod(classname, "PlayAD", args, sigs)

--	    local function WatchAdCallBack(msg)
--            self.double = 2
--            mdt.AdCD[1] = os.time()+static.ad[1].cd*60
--            mdt.funCD[3] = os.time()+static.adfunction[3].cd*60
--		    net.msg.NC_GetDayReward(self.day,1)
--            util.closeDialog('LogIn.LogIn')
--	    end

--	    util.SendLuaFuncID2Java(WatchAdCallBack)

--    else
--        self.double = 2
--        mdt.AdCD[1] = os.time()+static.ad[1].cd*60
--        mdt.funCD[3] = os.time()+static.adfunction[3].cd*60
--		net.msg.NC_GetDayReward(self.day,1)
--        util.closeDialog('LogIn.LogIn')
--    end
end

return LogIn
