local LoginItem = class("LoginItem", cc.load("mvc").LayoutBase)
LoginItem.RESOURCE_FILENAME = "LogIn.LoginItem"

function LoginItem:onCreate()
    self:addEvent('animcomplete')
end

function LoginItem:onEnter()

end

function LoginItem:onExit()

end

function LoginItem:animcomplete()
    if mdt.curday == self.day then
        self.effect:play('qirijiangli')
    end
end

function LoginItem:setkey(day)
    self.day = day
    if mdt.curday == day and mdt.isPack == true then
        self.effect = self:getApp():createView('LogIn.qiri')
        self.effect:setPosition(self.ui.Panel_1:getPositionX()-20,self.ui.Panel_1:getPositionY()-20)
        self.effect:setkey(day)
        self.ui.Panel_1:addChild(self.effect)
        self.effect:play('xunhuan',true)       
    end
    if static.days[day].itemType == 1 then 
        self.ui.Reward:loadTexture("Image/coin.png",0)
        self.ui.Count:setString(static.days[day].num)
    elseif static.days[day].itemType == 2 then 
        self.ui.Reward:loadTexture("Image/Theme0/heart.png",0)
        self.ui.Count:setString(static.days[day].num)
    elseif static.days[day].itemType == 3 then 
        self.ui.Reward:loadTexture(static.shop[static.days[day].itemCode].imageId,0)
        --self.ui.Count:setString(static.days[day].num)
        self.ui.Count:setVisible(false)
    elseif static.days[day].itemType == 4 then 
        self.ui.Reward:loadTexture("Image/donghua/xiang.png",0)
        self.ui.Count:setString(static.days[day].num)
    elseif static.days[day].itemType == 5 then 
        self.ui.Reward:loadTexture("Image/diamond/diamond1.png",0)
        self.ui.Count:setString(static.days[day].num)
    end
    self.ui.Image_6:loadTexture("Image/day/wupin_di.png",0)
    if mdt.curday == day then
        self.ui.Image_6:loadTexture("Image/day/wupin_di1.png",0)
    end
    if mdt.curday > day or mdt.curday == day and mdt.isPack == false then
        self.ui.Pick:setVisible(true)
    end

    self.ui.Text_4:setString(string.format(static.language[30041][device.language],self.day))
end

return LoginItem
