local BottleItem = class("BottleItem", cc.load("mvc").LayoutBase)
BottleItem.RESOURCE_FILENAME = "MsgBoard.BottleItem"

function BottleItem:onCreate()
    self:addEvent('NS_DriftBottleHaveReply')
end

function BottleItem:onEnter()

end

function BottleItem:onExit()

end

function BottleItem:NS_DriftBottleHaveReply(ev,ns)
    if mdt.Replybottle ~= nil then
        for k,v in pairs(mdt.Replybottle) do
            if v == self.data.nId then
                self.ui.redpoint_1:setVisible(true)
            end
        end
    end
end

function BottleItem:setData(data)
    if mdt.Newbottle ~= nil then
        for k,v in pairs(mdt.Newbottle) do
            if v == data.nId then
                self.ui.redpoint_1:setVisible(true)
            end
        end
    end
    if mdt.Replybottle ~= nil then
        for k,v in pairs(mdt.Replybottle) do
            if v == data.nId then
                self.ui.redpoint_1:setVisible(true)
                self.id = v
            end
        end
    end
    self.data = data
    local str = self.data.szTitle
    local a = string.sub(str,0,1)
    if string.byte(a) >= 65 and string.byte(a) <= 90 or string.byte(a) >= 97 and string.byte(a) <= 122 then 
        self.ui.title_0:setString(a)
        self.ui.title:setString(string.sub(str,2,string.len(str)))
    else
        self.ui.title_0:setString('!')
        self.ui.title:setString(str)
    end
    
    local hour = math.floor(data.nLastTime/3600)
    local min = math.floor((data.nLastTime-hour*3600)/60)
    local timetxt = ''
    local hourstr = ''
    local minstr = ''
    if hour >= 10 then
        hourstr = hour
    else
        hourstr = '0'..hour
    end
    if min >= 10 then
        minstr = min
    else
        minstr = '0'..min
    end
    if hour > 0 then
        
        timetxt = hourstr..' : '..minstr
    else
        timetxt = '00 : '..minstr
    end
--    if string.len(self.data.szTitle) <= 39 then
--        self.ui.title:setTextVerticalAlignment(1)
--    else
--        self.ui.title:setTextVerticalAlignment(0)
--    end
    self.ui.time:setString(timetxt)
    self.ui.txtLike:setString(data.nLikeNum)
    self.ui.Head:setInfo(data.nId,data.nPlayerHead,data.nPlayerCountry)
end

-- Event for btnDel callback (addClickEventListener)
function BottleItem:onDel(node, eventType, userdata)
    ctr.player.showMessageBox(static.language[30113][device.language], 2, function(ok)
        if ok then
            net.msg.NC_DeleteAttentionDriftBottle(self.data.nId)
        end
    end)
    
end

-- Event for BG callback (addClickEventListener)
function BottleItem:onClick(node, eventType, userdata)    
    self.ui.redpoint_1:setVisible(false)
    if  mdt.Newbottle ~= nil and self.data.nId ~= nil then
        for k,v in pairs(mdt.Newbottle) do 
            if v == self.data.nId then
                mdt.Newbottle[k]=nil
            end
        end
    end
    if  mdt.Replybottle ~= nil and self.data.nId ~= nil then
        for k,v in pairs(mdt.Replybottle) do 
            if v == self.data.nId then
                mdt.Replybottle[k]=nil
            end
        end
    end
    if  mdt.AllNewbottle ~= nil and self.data.nId ~= nil then
        for k,v in pairs(mdt.AllNewbottle) do 
            if v == self.data.nId then
                table.remove(mdt.AllNewbottle,k)
            end
        end
    end
    event.dispatch('ClosseRedP')
    mdt.curbottleid = self.data.nPlayerId
    net.msg.NC_LoadDriftBottle(self.data.nId)
end

return BottleItem
