local BottleWrite = class("BottleWrite", cc.load("mvc").LayoutBase)
BottleWrite.RESOURCE_FILENAME = "MsgBoard.BottleWrite"

function BottleWrite:onCreate()

end

function BottleWrite:onEnter()
    self.ui.txtContent:setPlaceHolder(static.language[30114][device.language])
    self.ui.txtTitle:setPlaceHolder(static.language[30114][device.language])
    self.ui.ContectTxt:setString(static.language[30065][device.language])
    self.ui.TitleTxt:setString(static.language[30064][device.language])
    self.ui.Name:setString(static.language[30063][device.language])
    self.ui.btnWrite:onSetText(static.language[10009][device.language])
--    self.ui.btnClose:onSetText(static.language[10002][device.language])
    self.lastInput1 = self.ui.txtTitle:getString()
    self.lastInput2 = self.ui.txtContent:getString()
end

function BottleWrite:onExit()

end

-- Event for BG callback (addClickEventListener)
function BottleWrite:onClose(node, eventType, userdata)
--    self.ui.txtContent:setDetachWithIME(false)
--    self.ui.txtTitle:setDetachWithIME(false)
end

-- Event for btnWrite callback (addClickEventListener)
function BottleWrite:onWrite(node, eventType, userdata)
    local title = self.ui.txtTitle:getString()
    local content = self.ui.txtContent:getString()
    if string.len(title)>0 and string.len(content) > 0 then
        net.msg.NC_CreateDriftBottle(title, content)
        sdkManager.talkingdata:setEvent("54",{BottleSendNum = "BottleSendNum"})
        sdkManager.appsflyer:setEvent("54",{BottleSendNum = "BottleSendNum"})
        util.playClose(self)
    else
        ctr.player.showMessageBox(static.language[30156][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

-- Event for txtTitle callback (addEventListener)
function BottleWrite:onCutInput1(node, eventType, userdata)
--    if eventType == 0 then

----        self:changetxt(1)
--    end
    local title = self.ui.txtTitle:getString()
    if string.len(title)>140 then
        self.ui.txtTitle:setText( self.lastInput1 )
    else
        self.lastInput1 = title
    end
end

-- Event for txtContent callback (addEventListener)
function BottleWrite:onCutInput2(node, eventType, userdata)
--    if eventType == 0 then

--        self:changetxt(2)
--    end
    local content = self.ui.txtContent:getString()
    if string.len(content)>300 then
        self.ui.txtContent:setText( self.lastInput2 )
    else
        self.lastInput2 = content
    end
end

function BottleWrite:changetxt(key)
    if key == 1 then
        self.ui.txtTitle:setPlaceHolder('')
        self.ui.txtContent:setPlaceHolder(static.language[30114][device.language])
    else
        self.ui.txtContent:setPlaceHolder('')
        self.ui.txtTitle:setPlaceHolder(static.language[30114][device.language])
    end
end

return BottleWrite
