local RankItem2 = class("RankItem2", cc.load("mvc").LayoutBase)
RankItem2.RESOURCE_FILENAME = "Rank.RankItem2"

function RankItem2:onCreate()

end

function RankItem2:onEnter()
    self.isSelfRank = false
end

function RankItem2:onExit()

end

function RankItem2:setMainInfo(data)
    self.ui.RankIcon:setVisible(false)
    self.ui.Rank:setString(data.ulIndex)
    self.ui.Score:setString(data.nParam1)
    --self.ui.Head:setInfo(data.nPlayerHead,data.nCountry)
    
    self.ui.Head:setInfo(data.nPlayerGuid,data.nPlayerHead,data.nCountry)
    self.ui.PlayerName:setString(data.szName) 
    local countryPic = "Image/country/DEFAULT.png"
    -- if  string.len(data.szCountry) > 0 then
    --     countryPic = "Image/country/"..data.szCountry..".png"
    -- end

--    local _,err = io.open(countryPic,"r+")
--    if err then
--        countryPic = "res/Image/country/DEFAULT.png"
--    else
--        countryPic = "res/Image/country/"..data.szCountry..".png"
--    end
    -- self.ui.Country:loadTexture(countryPic,0)
    -- self.ui.Pic:setInfo(data.nPlayerGuid, data.head_url)
    
    for i = 1, 3 do
        if data.ulIndex == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end

function RankItem2:setRecordMainInfo(data)
    self.ui.RankIcon:setVisible(false)
    self.ui.Head:setInfo(data.nId,data.nHeadIndex,data.nCountryIndex)--国家缺少
    self.ui.Rank:setString(data.nRankIndex)
    self.ui.Score:setString(data.rankValue)
    self.ui.PlayerName:setString(data.szName) 
    local countryPic = "Image/country/DEFAULT.png"
    for i = 1, 3 do
        if data.ulIndex == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end

function RankItem2:setMainInfo1(data,list)
    self.ui.Head:setVisible(false)
    for i=1,#list do
        if list[i].id==data.Country then
            local pic = "res/Image/country/"..list[i].nameID..".png"
            --print("找到图片",pic)
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic)
            self.ui.Image_6:setScale(2)
            self.ui.country:setVisible(true)
            self.ui.country:setString(static.language[100000+tonumber(list[i].id)][device.language])
            break

         else
            local pic1 = "res/Image/country/DEFAULT.png"
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic1)
            self.ui.Image_6:setScale(2)
        end
    end
    if data.gridnum~=nil then
        self.ui.Score:setString(data.gridnum)
    end
    if data.bombnum ~= nil then
        self.ui.Score:setString(data.bombnum)
    end
    self.ui.Rank:setString(data.ranking)
     for i = 1, 3 do
        if data.ranking == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end

function RankItem2:setRecordMainInfo1(data,list)
    self.ui.Head:setVisible(false)
    for i=1,#list do
        if list[i].id==tonumber(data.nId.a) then
            local pic = "res/Image/country/"..list[i].nameID..".png"
            --print("找到图片",pic)
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic)
            self.ui.country:setVisible(true)
            self.ui.country:setString(static.language[100000+tonumber(list[i].id)][device.language])
            self.ui.Image_6:setScale(2)
            break
        else
            local pic1 = "res/Image/country/DEFAULT.png"
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic1)
            self.ui.Image_6:setScale(2)
        end


    end
     
    self.ui.Rank:setString(data.nRankIndex)
    if data.rankValue~=nil then
        self.ui.Score:setString(data.rankValue)
    end
     for i = 1, 3 do
        if data.nRankIndex == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end

function RankItem2:setMainInfo2(data)
     self.ui.RankIcon:setVisible(false)
    self.ui.Rank:setString(data.nRank)
    self.ui.Score:setString(data.nScore)
    self.ui.PlayerName:setString(data.szPlayerName) 
    local countryPic = "Image/country/DEFAULT.png"
    for i = 1, 3 do
        if data.ulIndex == i or data.nRank == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end

function RankItem2:setMainInfo3(data,list)
    --print("进入新国家排行！")
     self.ui.Head:setVisible(false)
    for i=1,#list do
        if list[i].id==data.nPlayerId.a then
            local pic = "res/Image/country/"..list[i].nameID..".png"
            --print("找到图片",pic)
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic)
            self.ui.Image_6:setScale(2)
            break
        else
            local pic1 = "res/Image/country/DEFAULT.png"
            self.ui.Image_6:setVisible(true)
            self.ui.Image_6:loadTexture(pic1)
            self.ui.Image_6:setScale(2)
        end


    end
     
    self.ui.Rank:setString(data.nRank)
    if data.gridnum~=nil then
        self.ui.Score:setString(data.gridnum)
    end
    if data.bombnum ~= nil then
        self.ui.Score:setString(data.bombnum)
    end
    if data.nScore ~= nil then
        self.ui.Score:setString(data.nScore)
    end
     for i = 1, 3 do
        if data.nRank == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
end


function RankItem2:loadRankTextureI(i)
    local path = "Image/rankbottom"..i..".png"
    self.ui.Image_8:loadTexture(path, 0) 
end

function RankItem2:setSelfSpecial()
    self.isSelfRank = true
end

return RankItem2
