local RankSelf = class("RankSelf", cc.load("mvc").LayoutBase)
RankSelf.RESOURCE_FILENAME = "Rank.RankSelf"

function RankSelf:onCreate()
    self.m_isSettingData = false
end

function RankSelf:onEnter()

end

function RankSelf:onExit()

end

function RankSelf:clear()
    self.m_isSettingData = false
end

function RankSelf:setOwnInfo(data)
    if self.m_isSettingData then return end

    self.m_isSettingData = true
    if data.nOwnRank ~= 0 then
        self.ui.Rank:setString(data.nOwnRank)
    else
        self.ui.Rank:setString(static.language[30132][device.language])--static.language[30132][device.language]
    end
    self.ui.Score:setString(data.nOwnParam1)
    self.ui.Head:setInfo(data.nGUID,data.nHeadUrl,data.nOwnCountry)
    local countryPic = "Image/country/DEFAULT.png"
    if  data.nOwnCountry then
        countryPic = "Image/country/"..data.nOwnCountry..".png"
    end
--    local _,err = io.open(countryPic,"r+")
--    if err then
--        countryPic = "Image/country/DEFAULT.png"
--    else
--        countryPic = "Image/country/"..data.nOwnCountry..".png"
--    end
    --self.ui.Head.Country:loadTexture(countryPic,0)
    --self.ui.Pic:setInfo(data.nPlayerGuid, data.head_url)
    self.ui.RankIcon:setVisible(false)
    for i = 1, 3 do
        if tonumber(data.nOwnRank) == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
    self.ui.PlayerName:setString(mdt.player.sMineMapData.szName)
end

function RankSelf:setRecordOwnInfo(data)
    if self.m_isSettingData then return end

    self.m_isSettingData = true
    if data.nOwnRank ~= 0 then
        self.ui.Rank:setString(data.nRankIndex)
    else
        self.ui.Rank:setString(static.language[30132][device.language])--static.language[30132][device.language]
    end
    self.ui.Score:setString(data.rankValue)
    self.ui.Head:setInfo(data.nGUID,data.nHeadIndex,data.nCountryIndex)
    local countryPic = "Image/country/DEFAULT.png"
    if  data.nOwnCountry then
        countryPic = "Image/country/"..data.nOwnCountry..".png"
    end
    self.ui.RankIcon:setVisible(false)
    for i = 1, 3 do
        if tonumber(data.nOwnRank) == i then
            local path = "Image/medal"..i..".png"
            self.ui.RankIcon:setTexture(path)
            self.ui.RankIcon:setVisible(true)
            self.ui.Rank:setString("")
        end
    end
    self.ui.PlayerName:setString(mdt.player.sMineMapData.szName)
end

return RankSelf
