local CoinItem = class("CoinItem", cc.load("mvc").LayoutBase)
CoinItem.RESOURCE_FILENAME = "Recharge.CoinItem"
CoinItem.DiamondView=1
CoinItem.GoldView=2
CoinItem["menuType"]=nil
function CoinItem:onCreate()
    self:addEvent('NS_DiamondExchangeMoney')
end

function CoinItem:onEnter()
    self.isBuy=false
end

function CoinItem:onExit()

end

function CoinItem:setkey(id)
    self.item = id
    if self.item.code>= 45000   then       --钻石买金币赋值
        self.ui.Coin:loadTexture(self.item.imageId)
        self.ui.minicoin:loadTexture("Image/coin.png") 
        self.ui.Sprite_5:setTexture("Image/coin.png") 
        self.ui.Num:setString(self.item.getNum)
        self.ui.Button1:onSetText("    "..self.item.cost)
--        self.ui.diamond:setTexture("Image/Diamond.png")
        self.menuType=CoinItem.GoldView
        self.ui.Image_11:setVisible(self.item.isHot == 1)
    else  
        self.ui.Coin:loadTexture(self.item.imageId)
        self.ui.minicoin:loadTexture("Image/Diamond.png") 
        self.ui.Sprite_5:setTexture("Image/Diamond.png") 
        self.ui.Num:setString(self.item.getNum)
        self.ui.Button1:onImageHide()
--            self.ui.diamond.ui.btnText:onReset()
        if static.isHaiWai then
            self.ui.Button1:onSetText('$ '..self.item.cost)
        else
            self.ui.Button1:onSetText('¥ '..self.item.cost)
        end
--        self.ui.diamond:setVisible(false)
        self.menuType=CoinItem.DiamondView
        self.ui.Image_11:setVisible(self.item.isHot == 1)

    end
end
function CoinItem:NS_DiamondExchangeMoney(ev,ns)
    if(ns.nErrorCode==0)  then
        if self.isBuy == true then
            event.dispatch('OnRefreshGoldOrDiamondRecharge')
            self.isBuy = false
            sdkManager.talkingdata:setEvent("38",{GoldBuy = "GoldBuy"..self.item.cost})
            sdkManager.appsflyer:setEvent("38",{GoldBuy = "GoldBuy"..self.item.cost})
        end
    end
end

-- Event for Panel_Buy callback (addClickEventListener)
function CoinItem:OnBuy(node, eventType, userdata)
    if self.menuType==CoinItem.DiamondView then
      mdt.payinfo = {}
		if util.isIOS() then
            
            local orderId = string.format("%s-%s-%d",mdt.player.nGUID.a,self.item.iapId,os.time())
            sdkManager.talkingdata:setPay(orderId) 
            mdt.payinfo['payid'] = orderId
            mdt.payinfo['price'] = self.item.cost
            mdt.payinfo['iapid'] = self.item.iapId
            local tab = {productId = self.item.iapId,Serverid = static.SERVER_LIST[mdlogin.getCurLoginServerID()].serverid,roleid = mdt.accountid, extraData='{serverId:'..mdlogin.getLastlistServerID()..'}'}
            dump(tab)
            if static.isHaiWai then
                sdkManager.locojoybj:Pay(tab)
            else
                ctr.player.showWaiting()
                local price = self.item.cost
                sdkManager.talkingdata:setPay(orderId,self.item.iapId,price)
                sdkManager.talkingdata:setPay("Sandbox-"..orderId,self.item.iapId,price)
                print("--------->>",self.item.iapId)
                sdkManager.applepay:pay(self.item.iapId,function(isSuccess,info)
                    if true == isSuccess then
                        ctr.player.doValidateOrder(info)
                        local Sandbox = ""
                        if string.find(info,"Sandbox") then
                            Sandbox = "Sandbox"
                            orderId = string.format("%s-%s",Sandbox,orderId)
                        end
                        sdkManager.talkingdata:setPaySuccess(orderId)
                        sdkManager.talkingdata:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..price})
                        sdkManager.appsflyer:setEvent("39",{DiamondBuy = 'Sandbox'.."DiamondBuy"..price})
                        sdkManager.appsflyer:setPaySuccess(orderId,self.item.iapId,price)
                        if not static.isHaiWai then
                            local data = {}
                            data['account'] = tostring(mdt.player.nGUID.a)
                            data['orderId'] = self.item.iapId
                            data['amount'] = price
                            if static.isHaiWai then
                                data['currencyType'] = 'USD'
                            else
                                data['currencyType'] = 'CNY'
                            end                       
                            data['payType'] = 'Apple Pay'
                            sdkManager.tdadtracking:setpay(data)
                        end
                    else
--                        ctr.player.showMessageBox(string.format(static.language[30150][device.language],info),1,function()
--                        -- body
--                        end)
                    end
                    print("支付状态:",isSuccess,orderId)
                    ctr.player.hideWaiting()
                end)
            end
            --北京SDK支付成功之后调用
            --sdkManager.talkingdata:setPaySuccess(orderId) 
        elseif util.isAndroid() then
            local orderId = string.format("%s-%s-%d",mdt.player.nGUID.a,self.item.iapId,os.time())
            local price = self.item.cost
            sdkManager.talkingdata:setPay(orderId, self.item.iapId, price)

            -- local param = {["sku"] = self.item.iapId}
            -- local args={json.encode(param)}
            mdt.payinfo['payid'] = orderId
            mdt.payinfo['price'] = self.item.cost
            mdt.payinfo['iapid'] = self.item.iapId

            if static.isHaiWai then
                sdkManager.locojoybj:Pay({sku = self.item.iapId, serverid = static.SERVER_LIST[mdlogin.getCurLoginServerID()].serverid, gameServer = mdlogin.getLastlistServerID()})
            elseif mdt.player.loginType == 6 then
                print("UCCCCCCCCCCCCCC")
                -- --ypn修改SDK
                -- local dialog = util.showDialog(nil, "Common.RechargeType")
                -- dialog:setData(self.item)
                -- --
                 --local ip = http://127.0.0.1:8080/MineShareServer/UcPayChargeSign?serverId=1&playerId=1111&productId=safsdf&amount=2&accountId=2222
                 local serverId = mdr.lastServer
                 local playerId = mdt.player.nGUID.a
                 local productId = self.item.iapId
                -- local amount = "0.01"
                 local amount = self.item.cost
                 local accountId = mdt.player.accountId
                 -- local ip = "http://127.0.0.1:8080/MineShareServer/UcPayChargeSign?serverId="..serverId.."&playerId="..playerId.."&productId="..productId.."&amount="..amount.."&accountId="..accountId
                 -- print("UCCCCCCCCCCCCCC"..ip)
                 -- local url = ""
                 local ip = "http://103.36.31.24:8080/MineShareServer/UcPayChargeSign?"
                 local url = "serverId="..serverId.."&playerId="..playerId.."&productId="..productId.."&amount="..amount.."&accountId="..accountId
                 print("UCCCCCCCCCCCCCC"..ip..url)
                  util.HttpManagerPOST(ip, url, function (result)
                        dump()
                        local callBackInfo = result["callbackInfo"]
                       local signType = result["signType"]
                       local sign = result["sign"]
                       local amount = result["amount"]
                       local accountId = result["accountId"]
                        local notifyUrl = result["notifyUrl"]
                        local cpOrderId = result["cpOrderId"]
                        sdkManager.uc:setPay(amount,notifyUrl,cpOrderId,accountId,signType,sign,callBackInfo)
                        print("收到服务器的了!!"..amount.."================"..notifyUrl)


                    end)
            else
                print("Huawei!!!!!!Pay!!!!",dump(self.item))
                local serverId = mdr.lastServer
                 local playerId = mdt.player.nGUID.a
                 local productId = self.item.iapId
                 -- local amount = self.item.cost
                 -- local accountId = mdt.player.accountId
                 -- local ip = "http://127.0.0.1:8080/MineShareServer/UcPayChargeSign?serverId="..serverId.."&playerId="..playerId.."&productId="..productId.."&amount="..amount.."&accountId="..accountId
                 -- print("UCCCCCCCCCCCCCC"..ip)
                 -- local url = ""
                 local ip = "http://103.36.31.24:8080/MineShareServer/HuaweiPayGenerateOrderId?"
                 local url = "serverId="..serverId.."&playerId="..playerId.."&productId="..productId
                 print("Huawei"..ip..url)
                  util.HttpManagerPOST(ip, url, function (result)
                        dump()
                       local orderId = result["orderId"]
                       local productId = result["productId"]
                       -- local amount = result["amount"]
                       -- local accountId = result["accountId"]
                       --  local notifyUrl = result["notifyUrl"]
                       --  local cpOrderId = result["cpOrderId"]
                       local amount = self.item.cost
                       local productName = self.item.name
                       local productDesc = self.item.iapName 
                       print("Huawei222"..amount..productName..productDesc)
                        sdkManager.huawei:setPay(orderId,amount,productName,productDesc)
                       -- print("收到服务器的了!!"..amount.."================"..notifyUrl)


                    end)
            end
		end

        
    else
        self.isBuy = true
        if tonumber(self.item.cost) > mdt.player.diamond then
            util.showDialog('Dialog3','Common.NotEnough'):setkey(3,true) 
        else  
            local view = util.showDialog(nil, 'Common.ConfirmDialog')
            view:setkey(
            self.item.cost,
            function()
                net.msg.NC_DiamondExchangeMoney(self.item.code)
            end ,
            3,30010)
        end
    end
end

-- Event for Panel callback (addClickEventListener)
function CoinItem:onBuy(node, eventType, userdata)

end
return CoinItem
