local Recharge = class("Recharge", cc.load("mvc").LayoutBase)
Recharge.RESOURCE_FILENAME = "Recharge.Recharge"
local Btnlist = {'FlagButton','FrameButton'}
Recharge.Flag = 1
Recharge.Frame = 2
function Recharge:onCreate()
    self:addEvent('SetChangeType1')
    self:addEvent('OnRefreshGoldOrDiamondRecharge')
end

function Recharge:onEnter()
    self:loadShopUI()
    self:loadShopData(1)
    self:setBtnState(1)
    self:doRequestProducts()
    self:doQuery()
    self.ui.FlagButton:setTouchEnabled(false)
    self.ui.FrameButton:setTouchEnabled(true)
end

function Recharge:doQuery()


    if util.isAndroid() then
        sdkManager.locojoybj:QUERY()
    end


    -- local function loginCallback(session)
    --     print("GET SESSION BY JAVA TO CONNET SETVER")
    --     mdt.session = session

    --     ctr.login.connect()
    -- end
end

function Recharge:onExit()

end

-- Event for btnClose callback (addClickEventListener)
function Recharge:onClose(node, eventType, userdata)
    util.closeDialog('Recharge.Recharge')
end

-- Event for Image_2_0 callback (addClickEventListener)
function Recharge:OnBuyHeart(node, eventType, userdata)

end

-- Event for Panel_3 callback (addClickEventListener)
function Recharge:onCharge(node, eventType, userdata)

end

-- Event for Panel_BuyCoin callback (addClickEventListener)
function Recharge:OnClickCharge(node, eventType, userdata)

end
function Recharge:chooseMode(id)
    self:loadShopUI()
    self:loadShopData(id)
end
function Recharge:OnChangeType(node, eventType, userdata)
    -- self.ui.Panel_Hide:setVisible(true)
--print("发事件了！",userdata)
    event.dispatch('SetChangeType1',userdata)
end
function Recharge:OnRefreshGoldOrDiamondRecharge()
    self.ui.Coin:setString(mdt.player.gold)
    self.ui.life:setString(mdt.player.diamond)
end
function Recharge:loadShopUI()
--    self.ui.FlagTxt:setString(static.language[30066][device.language])
--    self.ui.FrameTxt:setString(static.language[30067][device.language])

--    self.ui.FlagTxt:setString(static.language[30069][device.language])
--    self.ui.FrameTxt:setString(static.language[30120][device.language])

    self.ui.FlagButton:setTitleText(static.language[30069][device.language])
    self.ui.FrameButton:setTitleText(static.language[30120][device.language])
end
function Recharge:loadShopData(id)
    self.Coin=mdt.player.gold
    self.ui.Coin:setString(self.Coin)
    self.Diamond=mdt.player.diamond
    self.ui.life:setString(self.Diamond)
    self.ui.PvpCoin:setString(mdt.mypvpcoin)
    self.curMoneyList={}
    self.curMoneyList=static.money
    self.curDiamondList={}

    local dataType = 1

    if util.isIOS() then
        if static.isHaiWai then
            dataType = 2  --apple
        else
            dataType = 1  --gn apple
        end
    elseif util.isAndroid() then
        if static.isHaiWai then
            dataType = 3  --google
        else
            dataType = 1  --wx zfb
        end
    end

    print("datatype = " .. dataType)

    
    for i=1,#static.diamond do
        if static.diamond[i].type == dataType then
            table.insert(self.curDiamondList, static.diamond[i])
        end
    end 
    --self:OnChangeType(nil,nil,1)
    self:SetChangeType1(nil,id)
end
function Recharge:SetChangeType1(ev,userdata)
    self.ui.FlagButton:setTouchEnabled(tonumber(userdata)==2)
    self.ui.FrameButton:setTouchEnabled(tonumber(userdata)==1)
    if tonumber(userdata)~= nil then
        self:setBtnState(tonumber(userdata))
    end
    if tonumber(userdata) == Recharge.Frame then
        self:OnRefreshDiamond(self.curMoneyList)
        self.ui.FrameButton:setLocalZOrder(100)
        self.ui.FlagButton:setLocalZOrder(50)
    elseif tonumber(userdata) == Recharge.Flag then
        self:OnRefreshDiamond(self.curDiamondList) 
        self.ui.FrameButton:setLocalZOrder(50)
        self.ui.FlagButton:setLocalZOrder(100)
    end
    self.ui.ShopItemList:jumpToPercentVertical(0)  
end
function Recharge:OnRefreshDiamond(list)
    print("刷新钻石,参数接受者:Shop.SkinItem")
    self.ui.ShopItemList:setVisible(true)
    self.ui.ShopItemList:removeAllChildren()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    local layout = nil
    local sign = 1
    for i=1 , #list do
        if list[i].getType == nil or list[i].getType == 1 then
            local DiamondItem = util.createView('Recharge.CoinItem')
            DiamondItem:setAnchorPoint(0,0)
            if sign%2 == 1 then
                layout = ccui.Layout:create()
                 -- local  layout1 = ccui.LayoutComponent:bindLayoutComponent(layout)
                 --            layout1:setPositionPercentXEnabled(true)
                 --            layout1:setPercentWidthEnabled(true)
                 --            layout1:setPercentHeightEnabled(true)
                 --            layout1:setPercentWidth(1.0000)
                 --            layout1:setPercentHeight(1.0000)
                 --            layout1:setSize({width = 450.0000, height = 100.0000})
                layout:setAnchorPoint(0,0)
                layout:setTouchEnabled(false)
                layout:setContentSize(self.ui.ShopItemList:getContentSize().width,DiamondItem:getContentSize().height+50)
                self.ui.ShopItemList:addChild(layout)
            end
            --print("宽度：",self.ui.ShopItemList:getContentSize().width)

            if sign%2 == 1 then
                DiamondItem:setAnchorPoint(0.5,0)
                DiamondItem:setPosition(layout:getContentSize().width/4,0)
            -- elseif sign%3 == 2 then
            --     DiamondItem:setAnchorPoint(0.5,0)
            --     DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width/2,0)
    --        elseif sign%4 == 3 then
    --            Flagitem:setAnchorPoint(0.67,0)
    --            Flagitem:setPosition(layout:getContentSize().width*2/3,0)
            else
                DiamondItem:setAnchorPoint(0.5,0)
                DiamondItem:setPosition(layout:getContentSize().width*3/4,0)
            end
            -- ccui.Helper:doLayout(DiamondItem)
            layout:addChild(DiamondItem)
            --print(self.ui.ShopItemList:getChildName())
            --self.ui.TableView1:addChild(DiamondItem)
            DiamondItem:setkey(list[i])
            sign = sign + 1
        end
    end

end
function Recharge:setBtnState(idx)
    -- self.ui.FlagButton:setContentSize({width = 362, height =124})
    -- self.ui.FrameButton:setContentSize({width = 362, height =124})
    -- self.ui.FlagButton:setScale(0.55)
    -- self.ui.FrameButton:setScale(0.55)

    for i = 1,#Btnlist do
        if i == idx then
            self.ui[Btnlist[i]]:setBright(false)
            self.ui[Btnlist[i]]:setTitleColor({r = 0, g = 0, b = 0})
            self.ui[Btnlist[i]]:setTitleFontSize(56)
        else 
            self.ui[Btnlist[i]]:setBright(true)
            self.ui[Btnlist[i]]:setTitleColor({r = 218, g = 218, b = 218})
            self.ui[Btnlist[i]]:setTitleFontSize(44)
        end
    end
end

function Recharge:doRequestProducts()
    -- if util.isIOS() then  --TODO 整体操作前置，防止因网络原因造成购买异常
    --     if false == sdkManager.applepay:isRequestedProducts() then
    --         local productsList = {}
    --         for k,v in pairs(static.diamond) do
    --             if v.type == 2 then --type=1 已经废弃
    --                 table.insert(productsList,v.iapId)
    --             end
    --         end
    --         -- ctr.player.showWaiting()
    --         sdkManager.applepay:requestProducts(productsList,function (isSuccess)
    --             -- ctr.player.hideWaiting()
    --         end)
    --     end
    -- end
end

-- Event for Panel_Coin callback (addClickEventListener)
function Recharge:OnTip(node, eventType, userdata)
    if eventType < 2 then
        if self.CoinTip==nil then
            self.CoinTip = self:getApp():createView('Common.CoinTip')
            self.CoinTip:setPosition({x=node:getPositionX()-self.CoinTip:getContentSize().width*userdata-(userdata-1)*self.ui.Image_1:getContentSize().width,y=node:getPositionY()-node:getContentSize().height*2-self.CoinTip:getContentSize().height})
            node:addChild(self.CoinTip)
            self.CoinTip:setTxt(tonumber(userdata))
        end
    else
        if self.CoinTip~=nil then
            node:removeChild(self.CoinTip)
            self.CoinTip=nil
        end
    end
end

return Recharge
