local CountryDialog = class("CountryDialog", cc.load("mvc").ViewBase)
CountryDialog.RESOURCE_FILENAME = "Setting.CountryDialog"

local ContinentTab = {}

function CountryDialog:onCreate()
    self:addEvent('setSeleteContinent')
    self:addEvent('setSeleteCountry')
    self:addEvent('NS_ChangeNationality')
end

function CountryDialog:onEnter()
    self.ui.ListCountry:setVisible(true)
    self.ui.ListContinue:setVisible(true)
    self.ui.ContinentTxt:setString(static.language[30219][device.language])
    self.ui.CountryTxt:setString(static.language[30220][device.language])
    self.ui.Buy:setString(static.language[30226][device.language])
    self.ui.Text_54:setString(static.language[30221][device.language])
    self.ui.Text_54:setVisible(false)
    self.ui.Text_3:setString(static.language[30222][device.language])
    self.SeleteContinent = 0
    self.SeleteCountry = mdt.player.country
    if self.SeleteCountry == 0 then
        
    else
        self.ui.CountryTxt:setString(static.language[100000+tonumber(self.SeleteCountry)][device.language])
    end
    self.ui.Yes:onBright(false)
    self.ui.Yes:onEnabled(false)
    for _,v in pairs(static.country) do
        if v.State ~= 99 then
            if ContinentTab[v.State] == nil then
                ContinentTab[v.State] = {}
            end
            ContinentTab[v.State][#ContinentTab[v.State]+1] = v
            if self.SeleteCountry ~= 0 and self.SeleteCountry == v.id then
                self.SeleteContinent = v.State
            end
        end
    end
    if self.SeleteContinent == 0 then
--        self.ui.Country:loadTexture('Image/newUI/button_ad3.png',0)
--        self.ui.Country:setTouchEnabled(false)
    else
        self.ui.ContinentTxt:setString(static.language[110000+tonumber(self.SeleteContinent)][device.language])
    end
    if mdt.ChangeNationalityNum == 0 then
        self.ui.Yes.ui.btnText:onReset()
        self.ui.Yes:onSetText(static.language[10001][device.language])
        self.ui.Text_mianfei:setVisible(true)
        self.ui.Text_mianfei:setString(static.language[30099][device.language])
    else
        self.ui.Text_mianfei:setVisible(false)
        self.ui.Yes.ui.btnText:onReset()
        self.ui.Yes.ui.btnText:onSetBuyLifetype("Image/Diamond.png",100)
    end
    self.isshowcontinent = false
    self.isshowcountry = false
end

function CountryDialog:onExit()

end

-- Event for ButtonYes callback (addClickEventListener)
function CountryDialog:OnClick(node, eventType, userdata)
    if tonumber(userdata) == 1 then
        local title = static.language[30218][device.language]
        ctr.player.showMessageBox(title, 2, function(ret)
            if ret then
                print(mdt.player.country,self.SeleteCountry)
                net.msg.NC_ChangeNationality(mdt.player.country,self.SeleteCountry)
                
            end
        end)
    else
        util.closeDialog('Setting.CountryDialog')
    end
end

function CountryDialog:NS_ChangeNationality(ev,ns)
    if ns.nErrorCode == 1 or ns.nErrorCode == 2 then
        mdt.player.country = ns.NewCountry
        mdt.ChangeNationalityNum = mdt.ChangeNationalityNum + 1
        util.closeDialog('Setting.CountryDialog')
    elseif ns.nErrorCode == 3 then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(3,true)
    else
        print('޸ʧ')
    end
end

-- Event for Continent callback (addClickEventListener)
function CountryDialog:OnSelete(node, eventType, userdata)
    if tonumber(userdata) == 1 then
        self.ui.ListContinue:play('listShow',false)
        if self.isshowcountry then
            self.ui.ListCountry:play('listClose',false)
        end
        self.ui.Panel_14:setVisible(false)
        self.ui.Image_21:setVisible(false)
        self.ui.Panel_16:setVisible(true)
        self.ui.Text_54:setVisible(false)
        self:RefreshContenentList()
        self.isshowcontinent = true
        self.isshowcountry = false
    else
        self.ui.Text_54:setVisible(false)
        self.ui.Image_4:setVisible(false)
        self.ui.Panel_14:setVisible(true)
        self.ui.ListCountry:play('listShow',false)   
        if self.isshowcontinent then
            self.ui.ListContinue:play('listClose',false)
        end     
        self.ui.Panel_16:setVisible(false)
        self:RefreshListCountry()
        self.isshowcontinent = false
        self.isshowcountry = true
    end
end

function CountryDialog:RefreshContenentList()
    self.ui.ListContinue.ui.ContinentList:removeAllChildren()
    self.ui.ListContinue.ui.ContinentList:setScrollBarEnabled(false)
    local view = nil
    for k,_ in pairs(ContinentTab) do
        view = util.createView('Setting.CountryItem')
        view:setContinent(k,self.SeleteContinent)
        self.ui.ListContinue.ui.ContinentList:pushBackCustomItem(view)
    end
end

function CountryDialog:RefreshListCountry()
    self.ui.ListCountry.ui.CountryList:removeAllChildren()
    if self.SeleteContinent ~= 0 then
        self.ui.ListCountry.ui.CountryList:setScrollBarEnabled(false)
        for _,v in pairs(ContinentTab[self.SeleteContinent]) do
            local view = util.createView('Setting.CountryItem2')
            view:setCountry(v.id,self.SeleteCountry)
            self.ui.ListCountry.ui.CountryList:pushBackCustomItem(view)
        end
    else
        self.ui.Text_54:setVisible(true)
    end
end

function CountryDialog:setSeleteContinent(ev,id)
    self.ui.ListContinue:play('listClose',false)
    self.isshowcontinent = false
    self.ui.Panel_14:setVisible(true)
    self.ui.ContinentTxt:setString(static.language[110000+tonumber(id)][device.language])
    self.SeleteContinent = id
    self.SeleteCountry = 0
    self.ui.CountryTxt:setString(static.language[30220][device.language])
    self.ui.Yes:onBright(false)
    self.ui.Yes:onEnabled(false)
end

function CountryDialog:setSeleteCountry(ev,id)
    self.ui.ListCountry:play('listClose',false)
    self.isshowcountry = false
    self.ui.Panel_16:setVisible(true)
    self.ui.Text_54:setVisible(false)
    self.ui.CountryTxt:setString(static.language[100000+tonumber(id)][device.language])
    self.SeleteCountry = id
    if self.SeleteCountry ~= 0 and self.SeleteCountry ~= mdt.player.country then
        self.ui.Yes:onBright(true)
        self.ui.Yes:onEnabled(true)
    else
        self.ui.Yes:onBright(false)
        self.ui.Yes:onEnabled(false)
    end
end

-- Event for Panel_15 callback (addClickEventListener)
function CountryDialog:OnClickPanel(node, eventType, userdata)
    if self.isshowcontinent then
        self.ui.ListContinue:play('listClose',false)
    end
    if self.isshowcountry then
        self.ui.ListCountry:play('listClose',false)
    end
    self.isshowcontinent = false
    self.isshowcountry = false
    self.ui.Panel_14:setVisible(true)
    self.ui.Panel_16:setVisible(true)
    self.ui.Text_54:setVisible(false)
end

-- Event for bg callback (addClickEventListener)
function CountryDialog:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function CountryDialog:onOK(node, eventType, userdata)

end

return CountryDialog
