local Shop = class("Shop", cc.load("mvc").LayoutBase)
Shop.RESOURCE_FILENAME = "Shop.Shop"

--Shop.Theme = 1
Shop.Flag = 1
Shop.Frame = 2
Shop.Item = 4
--Shop.Diamond = 4
Shop.ShopMode=1
Shop.SkinMode=2
Shop["curLevel"]=1
local itemlist = {}
local Btnlist = {'FlagButton','FrameButton','ExtraButton','ItemButton'}

function Shop:onCreate()
    -- self:addEvent('NS_LoadShop')
    -- self:addEvent('NS_LoadTopUp')
    -- self:addEvent('NS_BuyItem')
    -- self:addEvent('NS_BuyLife')
    -- self:addEvent('NS_UpdateLife')
    -- self:addEvent('NS_ExceteTopUp')
     self:addEvent('SetChangeType')
     self:addEvent('NS_ShopItemLevelUp')
     self:addEvent('OnRefreshGoldOrDiamond')
     self:addEvent("OnRefreshGoldOrDiamondRecharge")
     --self:addEvent('NS_DiamondExchangeMoney')
    -- self:addEvent('OnbtnForbid')
    -- self:addEvent('NS_GoogleRechargeComplete')
    self:addEvent('NS_RequestAllShopItem')
end
function Shop:onEnter()

    self.curtype = Shop.Flag
    self.topupready = true
    net.msg.NC_RequestAllShopItem()
    self:loadSkinUI()
    --self:loadSkinData()
    self:setBtnState(1)
    self:OnRefreshGoldOrDiamond()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    self.ui.Name:setString(static.language[20006][device.language])
    self.length = 0
    self.ui.Panel_Hide:setVisible(true)
    self.ui.FlagButton:setLocalZOrder(100)
    self.ui.ItemButton:setVisible(true)
    self.ui.FlagButton:setTouchEnabled(false)
    self.ui.FrameButton:setTouchEnabled(true)
    self.ui.ItemButton:setTouchEnabled(true)
end

function Shop:loadShopData()
    self.Coin=mdt.player.gold
    self.ui.Coin:setString(self.Coin)
    self.Diamond=mdt.player.diamond
    self.ui.life:setString(self.Diamond)
    self.curMoneyList={}
    self.curMoneyList=static.money
    --dump(self.curMoneyList)
    self.curDiamondList={}
    
        for i=1,#static.diamond do
            if static.diamond[i].type == 2   then
                --self.curDiamondList=static.diamond[k]
                table.insert(self.curDiamondList,static.diamond[i])
            end 
        end 
    self:OnChangeType(nil,nil,1)
end

function Shop:NS_ShopItemLevelUp(ev,ns)
    if ns.nErrorCode == 0 then
        table.insert(self.curOwnAllList,mdt.updataid)
        self:loadSkinData()
        self:OnRefreshSkin(self.curSkinqiList,self.curOwnAllList,1)
        self:OnRefreshGoldOrDiamond()
    else
        print('Updata error!ID='..ns.nErrorCode)
    end
end

function Shop:loadSkinData()
    self.curSkinAllList=static.shop
    self.curSkinqiList={}
    self.curSkincursorList={}
    self.curSkinthemeList={}
    self.curItemList = {}
    for i=1,#static.shop do
        if static.shop[i].itemCode <=19999  then
            for j=1,#static.item do
                if static.item[j].id == static.shop[i].itemCode then
                    if static.item[j].beforeID <=0 then
                        table.insert(self.curSkinqiList,static.shop[i])
                    else
                        for x=1,#self.curOwnAllList do
                            if static.shop[i].itemCode == self.curOwnAllList[x] then
                                table.insert(self.curSkinqiList,static.shop[i])
                                break
                            end
                        end
                    end
                end
            end
        elseif static.shop[i].itemCode <=29999 then
            table.insert(self.curSkincursorList,static.shop[i])
        elseif static.shop[i].itemCode <=39999 then
            table.insert(self.curSkinthemeList,static.shop[i])
        elseif static.shop[i].itemCode <=59999 and static.shop[i].itemCode >= 50000 then
            table.insert(self.curItemList,static.shop[i])
        end
    end
    print("QI表为：",self.curSkinqiList)
end
function Shop:loadSkinUI()
--    self.ui.FlagTxt:setString(static.language[30066][device.language])
--    self.ui.FrameTxt:setString(static.language[30067][device.language])
    self.ui.FlagButton:setTitleText(static.language[30066][device.language])
    self.ui.FrameButton:setTitleText(static.language[30067][device.language])
    self.ui.ExtraButton:setTitleText(static.language[30068][device.language])
    self.ui.ItemButton:setTitleText(static.language[30208][device.language])
end
function Shop:loadShopUI()
--    self.ui.FlagTxt:setString(static.language[30066][device.language])
    self.ui.FlagButton:setTitleText(static.language[30066][device.language])
--    self.ui.FrameTxt:setString(static.language[30067][device.language])
    self.ui.FrameButton:setTitleText(static.language[30067][device.language])
    self.ui.ExtraButton:setVisible(false)
end
function Shop:chooseMode(id)
    if(tonumber(id)==1) then
        self.curMode=Shop.ShopMode
        --self:loadShopData()
        self:loadShopUI()
    else
        self.curMode=Shop.SkinMode
        self:loadSkinUI()
        --self:loadSkinData()
    end
    print("选择商店/皮肤模式",self.curMode)
end
function Shop:setBtnState(idx)
    
    for i = 1,#Btnlist do
        if i == idx then
            self.ui[Btnlist[i]]:setBright(false)
            self.ui[Btnlist[i]]:setTitleColor({r = 0, g = 0, b = 0})
            self.ui[Btnlist[i]]:setTitleFontSize(56)
        else 
            self.ui[Btnlist[i]]:setBright(true)
            self.ui[Btnlist[i]]:setTitleColor({r = 218, g = 218, b = 218})
            self.ui[Btnlist[i]]:setTitleFontSize(44)
        end
    end
end

function Shop:onExit()
end
function Shop:OnRefreshGoldOrDiamond()
    self.ui.Coin:setString(mdt.player.gold)
    self.ui.life:setString(mdt.player.diamond)
    self.ui.PvpCoin:setString(mdt.mypvpcoin)
end
function Shop:OnRefreshGoldOrDiamondRecharge(env,ns)
    self:OnRefreshGoldOrDiamond()
end
function Shop:OnChangeType(node, eventType, userdata)
    self.ui.FlagButton:setTouchEnabled(tonumber(userdata)~=1)
    self.ui.FrameButton:setTouchEnabled(tonumber(userdata)~=2)
    self.ui.ItemButton:setTouchEnabled(tonumber(userdata)~=4)
    self:SetChangeType(nil,userdata)
end
function Shop:NS_RequestAllShopItem(ev,ns)
    local list = {}
    for _,v in pairs(ns.itemData) do 
        list[#list+1]=v.ItemCode
    end
    self.curOwnAllList=list
    self:loadSkinData()
--    self:OnRefreshSkin(self.curSkinqiList,self.curOwnAllList,1)
    event.dispatch('SetChangeType',1)
end

function Shop:OnbtnForbid()
    self.ui.ThemeButton:setBright(false)
    self.ui.ThemeButton:setEnabled(false)
    self.ui.FlagButton:setBright(false)
    self.ui.FlagButton:setEnabled(false)
    self.ui.FrameButton:setBright(false)
    self.ui.FrameButton:setEnabled(false)
    self.ui.ExtraButton:setBright(false)
    self.ui.ExtraButton:setEnabled(false)
    self.ui.DiamondButton:setEnabled(false)
    self.ui.BuyCoin:setEnabled(false)
    self.ui.BuyCoin:setTouchEnabled(false)
    self.ui.BuyCoin_0:setEnabled(false)
    self.ui.BuyCoin_0:setTouchEnabled(false)
    self.ui.Panel_3:setTouchEnabled(false)
    self.ui.Panel_2:setTouchEnabled(false)
    self.ui.ThemeButton:loadTextureDisabled("Image/shop/biaoqian_ban.png",0)
end

function Shop:MainUICharge()
    self.curtype = Shop.Diamond
    --self:setBtnState(4)
end

function Shop:SetChangeType(ev,userdata)
    self:setBtnState(tonumber(userdata))
    if (self.curMode==Shop.ShopMode) then
        print("当前模式为：",tonumber(userdata),self.curMode)
        if tonumber(userdata) == Shop.Frame then
            self:OnRefreshDiamond(self.curMoneyList)                   
        elseif tonumber(userdata) == Shop.Flag then
            self:OnRefreshDiamond(self.curDiamondList)                 
        end
    else
        if tonumber(userdata) == Shop.Frame then
            self.ui.FrameButton:setLocalZOrder(100)
            self.ui.FlagButton:setLocalZOrder(50)
            self.ui.ExtraButton:setLocalZOrder(50)  
            self.ui.ItemButton:setLocalZOrder(50)  
            self:OnRefreshSkin(self.curSkincursorList,self.curOwnAllList,2)
        elseif tonumber(userdata) == Shop.Flag then
            self:OnRefreshSkin(self.curSkinqiList,self.curOwnAllList,1) 
            self.ui.FrameButton:setLocalZOrder(50)
            self.ui.FlagButton:setLocalZOrder(100)
            self.ui.ExtraButton:setLocalZOrder(50) 
            self.ui.ItemButton:setLocalZOrder(50)  
        elseif  tonumber(userdata) == Shop.Item then
            self:OnRefreshSkin(self.curItemList,self.curOwnAllList,3) 
            self.ui.FrameButton:setLocalZOrder(50)
            self.ui.FlagButton:setLocalZOrder(50)
            self.ui.ExtraButton:setLocalZOrder(50) 
            self.ui.ItemButton:setLocalZOrder(100)  
        else
            self:OnRefreshTheme(self.curSkinthemeList,self.curOwnAllList)
            self.ui.FrameButton:setLocalZOrder(50)
            self.ui.FlagButton:setLocalZOrder(50)
            self.ui.ExtraButton:setLocalZOrder(100) 
            self.ui.ItemButton:setLocalZOrder(50)   
        end
    end
end

function Shop:OnRefreshTheme(list,curlist)
    self.ui.ShopItemList:setVisible(true)
    self.ui.ShopItemList:removeAllChildren()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    for i=1,#list do
        local item = util.createView('Shop.ThemeItem')
        
        self.ui.ShopItemList:pushBackCustomItem(item)
        item:setThemekey(list[i],curlist)

        local baseWidth = item.ui.Panel_start:getContentSize().width
        local baseHeight = item.ui.Panel_start:getContentSize().height
        local buttonWidth = item.ui.Buy:getContentSize().width
        local buttonHeight = item.ui.Buy:getContentSize().height

        item.ui.Buy:setScaleX(baseWidth / buttonWidth)
        item.ui.Buy:setScaleY(baseHeight / buttonHeight)
    end
end

function Shop:OnRefreshSkin(list,curlist,id)
    print("刷新皮肤！")
    self.ui.ShopItemList:setVisible(true)
    self.ui.ShopItemList:removeAllChildren()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    local layout = nil
    local sign = 1
    for i=1 , #list do
        local DiamondItem = util.createView('Shop.SkinItem')
        DiamondItem:setAnchorPoint(0,0)
        if sign%3 == 1 then
            layout = ccui.Layout:create()
            layout:setAnchorPoint(0,0)
            layout:setTouchEnabled(false)
            layout:setContentSize(self.ui.ShopItemList:getContentSize().width,DiamondItem:getContentSize().height+0)
            self.ui.ShopItemList:pushBackCustomItem(layout)
        end
        if sign%3 == 1 then
            DiamondItem:setAnchorPoint(1,0)
            DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width/3,0)
        elseif sign%3 == 2 then
            DiamondItem:setAnchorPoint(0.5,0)
            DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width/2,0)
        else
            DiamondItem:setAnchorPoint(0,0)
            DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width*2/3,0)
        end
        layout:addChild(DiamondItem)
        if(id==2) then
            DiamondItem:setkey(list[i],curlist)
        elseif id == 1 then
            DiamondItem:setkey1(list[i],curlist)
        else
            DiamondItem:setitemkey(list[i])
        end
        sign = sign + 1
    end

end
local isFirstRefreshDiamond = true

function Shop:OnRefreshDiamond(list)
    print("刷新钻石,参数接受者:Shop.SkinItem")
    self.ui.ShopItemList:setVisible(true)
    self.ui.ShopItemList:removeAllChildren()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    local layout = nil
    local sign = 1
    for i=1 , #list do
        local DiamondItem = util.createView('Shop.DiamondItem')
        DiamondItem:setAnchorPoint(0,0)
        if sign%3 == 1 then
            layout = ccui.Layout:create()
            layout:setAnchorPoint(0,0)
            layout:setTouchEnabled(false)
            layout:setContentSize(self.ui.ShopItemList:getContentSize().width,DiamondItem:getContentSize().height+50)
            self.ui.ShopItemList:pushBackCustomItem(layout)
        end
        --print("宽度：",self.ui.ShopItemList:getContentSize().width)

        if sign%3 == 1 then
            DiamondItem:setAnchorPoint(0,0)
            DiamondItem:setPosition(45,0)
        elseif sign%3 == 2 then
            DiamondItem:setAnchorPoint(0.5,0)
            DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width/2,0)
--        elseif sign%4 == 3 then
--            Flagitem:setAnchorPoint(0.67,0)
--            Flagitem:setPosition(layout:getContentSize().width*2/3,0)
        else
            DiamondItem:setAnchorPoint(1,0)
            DiamondItem:setPosition(self.ui.ShopItemList:getContentSize().width-45,0)
        end
        -- ccui.Helper:doLayout(DiamondItem)
        layout:addChild(DiamondItem)
        DiamondItem:setkey(list[i])
        sign = sign + 1
    end

end
-- Event for btnClose callback (addClickEventListener)
function Shop:onClose(node, eventType, userdata)
    -- self.ui.ShopItemList:setVisible(false)
    -- self.ui.Image_2:setVisible(false)
    -- self.ui.Image_2_0:setVisible(false)
    -- self.ui.Image_2_1:setVisible(false)
    -- event.dispatch('SetOpenstate')
    -- util.closeDialog('Shop.Shop')
end


-- Event for BuyCoin_0 callback (addClickEventListener)
function Shop:OnClickCharge(node, eventType, userdata)
    event.dispatch('SetChangeType',4)
end

-- Event for Panel_3 callback (addClickEventListener)
function Shop:onCharge(node, eventType, userdata)
--    local view = util.showDialog('Dialog', 'Shop.Shop')
--    view:MainUICharge()
    event.dispatch('SetChangeType',4)
end

-- Event for Image_2_0 callback (addClickEventListener)
function Shop:OnBuyHeart(node, eventType, userdata)

end

-- Event for Panel_Coin callback (addTouchEventListener)
function Shop:OnTip(node, eventType, userdata)
    if eventType < 2 then
        if self.CoinTip==nil then
            self.CoinTip = self:getApp():createView('Common.CoinTip')
            self.CoinTip:setPosition({x=node:getPositionX()-self.CoinTip:getContentSize().width*userdata-(userdata-1)*self.ui.Image_1:getContentSize().width,
                                      y=node:getPositionY()-node:getContentSize().height*2-self.CoinTip:getContentSize().height})
            node:addChild(self.CoinTip)
            self.CoinTip:setTxt(tonumber(userdata))
        end
    else
        if self.CoinTip~=nil then
            node:removeChild(self.CoinTip)
            self.CoinTip=nil
        end
    end
end

return Shop
