local TempShop = class("TempShop", cc.load("mvc").LayoutBase)
TempShop.RESOURCE_FILENAME = "Shop.TempShop"

local shoplist = {}

function TempShop:onCreate()
    self:addEvent('NS_DiamondExchangeMoney')
    self:addEvent('NS_SimulationCharge')
end

function TempShop:onEnter()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    self.ui.Name:setString(static.language[20006][device.language])
    self.ui.Coin:setString(mdt.player.gold)
    --self.ui.PvpCoin:setString(ns.nChanllengePoint)
    self.ui.life:setString(mdt.player.diamond)
    self:Getlist()
    shoplist = {}
end

function TempShop:onExit()

end

function TempShop:NS_SimulationCharge(ev,ns)
    self.ui.life:setString(mdt.player.diamond)
end

function TempShop:NS_DiamondExchangeMoney(ev,ns)
    self.ui.Coin:setString(mdt.player.gold)
--    self.ui.PvpCoin:setString(mdt.mypvpcoin)
    self.ui.life:setString(mdt.player.diamond)
end

function TempShop:Getlist()
    for k,_ in pairs(static.diamond) do
        if static.diamond[k].type == 1 then
            shoplist[#shoplist+1]={key= k,type='diamond'}
        end
    end
    for k,_ in pairs(static.money) do
        shoplist[#shoplist+1]={key= k,type='gold'}
    end
    self:OnRefresh()
end

function TempShop:OnRefresh()
    self.ui.ShopItemList:setScrollBarEnabled(false)
    self.ui.ShopItemList:removeAllChildren()
    local layout = nil
    for i=1 , #shoplist do
    local Flagitem = util.createView('Shop.FlagItem')
        Flagitem:setAnchorPoint(0,0)                   
        if i%3 == 1 then
            layout = ccui.Layout:create()
            layout:setAnchorPoint(0,0)
            layout:setTouchEnabled(false)
            layout:setContentSize(self.ui.ShopItemList:getContentSize().width,Flagitem:getContentSize().height+50)
            self.ui.ShopItemList:add(layout)
        end
        if i%3 == 1 then
            Flagitem:setAnchorPoint(0,0)
            Flagitem:setPosition(90,0)
        elseif i%3 == 2 then
            Flagitem:setAnchorPoint(0,0)
            Flagitem:setPosition(layout:getContentSize().width/2,0)
        else
            Flagitem:setAnchorPoint(0,0)
            Flagitem:setPosition(layout:getContentSize().width-90,0)
        end  
        layout:addChild(Flagitem) 
        Flagitem:setVisible(true)
        Flagitem:setkeydiamond(shoplist[i])
    end
end

-- Event for btnClose callback (addClickEventListener)
function TempShop:onClose(node, eventType, userdata)

end

-- Event for FlagButton callback (addClickEventListener)
function TempShop:OnChangeType(node, eventType, userdata)

end

-- Event for Image_2_0 callback (addClickEventListener)
function TempShop:OnBuyHeart(node, eventType, userdata)

end

-- Event for Panel_3 callback (addClickEventListener)
function TempShop:onCharge(node, eventType, userdata)

end

-- Event for Panel_BuyCoin callback (addClickEventListener)
function TempShop:OnClickCharge(node, eventType, userdata)

end

return TempShop
