local Success = class("Success", cc.load("mvc").LayoutBase)
Success.RESOURCE_FILENAME = "Success.Success"

Success["const"]={
    COUNT_MENU = 11  --分类固定为11种
}

Success["curOrderSuccessData"]={} --分类后的成就数据
Success["curSelectedMenuIndex"]=1 --每次打开成就界面默认显示第一项分类数据
Success["curAllSuccessData"]=nil --当前来自服务器的全部成就数据
Success["curTopMenuIndex"]=1--上方成就版初始化
function Success:onCreate()
    self:addEvent('OnSuccessRefresh')
    self:addEvent('NS_LoadAchievement') --请求服务器数据
    self:addEvent('initMenu')
end

function Success:onEnter()
    self.ui.Name:setString(static.language[20012][device.language])
    self:processSuccessData()
    self:initMenu()
    net.msg.NC_LoadAchievement() --请求服务器成就数据

end

function Success:onExit()

end

function Success:NS_LoadAchievement(ev,ns)
    self.curAllSuccessData=ns.sAchievement
    --dump(ns)
--    dump(self.curAllSuccessData)
    -- print("成就id==1:",self.curAllSuccessData[1].nGUID.a)
    -- print("成就id==3:",self.curAllSuccessData[3].nGUID.a)
    -- 取出 self.curAllSuccessData 里面对应的成就编号  比如  60101
    -- 
    self:OnSuccessRefresh()
    
end

function Success:initMenu(ev,id)
    self.ui.SuccessTypeList:removeAllChildren()
    self.ui.SuccessTypeList:setScrollBarEnabled(false)
    for i=1,self.const.COUNT_MENU  do
        --print("lalalalala")
        local SuccessTypeitem = util.createView('Success.SuccessTypeItem')
        SuccessTypeitem:setBtn(i,self.curOrderSuccessData)
        --SuccessTypeitem:getChildren()[1]:getChildren()[1]:setTitleText("Menu"..i)
        self.ui.SuccessTypeList:pushBackCustomItem(SuccessTypeitem)   
    end
    print("id:",tonumber(id))
    if id~=nil then
        if tonumber(id)<=11 and tonumber(id)>8 then
        util.delayNode(0.03,function ()
            self.ui.SuccessTypeList:jumpToPercentHorizontal(100)
        end)
        elseif tonumber(id)>6 and tonumber(id)<=8 then 
            util.delayNode(0.03,function ()
            self.ui.SuccessTypeList:jumpToPercentHorizontal(50)
        end)
        else

        end
    end
     -- self.ui.SuccessTypeList:jumpToPercentVertical(0.5)
     -- self.ui.SuccessTypeList:jumpToRight
     --self.ui.SuccessTypeList:scrollToRight(0.5,true)
 end

function Success:processSuccessData()
    self.curOrderSuccessData={}
    for k,v in pairs(static.achievement) do
        local achID = static.achievement[k].achID
        if nil == self.curOrderSuccessData[achID] then
            self.curOrderSuccessData[achID] = {}
        end
        table.insert(self.curOrderSuccessData[achID],static.achievement[k])
    end
end

function Success:OnSuccessRefresh(ev,param)
    --print("123123123",param)
    if(param ~= nil ) then 
        self.curSelectedMenuIndex=param 
    end
    self.ui.SuccessItemList:removeAllChildren()
    self.ui.SuccessItemList:setScrollBarEnabled(false)
    local tempLanguageData="60100"+self.curSelectedMenuIndex
    self.ui.SuccessName:setString(static.language[tonumber(tempLanguageData)][device.language])
    local curSelectedMenuData = self.curOrderSuccessData[self.curSelectedMenuIndex]
    
    self:TopToAccessAchieveiment(curSelectedMenuData)
    --dump(curSelectedMenuData)

    local curSelectedMenuDataCount = table.nums(curSelectedMenuData)
    for i=1,curSelectedMenuDataCount do
        local Successitem = util.createView('Success.SuccessItem')
        Successitem:setkey(curSelectedMenuData[i],self.curAllSuccessData)

        -- Successitem:refresh(self.curAllSuccessData)
        -- 内部自行遍历，看成就id是否和key的id一样，如果一样就渲染，如果不一样，忽略不更新
        self.ui.SuccessItemList:pushBackCustomItem(Successitem)
    end
end
--排序用
function Success:TopToAccessAchieveiment(MenuTable)
    local temp = {}
    --dump(self.curAllSuccessData)
    if self.curAllSuccessData~=nil then
            for k,v in pairs(self.curAllSuccessData) do 
                if v.nGetReward == 1 then 
                   --print("111111111111111",v.nAchievementID)
                   table.insert(temp,v.nAchievementID)
                end
            end
           
            --dump(MenuTable)
            -- for k,v in pairs(temp) do
            --      local  aa = nil
            --     local tempSp=nil

            --     for m,n in pairs(MenuTable) do
            --         if (n.code == v) then
            --              tempSp = n
            --             aa= m   
            --             break
            --         end
            --     end
            --     if aa~=nil and tempSp~=nil then
            --         table.remove(MenuTable,aa)
            --         --dump(MenuTable)
            --         table.insert(MenuTable,1, tempSp)
            --         --dump(MenuTable)
            --     end
            -- end

            for i=(#temp) ,1,  -1 do
                 local  aa = nil
                local tempSp=nil

                for m,n in pairs(MenuTable) do
                    if (n.code == temp[i]) then
                         tempSp = n
                        aa= m   
                        break
                    end
                end
                if aa~=nil and tempSp~=nil then
                    table.remove(MenuTable,aa)
                    --dump(MenuTable)
                    table.insert(MenuTable,1, tempSp)
                    --dump(MenuTable)
                end

            end
        end
end

-- Event for btnClose callback (addClickEventListener)
function Success:onClose(node, eventType, userdata)

end

function Success:setListPosition(pos)
    local id = 0
    if pos-1 > 5 then
        id = 5.5
    else
        id = pos-1
    end
    self.ui.SuccessTypeList:jumpToPercentHorizontal(id/5.5*100)
    util.delay(0.1,function()
        event.dispatch('ChangeSuccessUI',pos)
    end)
end 

return Success