local SuccessTypeItem = class("SuccessTypeItem", cc.load("mvc").LayoutBase)
SuccessTypeItem.RESOURCE_FILENAME = "Success.SuccessTypeItem"

function SuccessTypeItem:onCreate()
    self:addEvent('OnCurChooseId')
    self:addEvent('OnCurChooseIndex')
    --self:addEvent("OnReachSuccess")
    self:addEvent('getach')
    self:addEvent('ChangeSuccessUI')
    self:addEvent('NS_LoadAchievement')
end

function SuccessTypeItem:OnReachSuccess(userdata)

    self:onClickTypeBtn(nil,nil,userdata)
    print("当前userdata为：",userdata)
end

function SuccessTypeItem:onEnter()

end

function SuccessTypeItem:onExit()

end

function SuccessTypeItem:NS_LoadAchievement()
    self:getach()
end

function SuccessTypeItem:getach()
    self.ui.redpoint_1:setVisible(false) 
    if mdt.reachAch~=nil then
        for i=1,#mdt.reachAch do
            if mdt.reachAch[i].nTypeID == self.k then
                self.ui.redpoint_1:setVisible(true)               
                break
            end
        end
    end
end

function SuccessTypeItem:setBtn(key,value)
    --self.ui.Button_1:loadTexture(static.achievement[self.id].image,0)
    self.k = key
    self:getach()
    self.item=key
    self.value=value
   -- print("lalala",self.item)
    self.ui.Button_1:setScale(0.55)
    self.ui.Button_1:loadTextureNormal(value[key][1].image)
    self.ui.Button_1:loadTexturePressed(value[key][1].image)
    self.ui.Button_1:setContentSize({width = 349, height =349})
    if(self.item~=1) then 
        self.isBGUI=false

    else 
        self.isBGUI=true
        self:OnCurChooseId()

    end
end
-- Event for Button_1 callback (addClickEventListener)
function SuccessTypeItem:onClickTypeBtn(node, eventType, userdata)
--     print("点击了成就模块:Menu"..self.item)
--     net.msg.NC_LoadAchievement() --请求服务器成就数据
--     event.dispatch('OnSuccessRefresh',self.item)
--     self.isBGUI=true
--      event.dispatch('OnCurChooseId')
     --self:OnCurChooseId()
     event.dispatch('ChangeSuccessUI',self.k)
end

function SuccessTypeItem:ChangeSuccessUI(ev,id)
    if id ~= self.k then return end
    net.msg.NC_LoadAchievement()
    event.dispatch('OnSuccessRefresh',id)
    self.isBGUI=true
    event.dispatch('OnCurChooseId')
end

function SuccessTypeItem:OnCurChooseId()
   -- print("lalala",self.item)
    if self.isBGUI==true then
        self.ui.Image_Bg:setVisible(true)
        self.ui.Image_3:setVisible(false)
        --print("lalala",self.item)
        self.isBGUI=false
    else
        self.ui.Image_Bg:setVisible(false)
        self.ui.Image_3:setVisible(true)
    end
end
function SuccessTypeItem:OnCurChooseIndex(ev,index)
   -- print("！！！！！！！！当前index为：",index)
    if tonumber(index) == self.item then 
      self.ui.Image_Bg:setVisible(true)
        --print("lalala",self.item)
    else
       self.ui.Image_Bg:setVisible(false)
    end
end

return SuccessTypeItem
