local combo = class("combo", cc.load("mvc").LayoutBase)
combo.RESOURCE_FILENAME = "donghua.combo"

function combo:onCreate()
end

function combo:onEnter()
    self:runAnimation()
    self.ui.ComboPanel:setVisible(false)
    self.lastComboLevel = 0
    self.lastComboNum = 0
    self.playHide = false  
end

function combo:onExit()

end

function combo:checkComboLevel(comboCount, comboLevel, score)
    if comboLevel < 2 then
        self.ui.ComboPanel:setVisible(false)
        if self.lastComboLevel >= 2 and not self.playHide then
            self:play("xiaoshi", false)
            self.playHide = true
            sdkManager.talkingdata:setEvent("73",{Combo = "Combo"..self.lastComboNum})
            sdkManager.appsflyer:setEvent("73",{Combo = "Combo"..self.lastComboNum})

        end
        self.lastComboLevel = 0
        self.lastComboNum = 0
        return
    else
        self.ui.ComboPanel:setVisible(true)
    end

    if comboLevel > self.lastComboLevel then
        self.lastComboLevel = comboLevel
        self:playComboAnimation(comboLevel)
    end
    if comboCount > self.lastComboNum then
        self.lastComboNum = comboCount
    end

    self.ui.comboLevel:loadTexture('Image/combo/combo_'..comboLevel..'.png',0)
    self.ui.LoadingBar_1:setPercent(100)
    self.maxComboTime = static.combo[comboLevel].cdTime / 1000.0
    self.comboLeftTime = self.maxComboTime
    self.alertTime = self.maxComboTime / 3.0
    self.ui.comboScore:setString(score)
    self.ui.comboNum:setString("Combo".."\n"..comboCount)
    self.ui.ComboPanel:setVisible(true)
end

function combo:checkPanel(dt)
    if self.comboLeftTime and self.comboLeftTime > 0 then
        self.comboLeftTime = self.comboLeftTime - dt
        if self.comboLeftTime <= self.alertTime and self.comboLeftTime > 0 then
            self.ui.Spine_1:setVisible(true)
        else
            self.ui.Spine_1:setVisible(false)
        end

        if self.comboLeftTime <= 0 then
            self.comboLeftTime = 0
            self:play("xiaoshi", false)
            self.playHide = true

            if mdt.allowRate and not mdt.dontShowRate then
                sdkManager.locojoybj:requestGotScore()
            end
            
        end      
        self.ui.LoadingBar_1:setPercent(self.comboLeftTime / self.maxComboTime * 100)
    end
end

function combo:playComboAnimation(level)
    local lastLevelStr = static.combo[level - 1].level
    local levelStr = static.combo[level].level
    local aniName = string.lower(lastLevelStr).."_"..string.lower(levelStr)
    self:play(aniName, false)
    audio.playEffect(static.combo[level].sound)
end

return combo
